	DATA

GWVA_FBUTTON_DEFAULT_METHODLIST:
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_FORM_CLICK,GWVA_FBUTTON_PRG_CLICK
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_FORM_KEYPRESS,GWVA_FBUTTON_PRG_KEYPRESS
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_FORM_IFACE_CLICK,GWVA_FBUTTON_PRG_IFACE_CLICK
	GWVA_OBJ_STRUCT_METHOD_END_LIST

	TEXT

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_FORM_KEYPRESS
; Asm label   : GWVA_FBUTTON_PRG_KEYPRESS
; Description : Mthode pour traiter l'effet de l'appui d'une touche sur un bouton
;
; in  : a0.l = pointeur sur l'objet
; in  : a1.l = pointeur sur la fentre formulaire contenant l'objet
; in  : a2.l = pointeur sur l'arbre formulaire en question
; in  : d0.w = index GEM de l'objet devant faire l'objc_edit
; in  : d1.w = position du curseur
; in  : d2.w = [ Key state.w | Key code.w ]
; out : d6.w = GWVA_PRGRET_NOT_CONSUMED ou GWVA_PRGRET_CONSUMED
;
; 29/11/98 : Cration
;------------------------------------------------------------------------------
GWVA_FBUTTON_PRG_KEYPRESS:

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_FORM_KEYPRESS
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq .pas_keypress_car_on_keypress_consomme

	;-----------------------------------;

	cmp.w GWVA_FBTON_OBJ_MAIN_IDX(a0),d0
	bne .je_ne_suis_pas_concerne_par_ce_msg

	lea FKEYB_TMP_IN_BUF,a3
	move.l a1,GWVA_FORM_KEYB_IN_WIND_PTR(a3)
	move.l a2,GWVA_FORM_KEYB_IN_TREE_PTR(a3)

	save.l a1/a2

	move.l a3,a1
	lea FKEYB_TMP_OUT_BUF,a2

	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS	#GWVA_METHOD_FORM_KEYBD

	move.w GWVA_FORM_KEYB_OUT_RET_CODE(a2),d3
	move.w GWVA_FORM_KEYB_OUT_NEW_OBJECT(a2),d4
	move.w GWVA_FORM_KEYB_OUT_KEY_OUT(a2),d5

	load.l a1/a2

	;-----------------------------------;

	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	bne .touche_pas_consommee

	tst d3	; 0 = bouton 'exit' default, 1 = pas de bouton en 'default'
	bne .objet_defaut_pas_active

	save.l a0-a1

	move.w d4,d0	; index
	move.l a2,a0	; arbre
	bsr GWVA_RSC_RETURN_OBJ_POS_SIZE

	load.l a0-a1

	asr.w #1,d2
	asr.w #1,d3
	add.w d2,d0		; on tappe en plein au milieu de l'objet
	add.w d3,d1

	save.l a0

	swap d0		; X mot haut d0
	move.l a1,a0	; ptr fenetre
	move.w GWVA_WIND_OBJ_GEM_HANDLE(a0),d0	; handle

	swap d1
	move #1,d1		; pour mettre le .w haut de d1  1
	swap d1
	moveq #1,d2		; key state=0 | mouse count=1

	GWVA_CALL_METHOD_OTHER_OBJ	#GWVA_METHOD_WIND_CLICK

	load.l a0

	;-----------------------------------;

.objet_defaut_pas_active:
.touche_pas_consommee:
.pas_keypress_car_on_keypress_consomme:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.je_ne_suis_pas_concerne_par_ce_msg:
	moveq #GWVA_PRGRET_NOT_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_FORM_IFACE_CLICK
; Asm label   : GWVA_FBUTTON_PRG_IFACE_CLICK
; Description : Regnration d'un clic sur cet objet
;
; in  : a0.l = pointeur sur l'objet
; in  : a1.l = pointeur sur la fenetre contenant l'objet
; out : d6.w = GWVA_PRGRET_CONSUMED
;
; 16/08/98 : Cration
;------------------------------------------------------------------------------
GWVA_FBUTTON_PRG_IFACE_CLICK:

	; bidouille infaame (ne marche pas si objet encapsul)
	move.l GWVA_OBJ_FATHER_PTR(a0),a1

	clr.l d0
	move.w GWVA_FBTON_OBJ_MAIN_IDX(a0),d0
	move.l #1,d1		; droit
	move.l #1,d2		; 1 clic

	move.l a1,a4
	lea GWVA_FORM_CLICK_IN_STRUCT,a1
	move #0,GWVA_FORM_CLICK_IN_FATHER_IDX(a1)	; je le connais pas ...
	move.l a4,GWVA_FORM_CLICK_IN_WIND_PTR(a1)
	move.l GWVA_WRSC_OBJ_TREE_PTR(a4),GWVA_FORM_CLICK_IN_TREE_PTR(a1)

	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS	#GWVA_METHOD_FORM_CLICK

	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_FORM_CLICK
; Asm label   : GWVA_FBUTTON_PRG_CLICK
; Description : Mthode de traitement d'un clic dans un formulaire
;
; Rq  : cette mthode traite tout ce qui est bouton, sauf radio-bouton
;
; in  : a0.l = pointeur sur l'objet
; in  : a1.l = pointeur sur le buffer d'entre typ GWVA_FORM_CLICK_IN
; in  : d0.l = [ X.w | num gem.w ]
; in  : d1.l = [ Y.w | mouse button.w ]
; in  : d2.l = [ Key state.w | mouse count.w ]
; out : d6.w = GWVA_PRGRET_NOT_CONSUMED ou GWVA_PRGRET_CONSUMED
;
; 14/02/98 : Cration
; 07/03/98 : Appel du form_button
;------------------------------------------------------------------------------
GWVA_FBUTTON_PRG_CLICK:

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_FORM_CLICK
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq .pas_buttonclick_car_on_buttonclick_consomme

	;-----------------------------------;

	cmp.w GWVA_FBTON_OBJ_MAIN_IDX(a0),d0
	bne .je_ne_suis_pas_concerne_par_ce_msg

	lea FBUTTON_TMP_IN_BUF,a3
	move.l GWVA_FORM_CLICK_IN_WIND_PTR(a1),GWVA_FORM_BUTTON_IN_WIND_PTR(a3)
	move.l GWVA_FORM_CLICK_IN_TREE_PTR(a1),GWVA_FORM_BUTTON_IN_TREE_PTR(a3)

	save.l a1			; seul ce paramtre bouge

	move.l a3,a1
	lea FBUTTON_TMP_OUT_BUF,a2

	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS	#GWVA_METHOD_FORM_BUTTON

	load.l a1			; seul ce paramtre bouge

	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	bne .clic_non_traite

	move.w GWVA_FORM_BUTTON_OUT_NEW_STATE(a2),d3
	move.w d3,GWVA_FBTON_OBJ_STATE(a0)
	move.w GWVA_FORM_BUTTON_OUT_NEW_TYPE(a2),d4
	move.w GWVA_FORM_BUTTON_OUT_OLD_STATE(a2),d5
	move.w GWVA_FORM_BUTTON_OUT_RET_CODE(a2),d6

	; pas d'after donc on peut scratcher les params d'entre
	; on positionne a1/a2, car ils servent pour tous les vnements
	move.l GWVA_FORM_CLICK_IN_TREE_PTR(a1),a2	; tant que a1 est bon
	move.l GWVA_FORM_CLICK_IN_WIND_PTR(a1),a1

	;-----------------------------------;

	; mettre clicked / changed ...

*	btst #DISABLED,d3		; ceci est fait dans le form button
*	bne .object_disabled

	save.l d0-d2

	tst d6
	bne .propriete_exit_non_activee

	cmp.w d5,d3
	bne.s .etat_a_change

	; Attention : positionner les paramtres d'entre + sauver les courants
	; ! on ne prpare pas les paramtres comme il faut pour le moment !
	swap d0
	move.w d1,d0
	swap d0
	move.w d4,d1	; type
	swap d1
	move d3,d1		; state
	cmp.w #2,d2
	beq.s .double_click
	swap d2
	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_FORM_CLICKED
	bra.s .clicked_ok
.double_click:
	swap d2
	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_FORM_DCLICKED
.clicked_ok:
	bra.s .fin_click_ok

	;-------------------;

.propriete_exit_non_activee:
	cmp.w d5,d3
	beq.s .etat_a_pas_change

.etat_a_change:

	move.w d4,d1	; type
	swap d1
	move d3,d1		; state
	swap d2

	; Attention : positionner les paramtres d'entre + sauver les courants
	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_FORM_CHANGED

	btst #SELECTED,d1	; ruse : d3 se retrouve dans d1
	beq.s .pas_selectionne

	; Attention : positionner les paramtres d'entre + sauver les courants
	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_FORM_SELECTED

	bra.s .fin_click_ok

.pas_selectionne:
	; Attention : positionner les paramtres d'entre + sauver les courants
	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_FORM_UNSELECTED

.etat_a_pas_change:
.fin_click_ok:

	load.l d0-d2

	;-----------------------------------;

.clic_non_traite:
.pas_buttonclick_car_on_buttonclick_consomme:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.je_ne_suis_pas_concerne_par_ce_msg:
	moveq #GWVA_PRGRET_NOT_CONSUMED,d6
	rts

 BSS
FBUTTON_TMP_IN_BUF:	ds.b GWVA_FORM_BUTTON_IN_STRUCT_LENGTH
FBUTTON_TMP_OUT_BUF:	ds.b GWVA_FORM_BUTTON_OUT_STRUCT_LENGTH
 TEXT

;------------------------------------------------------------------------------
