	DATA

GWVA_FORM_DEFAULT_METHODLIST:
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_FORM_BUTTON,GWVA_FORM_PRG_FORM_BUTTON
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_FORM_KEYBD,GWVA_FORM_PRG_FORM_KEYB
	GWVA_OBJ_STRUCT_METHOD_END_LIST

	TEXT

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_FORM_KEYBD
; Asm label   : GWVA_FORM_PRG_FORM_KEYB
; Description : Mthode pour traiter l'effet de l'appui d'une touche sur un champ texte
;
; Rq  : Appel par les classes bouton et texte ditable
;
; in  : a0.l = pointeur sur l'objet
; in  : a1.l = pointeur sur le buffer de sortie typ GWVA_FORM_KEYB_IN
; in  : a2.l = pointeur sur le buffer de sortie typ GWVA_FORM_KEYB_OUT
; in  : d0.w = Champs texte o appliquer le Key code ou 0.w si aucun champ ditable
; in  : d2.w = Key code
; out : d6.w = GWVA_PRGRET_NOT_CONSUMED s'il faut faire un objc_edit derrire
;	   ou GWVA_PRGRET_CONSUMED si la touche a t consomme
;
; 10/05/98 : Cration
;------------------------------------------------------------------------------
GWVA_FORM_PRG_FORM_KEYB:

	save.l a0-a2/d0-d2
	form_keybd GWVA_FORM_KEYB_IN_TREE_PTR(a1),d0,#1,d2	; #1 parce qu'il le faut
	move d0,d3
	load.l a0-a2/d0-d2

	move.w d3,GWVA_FORM_KEYB_OUT_RET_CODE(a2)
	move.w int_out+1*2,d4
	move.w d4,GWVA_FORM_KEYB_OUT_NEW_OBJECT(a2)
	move.w int_out+2*2,d5
	move.w d5,GWVA_FORM_KEYB_OUT_KEY_OUT(a2)

	tst d3	; 0 = bouton 'exit' default, 1 = pas de bouton en 'default'
	beq .objet_defaut_active

	tst d5		; a-t-il russi  la traiter ?
	bne .fkbd_pas_pu_traiter_touche

	; Patch pour le GEM qui renvoie new_obj =0 si press enter
	; et pas de bouton default
	tst d4
	bne.s .pas_patch_new_obj_eq_0
.common_patch_buggy_default:
	move d3,GWVA_FORM_KEYB_OUT_NEW_OBJECT(a2)	; new=old => ne rien faire
.pas_patch_new_obj_eq_0:

.objet_defaut_active_correctement:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts
		;----------

.objet_defaut_active:
	move d4,d6			; new obj

	mulu #L_OBJECT,d6
	add.l GWVA_FORM_KEYB_IN_TREE_PTR(a1),d6
	move.l d6,a3
*	btst #EDITABLE,ob_flags+1(a3)	; ditable ?
*	beq .next_obj_pas_editable

	bclr #SELECTED,ob_state+1(a3)	; dslection de l'objet

	btst #DISABLED,ob_state+1(a3)	; objet 'default' disable ? -> on doit le rafficher deselectionner ?_PATCH_?
	bne.s .objet_defaut_active_but_disable

	btst #SELECTABLE,ob_flags+1(a3)	; objet 'default' pas selectable ? -> on doit le rafficher deselectionner ?_PATCH_?
	beq.s .objet_defaut_active_but_not_selectable

	bra.s .objet_defaut_active_correctement

.objet_defaut_active_but_not_selectable:
.objet_defaut_active_but_disable:
	move.w #1,GWVA_FORM_KEYB_OUT_RET_CODE(a2)	; on vire le 'default activated'
	bra.s .common_patch_buggy_default

		;----------

.fkbd_pas_pu_traiter_touche:

	moveq #GWVA_PRGRET_NOT_CONSUMED,d6
	rts

 BSS
FKEYB_TMP_IN_BUF:	ds.b GWVA_FORM_KEYB_IN_STRUCT_LENGTH
FKEYB_TMP_OUT_BUF:	ds.b GWVA_FORM_KEYB_OUT_STRUCT_LENGTH
 TEXT

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_FORM_BUTTON
; Asm label   : GWVA_FORM_PRG_FORM_BUTTON
; Description : Effectue un form button sur un objet rsc
;
; Rq  : Ragit graphiquement au clic => appel  FORM_BUTTON et retourne
; Rq  : sert pour tous les objets cliquables : boutons, radios ...
;
; in  : a0.l = pointeur sur l'objet
; in  : a1.l = pointeur sur le buffer d'entre typ GWVA_FORM_BUTTON_IN
; in  : a2.l = pointeur sur le buffer de sortie typ GWVA_FORM_BUTTON_OUT
; in  : d0.l = [ X.w | num gem.w ]
; in  : d1.l = [ Y.w | mouse button.w ]
; in  : d2.l = [ Key state.w | mouse count.w ]
; out : d6.w = GWVA_PRGRET_NOT_CONSUMED ou GWVA_PRGRET_CONSUMED
;
; 07/03/98 : Cration
;------------------------------------------------------------------------------
GWVA_FORM_PRG_FORM_BUTTON:

	btst #0,d1			; quel bouton click ?
	beq .its_not_left_button

	move.l GWVA_FORM_BUTTON_IN_TREE_PTR(a1),a3	; a3 = ptr sur le ressource
	move d0,d3
	mulu #L_OBJECT,d3
	add.l d3,a3

	; on teste si je suis pas slectable mais que mon pre le serait
	; et dans ce cas on fait comme si il avait cliqu dans mon pre

	btst #SELECTABLE,ob_flags+1(a3)
	bne.s .je_suis_selectable

	save.l d0-d2/a0-a3
	move.l GWVA_FORM_BUTTON_IN_TREE_PTR(a1),a0	; a0.l + d0.w num obj
	bsr GWVA_RSC_FIND_FATHER_OBJECT
	move d0,d3
	move.l a0,a4
	load.l d0-d2/a0-a3
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne.s .click_in_root

	btst #SELECTABLE,ob_flags+1(a4)
	beq.s .mon_pere_est_pas_selectable

	move d3,d0		; l'objet cliqu devient le pre
	move.l a4,a3	; ruse pour les caractres "shortcut" sur les boutons

.mon_pere_est_pas_selectable:
.click_in_root:
.je_suis_selectable:
	;  partir d'ici A3 pointe sur l'objet dans le formulaire

	move ob_state(a3),d3	; D3  sauver  partir d'ici (ancien tat)

	move.w d0,GWVA_FORM_BUTTON_OUT_OBJECT(a2)
	move.w d3,GWVA_FORM_BUTTON_OUT_OLD_STATE(a2)
	move.l a3,GWVA_FORM_BUTTON_OUT_OBJ_PTR(a2)

	move #1,GWVA_FORM_BUTTON_OUT_RET_CODE(a2)	; si disabled : on fait comme si on n'avait pas cliqu sur l'objet (retour de form_buton)

	btst #DISABLED,d3
	bne .object_disabled

	;--------------

	ifd MDL_FORM_EDITABLE_TEXT2

	; a2 ne pointe plus sur le objet du rsc

	btst #EDITABLE,ob_flags+1(a2)	; ditable ? G_FTEXT G_FBOXTEXT
	beq .pas_texte_editable

	; d0 : objet
** d2 est scratch !	
	; d2 : quoi redressiner
	; d3 : tat de l'objet avant modifs
	; a0 : window
	; a1 : ptr form struct
	; a2 : ptr objet cliqu

	save.l d0/d2/d3/a0-a2

	v_hide_c

	movem.l (sp),d0/d2/d3/a0-a2

	bsr GWVA_WFORM_OBJ_PRG_HIDE_CURSOR

	movem.l (sp),d0/d2/d3/a0-a2

	cmp.w GWVA_WIND_OBJ_FOCUSED_OBJECT(a0),d0
	beq.s .no_lost_focus_cause_no_change_objet
	move.w GWVA_WIND_OBJ_FOCUSED_OBJECT(a0),d0
	move #GWVA_EVNT_LOSTFOCUS,d7
	lea GWVA_WFORM_OBJ_START_OBJ_LIST(a1),a2
	bsr GWVA_WIND_OBJ_PRG_SEARCH_EVNT

	movem.l (sp),d0/d2/d3/a0-a2

.no_lost_focus_cause_no_change_objet:

; Affiche le curseur texte sur le nouvel objet

	move.w GWVA_WIND_OBJ_FOCUSED_OBJECT(a0),-(sp)	; on sauve avant d'craser

	ifd OPT_GWVA_WIND_FORM_CURS_POS_WITH_MOUSE

	move.w GWVA_APP_OBJ_EVNT_MULTI_MX,d1
	bsr GWVA_WFORM_OBJ_PRG_DRAW_CURSOR_X
	else
	move.l GWVA_WFORM_OBJ_FORM_PTR(a1),a2
	move.w d0,d1
	mulu #L_OBJECT,d1
	move.w ([a2,d1.l,ob_spec],te_txtlen),d1
	subq.w #1,d1		; positionne  la fin du champ ditable
				; (comportement du V.A. normal)
	bsr GWVA_WFORM_OBJ_PRG_DRAW_CURSOR
	endc	; ifd OPT_GWVA_WIND_FORM_CURS_POS_WITH_MOUSE

	move.w (sp)+,d1		; Ancien objet ayant le focus

	movem.l (sp),d0/d2/d3/a0-a2

	cmp.w GWVA_WIND_OBJ_FOCUSED_OBJECT(a0),d1
	beq.s .no_got_focus_cause_no_change_objet
	; d0 : objet gagnant le focus
	move #GWVA_EVNT_GOTFOCUS,d7
	lea GWVA_WFORM_OBJ_START_OBJ_LIST(a1),a2
	bsr GWVA_WIND_OBJ_PRG_SEARCH_EVNT

	movem.l (sp),d0/d2/d3/a0-a2
.no_got_focus_cause_no_change_objet:

	v_show_c #1

	ifd MDL_CHILDREN_WINDOWS

	movem.l (sp),d0/d2/d3/a0-a2

	bsr GWVA_WIND_OBJ_PRG_RETURN_TOP_FAMILY_MEMBER
	bsr GWVA_WIND_OBJ_PRG_RETURN_FOCUSED_CHILD
	tst d7
	bmi.s .no_focused_at_this_time

	bclr #GWVA_WIN_BIT_FOCUSED,GWVA_WIND_OBJ_STATUS+1(a0)

.no_focused_at_this_time:
	load.l d0/d2/d3/a0-a2

	bset #GWVA_WIN_BIT_FOCUSED,GWVA_WIND_OBJ_STATUS+1(a0)

	else

	load.l d0/d2/d3/a0-a2

	endc	; ifd MDL_CHILDREN_WINDOWS

.pas_texte_editable:

	endc	; ifd MDL_FORM_EDITABLE_TEXT2

	;--------------

	save.l d0-d3/a0-a3
	form_button GWVA_FORM_BUTTON_IN_TREE_PTR(a1),d0,d2	; ptr,obj,m_count
	move d0,d5
	move.w int_out+2,d4	; *newobject : index de l'objet s'il est
			; ditable ou exit (bit 15 mis si double clic et touche-exit)
	load.l d0-d3/a0-a3

	move.w d5,GWVA_FORM_BUTTON_OUT_RET_CODE(a2)
	move.w d4,GWVA_FORM_BUTTON_OUT_NEW_OBJECT(a2)

	; il retourne un zro si
	; bouton est exit avec le click relach dans le bouton
	; bouton est touch_exit qqs la position de la souris au relachement

	tst d5
	bne.s .propriete_exit_non_activee

	; conditions de redessin ...

	btst #RBUTTON,ob_flags+1(a3)
	bne.s .radio_no_redraw		; car radio bouton : le GEM
				; a dj dessin pour nous

	btst #SELECTABLE,ob_flags+1(a3)	; l'objet doit etre selectionable pour changer d'tat
	beq.s .no_selectable

	bclr #SELECTED,ob_state+1(a3)	; dslection de l'objet
	beq.s .no_redraw_object		; pas de redraw si pas slectionn

	save.l d0-d3/a0-a3

	move.l GWVA_FORM_BUTTON_IN_WIND_PTR(a1),a0
	lea GWVA_FORM_TMP_OBJ_LIST,a1
	move.w d0,(a1)	; objet
	move.w #7,2(a1)	; profondeur
	move.w #GWVA_WRSC_CTE_REDRAW_PART_END_LIST,4(a1)
	GWVA_CALL_METHOD_OTHER_OBJ	#GWVA_METHOD_WRSC_REDRAW_PART_CONTENTS

	load.l d0-d3/a0-a3

.no_redraw_object:
.no_selectable:

	bra.s .envoie_message		; de toute faon

.radio_no_redraw:
.propriete_exit_non_activee:
	; soit radio juste selectable
	; soit bouton juste selectable

	btst #SELECTABLE,ob_flags+1(a3)	; slectionnable ?
	beq .pas_selectionable

	cmp.w ob_state(a3),d3
	beq .etat_inchange

	btst #RBUTTON,ob_flags+1(a3)
	beq.s .bouton_normal

	; ici : radio-bouton

	save.l d0-d3/a0-a3
	move.l GWVA_FORM_BUTTON_IN_TREE_PTR(a1),a0	; a0.l + d0.w num obj
	bsr GWVA_RSC_FIND_FATHER_OBJECT
	move d0,d4
	load.l d0-d3/a0-a3
	swap d0	; on garde l'obj cliqu mais on bosse avec le pre
	move d4,d0

.bouton_normal:
.envoie_message:	
.etat_inchange:
.pas_selectionable:
.object_disabled:

	move.w ob_state(a3),GWVA_FORM_BUTTON_OUT_NEW_STATE(a2)
	move.w ob_type(a3),GWVA_FORM_BUTTON_OUT_NEW_TYPE(a2)

	moveq #GWVA_PRGRET_CONSUMED,d6
	rts
.its_not_left_button:
	moveq #GWVA_PRGRET_NOT_CONSUMED,d6
	rts

 BSS
GWVA_FORM_TMP_OBJ_LIST:	ds.w 2+1
 TEXT

;------------------------------------------------------------------------------
