;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_FORM_CLICK
; Asm label   : GWVA_FEDIT_TEXT_PRG_CLICK
; Description : Mthode de traitement d'un clic dans un formulaire
;
; Rq  : cette mthode traite le clic dans un champs de texte ditable
;
; in  : a0.l = pointeur sur l'objet
; in  : a1.l = pointeur sur le buffer d'entre typ GWVA_FORM_CLICK_IN
; in  : d0.l = [ X.w | num gem.w ]
; in  : d1.l = [ Y.w | mouse button.w ]
; in  : d2.l = [ Key state.w | mouse count.w ]
; out : d6.w = GWVA_PRGRET_NOT_CONSUMED ou GWVA_PRGRET_CONSUMED
;
; 05/09/98 : Cration
;------------------------------------------------------------------------------
GWVA_FEDIT_TEXT_PRG_CLICK:

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_FORM_CLICK
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq .pas_textclick_car_on_textclick_consomme

	;-----------------------------------;

	cmp.w GWVA_FTEXT_OBJ_MAIN_IDX(a0),d0
	bne .je_ne_suis_pas_concerne_par_ce_msg


	save.l d0-d2/a0-a1
	move.l GWVA_FORM_CLICK_IN_WIND_PTR(a1),a0
	bsr GWVA_WFORM_HIDE_CURSOR
	load.l d0-d2/a0-a1

*	save.l d0-d2/a0-a1
	; d0  jour		; No objet
	move.l d0,d1
	swap d1		; X
	move.l GWVA_FORM_CLICK_IN_WIND_PTR(a1),a0
	bsr GWVA_FORM_PRG_DRAW_CURSOR_X
*	load.l d0-d2/a0-a1

	;-----------------------------------;

.pas_textclick_car_on_textclick_consomme:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.je_ne_suis_pas_concerne_par_ce_msg:
	moveq #GWVA_PRGRET_NOT_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_FORM_PRG_DRAW_CURSOR_X
; Description : positionne et affiche le curseur texte  une position x cran
; Description : (dans un champ ditable) + mets  jour la structure
;
; in  : a0.l = pointeur sur l'objet fentre contenant l'objet
; in  : d0.w = No objet texte editable  focuser
; in  : d1.w = position x absolue o positionner le curseur
;
; 05/09/98 : Cration
;------------------------------------------------------------------------------
GWVA_FORM_PRG_DRAW_CURSOR_X:

	move.w d0,GWVA_WFORM_OBJ_FOCUSED_IDX(a0)
	bsr GWVA_WFORM_PRG_RETURN_POSITON_EDITABLE_CHAR_UNDER_X

	move.w d0,GWVA_WFORM_OBJ_FOCUSED_IDX_CURSOR_POS(a0)
	bsr GWVA_WFORM_REDRAW_CURSOR
*	bsr GWVA_WFORM_PRG_DRAW_CURSOR
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_WFORM_PRG_RETURN_POSITON_EDITABLE_CHAR_UNDER_X
; Description : retourne la position en caractre avec en entre la position
; Description : en X dans un champs ditable
;
; in  : a0.l = pointeur sur l'objet fentre contenant l'objet
; in  : d0.w = No objet texte editable  focuser
; in  : d1.w = position x absolue o positionner le curseur
; out : d0.w = position curseur dans le champ ditable
;
; 05/09/98 : Cration
;------------------------------------------------------------------------------
GWVA_WFORM_PRG_RETURN_POSITON_EDITABLE_CHAR_UNDER_X:

	move.l GWVA_WRSC_OBJ_TREE_PTR(a0),a1

	move.w d0,d4
	mulu #L_OBJECT,d4
	lea (a1,d4.l),a2
	move.l ob_spec(a2),a1

	save.l a0-a2/d0-d1
	bsr GWVA_RSC_PRG_RETURN_POSITIONS_CURSOR_TXT
; d0 : position du curseur dans l'objet texte
; d1 : position du curseur dans le champ editable
; d2 : longueur du champ texte
	load.l a0-a2/d0-d1

	move.w GWVA_ROOT_SYSTEM_LARGEFONT_CELL_WIDTH,d4
	cmp.w #5,te_font(a1)		; small font ?
	bne.s .pas_de_small_font
	move.w GWVA_ROOT_SYSTEM_SMALLFONT_CELL_WIDTH,d4
.pas_de_small_font:

	mulu d4,d2		; taille du text en pixel

	save.l a0-a2/d0-d2
	objc_offset GWVA_WRSC_OBJ_TREE_PTR(a0),d0
	load.l a0-a2/d0-d2

	move.w int_out+1*2,d4	; position x de l'objet texte

	cmp.w #0,te_just(a1)	: justification gauche ?
	beq.s .justified_left

	cmp.w #1,te_just(a1)	: justification droite ?
	bne.s .not_justified_right

	move.w ob_width(a2),d5
	sub.w d2,d5
	add.w d5,d4
.not_justified_right:

	cmp.w #2,te_just(a1)	: justification centre ?
	bne.s .not_justified_center

	move.w ob_width(a2),d5
	sub.w d2,d5
	asr.w #1,d5
	add.w d5,d4
.not_justified_center:
.justified_left:
; -> d4 : position x du debut du texte en pixel

	sub.w d4,d1		; position relative x de la souris dans le texte
	bpl.s .souris_a_droite_debut_texte
	moveq #0,d1
.souris_a_droite_debut_texte:
	cmp.w d2,d1
	blt.s .souris_a_gauche_fin_texte
	move.w d2,d1
.souris_a_gauche_fin_texte:

	move.w GWVA_ROOT_SYSTEM_LARGEFONT_CELL_WIDTH,d4
	cmp.w #5,te_font(a1)		; small font ?
	bne.s .pas_de_small_font2
	move.w GWVA_ROOT_SYSTEM_SMALLFONT_CELL_WIDTH,d4
.pas_de_small_font2:

	ext.l d1
	divu d4,d1		; d1 : caractre o placer le curseur

	lea GWVA_WFORM_OBJ_INTERMEDIAIRE_TEXT+2,a1
	add.w d1,d1
	add.w d1,a1		; positionnement dans le texte
.recherche_texte:
	lea -2(a1),a1
	cmp.l #GWVA_WFORM_OBJ_INTERMEDIAIRE_TEXT,a1
	beq.s .curseur_debut_texte
	cmp.b #'_',-2+1(a1)
	beq.s .recherche_texte
.curseur_debut_texte:

	lea GWVA_WFORM_OBJ_INTERMEDIAIRE_TEXT,a2
	clr.w d0
.determine_position_curseur:
	cmp.l a2,a1
	beq.s .position_curseur_determinee
	tst.b (a2)
	beq.s .pas_caractere_editable
	add.w #1,d0
.pas_caractere_editable:
	lea 2(a2),a2
	bra.s .determine_position_curseur
.position_curseur_determinee:
; -> d0.w
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_RSC_PRG_RETURN_POSITIONS_CURSOR_TXT
; Description : retourne les positions 1) dans le texte 2) dans le masque
; Description : + longeur texte pour un champs ditable
;
; in  : a1.l = pointeur sur l'ob_spec de l'objet
; out : d0.w = position du curseur dans l'objet texte (entre 0( gauche 1er) et d2( droite dernier))
; out : d1.w = position du curseur dans le champ editable
; out : d2.w = longueur du champ texte
;
; 05/09/98 : Cration
;------------------------------------------------------------------------------
GWVA_RSC_PRG_RETURN_POSITIONS_CURSOR_TXT:

	move.l te_ptmplt(a1),a3
	lea GWVA_WFORM_OBJ_INTERMEDIAIRE_TEXT,a5

.reconstruit_texte_non_editable:
	clr.b (a5)+			; type de texte - non editable
	move.b (a3)+,(a5)+
	tst.b -1(a5)
	bne.s .reconstruit_texte_non_editable

	lea GWVA_WFORM_OBJ_INTERMEDIAIRE_TEXT-2,a3
	move.l te_ptext(a1),a4

.reconstruit_texte_editable:
	lea 2(a3),a3

	tst.b 1(a3)
	beq.s .plus_de_texte_dispo

	cmp.b #'_',1(a3)		; marque d'emplacement d'un texte editable
	bne.s .reconstruit_texte_editable

	tst.b (a4)
	beq.s .plus_de_texte_editable_dispo

	move.b (a4)+,1(a3)
	move.b #1,(a3)		; ce caractre est ditable

	tst.b (a4)
	bne.s .reconstruit_texte_editable

	lea 2(a3),a3

.plus_de_texte_editable_dispo:
	lea -2(a3),a5

.recherche_pos_curs:
	lea 2(a5),a5
	tst.b 1(a5)
	beq.s .plus_de_texte_dispo
	cmp.b #'_',1(a5)
	bne.s .recherche_pos_curs
	move.l a5,a3
.plus_de_texte_dispo:

	sub.l #GWVA_WFORM_OBJ_INTERMEDIAIRE_TEXT,a3
	move.w a3,d0
	asr.w #1,d0		; position du curseur dans le champ texte
	
	sub.l te_ptext(a1),a4
	move.w a4,d1	; position du curseur dans le champ editable

	lea GWVA_WFORM_OBJ_INTERMEDIAIRE_TEXT-2,a3
.calcul_longueur_texte:
	lea 2(a3),a3
	tst.b 1(a3)
	bne.s .calcul_longueur_texte

	sub.l #GWVA_WFORM_OBJ_INTERMEDIAIRE_TEXT,a3
	move.w a3,d2
	asr.w #1,d2		; longueur du texte

	rts

 BSS
GWVA_WFORM_OBJ_INTERMEDIAIRE_TEXT:	ds.b 256+2
 TEXT

;------------------------------------------------------------------------------
