	DATA

GWVA_FPROGRESS_BAR_DEFAULT_METHODLIST:
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_FPROGRESS_BAR_SET_PERCENT,GWVA_FPROGRESS_BAR_PRG_SET_PERCENT
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_FPROGRESS_BAR_UPDATE_PERCENT,GWVA_FPROGRESS_BAR_PRG_UPDATE_PERCENT
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_FPROGRESS_BAR_REDRAW,GWVA_FPROGRESS_BAR_PRG_REDRAW
	GWVA_OBJ_STRUCT_METHOD_END_LIST

	TEXT
;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_FPROGRESS_BAR_SET_PERCENT
; Asm label   : GWVA_FPROGRESS_BAR_PRG_SET_PERCENT
; Description : Mthode pour mettre  jour le pourcentage de l'objet sans redraw
;
; in  : a0.l = pointeur sur l'objet progress bar
; in  : d0.w = pourcentage
; out : d6.w = GWVA_PRGRET_CONSUMED
;
; 14/03/98 : Cration
;------------------------------------------------------------------------------
GWVA_FPROGRESS_BAR_PRG_SET_PERCENT:
	move.w d0,GWVA_FPROGRESS_OBJ_PERCENT(a0)
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_FPROGRESS_BAR_UPDATE_PERCENT
; Asm label   : GWVA_FPROGRESS_BAR_PRG_UPDATE_PERCENT
; Description : Mthode pour mettre  jour le pourcentage de l'objet avec redraw
;
; in  : a0.l = pointeur sur l'objet progress bar
; in  : a1.l = pointeur sur la fentre formulaire contenant l'objet
; in  : d0.w = pourcentage
; out : d6.w = GWVA_PRGRET_CONSUMED
;
; 14/03/98 : Cration
;------------------------------------------------------------------------------
GWVA_FPROGRESS_BAR_PRG_UPDATE_PERCENT:
	cmp.w GWVA_FPROGRESS_OBJ_PERCENT(a0),d0	; en fait c'est pas terrible
	beq.s .no_change			; si la fois d'avant on a chang sans redrawer
					; et que l c'est la mme valeur : pas de redraw !!

	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS #GWVA_METHOD_FPROGRESS_BAR_SET_PERCENT

	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS #GWVA_METHOD_FPROGRESS_BAR_REDRAW

.no_change:	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_FPROGRESS_BAR_REDRAW
; Asm label   : GWVA_FPROGRESS_BAR_PRG_REDRAW
; Description : Mthode pour mettre  jour le pourcentage de l'objet sans redraw
;
; in  : a0.l = pointeur sur l'objet progress bar
; in  : a1.l = pointeur sur la fentre formulaire contenant l'objet
; out : d6.w = GWVA_PRGRET_CONSUMED
;
; 14/03/98 : Cration
;------------------------------------------------------------------------------
GWVA_FPROGRESS_BAR_PRG_REDRAW:

	save.l a0-a1
	lea 0.w,a3
	move.w GWVA_WRSC_OBJ_TREE(a1),d0
	move.w GWVA_FPROGRESS_OBJ_TEXT_IDX(a0),d1
	beq.s .no_text
	bsr GWVA_RSC_RETURN_PTR_ON_TEXT
	move.l a1,a3
.no_text:	load.l a0-a1

	move.l GWVA_WRSC_OBJ_TREE_PTR(a1),a2

	move.w GWVA_FPROGRESS_OBJ_BAR_FATHER_IDX(a0),d1
	mulu #L_OBJECT,d1
	move.w GWVA_FPROGRESS_OBJ_BAR_SON_IDX(a0),d2
	mulu #L_OBJECT,d2

	move GWVA_FPROGRESS_OBJ_PERCENT(a0),d3
	tst d3
	bmi.s .infinite
	cmp.w #100,d3
	ble.s .correct

.infinite:	cmp.l #0,a3
	beq.s .notxt
	move.w #'oo',(a3)
	clr.b 2(a3)
.notxt:	tst d1
	beq.s .father_0
	move ob_width(a2,d1.w),ob_width(a2,d2.w)
.father_0:
	bra.s .done

.correct:	tst d1
	beq.s .father_02
	mulu ob_width(a2,d1.w),d3
	divu #100,d3
	move d3,ob_width(a2,d2.w)
.father_02:

	cmp.l #0,a3
	beq.s .no_txt2
	save.l a0-a1
	clr.l d0
	move GWVA_FPROGRESS_OBJ_PERCENT(a0),d0	; valeur
	move.l a3,a1			; chaine
	bsr GWVA_STOCK_DECI
	load.l a0-a1
.no_txt2:
.done:
	; redraw

	save.l a1
	lea GWVA_WFORM_PROGRESS_BAR_TMP_LIST,a1
	beq.s .no_text3
	move.w GWVA_FPROGRESS_OBJ_TEXT_IDX(a0),(a1)+
	move #7,(a1)+
.no_text3:	move.w GWVA_FPROGRESS_OBJ_BAR_FATHER_IDX(a0),(a1)+
	move #7,(a1)+
	move.w #GWVA_WRSC_CTE_REDRAW_PART_END_LIST,(a1)
	load.l a1
	move.l a1,a0
	lea GWVA_WFORM_PROGRESS_BAR_TMP_LIST,a1
	GWVA_CALL_METHOD_OTHER_OBJ	#GWVA_METHOD_WRSC_REDRAW_PART_CONTENTS

*	move d0,d2
*
*	move.w GWVA_FORM_PROGRESS_OBJ_TEXT_IDX(a1),d0
*	beq.s .no_txt3
*	moveq #7,d1
*	save.l d2/a1
*	bsr GWVA_FORM_WIND_OBJ_PRG_REDRAW_PART
*	load.l d2/a1
*.no_txt3:
*	move.w GWVA_FORM_PROGRESS_OBJ_GRAPHIC_FIDX(a1),d0
*	beq.s .no_phix3
*	moveq #7,d1
*	bsr GWVA_FORM_WIND_OBJ_PRG_REDRAW_PART
*.no_phix3:

	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

 BSS
GWVA_WFORM_PROGRESS_BAR_TMP_LIST:	ds.w 2*2+1
 TEXT
