	DATA

GWVA_MENU_DEFAULT_METHODLIST:
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_CREATE,GWVA_MENU_PRG_CREATE
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_DELETE,GWVA_MENU_PRG_DELETE
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_OPEN,GWVA_MENU_PRG_OPEN
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_CLOSE,GWVA_MENU_PRG_CLOSE
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_KEYPRESS,GWVA_MENU_PRG_KEYPRESS

	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_MENU_SELECT,GWVA_MENU_PRG_MENU_SELECT
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_MENU_CHECK,GWVA_MENU_PRG_MENU_CHECK

	ifd MDL_WIND_MENU
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WM_REDRAW,GWVA_MENU_PRG_WM_REDRAW
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_MENU_UPDATE,GWVA_MENU_PRG_UPDATE
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_MENU_CLICK,GWVA_MENU_PRG_CLICK
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_MENU_REDRAW_ALL_CONTENTS,GWVA_MENU_PRG_REDRAW_ALL_CONTENTS

	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_MENU_MZONE_TITLE,GWVA_MENU_PRG_MZONE_TITLE
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_MENU_ITEM_SELECTED,GWVA_MENU_PRG_ITEM_SELECTED
	endc	; ifd MDL_WIND_MENU

	GWVA_OBJ_STRUCT_METHOD_END_LIST

	TEXT

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_MENU_CHECK
; Asm label   : GWVA_MENU_PRG_MENU_CHECK
; Description : Gestion de la marque de check
;
; Rq  : Pas de ON_ ni de ED
;
; in  : a0.l = pointeur sur un objet menu
; in  : d0.w = mode d'activation
;	   GWVA_MENU_CTE_UNCHECK
;	   GWVA_MENU_CTE_CHECK
;	   GWVA_MENU_CTE_CHANGE_CHECK
;	   GWVA_MENU_CTE_TEST_CHECK
; in  : d1.w = index de l'item  checker
; out : d6.w = GWVA_PRGRET_CONSUMED
; out : d7.w = tat du check avant
;	   GWVA_MENU_CTE_UNCHECK
;	   GWVA_MENU_CTE_CHECK
; 02/05/98 : Cration
;------------------------------------------------------------------------------
GWVA_MENU_PRG_MENU_CHECK:
; pas de before
	;-----------------------------------;

	move.l GWVA_RSC_OBJ_TREE_PTR(a0),a1
	move.w d1,d2
	mulu #L_OBJECT,d2
	move.w ob_state(a1,d2.l),d2	; ancien tat

	cmp.w #GWVA_MENU_CTE_CHANGE_CHECK,d0
	bne.s .no_change_check

	move.w d2,d0
	and.w #MASK_CHECKED,d0
	eor.w #MASK_CHECKED,d0	; inversion du bit
	lsr.w #CHECKED,d0	; en bit 0
.no_change_check:

	cmp.w #GWVA_MENU_CTE_TEST_CHECK,d0
	beq.s .test_check

	save.l a0/d2
	menu_icheck GWVA_RSC_OBJ_TREE_PTR(a0),d1,d0
	load.l a0/d2

.test_check:
	move.w d2,d7
	and.w #MASK_CHECKED,d7
	lsr.w #CHECKED,d7	; en bit 0

	;-----------------------------------;
; pas d'after

	move.w #GWVA_PRGRET_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_KEYPRESS
; Asm label   : GWVA_MENU_PRG_KEYPRESS
; Description : traitement d'une touche pour un menu
;
; Rq  : Appel par l'objet fentre lorsqu'il reoit un evnt_keyb
; Rq  : recherche d'activation d'un menu par shortcut et renvoie si trouv ou non
;
; in  : a0.l = pointeur objet menu
; in  : d0.w = Key code
; in  : d1.w = Key state
; out : d6.w = GWVA_PRGRET_NOT_CONSUMED ou GWVA_PRGRET_CONSUMED
;
; 25/01/98 : Cration
;------------------------------------------------------------------------------
GWVA_MENU_PRG_KEYPRESS:
	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_KEYPRESS
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq .pas_menu_keypress_car_on_menu_keypress

	;-----------------------------------;

	; tous les paramtres sont bons

	save.l d0-d1/a0
	bsr GWVA_MENU_EXEC_MENU_ROUTINE_FROM_KC
	load.l d0-d1/a0

	cmp.w #GWVA_ERROR_GENERIC,d7
	beq.s .not_found_in_menu_nor_sub_menu

	;-----------------------------------;

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_KEYPRESSED

.pas_menu_keypress_car_on_menu_keypress:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.not_found_in_menu_nor_sub_menu:
	moveq #GWVA_PRGRET_NOT_CONSUMED,d6
	rts

	ifd MDL_WIND_MENU

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_MENU_ITEM_SELECTED
; Asm label   : GWVA_MENU_PRG_ITEM_SELECTED
; Description : Mthode appele par la fentre popup lors d'une slection d'un item
;
; Rq  : Pas de ON_ ni de ED
;
; in  : a0.l = pointeur sur l'objet
; in  : d0.w = index de l'objet slectionn
; out : d6.w = GWVA_PRGRET_CONSUMED
;
; 16/08/98 : Cration
;------------------------------------------------------------------------------
GWVA_MENU_PRG_ITEM_SELECTED:
; pas de before

	;-----------------------------------;

	lea GWVA_MENU_MSG_BUF,a1
	move.w #MN_SELECTED,bmsg_msgid(a1)
	move.w global+_AESapid,bmsg_apid(a1)
	clr.w bmsg_extd(a1)
	move.w GWVA_MENU_OBJ_TITLE_SELECTED(a0),bmsg_menu_title(a1)
	move.w d0,bmsg_menu_item(a1)
	move.l GWVA_RSC_OBJ_TREE_PTR(a0),bmsg_menu_tree(a1)
	move.w GWVA_MENU_OBJ_DROPDOWN_LIST_SELECTED(a0),bmsg_menu_parent_item(a1)

	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS #GWVA_METHOD_MENU_SELECT

	;-----------------------------------;
; pas d'after

	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_MENU_MZONE_TITLE
; Asm label   : GWVA_MENU_PRG_MZONE_TITLE
; Description : Gestion de la sortie du title du menu et de l'entre dans le menu
;
; Rq  : Pas de ON_ ni de ED
;
; in  : a0.l = pointeur sur l'objet
; in  : d0.w = x souris
; in  : d1.w = y souris
; in  : d2.l = [ Key state.w | mouse button.w ]
; out : d6.w = GWVA_PRGRET_CONSUMED
;
; 14/08/98 : Cration
;------------------------------------------------------------------------------
GWVA_MENU_PRG_MZONE_TITLE:
; pas de before

	;-----------------------------------;

	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS	#GWVA_METHOD_MENU_UPDATE

	;--------------------

*	save.w d0-d1
*	clr.l d0
*	bsr GWVA_ROOT_UNREGISTER_MOUSE_ZONE
*	load.w d0-d1

; On doit d'abord tester l'arbre des fleches

*	save.l d0-d1/a0
*	objc_find #GWVA_ROOT_MENU_TREE_ARROWS,#0,#7,d0,d1
*	move.w d0,d2
*	load.l d0-d1/a0

*	tst d2
*	bmi .pas_objet_arrows

; Sur les flches : fermeture de la dropdown list et title en video normale

*	save.l a0
*	lea GWVA_MENU_TMP_MENU_OPEN_OBJECT,a0
*	bsr GWVA_WIND_DELETE_ONE_WIND
*	load.l a0

*	move.l GWVA_RSC_OBJ_TREE_PTR(a0),a2
*	move.w GWVA_MENU_OBJ_TITLE_SELECTED(a0),d0
*	mulu #L_OBJECT,d0
*	move.w GWVA_MENU_OBJ_TITLE_SELECTED_STATE(a0),d1
*	move.w d1,ob_state(a2,d0.l)
*	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS #GWVA_METHOD_MENU_REDRAW_ALL_CONTENTS

*	move.l GWVA_OBJ_FATHER_PTR(a0),a1	; fenetre contenant le menu
*	clr.w d0
*	bftst GWVA_WIND_OBJ_STATUS(a1){GWVA_WIND_OLBIT_UNTOPPABLE:1}
*	beq.s .pas_untoppable
*	bset #B_UNTOPPABLE,d0
*.pas_untoppable:
	
*	save.l a0
*	move.w d0,int_in+2*2
*	wind_set GWVA_WIND_OBJ_GEM_HANDLE(a1),#WF_BEVENT
*	load.l a0

*	bra .fin_mouse_zone_title

.pas_objet_arrows:

; Attention : on a raccourci l'objet menu  la fenetre et si on recherche dans un menu
; qui depasse de la fenetre, on ne trouve aucun objet ....
; On augmente donc la taille du root  la taille du bureau.

	save.l d0-d1/a0
	objc_find GWVA_RSC_OBJ_TREE_PTR(a0),#0,#7,d0,d1		; dans le menu ? (on a mis le hide tree sur l'objet dropdown -> on aura aucune info sur les objets aprs ce hidetree)
	move.w d0,d2
	load.l d0-d1/a0

	tst.w d2
	bmi .pas_dans_menu_bar

	save.w d0-d1

; Dans le menu mais pas dans la dropdown ouverte

	move.l GWVA_RSC_OBJ_TREE_PTR(a0),a2

	move.w d2,d0
	move.w d2,d1
	mulu #L_OBJECT,d1
	cmp.b #G_TITLE,ob_type+1(a2,d1.l)
	bne .pas_objet_titre

	cmp.w GWVA_MENU_OBJ_TITLE_SELECTED(a0),d0
	beq.s .dans_le_meme_title

	btst #DISABLED,ob_state+1(a2,d1.l)
	beq .objet_titre_pas_disable

; On est sur un titre DISABLE : on laisse le menu ouvert mais on definie une zone autour de ce title

.dans_le_meme_title:

 	move.w #MO_LEAVE,d1
	move.l #GWVA_METHOD_MENU_MZONE_TITLE,a1
	bsr GWVA_MENU_SET_OBJECT_MZONE

	load.w d0-d1

	bra .fin_mouse_zone_title

.objet_titre_pas_disable:

; On doit fermer le menu, et slectionner le nouveau
; d0.w : numro du nouvel objet title

	save.l d0/a0
	lea GWVA_MENU_TMP_MENU_OPEN_OBJECT,a0
*	bsr GWVA_WIND_DELETE_ONE_WIND
	GWVA_CALL_METHOD_OTHER_OBJ	#GWVA_METHOD_DELETE
	load.l d0/a0

*	save.w d0
*	move.l GWVA_RSC_OBJ_TREE_PTR(a0),a2
*	move.w GWVA_MENU_OBJ_TITLE_SELECTED(a0),d0
*	mulu #L_OBJECT,d0
*	move.w GWVA_MENU_OBJ_TITLE_SELECTED_STATE(a0),d1
*	move.w d1,ob_state(a2,d0.l)
*	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS #GWVA_METHOD_MENU_REDRAW_ALL_CONTENTS
*	load.w d0

	bsr GWVA_MENU_CLICK_IN_MENU_TITLE

	load.w d0-d1
	bra .fin_mouse_zone_title

.pas_objet_titre:
	load.w d0-d1

; On est dans la menu bar, mais pas dans un titre : on va dfinir une zone autour de la souris
; sans fermer le menu

	lea GWVA_ROOT_TMP_MOUSE_ZONE_XYWH,a1
	move.w d0,(a1)+
	move.w d1,(a1)+
	move.w #1,(a1)+
	move.w #1,(a1)+
	move.w #MO_LEAVE,d1
	move.l #GWVA_METHOD_MENU_MZONE_TITLE,d0
	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS #GWVA_METHOD_REGISTER_MOUSE_ZONE

	bra .fin_mouse_zone_title

.pas_dans_menu_bar:

; On dfinit une zone d'entre autour du menu

	save.l a0
	move.l GWVA_OBJ_FATHER_PTR(a0),a0
	bsr GWVA_WIND_RETURN_INT_ABS_POS_SIZE
	sub GWVA_WIND_OBJ_MENU_HEIGHT(a0),d1
	move.w GWVA_WIND_OBJ_MENU_HEIGHT(a0),d3
	load.l a0

	lea GWVA_ROOT_TMP_MOUSE_ZONE_XYWH,a1
	movem.w d0-d3,(a1)
	move.w #MO_ENTER,d1
	move.l #GWVA_METHOD_MENU_MZONE_TITLE,d0
	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS #GWVA_METHOD_REGISTER_MOUSE_ZONE

.fin_mouse_zone_title:

	;-----------------------------------;
; pas d'after

	move.w #GWVA_PRGRET_CONSUMED,d6
	rts


;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_MENU_REDRAW_ALL_CONTENTS
; Asm label   : GWVA_MENU_PRG_REDRAW_ALL_CONTENTS
; Description : Mthode demandant le redessin du menu
;
; Rq  : Pas de ON_REDRAW ni de REDRAWN
;
; in  : a0.l = pointeur sur la fentre menu
; out : d6.w = GWVA_PRGRET_CONSUMED
; out : d7.w = GWVA_NO_ERROR_GENERIC ou GWVA_ERROR_ROOT_APPL_WRITE_FAILED si
;	   le message n'a pu tre dlivr
;
; 22/03/98 : Cration
;------------------------------------------------------------------------------
GWVA_MENU_PRG_REDRAW_ALL_CONTENTS:
; pas de before

	;-----------------------------------;

	save.l a0

	move.l GWVA_OBJ_FATHER_PTR(a0),a0
	bsr GWVA_WIND_RETURN_INT_ABS_POS_SIZE
	sub GWVA_WIND_OBJ_MENU_HEIGHT(a0),d1
	move.w GWVA_WIND_OBJ_MENU_HEIGHT(a0),d3

	swap d2
	move.w d3,d2
	GWVA_CALL_METHOD_OTHER_OBJ #GWVA_METHOD_WIND_REDRAW_PART_CONTENTS

	load.l a0

	;-----------------------------------;
; pas d'after

	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_MENU_CLICK
; Asm label   : GWVA_MENU_PRG_CLICK
; Description : traitement du click dans la barre du menu d'une fentre
;
; Rq  : Appel par l'objet fentre lorsqu'il reoit un evnt_buton
;
; in  : a0.l = pointeur objet menu
; in  : d0.l = [ X.w | handle fentre gem.w ]
; in  : d1.l = [ mouse button.w | Y.w ]
; in  : d2.l = [ Key state.w | mouse count.w ]
; out : d6.w = GWVA_PRGRET_NOT_CONSUMED ou GWVA_PRGRET_CONSUMED
;
; 21/03/98 : Cration
;------------------------------------------------------------------------------
GWVA_MENU_PRG_CLICK:
	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_MENU_CLICK
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq .pas_menu_click_car_on_menu_click

	;-----------------------------------;

	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS	#GWVA_METHOD_MENU_UPDATE

	;--------------------

	swap d0

	save.l d0-d2/a0
	objc_find #GWVA_ROOT_MENU_TREE_ARROWS,#0,#2,d0,d1
	move.w d0,d3
	load.l d0-d2/a0

	tst.w d3
	bmi.s .not_in_arrow

	move.w d3,d4
	mulu #L_OBJECT,d4
	lea GWVA_ROOT_MENU_TREE_ARROWS,a2
	cmp.b #G_BOXCHAR,ob_type+1(a2,d4.l)	; a-t-on cliqu dans une flche
	bne.s .not_in_arrow		; et non dans la partie OUTLINED de l'objet pre
	save.l d0-d2/a0
	move.w d3,d0
	bsr GWVA_MENU_CLICK_IN_ARROWS
	load.l d0-d2/a0
	bra.s .click_consomme_par_fleches

.not_in_arrow:
	save.l d0-d2/a0
	objc_find GWVA_RSC_OBJ_TREE_PTR(a0),#0,#7,d0,d1
	move.w d0,d3
	load.l d0-d2/a0

	tst d3
	bmi.s .not_in_menu

	move.w d3,d4
	mulu #L_OBJECT,d4
	move.l GWVA_RSC_OBJ_TREE_PTR(a0),a2
	cmp.b #G_TITLE,ob_type+1(a2,d4.l)
	bne.s .not_in_title

	btst #DISABLED,ob_state+1(a2,d4.l)
	bne .title_off

	save.l d0-d2/a0
	move.w d3,d0
	bsr GWVA_MENU_CLICK_IN_MENU_TITLE
	load.l d0-d2/a0
.title_off:
	bra.s .click_consomme_par_menu

.not_in_title:
.not_in_menu:
	bra.s .click_not_consumed
	;-----------------------------------;
.click_consomme_par_fleches:
.click_consomme_par_menu:

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_MENU_CLICKED

.pas_menu_click_car_on_menu_click:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts
.click_not_consumed:
	moveq #GWVA_PRGRET_NOT_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WM_REDRAW
; Asm label   : GWVA_MENU_PRG_WM_REDRAW
; Description : Mthode de redessin d'une partie du contenu du menu
;
; in  : a0.l = pointeur sur le menu
; in  : a1.l = pointeur sur le buffer message reu du GEM
; in  : a2.l = pointeur sur le buffer GEM tendu s'il y en avait un prsent ou 0.l sinon
; in  : d0.w = x
; in  : d1.w = y
; in  : d2.l = [ width.w | height.w ] de la zone  redessiner
; out : d6.w = GWVA_PRGRET_CONSUMED
;
; 04/08/98 : Cration
;------------------------------------------------------------------------------
GWVA_MENU_PRG_WM_REDRAW:
	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_WM_REDRAW
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq .pas_redraw_car_on_redraw_consome

	;-----------------------------------;
; On remet le ressource  sa place dans la fentre

	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS	#GWVA_METHOD_MENU_UPDATE

	save.l d0-d2/a0-a2
	;-----------------------------------;

	move.w d2,d3
	swap d2

	save.l d0-d3/a0
	bsr GWVA_ROOT_HIDE_MOUSE
	movem.l (sp),d0-d3/a0
	objc_draw GWVA_RSC_OBJ_TREE_PTR(a0),#0,#4,d0,d1,d2,d3
	movem.l (sp),d0-d3/a0
	objc_draw #GWVA_ROOT_MENU_TREE_ARROWS,#0,#2,d0,d1,d2,d3
	bsr GWVA_ROOT_SHOW_MOUSE
	load.l d0-d3/a0

	;-----------------------------------;

	load.l d0-d2/a0-a2

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_WM_REDRAWN

.pas_redraw_car_on_redraw_consome:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_MENU_UPDATE
; Asm label   : GWVA_MENU_PRG_UPDATE
; Description : Met  jour la position du menu et son contenu dans le cas
;	    d'un multi-menu
;
; Rq  : -
;
; in  : a0.l = pointeur objet menu
; out : d6.w = GWVA_PRGRET_CONSUMED
;
; 22/03/98 : Cration
;------------------------------------------------------------------------------
GWVA_MENU_PRG_UPDATE:
	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_MENU_UPDATE
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq .pas_menu_update_car_on_menu_update

	;-----------------------------------;

	ifd MDL_WIND_MENU_CLONING

	bsr GWVA_MENU_UPDATE_MULTI_RSC

	endc	; ifd MDL_WIND_MENU_CLONING

	move.l GWVA_OBJ_FATHER_PTR(a0),a1

	lea GWVA_ROOT_MENU_TREE_ARROWS,a2
	clr.l ob_x(a2)		; objet root des flches

	save.l a0-a2
	move.l a2,a0
	clr.w d0
	bsr GWVA_RSC_RETURN_OBJ_POS_SIZE
	load.l a0-a2
	neg.w d0
	neg.w d1
	movem.w d0-d1,ob_x(a2)		; on place les flches de faon  voir les scultures

	move.l GWVA_RSC_OBJ_TREE_PTR(a0),a3
	clr.l ob_x(a3)		; objet root du menu
	clr.w ob_width(a3)		; 

	save.l a0-a3
	move.l a3,a0
	clr.w d0
	bsr GWVA_RSC_RETURN_OBJ_POS_SIZE
	load.l a0-a3
	neg.w d0
	neg.w d1
	movem.w d0-d1,ob_x(a3)

	save.l a0-a2
	move.l a1,a0
	bsr GWVA_WIND_RETURN_INT_ABS_POS_SIZE
	load.l a0-a2
	move.w GWVA_WIND_OBJ_MENU_HEIGHT(a1),d3
	sub.w d3,d1		; -> d0-d3 position absolue o placer le menu

	add.w d0,ob_x(a2)
	add.w d1,ob_y(a2)		; positionne les fleches au bord de l'intrieur de la fentre
	add.w d0,ob_x(a3)
	add.w d1,ob_y(a3)		; positionne le ROOT du menu
	move.w d2,ob_width(a3)		; taille du root du menu

	save.l a0-a3
	move.l a2,a0
	clr.w d0
	bsr GWVA_RSC_RETURN_OBJ_POS_SIZE
	load.l a0-a3
	add.w d2,d0		; position x juste aprs les flches
	move.w ob_x(a3),d1	; position du root
	sub.w d1,d0		; correction  apporter pour placer le root aprs les flches
	add.w d0,ob_x(a3)
	sub.w d0,ob_width(a3)	; correction de la taille du root

; positionnement des titles (objet BAR)

	move.w ob_head(a3),d1		; premier fils de l'objet Root
	move.w ob_tail(a3),d2		; deuxieme fils de l'objet Root
	mulu #L_OBJECT,d1
	cmp.b #G_BOX,ob_type+1(a3,d1.l)
	beq.s .objet_bar
	move.w ob_tail(a3),d1		; autre fils de l'objet Root
	move.w ob_head(a3),d2
	mulu #L_OBJECT,d1
.objet_bar:	lea (a3,d1.l),a4		; objet bar
; a4.l : pointeur sur l'objet BAR
	mulu #L_OBJECT,d2
	lea (a3,d2.l),a5
; a5.l : pointeur sur l'objet dropdowns

	clr.w ob_x(a4)		; objet bar au dbut du root
	clr.w ob_x(a5)		; objet dropdowns au dbut du root

.recherche_le_titre:
	move.w GWVA_MENU_OBJ_SCROLL_INDEX(a0),d0	; ordinal du title le plus  gauche
	move.w ob_head(a4),d1		; d1.w : objet active = pere des G_TITLE

	save.l a0-a5
	move.l a3,a0
	bsr GWVA_RSC_FIND_SON_OBJECT_FROM_ORDINAL	; il exite forcement ?
	load.l a0-a5
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	beq.s .fils_trouve
	clr.w GWVA_MENU_OBJ_SCROLL_INDEX(a0)	; si l'utilisateur a mis un chiffre fantaisiste
	bra.s .recherche_le_titre
.fils_trouve:

	save.l a0-a5
	move.l a3,a0
	bsr GWVA_RSC_RETURN_OBJ_POS_SIZE
	load.l a0-a5
; -> d0.w = position actuelle du titre devant devenir le plus  gauche

	save.l d0/a0-a5
	move.l a3,a0
	clr.w d0
	bsr GWVA_RSC_RETURN_OBJ_POS_SIZE
	move.w d0,d1
	load.l d0/a0-a5

	sub.w d1,d0		; d0.w = dcalage  effectu sur l'objet BAR et dropdown
	sub.w d0,ob_x(a4)	; on dcale l'objet BAR de ce qu'il faut
	sub.w d0,ob_x(a5)	; on dcale l'objet dropdown de ce qu'il faut

	bset #DISABLED,(a2,L_OBJECT*1+ob_state+1)	; on grise la fleche gauche si besoin
	tst.w GWVA_MENU_OBJ_SCROLL_INDEX(a0)
	beq.s .fleche_gauche_indisponible
	bclr #DISABLED,(a2,L_OBJECT*1+ob_state+1)
.fleche_gauche_indisponible:

; meme chose pour la fleche droite ?

; la taille de l'objet BAR est celle de l'objet ROOT
	move.w ob_width(a3),ob_width(a4)
	move.w ob_x(a4),d0
	sub.w d0,ob_width(a4)	;  la taille de la fentre

	;-----------------------------------;

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_MENU_UPDATED

.pas_menu_update_car_on_menu_update:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

	endc	; ifd MDL_WIND_MENU

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_MENU_SELECT
; Asm label   : GWVA_MENU_PRG_MENU_SELECT
; Description : gestion d'un vnement mnu_selected
;
; Rq  : -
;
; in  : a0.l = pointeur objet menu
; in  : a1.l = pointeur sur le buffer message GEM
; out : d6.w = GWVA_PRGRET_NOT_CONSUMED ou GWVA_PRGRET_CONSUMED
; out : d7.w = GWVA_NO_ERROR_GENERIC ou erreur
;
; 01/08/98 : Cration
;------------------------------------------------------------------------------
GWVA_MENU_PRG_MENU_SELECT:
	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_MENU_SELECT
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq .pas_menu_select_car_on_menu_select

	;-----------------------------------;

	save.l a0-a1

	move.w bmsg_menu_item(a1),d0	; Menu Idx
	move.l bmsg_menu_tree(a1),d1	; Tree ad.
	bsr GWVA_MENU_EXEC_MENU_ROUTINE_FROM_MENU_AD_AND_IDX

	movem.l (sp),a0-a1

	move.l GWVA_OBJ_FATHER_PTR(a0),a1
	cmp.w #GWVA_CLASS_WIND.APP,GWVA_OBJ_CLASS(a1)
	bne.s .pere_pas_objet_fenetre_app

	movem.l (sp),a0-a1

	save.w d7
	menu_tnormal GWVA_RSC_OBJ_TREE_PTR(a0),bmsg_menu_title(a1),#1	; top menu en vido normale
	load.w d7

	bra.s .fin_menu_select

.pere_pas_objet_fenetre_app:

	ifd MDL_WIND_MENU

	move.w GWVA_MENU_OBJ_TITLE_SELECTED(a0),d0
	bmi.s .no_selection

	save.w d7
	move.l GWVA_RSC_OBJ_TREE_PTR(a0),a2
	mulu #L_OBJECT,d0
	move.w ob_state(a2,d0.l),d1
	bclr #SELECTED,d1
	move.w d1,ob_state(a2,d0.l)
	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS #GWVA_METHOD_MENU_REDRAW_ALL_CONTENTS
	load.w d7

	move.w #-1,GWVA_MENU_OBJ_TITLE_SELECTED(a0)
.no_selection:
	endc	; ifd MDL_WIND_MENU

.fin_menu_select:

	load.l a0-a1

	cmp.w #GWVA_ERROR_GENERIC,d7
	beq.s .pas_menu_selected_car_erreur

	;-----------------------------------;

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_MENU_SELECTED

	moveq #GWVA_NO_ERROR_GENERIC,d7
.pas_menu_selected_car_erreur:
	moveq #GWVA_PRGRET_CONSUMED,d6
.pas_menu_select_car_on_menu_select:
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_CLOSE
; Asm label   : GWVA_MENU_PRG_CLOSE
; Description : Mthode de fermeture du menu (effacement)
;
; Rq  : Utilisation du GEM pour le menu de l'application principale.
;
; in  : a0.l = pointeur objet menu
; out : d6.w = GWVA_PRGRET_CONSUMED
; out : d7.w = GWVA_NO_ERROR_GENERIC
;
; 31/07/98 : Cration
;------------------------------------------------------------------------------
GWVA_MENU_PRG_CLOSE:
	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_CLOSE
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq .pas_close_car_on_close_consome

	;-----------------------------------;

	bftst GWVA_MENU_OBJ_STATUS(a0){GWVA_MENU_OLBIT_OPEN:1}
	beq .deja_ferme

	move.l GWVA_OBJ_FATHER_PTR(a0),a1

	cmp.w #GWVA_CLASS_WIND.APP,GWVA_OBJ_CLASS(a1)
	bne.s .pere_pas_objet_fenetre_app

; Le ptr sur le menu principal a t calcul par le CREATE.
; On ne fait aucun teste ici.

	save.l a0-a1
	wind_update #BEG_UPDATE
	movem.l (sp),a0-a1
	menu_bar GWVA_RSC_OBJ_TREE_PTR(a0),#0
	wind_update #END_UPDATE
	load.l a0-a1

	bra.s .fin_close_menu

.pere_pas_objet_fenetre_app:

	ifd MDL_WIND_MENU

	clr.l d0
	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS #GWVA_METHOD_UNREGISTER_MOUSE_ZONE

	save.l a0
	lea GWVA_MENU_TMP_MENU_OPEN_OBJECT,a0
	bsr GWVA_WIND_TEST_IF_WIND_CREATED
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne.s .pas_delete

*	bsr GWVA_WIND_DELETE_ONE_WIND
	GWVA_CALL_METHOD_OTHER_OBJ	#GWVA_METHOD_DELETE
.pas_delete:
	load.l a0

	endc	; ifd MDL_WIND_MENU

.fin_close_menu:

	bfclr GWVA_MENU_OBJ_STATUS(a0){GWVA_MENU_OLBIT_OPEN:1}

.deja_ferme:
	;-----------------------------------;

	; envoyer la mthode GWVA_METHOD_CLOSED

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_CLOSED

	moveq #GWVA_NO_ERROR_GENERIC,d7
.pas_close_car_on_close_consome:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_OPEN
; Asm label   : GWVA_MENU_PRG_OPEN
; Description : Mthode d'ouverture du menu (affichage)
;
; Rq : Utilisation du GEM pour le menu de l'application principale.
;
; in  : a0.l = pointeur objet menu
; out : d6.w = GWVA_PRGRET_CONSUMED
; out : d7.w = GWVA_NO_ERROR_GENERIC
;
; 31/07/98 : Cration
;------------------------------------------------------------------------------
GWVA_MENU_PRG_OPEN:
	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_OPEN
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq.s .pas_open_car_on_open_consome

	;-----------------------------------;

	bftst GWVA_MENU_OBJ_STATUS(a0){GWVA_MENU_OLBIT_OPEN:1}
	bne.s .deja_ouvert

	move.l GWVA_OBJ_FATHER_PTR(a0),a1

	cmp.w #GWVA_CLASS_WIND.APP,GWVA_OBJ_CLASS(a1)
	bne.s .pas_objet_fenetre_app

; Le ptr sur le menu principal a t calcul par le CREATE.
; On ne fait aucun teste ici.

	save.l a0-a1
	wind_update #BEG_UPDATE
	movem.l (sp),a0-a1
	menu_bar GWVA_RSC_OBJ_TREE_PTR(a0),#1
	wind_update #END_UPDATE
	load.l a0-a1

.pas_objet_fenetre_app:

	bfset GWVA_MENU_OBJ_STATUS(a0){GWVA_MENU_OLBIT_OPEN:1}

.deja_ouvert:

	;-----------------------------------;

	; envoyer la mthode GWVA_METHOD_OPENED

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_OPENED

	moveq #GWVA_NO_ERROR_GENERIC,d7
.pas_open_car_on_open_consome:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_DELETE
; Asm label   : GWVA_MENU_PRG_DELETE
; Description : Mthode de destruction d'un menu
;
; Rq  : -
;
; in  : a0.l = pointeur objet menu
; out : d6.w = GWVA_PRGRET_CONSUMED
;
; 31/07/98 : Cration
;------------------------------------------------------------------------------
GWVA_MENU_PRG_DELETE:
	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_DELETE
; Si on revient de cette mthode, il faut tout de mme continuer (cas exceptionel)

	;-----------------------------------;

	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS #GWVA_METHOD_CLOSE

	;-------------------------;

	ifd MDL_WIND_MENU_CLONING
	
	tst.w GWVA_RSC_OBJ_IS_CLONE_RSC(a0)
	beq.s .pas_de_clonage

	bftst GWVA_RSC_OBJ_PROPERTIES(a0){GWVA_RSC_OLBIT_FREECLONE:1}
	beq.s .pas_de_libration_automatique
	move.l GWVA_RSC_OBJ_CLONE_SAVED_RSC_PTR(a0),d0
	beq.s .pas_de_sauvegarde
	save.l a0
	MFREE d0
	load.l a0
	clr.l GWVA_RSC_OBJ_CLONE_SAVED_RSC_PTR(a0)
.pas_de_sauvegarde:
.pas_de_libration_automatique:
.pas_de_clonage:

	endc	; ifd MDL_WIND_MENU_CLONING

	;-------------

	GWVA_CALL_METHOD_INHERITED

	;-------------------------;

	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_CREATE
; Asm label   : GWVA_MENU_PRG_CREATE
; Description : Mthode de cration d'un menu
;
; Rq  : Utilisation du GEM pour le menu de l'application principale.
; Rq  : Menus attachs pour le menu de l'application principale uniquement.
; Rq  : On attache le menu  la fentre le contenant par le FATHER_PTR
;
; in  : a0.l = pointeur objet menu
; in  : a1.l = pointeur objet fentre contenant le menu
; out : d6.w = GWVA_PRGRET_CONSUMED
; out : d7.w = GWVA_NO_ERROR_GENERIC ou
; 	   GWVA_ERROR_MALLOC si erreur lors du clonage
;
; 31/07/98 : Cration
; 02/09/98 : Mise en place du clonage
;------------------------------------------------------------------------------
GWVA_MENU_PRG_CREATE:

	; On appelle la mthode CREATE de la classe mre

	GWVA_CALL_METHOD_INHERITED

	;-----------------------------------;

; On attache le menu  sa fentre mre en retour seulement

	move.l a1,GWVA_OBJ_FATHER_PTR(a0)

	;-----------------------------------;

; On stocke le pointeur sur le tree du menu

	exg.l a0,a1			; a1.l : pointeur sur la fentre menu

	move.w GWVA_RSC_OBJ_TREE(a1),d0
	save.l a0-a1
	lea GWVA_RSC_OBJ_TREE_PTR(a1),a0	; ad. tree du menu principal
	bsr GWVA_RSC_RETURN_PTR_ON_TREE
	load.l a0-a1

; On stocke la hauteur du menu

	move.l GWVA_RSC_OBJ_TREE_PTR(a1),a2
	move.w ob_head(a2),d0		; premier fils de l'objet Root
	move.w d0,d2
	mulu #L_OBJECT,d2
	cmp.w #G_BOX,ob_type(a2,d2.l)
	beq.s .objet_bar
	move.w ob_tail(a2),d0		; autre fils de l'objet Root
.objet_bar:
	save.l d0/a0-a2
	move.l a2,a0
	bsr GWVA_RSC_RETURN_OBJ_POS_SIZE
	load.l d0/a0-a2

	move.w d3,GWVA_WIND_OBJ_MENU_HEIGHT(a0)

	cmp.w #GWVA_CLASS_WIND.APP,GWVA_OBJ_CLASS(a0)
	bne .creation_menu_fenetre

	cmp.w #$330,_AESversion+global
	blt .pas_de_menu_attache_aes_insuffisant

	tst.l GWVA_MENU_OBJ_LIST_ATTACH_PTR(a1)
	beq .pas_de_sous_menu

	save.l a0-a1

	move.l GWVA_MENU_OBJ_LIST_ATTACH_PTR(a1),a1	; a1.l : pointeur sur la liste de pointeurs sur les structures SUB_MENU

.loop_ss_mn:tst.l (a1)
	beq.s .fin_liste_ss_menu

	move.l (a1)+,a2		; a2.l : pointeur sur une structure sous-menu
	move GWVA_SUB_MENU_TREE(a2),d0	; le sous-menu se trouve dans le TREE d0.w
	clr d1			; on veut l'adresse du root
	save.l a0-a2
	bsr GWVA_RSC_RETURN_PTR_ON_OBJ
	move.l a1,a4
	movem.l (sp),a0-a2

	lea GWVA_MENU_TMP_MENU_OBJ,a3
	move.l a4,mn_tree(a3)
	move.w GWVA_SUB_MENU_IDX(a2),mn_menu(a3)
	move.w GWVA_SUB_MENU_WHICH_ALIGN(a2),mn_item(a3)
	move.w GWVA_SUB_MENU_SCROLL(a2),mn_scroll(a3)
	move.w #0,mn_keystate(a3)

	move GWVA_SUB_MENU_TREE_ATTACHED(a2),d0
	clr d1
	bsr GWVA_RSC_RETURN_PTR_ON_OBJ
	move.l a1,a3
	movem.l (sp),a0-a2

	menu_attach #1,a3,GWVA_SUB_MENU_IDX_ATTACHED(a2),#GWVA_MENU_TMP_MENU_OBJ
	load.l a0-a2

	bra.s .loop_ss_mn
.fin_liste_ss_menu:
	load.l a0-a1
.pas_de_sous_menu:
.pas_de_menu_attache_aes_insuffisant:
	bra.s .fin_creation_menu_app

.creation_menu_fenetre:

	ifd MDL_WIND_MENU

	;------------

	ifd MDL_WIND_MENU_CLONING
	
; On doit cloner le ressource si ncessaire
	tst.w GWVA_RSC_OBJ_IS_CLONE_RSC(a0)
	beq.s .pas_de_clonage

	save.l a0
	move.l GWVA_RSC_OBJ_CLONE_SAVED_RSC_PTR(a0),a0
	lea 0.w,a1
	bsr GWVA_RSC_COPY_SAVED_TREE
	move.l a0,a1
	load.l a0
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne .erreur_creation_clone

	move.l a1,GWVA_RSC_OBJ_CLONE_SAVED_RSC_PTR(a0)
.pas_de_clonage:

	endc	; ifd MDL_WIND_MENU_CLONING

	;------------

	move.w d0,d2
	mulu #L_OBJECT,d2
	move.b #-1,ob_spec+1(a2,d2.l)	; on met un bord extrieur  l'objet BAR
	move.b #-1,ob_spec+1(a2)	; ainsi qu'a l'objet ROOT

	save.l d2/a0-a2
	move.l a2,a0
	bsr GWVA_RSC_RETURN_OBJ_POS_SIZE
	load.l d2/a0-a2

	move.w d3,GWVA_WIND_OBJ_MENU_HEIGHT(a0)	; hauteur du menu = hauteur de l'objet BAR avec scultures
	move.w ob_height(a2,d2.l),ob_height(a2)	; hauteur menu = hauteur de l'objet BAR sans scultures
	
; Cration du menu d'une fentre 'normale'
***; Il faut parser toutes les dropdown lists pour les positionner en tant que HIDE
; 29/03/98 : seul l'objet DROPDOWNS est positionner en tant que HIDE

; a0.l : pointeur sur l'objet fentre dont on veut crer le menu
; a1.l : pointeur sur l'objet fentre menu

	save.l a0-a1

	move.w ob_head(a2),d0		; premier fils de l'objet Root
	move.w d0,d1
	mulu #L_OBJECT,d0
	cmp.w #G_IBOX,ob_type(a2,d0.l)	; Dropdowns ?
	beq.s .objet_dropdowns
	move.w ob_tail(a2),d0		; autre fils de l'objet Root
	move.w d0,d1
.objet_dropdowns:	; -> d1.w : numro de l'objet dropdowns

	move.w GWVA_RSC_OBJ_TREE(a1),d0	; numero du tree du menu
	move.w #1,d2		; 'hide'
*	bsr GWVA_RSC_SHOW_HIDE_TREE


*	move.l GWVA_RSC_OBJ_TREE_PTR(a1),a2
*	moveq #0,d0
*
*.parse_all_dropdown_list:
*	move.l a2,a0
*	save.l d0-d1/a1-a2
*	bsr GWVA_RSC_FIND_SON_OBJECT_FROM_ORDINAL
*	move.w d0,d2	; index de la dropdown list + a0.l : pointeur sur cette liste
*	load.l d0-d1/a1-a2
*	cmp.w #GWVA_NO_ERROR_GENERIC,d7
*	bne.s .on_a_fait_le_tour_des_listes
*
*	save.l d0-d1/a1-a2
*	move.w GWVA_RSC_OBJ_TREE(a1),d0	; numero du tree du menu
*	move.w d2,d1		; index de la dropdown list
*	move.w #1,d2		; 'hide'
*	bsr GWVA_RSC_SHOW_HIDE_TREE
*	load.l d0-d1/a1-a2
*
*	add.w #1,d0			; dropdown list suivante
*	bra.s .parse_all_dropdown_list
*
*.on_a_fait_le_tour_des_listes:

	load.l a0-a1

	endc	; ifd MDL_WIND_MENU

.fin_creation_menu_app:

	bfclr GWVA_MENU_OBJ_STATUS(a0){0:GWVA_MENU_OLBIT_OPEN+1}

	exg.l a0,a1

	;-----------------------------------;

	; envoyer la mthode GWVA_METHOD_CREATED

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_CREATED

	moveq #GWVA_NO_ERROR_GENERIC,d7
.erreur_creation_clone:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts
	

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_MENU_EXEC_MENU_ROUTINE_FROM_MENU_AD_AND_IDX
; Description : excute une routine avec l'ad du menu et l'index slectionn
;
; in  : a0.l = pointeur objet menu
; in  : a1.l = pointeur sur le buffer message GEM
; in  : d0.w = index du menu slectionn
; in  : d1.l = pointeur sur le tree contenant le menu
; out : d7.w = GWVA_NO_ERROR_GENERIC ou GWVA_ERROR_GENERIC si pas trouv
;
; 01/08/98 : Cration
;------------------------------------------------------------------------------
GWVA_MENU_EXEC_MENU_ROUTINE_FROM_MENU_AD_AND_IDX:

	tst.l d1
	beq.s .aes_inferieur_330	; pas de mot long pointant sur l'adresse du tree du menu

	cmp.l GWVA_RSC_OBJ_TREE_PTR(a0),d1
	bne.s .in_a_sub_menu

.aes_inferieur_330:
	lea GWVA_MENU_OBJ_START_LIST(a0),a3
	bra.s GWVA_MENU_EXEC_MENU_ROUTINE_FROM_MENU_IDX

.in_a_sub_menu:
	moveq #GWVA_ERROR_GENERIC,d7

	move.l GWVA_MENU_OBJ_LIST_ATTACH_PTR(a0),a4
	cmp.l #0,a4
	beq.s .pas_de_sous_menu

.recherche_sous_menu:
	move.l (a4)+,a3
	cmp.l #0,a3
	beq.s .pas_de_sous_menu

	save.l d0-d1/a0-a4
	move.w GWVA_SUB_MENU_TREE(a3),d0		; Index de l'arbre contenant le sous-menu
	lea GWVA_MENU_TMP_MENU_OBJ,a0
	bsr GWVA_RSC_RETURN_PTR_ON_TREE
	load.l d0-d1/a0-a4

	cmp.l GWVA_MENU_TMP_MENU_OBJ,d1		; est-ce le bon sous-menu ?
	bne.s .recherche_sous_menu

	save.l d0-d1/a0-a4
	lea GWVA_SUB_MENU_START_LIST(a3),a3
	bsr.s GWVA_MENU_EXEC_MENU_ROUTINE_FROM_MENU_IDX
	load.l d0-d1/a0-a4
	cmp.w #GWVA_ERROR_GENERIC,d7
	beq.s .recherche_sous_menu

.pas_de_sous_menu:
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_MENU_EXEC_MENU_ROUTINE_FROM_MENU_IDX
; Description : excute une routine depuis l'index du menu cliqu
;
; in  : a0.l = pointeur objet menu
; in  : a1.l = pointeur sur le buffer message GEM ou 0.l si pas
; in  : a3.l = pointeur sur une structure GWVA_WMENU_OBJ_MNULIST_ITEM
; in  : d0.w = index du menu slectionn
; out : d7.w = GWVA_NO_ERROR_GENERIC ou GWVA_ERROR_GENERIC si pas trouv
; 
; 24/01/98 : Cration
; 27/02/98 : Recherche des paramtres  passer  la routine utilisateur dans le
;	 cas d'une activation par shortcut
;------------------------------------------------------------------------------
GWVA_MENU_EXEC_MENU_ROUTINE_FROM_MENU_IDX:

	cmp.w #GWVA_ROOT_CTE_SHORTCUT_ENDS_LIST,GWVA_MENU_OBJ_MNULIST_ITEM_SHORTCUT(a3)
	beq .no_routine_found
	cmp.w GWVA_MENU_OBJ_MNULIST_ITEM_IDX(a3),d0
	beq.s .found
	lea GWVA_MENU_OBJ_MNULIST_STRUCT_LENGTH(a3),a3
	bra.s GWVA_MENU_EXEC_MENU_ROUTINE_FROM_MENU_IDX
.found:	tst.l GWVA_MENU_OBJ_MNULIST_ITEM_ROUTINE(a3)
	beq .no_routine_found
	move.l a3,a4		; pointeur dans la liste courante

	cmp.l #0,a1
	bne.s .gem_buffer

; on reconstruit les paramtres que l'on trouve normalement dans le buffer GEM
; - index du menu title
; - index de l'item
; - index du parent item	; AES 4.0 ??
; - adresse du tree		; AES 4.0 ??

	save.l a0-a4
	move.l GWVA_RSC_OBJ_TREE_PTR(a0),a0
	save.l a0
	bsr GWVA_RSC_FIND_FATHER_OBJECT		; <- d0 : numro du fils
	move.w d0,d2			; index du Parent-item
	move.l (sp),a0
	save.w d0/d2
	bsr GWVA_RSC_FIND_FATHER_OBJECT		; <- d0 : numro du fils
	move.w d0,d1			; index de la Dropdown list
	load.w d0/d2
	load.l a0
	save.w d2
	bsr GWVA_RSC_FIND_ORDINAL_SON_OBJECT	; <- d0:fils, d1:pre, -> d0 : ordinal
	load.w d2
	load.l a0-a4
	
	save.l d2/a0-a4
	save.w d0
	move.l GWVA_RSC_OBJ_TREE_PTR(a0),a0	;
	move.w ob_head(a0),d0		; premier fils de l'objet Root
	move.w d0,d1
	mulu #L_OBJECT,d0
	cmp.w #G_BOX,ob_type(a0,d0.l)	; Dropdowns ?
	beq.s .objet_bar
	move.w ob_tail(a0),d1		; autre fils de l'objet Root
.objet_bar:				; -> d1.w : numro de l'objet bar
	mulu #L_OBJECT,d1
	move.w ob_head(a0,d0.l),d1	; objet active
	load.w d0
	bsr GWVA_RSC_FIND_SON_OBJECT_FROM_ORDINAL	; -> d0 : index du title correspondant  la dropdownlist
	load.l d2/a0-a4

	move.w GWVA_MENU_OBJ_MNULIST_ITEM_IDX(a3),d1
	move.l GWVA_RSC_OBJ_TREE_PTR(a0),a3

	bra.s .no_gem_buffer

.gem_buffer:
	move.w bmsg_menu_title(a1),d0		; Top menu slectionn
	move.w bmsg_menu_item(a1),d1		; Menu-item Idx

	save.l d0-d1/a0-a4
	move.l GWVA_RSC_OBJ_TREE_PTR(a0),a0
	move.w d0,d1
	bsr GWVA_RSC_FIND_FATHER_OBJECT		; <- d0 : numro du fils
	move.w d0,d2			; index du Parent-item
	load.l d0-d1/a0-a4

	move.l GWVA_RSC_OBJ_TREE_PTR(a0),a3

*	move.w bmsg_menu_parent_item(a1),d2		; Menu Idx
*	move.l bmsg_menu_tree(a1),a3		; Tree ad.
.no_gem_buffer:
	save.l a0/a2
	move.l a1,a2
	move.l GWVA_OBJ_FATHER_PTR(a0),a1
	jsr ([a4,GWVA_MENU_OBJ_MNULIST_ITEM_ROUTINE])	;
	moveq #GWVA_NO_ERROR_GENERIC,d7
	load.l a0/a1
	rts
.no_routine_found:
	moveq #GWVA_ERROR_GENERIC,d7
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_MENU_EXEC_MENU_ROUTINE_FROM_KC
; Description : recherche et xcution d'une routine en fonction d'une touche
;
; in  : a0.l = pointeur objet menu
; in  : d0.w = Key code
; in  : d1.w = Key state
; out : d7.w = GWVA_NO_ERROR_GENERIC ou GWVA_ERROR_GENERIC si pas trouv
;
; 25/01/98 : Cration
;------------------------------------------------------------------------------

GWVA_MENU_EXEC_MENU_ROUTINE_FROM_KC:

	save.l d0-d1/a0
	lea GWVA_MENU_OBJ_START_LIST(a0),a0
	moveq #GWVA_MENU_OBJ_MNULIST_STRUCT_LENGTH,d2
	bsr GWVA_ROOT_RETURN_ITEMLIST_PTR_FROM_KC	; -> a0.l sur structure et d7
	move.l a0,a2
	load.l d0-d1/a0
	cmp.w #GWVA_ERROR_GENERIC,d7
	beq.s .cherche_dans_sous_menu

	move GWVA_MENU_OBJ_MNULIST_ITEM_IDX(a2),d0
	move d0,d2
	mulu #L_OBJECT,d2
	btst #DISABLED,([a0,GWVA_RSC_OBJ_TREE_PTR],d2.l,ob_state+1)
	bne.s .item_menu_disabled	; un short-cut ne peut pas slectionner un menu DISABLED

	move.l a2,a3		; il est dj bien positionn
	lea 0.w,a1			; pas de buffer message GEM
	bra GWVA_MENU_EXEC_MENU_ROUTINE_FROM_MENU_IDX

.cherche_dans_sous_menu:
	move.l GWVA_MENU_OBJ_LIST_ATTACH_PTR(a0),a2
	cmp.l #0,a2
	beq.s .pas_de_sous_menu

.recherche_sous_menu:
	move.l (a2)+,a3
	cmp.l #0,a3
	beq.s .pas_de_sous_menu

	save.l d0-d1/a0/a2-a3
	lea GWVA_SUB_MENU_START_LIST(a3),a0
	moveq #GWVA_MENU_OBJ_MNULIST_STRUCT_LENGTH,d2
	bsr GWVA_ROOT_RETURN_ITEMLIST_PTR_FROM_KC
	move.l a0,a4
	load.l d0-d1/a0/a2-a3
	cmp.w #GWVA_ERROR_GENERIC,d7
	beq.s .recherche_sous_menu

	save.l a0/a4
	move.w GWVA_SUB_MENU_TREE_ATTACHED(a3),d0
	lea GWVA_MENU_TMP_MENU_OBJ,a0
	bsr GWVA_RSC_RETURN_PTR_ON_TREE
	load.l a0/a4

	move GWVA_MENU_OBJ_MNULIST_ITEM_IDX(a4),d0
	move d0,d2
	mulu #L_OBJECT,d2
	btst #DISABLED,([GWVA_MENU_TMP_MENU_OBJ.l],d2.l,ob_state+1)
	bne.s .item_menu_disabled	; un short-cut ne peut pas slectionner un menu DISABLED

	move.l a4,a3		; il est dj bien positionn
	lea 0.w,a1			; pas de buffer message GEM
	bra GWVA_MENU_EXEC_MENU_ROUTINE_FROM_MENU_IDX

.pas_de_sous_menu:
.item_menu_disabled:
	moveq #GWVA_ERROR_GENERIC,d7
	rts


	ifd MDL_WIND_MENU

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_MENU_CLICK_IN_ARROWS
; Description : Gestion du click dans les flches du menu de la fentre
;
; Rq  : 
;
; in  : a0.l = pointeur objet menu
; in  : d0.w = numro de l'objet cliqu
; out : d6.w = GWVA_PRGRET_NOT_CONSUMED ou GWVA_PRGRET_CONSUMED
;
; 21/03/98 : Cration
;------------------------------------------------------------------------------
GWVA_MENU_CLICK_IN_ARROWS:

	cmp.w #1,d0
	bne.s .fleche_droite

	move.w GWVA_MENU_OBJ_SCROLL_INDEX(a0),d0
	beq .pas_de_changement_menu
	sub.w #1,d0
	bra .changement_menu

.fleche_droite:
	move.w GWVA_MENU_OBJ_SCROLL_INDEX(a0),d0
	add.w #1,d0

	move.l GWVA_RSC_OBJ_TREE_PTR(a0),a2
	move.w ob_head(a2),d1		; premier fils de l'objet Root
	mulu #L_OBJECT,d1
	cmp.b #G_BOX,ob_type+1(a2,d1.l)
	beq.s .objet_bar
	move.w ob_tail(a2),d1		; autre fils de l'objet Root
	mulu #L_OBJECT,d1
.objet_bar:	lea (a2,d1.l),a3		; objet bar

	move.w ob_head(a3),d1		; -> objet active = pere des G_TITLE
	save.l d0/a0
	move.l a2,a0
	bsr GWVA_RSC_FIND_SON_OBJECT_FROM_ORDINAL	; il exite ?
	load.l d0/a0
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	beq.s .fils_trouve
	sub.w #1,d0
.fils_trouve:
.changement_menu:
	cmp.w GWVA_MENU_OBJ_SCROLL_INDEX(a0),d0
	beq.s .pas_de_changement_menu

	move.w d0,GWVA_MENU_OBJ_SCROLL_INDEX(a0)

	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS #GWVA_METHOD_MENU_UPDATE
	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS #GWVA_METHOD_MENU_REDRAW_ALL_CONTENTS

.pas_de_changement_menu:
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_MENU_CLICK_IN_MENU_TITLE
; Description : Gestion du click dans la barre de menu (TITLE)
;
; Rq  : On ouvre une fentre formulaire qui contiendra la dropdown list du menu
; Rq  : ouvert. On doit dtourner les clicks et le clavier, et dfinir des mouse
; Rq  : zones.
;
; in  : a0.l = pointeur objet menu
; in  : d0.w = numro de l'objet cliqu (G_TITLE)
;
; 29/03/98 : Cration
;------------------------------------------------------------------------------
GWVA_MENU_CLICK_IN_MENU_TITLE:

	move.w d0,GWVA_MENU_OBJ_TITLE_SELECTED(a0)

	move.l GWVA_RSC_OBJ_TREE_PTR(a0),a2
	move.w d0,d1
	mulu #L_OBJECT,d1
	move.w ob_state(a2,d1.l),d2	; tat du titre
	bset #SELECTED,d2		; selection du titre
	move.w d2,ob_state(a2,d1.l)
	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS #GWVA_METHOD_MENU_REDRAW_ALL_CONTENTS

; On dclare la zone TITLE comme zone souris en sortie

	save.l a0
	move.w GWVA_MENU_OBJ_TITLE_SELECTED(a0),d0
	move.w #MO_LEAVE,d1
	move.l #GWVA_METHOD_MENU_MZONE_TITLE,a1
	bsr GWVA_MENU_SET_OBJECT_MZONE
	load.l a0

	save.l a0/a2

	move.w GWVA_MENU_OBJ_TITLE_SELECTED(a0),d0
	move.l a2,a0
	bsr GWVA_RSC_FIND_FATHER_OBJECT	; l'objet a forcement un pre
	move.w d0,d2		; numro du pre du title

	movem.l (sp),a0/a2

	move.w GWVA_MENU_OBJ_TITLE_SELECTED(a0),d0
	move.l a2,a0
	move.w d2,d1
	bsr GWVA_RSC_FIND_ORDINAL_SON_OBJECT	; on recherche l'ordinal du title
	move.w d0,d2		; -> c'est le mme ordinal que celui de la dropdown list

	load.l a0/a2

	move.w ob_head(a2),d3		; premier fils de l'objet Root
	move.w d3,d4
	mulu #L_OBJECT,d4
	cmp.b #G_IBOX,ob_type+1(a2,d4.l)
	beq.s .objet_dropdowns
	move.w ob_tail(a2),d3		; autre fils de l'objet Root
.objet_dropdowns:
; d3.w est l'index de l'objet dropdowns

	save.l a0/a2
	move.l a2,a0
	move.w d2,d0
	move.w d3,d1
	bsr GWVA_RSC_FIND_SON_OBJECT_FROM_ORDINAL
	load.l a0/a2
	move.w d0,GWVA_MENU_OBJ_DROPDOWN_LIST_SELECTED(a0)	; d0 : index de la dropdown list

	move.w d0,d1
	mulu #L_OBJECT,d1
	move.l ob_spec(a2,d1.l),d2
	and.l #$ff00ffff,d2			; on vire le bord ...
	move.l d2,ob_spec(a2,d1.l)

; On doit crer la fentre popup pour la dropdown

	ifd MDL_WIND_RSC_POPUP

	save.l a0

	move.l a0,a1
	lea GWVA_MENU_TMP_MENU_OPEN_OBJECT,a0

	save.l a0-a2
	move.w GWVA_MENU_OBJ_DROPDOWN_LIST_SELECTED(a1),d0
	move.l a2,a0
	bsr GWVA_RSC_RETURN_OBJ_POS_SIZE
	movem.l (sp),a0-a2
	movem.w d0-d1,GWVA_WIND_OBJ_FIRST_EXT_DX(a0)
	move.l GWVA_ROOT_PTR_WAPP,a0		; car la fentre dropdown n'est pas relative  la fentre l'ouvrant, mais au bureau
	bsr GWVA_WIND_RETURN_INT_ABS_POS_SIZE
	load.l a0-a2
	sub.w d0,GWVA_WIND_OBJ_FIRST_EXT_DX(a0)
	sub.w d1,GWVA_WIND_OBJ_FIRST_EXT_DY(a0)

	save.l a0-a2
	wind_calc #0,#0,GWVA_WIND_OBJ_FIRST_EXT_DX(a0),GWVA_WIND_OBJ_FIRST_EXT_DY(a0),#0,#0	; int -> ext
	load.l a0-a2
	movem.w int_out+1*2,d0-d1	; x,y

	move.w d0,GWVA_WIND_OBJ_FIRST_EXT_DX(a0)
	move.w d1,GWVA_WIND_OBJ_FIRST_EXT_DY(a0)

	move.w GWVA_MENU_OBJ_DROPDOWN_LIST_SELECTED(a1),GWVA_WRSC_OBJ_IDX(a0)
	move.w #7,GWVA_WRSC_OBJ_DEPTH(a0)

	load.l a0

	move.l a0,GWVA_MENU_TMP_MENU_OPEN_OBJECT+GWVA_WRSCPOPUP_OBJ_ATTACHED_OBJECT
	move.w GWVA_RSC_OBJ_TREE(a0),GWVA_MENU_TMP_MENU_OPEN_OBJECT+GWVA_WRSC_OBJ_TREE

	save.l a0
	lea GWVA_MENU_TMP_MENU_OPEN_OBJECT,a0
	bsr GWVA_WIND_CREATE_OPEN_ONE_WIND
	load.l a0

	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne.s .erreur_creation

	move.l GWVA_OBJ_FATHER_PTR(a0),a1

	save.l a0-a1
	wind_get GWVA_WIND_OBJ_GEM_HANDLE(a1),#WF_BEVENT

	movem.l (sp),a0-a1
	move.w int_out+1*2,d0
	bfclr GWVA_WIND_OBJ_STATUS(a1){GWVA_WIND_OLBIT_UNTOPPABLE:1}

	btst #B_UNTOPPABLE,d0
	beq.s .pas_untoppable

	bfset GWVA_WIND_OBJ_STATUS(a1){GWVA_WIND_OLBIT_UNTOPPABLE:1}
.pas_untoppable:
	
	move.w #MASK_B_UNTOPPABLE,int_in+2*2
	wind_set GWVA_WIND_OBJ_GEM_HANDLE(a1),#WF_BEVENT
	load.l a0-a1

.erreur_creation:
	endc	; ifd MDL_WIND_RSC_POPUP

	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_MENU_SET_OBJECT_MZONE
; Description : Dclaration d'une mouse zone autour d'un objet RSC
;
; in  : a0.l = pointeur objet menu
; in  : a1.l = mthode  activer
; in  : d0.w = numro de l'objet RSC
; in  : d1.w = dclaration de la mouse zone (MO_LEAVE ou MO_ENTER)
; out : d7.w = GWVA_NO_ERROR_GENERIC si la zone a t bien dfini
;	   GWVA_ERROR_GENERIC sinon.
;
; 14/08/98 : Cration
;------------------------------------------------------------------------------
GWVA_MENU_SET_OBJECT_MZONE:

	save.w d1
	save.l a0-a1
	move.l GWVA_RSC_OBJ_TREE_PTR(a0),a0
	bsr GWVA_RSC_RETURN_OBJ_POS_SIZE

	movem.l (sp),a0-a1

	save.w d0-d3
	move.l GWVA_OBJ_FATHER_PTR(a0),a0
	bsr GWVA_WIND_RETURN_INT_ABS_POS_SIZE
	sub GWVA_WIND_OBJ_MENU_HEIGHT(a0),d1
	move.w GWVA_WIND_OBJ_MENU_HEIGHT(a0),d3
	load.w d4-d7

	bsr GWVA_WIND_INTERSEC_REC	; il y a forcment intersection ?
	load.l a0-a1
	load.w d6			; dfinition de la mouse zone
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne.s .pas_intersection

	move.l a1,d4
	lea GWVA_ROOT_TMP_MOUSE_ZONE_XYWH,a1
	movem.w d0-d3,(a1)
	move.w d6,d1
	move.l d4,d0
	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS #GWVA_METHOD_REGISTER_MOUSE_ZONE

	moveq #GWVA_NO_ERROR_GENERIC,d7
.pas_intersection
	rts

	ifd MDL_WIND_RSC_POPUP

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_MENU_DROPDOWNLIST_ON_CLOSE
; Description : La liste du menu (la fentre RSCPOPUP) va tre ferme
;
; in  : a0.l = pointeur objet fentre RSCPOPUP
; out : d6.w = GWVA_PRGRET_NOT_CONSUMED
;
; 15/08/98 : Cration
;------------------------------------------------------------------------------
GWVA_MENU_DROPDOWNLIST_ON_CLOSE:

	save.l a0
	move.l GWVA_WRSCPOPUP_OBJ_ATTACHED_OBJECT(a0),a0	; l'objet menu
	clr.l d0
	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS #GWVA_METHOD_UNREGISTER_MOUSE_ZONE
	load.l a0

	tst.w GWVA_WRSCPOPUP_OBJ_SELECTED_ITEM_IDX(a0)
	bpl.s .un_item_selectione

; Si un item a t slectionn et que la fentre est delet, c'est qu'il y a eu un click
; sur celui-ci. On ne doit pas alors remettre en vido normale le title du menu, c'est la
; mthode MENU_SELECT qui s'en chargera.

	move.l GWVA_WRSCPOPUP_OBJ_ATTACHED_OBJECT(a0),a1

	move.l GWVA_RSC_OBJ_TREE_PTR(a1),a2
	move.w GWVA_MENU_OBJ_TITLE_SELECTED(a1),d0
	bmi.s .no_selection

	mulu #L_OBJECT,d0
	move.w ob_state(a2,d0.l),d1
	bclr #SELECTED,d1
	move.w d1,ob_state(a2,d0.l)
; ON EST DANS LA CLASSE DU POPUP
	save.l a0
	move.l a1,a0
	GWVA_CALL_METHOD_OTHER_OBJ #GWVA_METHOD_MENU_REDRAW_ALL_CONTENTS
	load.l a0

	move.w #-1,GWVA_MENU_OBJ_TITLE_SELECTED(a1)

.un_item_selectione:
	move.l GWVA_WRSCPOPUP_OBJ_ATTACHED_OBJECT(a0),a1

	move.l GWVA_OBJ_FATHER_PTR(a1),a1	; fenetre contenant le menu
	clr.w d0
	bftst GWVA_WIND_OBJ_STATUS(a1){GWVA_WIND_OLBIT_UNTOPPABLE:1}
	beq.s .pas_untoppable
	bset #B_UNTOPPABLE,d0
.pas_untoppable:
	
	save.l a0
	move.w d0,int_in+2*2
	wind_set GWVA_WIND_OBJ_GEM_HANDLE(a1),#WF_BEVENT
	load.l a0

.no_selection:
	move.w #GWVA_PRGRET_NOT_CONSUMED,d6
	rts

	endc	; ifd MDL_WIND_RSC_POPUP


	ifd MDL_WIND_MENU_CLONING

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_MENU_UPDATE_MULTI_RSC
; Description : Met  jour le contenu du ressource du menu
;
; Rq  : -
;
; in  : a0.l = pointeur objet
;
; 02/09/98 : Cration
;------------------------------------------------------------------------------
GWVA_MENU_UPDATE_MULTI_RSC:

	tst.w GWVA_RSC_OBJ_IS_CLONE_RSC(a0)
	beq.s .not_a_clone

	move.l ([GWVA_RSC_OBJ_CLONE_MAIN_PTR,a0]),a1	; a1.l=pointeur sur la fentre RSC qui a le contenu du RSC pour lui
	cmp.l #0,a1
	beq.s .pas_de_precedent_pas_de_sauvegarde

	cmp.l a1,a0
	beq.s .c_est_moi_pas_de_restauration_sauvegarde

; On doit sauver le contenu du ressource du prcdent

	save.l a0-a1
	move.w GWVA_RSC_OBJ_TREE(a1),d0
	move.w GWVA_RSC_OBJ_IS_CLONE_RSC(a1),d1
	move.l GWVA_RSC_OBJ_CLONE_SAVED_RSC_PTR(a1),a0
	bsr GWVA_RSC_SAVE_TREE
	load.l a0-a1

.pas_de_precedent_pas_de_sauvegarde:

; On restaure la restaure le formulaire pour la fentre

	save.l a0
	move.w GWVA_RSC_OBJ_TREE(a0),d0
	move.w GWVA_RSC_OBJ_IS_CLONE_RSC(a0),d1
	move.l GWVA_RSC_OBJ_CLONE_SAVED_RSC_PTR(a0),a0
	bsr GWVA_RSC_RESTORE_TREE
	load.l a0

	move.l a0,([GWVA_RSC_OBJ_CLONE_MAIN_PTR,a0])

.c_est_moi_pas_de_restauration_sauvegarde:
.not_a_clone:
	rts

	endc	; ifd MDL_WIND_MENU_CLONING

	endc	; ifd MDL_WIND_MENU

;------------------------------------------------------------------------------
	DATA

	ifd MDL_WIND_RSC_POPUP

GWVA_MENU_TMP_MENU_OPEN_OBJECT:
		; CLASS;METHODLIST_PTR;NAME;SHORTCUTLIST_PTR;PROPERTIES
	GWVA_OBJ_STRUCT_HEAD GWVA_CLASS_WIND.RSC.POPUP,GWVA_MENU_TMP_MENU_OPEN_OBJECT_METHODLIST,'_Mnu'
		; ;FATHER_PTR;NEXT_BROTHER_PTR;FIRST_SON_PTR
	GWVA_OBJ_STRUCT_FAMILY 

		; FLAGS,PROPERTIES,NAME,INFO;TOPABLE_STATE
	GWVA_WIND_STRUCT_BASE	0,0,0,0,-1

		; ;ICON_WIND_PTR;MENU_SPEC_PTR;MOUSE_SPEC_PTR
	GWVA_WIND_STRUCT_DEF_EXTEND 

		; FIRST_EXT_DX,FIRST_EXT_DY;FIRST_INT_VISIBLE_W,FIRST_INT_VISIBLE_H;FIRST_CONTENTS_W,FIRST_CONTENTS_H;FIRST_CONTENTS_DX,FIRST_CONTENTS_DY;FIRST_INT_BORDERS_W,FIRST_INT_BORDERS_H
	GWVA_WIND_STRUCT_FIRST_GEOMETRY 0,0

	GWVA_WIND_STRUCT_USER		; ;USER_PTR1;USER_PTR2

	GWVA_WRSC_STRUCT_BASE	0	; TREE;PROPERTIES;IDX;DEPTH
	GWVA_WRSC_STRUCT_CLONE		; ;IS_CLONE_FORM,CLONE_MAIN_PTR;CLONE_FORM_SAVE

		; ATTACHED_OBJECT,SELECTED_METHOD;PROPERTIES
	GWVA_WRSCPOPUP_STRUCT_BASE 0,GWVA_METHOD_MENU_ITEM_SELECTED

 even
GWVA_MENU_TMP_MENU_OPEN_OBJECT_METHODLIST:
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_ON_DELETE,GWVA_MENU_DROPDOWNLIST_ON_CLOSE
	GWVA_OBJ_STRUCT_METHOD_END_LIST

	endc	; ifd MDL_WIND_RSC_POPUP

	BSS

GWVA_MENU_TMP_MENU_OBJ:		ds.b LONG_STRUC_MENU

	ifd MDL_WIND_MENU
GWVA_MENU_MSG_BUF:		ds.w 8	; pour simuler le message menuselected
	endc	; ifd MDL_WIND_MENU

 even
	TEXT
