	DATA

GWVA_ROOT_DEFAULT_METHODLIST:
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_CREATE,GWVA_ROOT_PRG_CREATE
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_DELETE,GWVA_ROOT_PRG_DELETE

	ifd MDL_EVENTS

	 ifne GWVA_ROOT_CTE_MAX_TIMER
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_REGISTER_TIMER,GWVA_ROOT_PRG_REGISTER_TIMER
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_UNREGISTER_TIMER,GWVA_ROOT_PRG_UNREGISTER_TIMER
	 endc	; ifne GWVA_ROOT_CTE_MAX_TIMER

	 ifge GWVA_ROOT_CTE_MAX_MOUSEZONE-1
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_REGISTER_MOUSE_ZONE,GWVA_ROOT_PRG_REGISTER_MOUSE_ZONE
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_UNREGISTER_MOUSE_ZONE,GWVA_ROOT_PRG_UNREGISTER_MOUSE_ZONE
	 endc	; ifge GWVA_ROOT_CTE_MAX_MOUSEZONE-1

	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_REGISTER_BUTTON,GWVA_ROOT_PRG_REGISTER_BUTTON
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_UNREGISTER_BUTTON,GWVA_ROOT_PRG_UNREGISTER_BUTTON
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_KEYPRESS,GWVA_ROOT_PRG_KEYPRESS

	endc	; ifd MDL_EVENTS

	GWVA_OBJ_STRUCT_METHOD_END_LIST

	TEXT

	ifd MDL_EVENTS

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_KEYPRESS
; Asm label   : GWVA_ROOT_PRG_KEYPRESS
; Description : Gestion d'une touche sur un objet
;
; Rq  : Test les shortcuts sur le mthodes de l'objet
; Rq  : Appele par la mthode KEYPRESS de la classe WIND (INHERITED)
; Rq  : Appele pour chaque objet FORM d'une fentre de classe WFORM avant de distribuer
; Rq  :  l'objet focus.
;
; in  : a0.l = pointeur sur l'objet 
; in  : d0.w = Key code
; in  : d1.w = Key state
; out : d6.w = GWVA_PRGRET_CONSUMED or GWVA_PRGRET_NOT_CONSUMED
;
; 22/11/98 : Cration
;------------------------------------------------------------------------------
GWVA_ROOT_PRG_KEYPRESS:

	tst.l GWVA_OBJ_SHORTCUTLIST_PTR(a0)
	beq.s .pas_de_shortcut_list

	save.l d0-d1/a0
	move.l GWVA_OBJ_SHORTCUTLIST_PTR(a0),a0
	moveq #GWVA_OBJ_SHORTCUTLIST_STRUCT_LENGTH,d2
	bsr GWVA_ROOT_RETURN_ITEMLIST_PTR_FROM_KC
	move.l a0,a1
	load.l d0-d1/a0
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne.s .pas_trouve_dans_liste_shortcut

	GWVA_CALL_METHOD_OTHER_OBJ	GWVA_OBJ_SHORTCUTLIST_ITEM_METHOD(a1)

	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.pas_trouve_dans_liste_shortcut:
.pas_de_shortcut_list:
	move.w #GWVA_PRGRET_NOT_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_REGISTER_BUTTON
; Asm label   : GWVA_ROOT_PRG_REGISTER_BUTTON
; Description : enregistre le click souris pour objet, et lock la ressource 
; Description : 'click bouton'
;
; Rq  : -
;
; in  : a0.l = pointeur sur l'objet devant tre averti
; in  : d0.l = numro de la mthode devant tre appele
; out : d6.w = GWVA_PRGRET_CONSUMED
; out : d7.w = GWVA_NO_ERROR_GENERIC ou
;	   GWVA_ERROR_GENERIC si la ressource est dj verrouille
;
; 22/04/98 : Cration
; 21/11/98 : Passage en mthode de la classe ROOT
;------------------------------------------------------------------------------
GWVA_ROOT_PRG_REGISTER_BUTTON:
	tst.w GWVA_ROOT_CLICK_LOCK
	bne.s .click_verrouille

*	save.l d0/a0
*	wind_update #BEG_MCTRL
*	move.w d0,d1
*	load.l d0/a0
*	tst.w d1
*	beq.s .click_verrouille

	move.l a0,GWVA_ROOT_CLICK_OBJ_PTR
	move.l d0,GWVA_ROOT_CLICK_METHOD
	move.w #1,GWVA_ROOT_CLICK_LOCK

	moveq #GWVA_NO_ERROR_GENERIC,d7
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.click_verrouille:
	GWVA_PROGRAMMER_ERROR GWVA_ASCII_ERROR_BUTTON_ALREADY_REGISTER
	moveq #GWVA_ERROR_GENERIC,d7
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_UNREGISTER_BUTTON
; Asm label   : GWVA_ROOT_PRG_UNREGISTER_BUTTON
; Description : ds-enregistre le click souris pour objet, et unlock la ressource 
; Description : 'click bouton'
;
; Rq  : -
;
; out : d6.w = GWVA_PRGRET_CONSUMED
; out : d7.w = GWVA_NO_ERROR_GENERIC ou
;	   GWVA_ERROR_GENERIC si la ressource est dj verrouille
;
; 22/04/98 : Cration
; 21/11/98 : Passage en mthode de la classe ROOT
;------------------------------------------------------------------------------
GWVA_ROOT_PRG_UNREGISTER_BUTTON:
	tst.w GWVA_ROOT_CLICK_LOCK
	beq.s .click_nonverrouille

*	save.l a0
*	wind_update #END_MCTRL
*	load.l a0

	move.l GWVA_ROOT_PTR_WAPP,GWVA_ROOT_CLICK_OBJ_PTR
	move.l #GWVA_METHOD_CLICK,GWVA_ROOT_CLICK_METHOD
	clr.w GWVA_ROOT_CLICK_LOCK

.click_nonverrouille:
	moveq #GWVA_NO_ERROR_GENERIC,d7
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts


	ifge GWVA_ROOT_CTE_MAX_MOUSEZONE-1

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_REGISTER_MOUSE_ZONE
; Asm label   : GWVA_ROOT_PRG_REGISTER_MOUSE_ZONE
; Description : enregistre une mouse zone
;
; Rq  : -
;
; in  : a0.l = pointeur sur l'objet devant tre averti
; in  : a1.l = x/y/w/h de la zone
; in  : d0.l = numro de la mthode devant tre appele
; in  : d1.w = zone dfinie en entre (MO_ENTER) ou en sortie (MO_LEAVE)
; out : d6.w = GWVA_PRGRET_CONSUMED
; out : d7.w = GWVA_NO_ERROR_GENERIC ou
;	   GWVA_ERROR_GENERIC si plus de place ou demande illgale
;
; 28/03/98 : Cration
; 21/11/98 : Passage en mthode de la classe ROOT
;------------------------------------------------------------------------------
GWVA_ROOT_PRG_REGISTER_MOUSE_ZONE:

	lea GWVA_ROOT_MOUSEZONE_LIST,a2

	move.w #GWVA_ROOT_CTE_MAX_MOUSEZONE-1,d7
.try_find_empty:
	tst.l GWVA_ROOT_OBJ_MOUSEZONE_OBJ_PTR(a2)
	beq.s .found
	lea GWVA_ROOT_OBJ_MOUSEZONE_STRUCT_LENGTH(a2),a2
	dbf d7,.try_find_empty

	GWVA_PROGRAMMER_ERROR GWVA_ASCII_ERROR_NO_MORE_MZONE

.erreur:	moveq #GWVA_ERROR_GENERIC,d7
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.found:	tst.w 0+2+2(a1)	; w
	beq.s .erreur
	tst.w 0+2+2+2(a1)	; h
	beq.s .erreur

	move.l a0,GWVA_ROOT_OBJ_MOUSEZONE_OBJ_PTR(a2)
	move.l d0,GWVA_ROOT_OBJ_MOUSEZONE_METHOD(a2)
	move.w d1,GWVA_ROOT_OBJ_MOUSEZONE_FLAG(a2)
	move.l (a1)+,GWVA_ROOT_OBJ_MOUSEZONE_X(a2)
*	move.w (a1)+,GWVA_ROOT_OBJ_MOUSEZONE_Y(a2)
	move.l (a1)+,GWVA_ROOT_OBJ_MOUSEZONE_W(a2)
*	move.w (a1)+,GWVA_ROOT_OBJ_MOUSEZONE_H(a2)

	moveq #GWVA_NO_ERROR_GENERIC,d7
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

 BSS
GWVA_ROOT_TMP_MOUSE_ZONE_XYWH:	ds.w 4
 TEXT

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_UNREGISTER_MOUSE_ZONE
; Asm label   : GWVA_ROOT_PRG_UNREGISTER_MOUSE_ZONE
; Description : ds-enregistre une mouse zone
;
; Rq  : conserve a0
; Rq  : est appele au delete d'un objet avec d0.l=0
;
; in  : a0.l = pointeur sur l'objet enregistr
; in  : d0.l = numro de la mthode devant tre ds-enregistre ou 0.l pour toutes
; out : d6.w = GWVA_PRGRET_CONSUMED
; out : d7.w = GWVA_NO_ERROR_GENERIC ou
;	   GWVA_ERROR_GENERIC si pas trouv
;
; 28/03/98 : Cration
; 21/11/98 : Passage en mthode de la classe ROOT
;------------------------------------------------------------------------------
GWVA_ROOT_PRG_UNREGISTER_MOUSE_ZONE:

	lea GWVA_ROOT_MOUSEZONE_LIST,a1

	move.l a0,d1

	moveq #GWVA_ERROR_GENERIC,d7

	move.w #GWVA_ROOT_CTE_MAX_MOUSEZONE-1,d6
.try_find_obj:
	cmp.l GWVA_ROOT_OBJ_MOUSEZONE_OBJ_PTR(a1),d1
	beq.s .found
.not_this_one:
.unregistred:
	lea GWVA_ROOT_OBJ_MOUSEZONE_STRUCT_LENGTH(a1),a1
	dbf d6,.try_find_obj

	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.found:	tst.l d0
	beq.s .unregister_all

	cmp.l GWVA_ROOT_OBJ_MOUSEZONE_METHOD(a1),d0
	bne.s .not_this_one

.unregister_all:
	clr.l GWVA_ROOT_OBJ_MOUSEZONE_OBJ_PTR(a1)
	moveq #GWVA_NO_ERROR_GENERIC,d7
	bra.s .unregistred

	endc	; ifge GWVA_ROOT_CTE_MAX_MOUSEZONE-1

	ifne GWVA_ROOT_CTE_MAX_TIMER

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_REGISTER_TIMER
; Asm label   : GWVA_ROOT_PRG_REGISTER_TIMER
; Description : enregistre un timer
;
; Rq  : conserve a0
;
; in  : a0.l = pointeur sur l'objet devant tre averti
; in  : d0.l = numro de la mthode devant tre appele
; in  : d1.l = valeur du timer dsir en milli-secondes (0 non accept)
; in  : d2.w = properties du timer
; out : d6.w = GWVA_PRGRET_CONSUMED
; out : d7.w = GWVA_NO_ERROR_GENERIC ou
;	   GWVA_ERROR_GENERIC si plus de place ou demande illgale
;
; 15/01/98 : Cration
; 21/11/98 : Passage en mthode de la classe ROOT
;------------------------------------------------------------------------------
GWVA_ROOT_PRG_REGISTER_TIMER:

	lea GWVA_ROOT_TIMER_LIST,a1

	move.w #GWVA_ROOT_CTE_MAX_TIMER-1,d7
.try_find_empty:
	tst.l GWVA_ROOT_OBJ_TIMER_OBJ_PTR(a1)
	beq.s .found
	lea GWVA_ROOT_OBJ_TIMER_STRUCT_LENGTH(a1),a1
	dbf d7,.try_find_empty

	GWVA_PROGRAMMER_ERROR GWVA_ASCII_ERROR_NO_MORE_TIMER

.erreur:
	moveq #GWVA_ERROR_GENERIC,d7
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.found:	tst.l d0
	beq.s .erreur

	move.l a0,GWVA_ROOT_OBJ_TIMER_OBJ_PTR(a1)
	move.l d0,GWVA_ROOT_OBJ_TIMER_METHOD(a1)
	move.l d1,GWVA_ROOT_OBJ_TIMER_COUNT(a1)
	move.w d2,GWVA_ROOT_OBJ_TIMER_PROPERTIES(a1)

	save.l a0/a1
	SUPEXEC GWVA_200HZ_GET_CURRENT_COUNTER
	load.l a0/a1

	move.l GWVA_200HZ_CURRENT_COUNTER,GWVA_ROOT_OBJ_TIMER_LAST_COUNT_200(a1)

	moveq #GWVA_NO_ERROR_GENERIC,d7
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_UNREGISTER_TIMER
; Asm label   : GWVA_ROOT_PRG_UNREGISTER_TIMER
; Description : ds-enregistre un timer
;
; Rq  : est appele au delete d'un objet avec d0=0
;
; in  : a0.l = pointeur sur l'objet enregistr
; in  : d0.l = numro de la mthode devant tre ds-enregistre ou 0.l pour toutes
; out : d6.w = GWVA_PRGRET_CONSUMED
; out : d7.w = GWVA_NO_ERROR_GENERIC ou
;	   GWVA_ERROR_GENERIC si pas trouv
;
; 15/01/98 : Cration
; 21/11/98 : Passage en mthode de la classe ROOT
;------------------------------------------------------------------------------
GWVA_ROOT_PRG_UNREGISTER_TIMER:

	lea GWVA_ROOT_TIMER_LIST,a1

	move.l a0,d1

	moveq #GWVA_ERROR_GENERIC,d7

	move.w #GWVA_ROOT_CTE_MAX_TIMER-1,d6
.try_find_obj:
	cmp.l GWVA_ROOT_OBJ_TIMER_OBJ_PTR(a1),d1
	beq.s .found
.not_this_one:
.unregistred:
	lea GWVA_ROOT_OBJ_TIMER_STRUCT_LENGTH(a1),a1
	dbf d6,.try_find_obj

	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.found:	tst.l d0
	beq.s .unregister_all

	cmp.l GWVA_ROOT_OBJ_TIMER_METHOD(a1),d0
	bne.s .not_this_one

.unregister_all:
	clr.l GWVA_ROOT_OBJ_TIMER_OBJ_PTR(a1)
	moveq #GWVA_NO_ERROR_GENERIC,d7
	bra.s .unregistred


	endc	; ifne GWVA_ROOT_CTE_MAX_TIMER

	endc	; ifd MDL_EVENTS

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_DELETE
; Asm label   : GWVA_MENU_PRG_DELETE
; Description : Mthode de destruction d'un objet
;
; Rq  : -
;
; in  : a0.l = pointeur sur l'objet  supprimer
; in  : d0-d1/a1-a2
; out : d7.w = erreurs de la mthode DELETE de l'objet
;
; 21/11/98 : Cration
;------------------------------------------------------------------------------
GWVA_ROOT_PRG_DELETE:
	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_DELETE
; Si on revient de cette mthode, il faut tout de mme continuer (cas exceptionel)

	;-----------------------------------;

	ifd MDL_EVENTS

	ifne GWVA_ROOT_CTE_MAX_TIMER
	save.l d0
	clr.l d0			; toutes le mthodes doivent dgager
	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS #GWVA_METHOD_UNREGISTER_TIMER
	load.l d0
	endc	; ifne GWVA_ROOT_CTE_MAX_TIMER

	ifne GWVA_ROOT_CTE_MAX_MOUSEZONE
	save.l d0
	clr.l d0			; toutes le mthodes doivent dgager
	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS #GWVA_METHOD_UNREGISTER_MOUSE_ZONE
	load.l d0
	endc	; ifne GWVA_ROOT_CTE_MAX_MOUSEZONE

	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS #GWVA_METHOD_UNREGISTER_BUTTON

	endc	; ifd MDL_EVENTS

	;-----------------------------------;

	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_CREATE
; Asm label   : GWVA_ROOT_PRG_CREATE
; Description : Mthode de cration d'un objet
;
; Rq  : -
;
; in  : a0.l = pointeur objet menu
; out : d6.w = GWVA_PRGRET_CONSUMED
; out : d7.w = GWVA_NO_ERROR_GENERIC
;
; 21/11/98 : Cration
;------------------------------------------------------------------------------
GWVA_ROOT_PRG_CREATE:
	GWVA_CHECK_OBJ_HANDLE

	;-----------------------------------;


	;-----------------------------------;

	; envoyer la mthode GWVA_METHOD_CREATED

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_CREATED

	moveq #GWVA_NO_ERROR_GENERIC,d7
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts



	ifeq 1

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_ROOT_DELETE_OBJECT
; Description : delete un objet et met son handle V.A  UNDEF
;
; in  : a0.l = pointeur sur l'objet  supprimer
; in  : d0-d1/a1-a2
; out : d7.w = erreurs de la mthode DELETE de l'objet
;
; 31/01/98 : Cration
; 28/03/98 : ajout appel unregister all timer methods
;------------------------------------------------------------------------------
*GWVA_ROOT_DELETE_OBJECT:
	bsr.s GWVA_ROOT_TEST_IF_OBJECT_CREATED
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne.s .no_exists

	ifd MDL_EVENTS

	ifne GWVA_ROOT_CTE_MAX_TIMER
	save.l d0-d1/a1-a2
	clr.l d0			; toutes le mthodes doivent dgager
	bsr GWVA_ROOT_UNREGISTER_TIMER
	load.l d0-d1/a1-a2
	endc	; ifne GWVA_ROOT_CTE_MAX_TIMER

	ifne GWVA_ROOT_CTE_MAX_MOUSEZONE
	save.l d0-d1/a1-a2
	clr.l d0			; toutes le mthodes doivent dgager
	bsr GWVA_ROOT_UNREGISTER_MOUSE_ZONE
	load.l d0-d1/a1-a2
	endc	; ifne GWVA_ROOT_CTE_MAX_MOUSEZONE

	save.l d0-d1/a1-a2
	bsr GWVA_ROOT_UNREGISTER_BUTTON
	load.l d0-d1/a1-a2

	endc	; ifd MDL_EVENTS

	GWVA_CALL_METHOD_OTHER_OBJ	#GWVA_METHOD_DELETE
	move.w #GWVA_OBJ_CTE_HANDLE_UNDEF,GWVA_OBJ_HANDLE(a0)
.no_exists:
	rts

	endc
