	DATA

GWVA_WAPP_DEFAULT_METHODLIST:
	GWVA_OBJ_STRUCT_METHOD GWVA_METHOD_CREATE,GWVA_WAPP_PRG_CREATE
	GWVA_OBJ_STRUCT_METHOD GWVA_METHOD_DELETE,GWVA_WAPP_PRG_DELETE

	ifd MDL_GEM
	 GWVA_OBJ_STRUCT_METHOD GWVA_METHOD_OPEN,GWVA_WAPP_PRG_OPEN
	 GWVA_OBJ_STRUCT_METHOD GWVA_METHOD_CLOSE,GWVA_WAPP_PRG_CLOSE
	 GWVA_OBJ_STRUCT_METHOD GWVA_METHOD_WAPP_LOAD_RSC,GWVA_WAPP_PRG_LOAD_RSC
	 GWVA_OBJ_STRUCT_METHOD GWVA_METHOD_WAPP_UNLOAD_RSC,GWVA_WAPP_PRG_UNLOAD_RSC
	 ifd MDL_COLORS
	  GWVA_OBJ_STRUCT_METHOD GWVA_METHOD_WAPP_SET_RIGHT_PALETTE,GWVA_WAPP_PRG_SET_RIGHT_PALETTE
	 endc	; ifd MDL_COLORS
	 ifd MDL_EVENTS
	  GWVA_OBJ_STRUCT_METHOD GWVA_METHOD_MESSAGE,GWVA_WAPP_PRG_MESSAGE
	  GWVA_OBJ_STRUCT_METHOD GWVA_METHOD_CLICK,GWVA_WAPP_PRG_CLICK
	  ifd MDL_WIND
	   GWVA_OBJ_STRUCT_METHOD GWVA_METHOD_WM_REDRAW,GWVA_WAPP_PRG_WM_REDRAW
	  endc	; ifd MDL_WIND
	 endc	; ifd MDL_EVENTS
	endc	; ifd MDL_GEM

	GWVA_OBJ_STRUCT_METHOD_END_LIST

	TEXT

	ifd MDL_COLORS

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WAPP_SET_RIGHT_PALETTE
; Asm label   : GWVA_WAPP_PRG_SET_RIGHT_PALETTE
; Description : Gestion des palettes de couleur entre les fentres et le bureau
;
; Rq  : -
;
; in  : a0.l = pointeur sur l'objet app
; out : d6.w = GWVA_PRGRET_CONSUMED
;
; 14/03/98 : Cration
;------------------------------------------------------------------------------
GWVA_WAPP_PRG_SET_RIGHT_PALETTE:
; pas de before
	;-----------------------------------;

	ifd MDL_WIND

	bsr GWVA_WIND_RETURN_TOP_WINDOW
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne.s .the_top_windows_is_not_mine

	GWVA_CALL_METHOD_OTHER_OBJ	#GWVA_METHOD_WIND_SET_PALETTE
	cmp.w #GWVA_SEARCH_EXEC_NOT_FOUND,d6
	bne.s .methode_trouvee
.the_top_windows_is_not_mine:
	endc	; ifd MDL_WIND

	bsr GWVA_ROOT_SET_DESK_PALETTE	; si la mthode n'a pas t trouve, on met la palette systme
.methode_trouvee:
	
	;-----------------------------------;
; pas de after

	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

	endc	; ifd MDL_COLORS

	ifd MDL_EVENTS

	ifd MDL_WIND
;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WM_REDRAW
; Asm label   : GWVA_WAPP_PRG_WM_REDRAW
; Description : Ordre de redessin d'une fentre
;
; Rq  : Sur un move, si la fentre n'a rien  redessiner, le GEM prend pour
; Rq  : lui l'ventuel redessin s'il le peut.
; Rq  : Attention : les redraws peuvent tre mergs dans le pipe GEM. (optimiss)
; Rq  : Dcoupage de la fentre en zones minimale (sans recouvrement)
;
; in  : a0.l = pointeur sur l'objet
; in  : a1.l = pointeur sur le buffer message reu du GEM
; in  : a2.l = pointeur sur le buffer GEM tendu s'il y en avait un prsent ou 0.l sinon
; in  : d0.w = handle de la fentre  redessiner
; out : d6.w = GWVA_PRGRET_CONSUMED
;
; 21/06/98 : Cration
;------------------------------------------------------------------------------
GWVA_WAPP_PRG_WM_REDRAW:

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_WM_REDRAW
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq .pas_redraw_car_on_redraw_consome

	;-----------------------------------;

	; !! attention  a1 et a2 tout du long !!!

;------------------------------------------------------------------------------

	movem.w bmsg_xywh(a1),d0-d3

	; intersection avec le bureau avec la zone  redessiner
	movem.w GWVA_WIND_OBJ_INT_DX(a0),d4-d7
	bsr GWVA_WIND_INTERSEC_REC	; => d0-d3 modifis =zone correcte

	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne .zone_redraw_pas_dans_bureau

	movem.w d0-d3,GWVA_WAPP_REDRAW_BOX	; zone  redessiner demande par le GEM

;------------------------------------------------------------------------------

	lea GWVA_WAPP_REDRAW_MSG_BUF,a3
	move.w bmsg_msgid(a1),bmsg_msgid(a3)
	move.w bmsg_apid(a1),bmsg_apid(a3)
	move.w bmsg_extd(a1),bmsg_extd(a3)
	move.w bmsg_handle(a1),bmsg_handle(a3)

	save.l a0-a2
	wind_update #BEG_UPDATE			; on rserve l'cran

	movem.l (sp),a0-a2
	wind_get bmsg_handle(a1),#WF_FIRSTXYWH	; on demande le premier rectangle GEM
	load.l a0-a2
	tst.w d0
	beq .erreur_fenetre_detruite

	; ==> boucle 1 : sur tous les rectangles

.draw_all_rectangles:
	tst.l int_out+3*2		; largeur & hauteur nulle ?
	beq .no_more_rectangle

	movem.w int_out+1*2,d0-d3	; position et taille du rectangle GEM de la fentre

; On dtermine en premier la zone qu'il faut effectivement redessiner

	; intersection du rectangle de la fentre
	movem.w GWVA_WAPP_REDRAW_BOX,d4-d7
	bsr GWVA_WIND_INTERSEC_REC	; avec la zone  redessiner
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne .pas_intersection_zone_gem	; pas d'intersection = pas de redraw ncessaire dans cette zone
	; -> d0-d3 = nouveau rectangle de redraw

	lea GWVA_WAPP_REDRAW_MSG_BUF,a3
	movem.w d0-d3,bmsg_xywh(a3)
	move.w bmsg_handle(a1),d0
	save.l a1
	move.l a3,a1
	GWVA_CALL_METHOD4	#GWVA_MODE_CLASS_METHOD_SEARCH_ALL_FIRST_SON,#GWVA_METHOD_WM_REDRAW
	load.l a1

.pas_intersection_zone_gem:
	save.l a0-a2
	wind_get bmsg_handle(a1),#WF_NEXTXYWH
	load.l a0-a2

	tst.w d0
	bne .draw_all_rectangles

.no_more_rectangle:

	;-----------------------------------;

	ifd MDL_WIND_FORM

	ifd MDL_FORM_EDITABLE_TEXT

	ifnd PATCH_GWVA_WFORM_CUSTOM_EDITABLE_TEXT

	save.l a0

	move.l GWVA_WIND_OBJ_FOCUSED_CHILD_PTR(a0),a0
	cmp.l #0,a0
	bne.s .on_a_bien_la_wind_focusee

	; si personne de focus, on prend la fentre TOP
	save.l a1-a2
	bsr GWVA_WIND_RETURN_TOP_WINDOW	; pas d'erreur ya au moins moi !
	; => a0
	load.l a1-a2
.on_a_bien_la_wind_focusee:

	cmp.w #GWVA_CLASS_WIND.RSC.FORM,GWVA_OBJ_CLASS(a0)
	bne .pas_form

	save.l a0-a2
	bsr GWVA_WIND_RETURN_TOP_WINDOW	; pas d'erreur ya au moins moi !
	load.l a0-a2
	cmp.w bmsg_handle(a1),d0
	bne.s .not_top_so_no_curs_redraw

	bftst GWVA_WIND_OBJ_STATUS(a0){GWVA_WIND_OLBIT_CURS:1}	; curseur texte affich ?
	bne.s .curseur_deja_affiche

	save.l a0-a2
	v_hide_c
	movem.l (sp),a0-a2

	bsr GWVA_WFORM_REDRAW_CURSOR

	v_show_c #1
	load.l a0-a2

	bfset GWVA_WIND_OBJ_STATUS(a0){GWVA_WIND_OLBIT_CURS:1}	; curseur texte affich ?

.curseur_deja_affiche:
.not_top_so_no_curs_redraw:
.pas_form:

	load.l a0

	endc	; ifnd PATCH_GWVA_WFORM_CUSTOM_EDITABLE_TEXT

	endc	; ifd MDL_FORM_EDITABLE_TEXT

	endc	; ifd MDL_WIND_FORM

	;-----------------------------------;

.erreur_fenetre_detruite:

	save.l a0
	wind_update #END_UPDATE
	load.l a0

	;-----------------------------------;

	; envoyer la mthode GWVA_METHOD_REDRAWED

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_WM_REDRAWN

.pas_redraw_car_on_redraw_consome:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.zone_redraw_pas_dans_bureau:
	moveq #GWVA_PRGRET_NOT_CONSUMED,d6
	rts

	endc	; ifd MDL_WIND

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_CLICK
; Asm label   : GWVA_WAPP_PRG_CLICK
; Description : Gestion du clic dans l'cran reu de l'evnt_multi
;
; Rq  : Si on a un click et non un evnt_top c'est qu'elle est top !
; Rq  : Ce n'est pas vrai si sur un WIND_TOP on ne fait pas LE WIND_TOP
; Rq  : demand par le GEM ... on a alors un click dans la fentre derrire.
;
; in  : a0.l = pointeur sur l'objet app
; in  : d0.w = [ X.w ]
; in  : d1.l = [ mouse button.w | Y.w ]
; in  : d2.l = [ Key state.w | mouse count.w ]
; out : d6.w = GWVA_PRGRET_CONSUMED
;
; 14/01/98 : Cration
;------------------------------------------------------------------------------
GWVA_WAPP_PRG_CLICK:

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_CLICK
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq.s .pas_click_car_on_click_consome

	;-----------------------------------;

	ifd MDL_WIND

	save.l d0-d2/a0

	; Ce code est ici car on peut avoir un MDL_EVENTS sans MDL_WIND
	wind_find d0,d1
	move d0,d7
*	move d0,GWVA_APP_OBJ_TMP_WIND_HANDLE
	load.l d0-d2/a0
	swap d0
	move d7,d0

	save.l d0-d2/a0			; attention
	bsr GWVA_WIND_RETURN_PTR_FROM_HANDLE
	load.l d0-d2/a0
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne.s .pas_a_nous_la_fenetre

	GWVA_CALL_METHOD4	#GWVA_MODE_CLASS_METHOD_SEARCH_ALL_FIRST_SON,#GWVA_METHOD_WIND_CLICK

	swap d0		; pour passer les bons paramtres  l'AFTER

	endc	; ifd MDL_WIND

	;-----------------------------------;

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_CLICKED

.pas_a_nous_la_fenetre:
.pas_click_car_on_click_consome:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_MESSAGE
; Asm label   : GWVA_WAPP_PRG_MESSAGE
; Description : Mthode de gestion des messages GEM. Redistribue  
; Description : ses fentres filles en fonction des types de message
;
; in  : a0.l = pointeur sur l'objet app
; in  : a1.l = pointeur sur le buffer GEM message
; in  : a2.l = pointeur sur le buffer GEM tendu s'il y en avait un prsent ou 0.l sinon
; in  : d0.w = numro du message GEM
; out : d6.w = GWVA_PRGRET_CONSUMED
; 
; 24/01/98 : Cration
;------------------------------------------------------------------------------
its_a_message:
GWVA_WAPP_PRG_MESSAGE:
	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_MESSAGE
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq .pas_message_car_on_message_consome

	;-----------------------------------;

	ifd MDL_MENU

	cmp.w #MN_SELECTED,d0		; si on recoit l'vnement menu, c'est qu'il y a un menu en haut !
	bne.s .not_a_menu_message

	ifd OPT_GWVA_DEBUG_ERROR
	tst.l GWVA_WIND_OBJ_MENU_SPEC_PTR(a0)
	beq.s .ptr_menu_nul
	bftst GWVA_WIND_OBJ_PROPERTIES(a0){GWVA_WIND_OLBIT_AMENU:1}
	bne.s .bit_menu_non_nul
.ptr_menu_nul:
	GWVA_PROGRAMMER_ERROR	GWVA_ASCII_ERROR_MENU_SELECTED
.bit_menu_non_nul:
	endc

	save.l a0
	move.l GWVA_WIND_OBJ_MENU_SPEC_PTR(a0),a0
	GWVA_CALL_METHOD_OTHER_OBJ	#GWVA_METHOD_MENU_SELECT
	load.l a0
	bra .distribute_method_messaged

.not_a_menu_message:

	endc	; ifd MDL_MENU

	;-----------------------------------;

	ifd MDL_WIND

	cmp.w #GWVA_MSG_WRSC_REDRAW_PART,d0
	bne.s .pas_redraw_customise
	move.w #WM_REDRAW,d0
.pas_redraw_customise:

	cmp.w #WM_REDRAW,d0
	blt.s .not_a_wind_message
	cmp.w #WM_ALLICONIFY,d0
	bgt.s .not_a_wind_message

	ifd OPT_GWVA_MULTIFORM_ALWAYS_UPDATE
	ifd MDL_CHILDREN_WINDOWS
	bsr GWVA_WIND_OBJ_PRG_UPDATE_POS_FAMILY_WINDOW
	else
	bsr GWVA_WIND_OBJ_PRG_UPDATE_POS_WINDOW
	endc	; ifd MDL_CHILDREN_WINDOWS
	endc	; ifd OPT_GWVA_MULTIFORM_ALWAYS_UPDATE

	cmp.w #WM_REDRAW,d0
	bne.s .pas_methode_redraw

	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS	#GWVA_METHOD_WM_REDRAW
	bra .distribute_method_messaged

.pas_methode_redraw:

	move.w d0,d1
	and.l #$ffff,d1
	move bmsg_handle(a1),d0		; handle de la fentre concerne
	; a0 pointe sur la WAPP
	; a1 pointe sur le buffer MSG
	GWVA_CALL_METHOD4	#GWVA_MODE_CLASS_METHOD_SEARCH_ALL_FIRST_SON,d1
	; on pourrait ne pas avoir prvu un message fentre ? (on sait jamais)
	bra .distribute_method_messaged

.not_a_wind_message:
	endc	; ifd MDL_WIND

	cmp.w #AC_OPEN,d0
	bne.s .pas_ac_open

	move.w GWVA_ROOT_ACC_NUMBER,d1
	cmp.w bmsg_ac_open_number(a1),d1
	bne .pas_distribute_method_messaged

	save.l d0/a1-a2
	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS	#GWVA_METHOD_OPEN
	load.l d0/a1-a2
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne. .pas_distribute_method_messaged

	save.l d0/a1-a2
; Normalement, que en local, comme les before et after
	GWVA_EXEC_VISUAL_EVENT	#AC_OPEN
	load.l d0/a1-a2

	bra.s .distribute_method_messaged
.pas_ac_open:

	cmp.w #AC_CLOSE,d0
	bne.s .pas_ac_close

	move.w GWVA_ROOT_ACC_NUMBER,d1
	cmp.w bmsg_ac_close_number(a1),d1
	bne.s .pas_distribute_method_messaged

	save.l d0/a1-a2
; Normalement, que en local, comme les before et after
	GWVA_EXEC_VISUAL_EVENT	#AC_CLOSE
	load.l d0/a1-a2

	save.l d0/a1-a2
	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS	#GWVA_METHOD_CLOSE
	load.l d0/a1-a2

	bra.s .distribute_method_messaged
.pas_ac_close:

; Si on ne reconnait pas le message, c'est au programmeur de dfinir s'il veut
; ragir  ce message : donc il doit tre dans la liste locale

	and.l #$ffff,d0			; mthode sur 1.L
	GWVA_EXEC_VISUAL_EVENT	d0

	;-----------------------------------;


.distribute_method_messaged:
	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_MESSAGED

.pas_distribute_method_messaged:
.pas_message_car_on_message_consome:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

	endc	; ifd MDL_EVENTS

	ifd MDL_GEM

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_CLOSE
; Asm label   : GWVA_WAPP_PRG_CLOSE
; Description : Mthode de fermeture de l'application
;
; Rq  : Ferme (mais pas delete) delete toutes les fentres
;
; in  : a0.l = pointeur sur l'objet app
; out : d6.w = GWVA_PRGRET_CONSUMED
;
; 17/01/98 : Cration
;------------------------------------------------------------------------------
GWVA_WAPP_PRG_CLOSE:
	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_CLOSE
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq .pas_close_car_on_close_consome

	;-----------------------------------;

	bftst GWVA_WIND_OBJ_STATUS(a0){GWVA_WIND_OLBIT_OPEN:1}
	beq .wapp_deja_fermee

	ifd MDL_WIND
	bsr GWVA_WIND_CLOSE_ALL_WIND
	endc	; ifd MDL_WIND

	ifd MDL_MENU

	tst GWVA_ROOT_IS_ACC_PRG
	beq.s .acc_pas_de_menu

	tst.l GWVA_WIND_OBJ_MENU_SPEC_PTR(a0)
	beq.s .pas_de_menu

	bftst GWVA_WIND_OBJ_PROPERTIES(a0){GWVA_WIND_OLBIT_AMENU:1}
	beq.s .pas_de_menu_a_effacer

	save.l a0
	move.l GWVA_WIND_OBJ_MENU_SPEC_PTR(a0),a0
	GWVA_CALL_METHOD_OTHER_OBJ	#GWVA_METHOD_CLOSE
	load.l a0
.pas_de_menu_a_effacer:
.pas_de_menu:
.acc_pas_de_menu:

	endc	; ifd MDL_MENU

	tst.l GWVA_WAPP_OBJ_BACKGROUND_WIND_PTR(a0)
	beq.s .pas_de_background

	bftst GWVA_WAPP_OBJ_PROPERTIES(a0){GWVA_WAPP_OLBIT_BACKGROUND:1}
	beq.s .pas_de_background

	move.l GWVA_WAPP_OBJ_BACKGROUND_WIND_PTR(a0),a1

	cmp.w #GWVA_CLASS_WIND.RSC,GWVA_OBJ_CLASS(a1)
	bne.s .other_than_rsc_not_supported

	save.l a0
	clr.l int_in+4
	wind_set #0,#WF_NEWDESK
	load.l a0
.other_than_rsc_not_supported:
.other_than_rsc_form_not_supported:
.pas_de_background:

	ifd MDL_COLORS
	bsr GWVA_ROOT_SET_DESK_PALETTE
	endc	; ifd MDL_COLORS

	save.l a0
	v_clsvwk		; then closing the virtual workstation
	load.l a0

	bfclr GWVA_WIND_OBJ_STATUS(a0){GWVA_WIND_OLBIT_OPEN:1}

	;-----------------------------------;

	; envoyer la mthode GWVA_METHOD_CLOSED

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_CLOSED

.wapp_deja_fermee:
.pas_close_car_on_close_consome:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

	endc	; ifd MDL_GEM

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_DELETE
; Asm label   : GWVA_WAPP_PRG_DELETE
; Description : Mthode d'ouverture de l'application
;
; Rq  : Renvoie le code d'erreur contenu dans GWVA_ROOT_RETURN_CODE
; Rq  : Retour en TSR possible
; Rq  : il n'y en pas de OUT car on ne ressort jamais (on fait l'appl_exit)
; Rq  : c'est le seul cas o on n'appelle pas le DELETE de la classe ROOT en hritage
;
; in  : a0.l = pointeur sur l'objet app
; in  : d0.w = code d'activation (i.e pourquoi demande-t-on le delete ?)
;	   GWVA_NO_ERROR_GENERIC
;	   GWVA_ERROR_WAPP_WORKSTATION_OPEN_FAILED
;	   GWVA_ERROR_WAPP_INIT_FAILED
;	   GWVA_ERROR_WAPP_RSC_LOAD_FAILED
;
; 17/01/98 : Cration
; 22/02/98 : Ajout de l'appel au close WAPP sur DELETE
; 20/03/98 : Ajout de GWVA_ERROR_WAPP_WORKSTATION_OPEN_FAILED (ancien ERROR_tout_court)
;------------------------------------------------------------------------------
GWVA_WAPP_PRG_DELETE:
	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_DELETE
; Si on revient de cette mthode, il faut tout de mme continuer (cas exceptionel)

	;-----------------------------------;

	ifd MDL_GEM

	cmp.w #GWVA_ERROR_WAPP_INIT_FAILED,d0
	beq .GWVA_BRANCH_IF_APPL_INIT_FAILED
	cmp.w #GWVA_ERROR_WAPP_RSC_LOAD_FAILED,d0
	beq.s .GWVA_BRANCH_IF_RSC_LOAD_FAILED
	cmp.w #GWVA_ERROR_WAPP_WORKSTATION_OPEN_FAILED,d0
	beq.s .GWVA_BRANCH_IF_OPEN_WORKSTATION_FAILED

	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS	#GWVA_METHOD_CLOSE

	ifd MDL_WIND

	bsr GWVA_WIND_DELETE_ALL_WIND	; delete toutes sauf WAPP

	endc	; ifd MDL_WIND

	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS	#GWVA_METHOD_WAPP_UNLOAD_RSC

	graf_mouse	#ARROW
	appl_exit

	endc		; ifd MDL_GEM

	move.l GWVA_ROOT_PTR_WAPP,a0
	tst.l GWVA_WAPP_OBJ_TSR_SIZE(a0)
	bne.s .tsr
	bra.s .not_tsr

	ifd MDL_GEM

.GWVA_BRANCH_IF_OPEN_WORKSTATION_FAILED:
.GWVA_BRANCH_IF_RSC_LOAD_FAILED:
	graf_mouse	#ARROW
	appl_exit
.GWVA_BRANCH_IF_APPL_INIT_FAILED:

	endc	; ifd MDL_GEM

.not_tsr:	move.w GWVA_ROOT_RETURN_CODE,-(sp)
	appel dos,p_term,4		; Pterm

	;-----------

.tsr:	move.l GWVA_ROOT_BASE_PAGE,a5

	move.l #L_BASEPAGE,d0
	add.l p_tlen(a5),d0		; prg
	add.l p_dlen(a5),d0		; data

	move.l GWVA_WAPP_OBJ_TSR_SIZE(a0),d1

	cmp.l #GWVA_TSR_SIZE_CTE_TEXT_DATA,d1
	bne.s .pas_text_plus_data
	move.l d0,d1
	bra.s .fin_commune
.pas_text_plus_data:
	cmp.l #GWVA_TSR_SIZE_CTE_TEXT_DATA_BSS,d1
	bne.s .pas_text_plus_data_plus_bss
	add.l p_blen(a5),d0		; bss
	move.l d0,d1
.pas_text_plus_data_plus_bss:
.fin_commune:

	and.w #-2,d1		; aligne sur un mot long
	addq.l #2,d1

	move.w GWVA_ROOT_RETURN_CODE,-(sp)
	move.l d1,-(sp)
	appel dos,p_termres,8		; laisse le programme rsident

	ifd MDL_GEM

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_OPEN
; Asm label   : GWVA_WAPP_PRG_OPEN
; Description : Mthode d'ouverture de l'application
;
; Rq  : Ouverture de la station virtuelle de travail
;
; in  : a0.l = pointeur sur l'objet app
; out : d6.w = GWVA_PRGRET_CONSUMED
; out : d7.w = GWVA_NO_ERROR_GENERIC ou erreur 
;	   GWVA_ERROR_WAPP_WORKSTATION_OPEN_FAILED
;
; 11/01/98 : Cration
;------------------------------------------------------------------------------
GWVA_WAPP_PRG_OPEN:
	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_OPEN
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq .pas_open_car_on_open_consome

	;-----------------------------------;

	bftst GWVA_WIND_OBJ_STATUS(a0){GWVA_WIND_OLBIT_OPEN:1}
	bne .wapp_deja_ouvert

	save.l a0

	lea intin,a0	; start by opening a virtual workstation
	moveq #10-1,d0
.fill:	move.w #1,(a0)+	; most params are 1
	dbf d0,.fill
	move.w #2,(a0)+	; use RC system

	appel xbios,getrez,2
	addq.w #2,d0
	move.w d0,intin	; Device identification number (dixit COMPENDIUM p 7.61)

	v_opnvwk			; open it
	load.l a0
	tst.w current_handle		; variable dfinie dans la librairie de DEVPAC (VDI.S)
	beq .open_workstation_failed

	save.l a0
	bsr GWVA_ROOT_PRG_INFO_VDI_WORKSTATION 

	graf_mouse #ARROW
	move.w #1,GWVA_ROOT_MOUSE_STATE	; souris affiche

	wind_get #0,#WF_WORKXYWH	; taille du bureau ?
	load.l a0
	move.l int_out+1*2,GWVA_WIND_OBJ_INT_DX(a0)
	move.l int_out+2*3,GWVA_WIND_OBJ_INT_VISIBLE_W(a0)
	clr.l GWVA_WIND_OBJ_CONTENTS_DX(a0)
	move.l int_out+2*3,GWVA_WIND_OBJ_CONTENTS_W(a0)
	clr.l GWVA_WIND_OBJ_INT_BORDERS_W(a0)

	save.l a0
	wind_get #0,#WF_CURRXYWH	; sans le menu
	load.l a0
	move.w GWVA_WIND_OBJ_INT_DY(a0),d0
	sub.w int_out+2*2,d0
	move.w d0,GWVA_WIND_OBJ_MENU_HEIGHT(a0)

	save.l a0
	vst_height GWVA_ROOT_SYSTEM_LARGEFONT_HEIGHT
	move.w ptsout+2*2,GWVA_ROOT_SYSTEM_LARGEFONT_CELL_WIDTH
	move.w ptsout+2*3,GWVA_ROOT_SYSTEM_LARGEFONT_CELL_HEIGHT

	vst_height GWVA_ROOT_SYSTEM_SMALLFONT_HEIGHT
	move.w ptsout+2*2,GWVA_ROOT_SYSTEM_SMALLFONT_CELL_WIDTH
	move.w ptsout+2*3,GWVA_ROOT_SYSTEM_SMALLFONT_CELL_HEIGHT

	vst_height GWVA_ROOT_TEXT_HEIGHT

	cmp.w #$340,global+_AESversion
	blt.s .pas_bonne_version_AES

	objc_sysvar #0,#AD3DVAL,#0,#0	; -> taille des bordures 3D
	tst.w d0
	beq.s .pas_de_resultat

	move.w int_out+1*2,GWVA_ROOT_SYSTEM_AES_3D_HBORDER
	move.w int_out+2*2,GWVA_ROOT_SYSTEM_AES_3D_VBORDER
.pas_de_resultat:
.pas_bonne_version_AES:

	load.l a0

	;-----------------------------------;

	bfset GWVA_WIND_OBJ_STATUS(a0){GWVA_WIND_OLBIT_OPEN:1}	; la station est ouverte

	;-----------------------------------;

	ifd MDL_COLORS

	save.l a0
	lea GWVA_ROOT_DESK_PALETTE,a0
	bsr GWVA_ROOT_STORE_VDI_PALETTE
	load.l a0

	endc	; ifd MDL_COLORS

	;-----------------------------------;

	tst.l GWVA_WAPP_OBJ_BACKGROUND_WIND_PTR(a0)
	beq .pas_de_background

	bftst GWVA_WAPP_OBJ_PROPERTIES(a0){GWVA_WAPP_OLBIT_BACKGROUND:1}
	beq .pas_de_background

	move.l GWVA_WAPP_OBJ_BACKGROUND_WIND_PTR(a0),a1

	cmp.w #GWVA_CLASS_WIND.RSC,GWVA_OBJ_CLASS(a1)
	bne .other_than_rsc_not_supported

; Extension de la taille de l'objet 0
	save.l a0-a1
	move.w GWVA_WRSC_OBJ_TREE(a1),d0
	lea GWVA_WRSC_OBJ_TREE_PTR(a1),a0
	bsr GWVA_RSC_RETURN_PTR_ON_TREE
	load.l a0-a1

	move.l GWVA_WRSC_OBJ_TREE_PTR(a1),a2
	move.l GWVA_WIND_OBJ_INT_DX(a0),ob_x(a2)
	move.l GWVA_WIND_OBJ_CONTENTS_W(a0),ob_width(a2)

	save.l a0-a2
	move.l a2,a0
	moveq #0,d0
	bsr GWVA_RSC_RETURN_OBJ_POS_SIZE
	load.l a0-a2

	movem.w ob_x(a2),d4-d5
	sub.w d0,d4
	sub.w d1,d5
	add.w d4,ob_x(a2)
	add.w d5,ob_y(a2)

	movem.w ob_width(a2),d4-d5
	sub.w d2,d4
	sub.w d3,d5
	add.w d4,ob_width(a2)
	add.w d5,ob_height(a2)	; on tend la taille de l'objet 0  la taille du bureau

; Centrage de l'objet 1

	bftst GWVA_WAPP_OBJ_PROPERTIES(a0){GWVA_WAPP_OLBIT_BACKGROUND_CENTER:1}
	beq.s .pas_centre_auto

	move.w GWVA_WRSC_OBJ_TREE(a1),d0
	move #1,d1
	save.l a0-a2
	bsr GWVA_RSC_RETURN_PTR_ON_OBJ
	move.l a1,a3
	load.l a0-a2
	move.w GWVA_WIND_OBJ_CONTENTS_W(a0),d0
	sub.w ob_width(a3),d0
	bmi.s .no_x
	asr.w #1,d0
	add.w GWVA_WIND_OBJ_INT_DX(a0),d0
	bmi.s .no_x
	move d0,ob_x(a3)
.no_x:	move.w GWVA_WIND_OBJ_CONTENTS_H(a0),d0
	sub.w ob_height(a3),d0
	bmi.s .no_y
	asr.w #1,d0
	add.w GWVA_WIND_OBJ_INT_DY(a0),d0
	bmi.s .no_y
	move d0,ob_y(a3)
.no_y:
.pas_centre_auto:

	move.l a2,int_in+2*2	; a2 : pointeur sur le tree servant de fond
	clr.w int_in+4*2	; Numro du 1er objet  redessiner
	save.l a0
	wind_set #0,#WF_NEWDESK
	move.l (sp),a0
	; pour forcer le redraw du fond du bureau
	form_dial #3,#0,#0,#0,#0,GWVA_WIND_OBJ_INT_DX(a0),GWVA_WIND_OBJ_INT_DY(a0),GWVA_WIND_OBJ_CONTENTS_W(a0),GWVA_WIND_OBJ_CONTENTS_H(a0)
	load.l a0

.other_than_rsc_form_not_supported:
.other_than_rsc_not_supported:
.pas_de_background:

	;---------------

	ifd MDL_MENU

	tst GWVA_ROOT_IS_ACC_PRG
	beq.s .acc_pas_de_menu

	tst.l GWVA_WIND_OBJ_MENU_SPEC_PTR(a0)
	beq.s .pas_de_menu

	bftst GWVA_WIND_OBJ_PROPERTIES(a0){GWVA_WIND_OLBIT_AMENU:1}
	beq.s .pas_de_menu_a_afficher

	save.l a0
	move.l GWVA_WIND_OBJ_MENU_SPEC_PTR(a0),a0
; pas d'erreur sur l'open du menu
	GWVA_CALL_METHOD_OTHER_OBJ	#GWVA_METHOD_OPEN
	load.l a0
.pas_de_menu_a_afficher:
.pas_de_menu:
.acc_pas_de_menu:

	endc	; ifd MDL_MENU

	;-----------------------------------;

	; envoyer la mthode GWVA_METHOD_OPENED

	move.w GWVA_ROOT_CMD_LINE_SIZE,d0
	move.l GWVA_ROOT_CMD_LINE_PTR,a1

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_OPENED

.wapp_deja_ouvert:
	moveq #GWVA_NO_ERROR_GENERIC,d7
.pas_open_car_on_open_consome:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.open_workstation_failed:
	move #GWVA_ERROR_WAPP_WORKSTATION_OPEN_FAILED,d7
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

	endc	; ifd MDL_GEM

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_CREATE
; Asm label   : GWVA_WAPP_PRG_CREATE
; Description : Mthode de cration de l'application
;
; Rq  : Fait le MSHRINK
; Rq  : N'appelle pas en hritage le CREATE de la classe WIND et donc du ROOT
;
; in  : a0.l = pointeur sur l'objet app
; out : d7.w = GWVA_NO_ERROR_GENERIC ou erreur 
; 	   GWVA_ERROR_WIND_BAD_HANDLE
;	   GWVA_ERROR_WAPP_INIT_FAILED
;	   GWVA_ERROR_ROOT_INIT_METHOD_LIST
;	   + erreurs eventuelles de GWVA_METHOD_WAPP_LOAD_RSC
;	   + erreurs du CREATE du menu ventuel
;
; 10/01/98 : Cration
; 01/02/98 : Ajout des erreurs de la cration du menu
;------------------------------------------------------------------------------
GWVA_WAPP_PRG_CREATE:
******	GWVA_CALL_METHOD_INHERITED

	cmp.w #GWVA_WIND_CTE_HANDLE_UNDEF,GWVA_WIND_OBJ_GEM_HANDLE(a0)
	bne .erreur_handle_wind

	clr.w GWVA_WIND_OBJ_GEM_HANDLE(a0)	; handle fentre bureau = 0 ?

; Effacer aussi les bit d'tat (voir WIND)

	clr.l GWVA_OBJ_FATHER_PTR(a0)
	clr.l GWVA_OBJ_NEXT_BROTHER_PTR(a0)

	;-----------------------------------;

	ifd MDL_GEM

	tst GWVA_ROOT_IS_ACC_PRG
	beq.s .pas_de_setblock_si_acc

	endc	; ifd MDL_GEM

	move.l GWVA_ROOT_BASE_PAGE,a5

	save.l a0
	move.l #L_BASEPAGE,d0
	add.l p_tlen(a5),d0		; prg
	add.l p_dlen(a5),d0		; data
	add.l p_blen(a5),d0		; bss
	and.w #-4,d0		; aligne sur un mot long
	addq.l #4,d0
	move.l d0,-(sp)
	move.l a5,-(sp)
	clr.w -(sp)
	appel dos,m_shrink,12
	load.l a0
.pas_de_setblock_si_acc:

	;-----------------------------------;

	ifd MDL_GEM

	save.l a0
	appl_init
	load.l a0
	tst d0
	bmi .wapp_appl_init_failed

	save.l a0
	graf_handle
	move.w d0,current_handle	; Desktop's VDI handle
	bsr GWVA_ROOT_PRG_INFO_VDI_WORKSTATION
	load.l a0

	;-----------------------------------;

; Peut-tre  placer dans l'open de l'APP

	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS	#GWVA_METHOD_WAPP_LOAD_RSC
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne .error_rsc_load

	;-----------------------------------;

	ifd MDL_MENU

	tst GWVA_ROOT_IS_ACC_PRG
	beq.s .acc_pas_de_menu

	tst.l GWVA_WIND_OBJ_MENU_SPEC_PTR(a0)
	beq.s .pas_de_menu

	save.l a0
	move.l a0,a1
	move.l GWVA_WIND_OBJ_MENU_SPEC_PTR(a0),a0

	bsr GWVA_ROOT_CREATE_OBJECT
	load.l a0
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne .erreur_create_menu

.pas_de_menu:
.acc_pas_de_menu:

	endc	; ifd MDL_MENU

	ifd MDL_EVENTS

	tst GWVA_ROOT_IS_ACC_PRG
	bne.s .no_menu_register_if_prg

**** inits ACC
	save.l a0
	menu_register global+_AESapid,GWVA_WAPP_OBJ_ACC_NAME(a0)
	load.l a0
	move.w d0,GWVA_ROOT_ACC_NUMBER
*	bmi GWVA_INFINITE_LOOP		; ?_ERROR_?

	bra.s .saute_multiprocess_inits_if_acc

.no_menu_register_if_prg:

	endc	; MDL_EVENTS

	cmp #1,global+_AESnumapps	; multiprocess ?
	beq.s .mono_process

**** inits multiprocess : on suppute qu'il supporte le shel_write mode SWM_NEWMSG

	save.l a0
	menu_register global+_AESapid,GWVA_WAPP_OBJ_ACC_NAME(a0)
	shel_write #SWM_NEWMSG,#-1,#0,#0,#0	; reoit les nouveaux messages AES 4.0
	load.l a0

**** inits mono process et multiprocess
.mono_process:
.saute_multiprocess_inits_if_acc:
	save.l a0
	menu_register #-1,GWVA_WAPP_OBJ_REG_NAME(a0)
	load.l a0

	endc	; ifd MDL_GEM

	;-----------------------------------;

	; envoyer la mthode GWVA_METHOD_CREATED

	move.w GWVA_ROOT_CMD_LINE_SIZE,d0
	move.l GWVA_ROOT_CMD_LINE_PTR,a1

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_CREATED

	moveq #GWVA_PRGRET_CONSUMED,d6
	moveq #GWVA_NO_ERROR_GENERIC,d7
	rts

	ifd MDL_GEM
.common_error_alert:
	save.w d7
	move #1,d0
	bsr GWVA_ROOT_PRG_ALERT_BOX
	load.w d7
	endc	; ifd MDL_GEM

.common_error:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.erreur_handle_wind:
	move.w #GWVA_ERROR_WIND_BAD_HANDLE,d7
	bra.s .common_error

	ifd MDL_GEM
	
.wapp_appl_init_failed:
	lea GWVA_WAPP_ALERT_AP_INIT_FAILED,a0
	move.w #GWVA_ERROR_WAPP_INIT_FAILED,d7
	bra.s .common_error_alert

.error_rsc_load:
	lea GWVA_WAPP_ALERT_NO_RSC,a0
	bra.s .common_error_alert

.erreur_create_menu:
	bra.s .common_error

	endc	; ifd MDL_GEM

	ifd MDL_GEM

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WAPP_LOAD_RSC
; Asm label   : GWVA_WAPP_PRG_LOAD_RSC
; Description : Mthode chargeant le ressource
;
; in  : a0.l = pointeur sur l'objet app
; out : d7.w = GWVA_NO_ERROR_GENERIC ou erreur 
;	   GWVA_ERROR_WAPP_RSC_LOAD_FAILED
;	   GWVA_ERROR_WAPP_RSC_LOAD_BAD_INCLUDE
;	   + erreur de GWVA_METHOD_WAPP_RELOCATE_RSC eventuelle
;
; 10/01/98 : Cration
;------------------------------------------------------------------------------
GWVA_WAPP_PRG_LOAD_RSC:
	tst.l GWVA_WAPP_OBJ_RSC_INFO(a0)
	beq.s .pas_de_ressource

	move.l GWVA_WAPP_OBJ_RSC_INFO(a0),a1

	bftst GWVA_WAPP_OBJ_PROPERTIES(a0){GWVA_WAPP_OLBIT_RSC_MULTI_RES:1}
	beq.s .un_seul_ressource

	moveq #1,d1		; est-on dans une rsolution avec palette ?
	move.w GWVA_ROOT_VDI_WORKSTATION_EXTD+4*2,d2
	lsl.w d2,d1
	move.w GWVA_ROOT_VDI_WORKSTATION+13*2,d3
	cmp.w d3,d1
	beq.s .resolution_palette
	move.w #-1,d1	; pas de palette
.resolution_palette
	cmp.w #2,d1
	beq.s .color_2
	lea 4(a1),a1
	cmp.w #4,d1
	beq.s .color_4
	lea 4(a1),a1
	cmp.w #16,d1
	beq.s .color_16
	lea 4(a1),a1
	cmp.w #256,d1
	beq.s .color_256
	lea 4(a1),a1
.color_2:
.color_4:
.color_16:
.color_256:
	move.l (a1),a1
	cmp.l #0,a1
	beq.s .rsc_fail

.un_seul_ressource:

	bftst GWVA_WAPP_OBJ_PROPERTIES(a0){GWVA_WAPP_OLBIT_RSC_IN_MEM:1}
	bne.s .rsc_in_memory

	rsrc_load a1
	tst.w d0
	bne.s .rsc_loaded_ok
.rsc_fail:
	moveq #GWVA_PRGRET_CONSUMED,d6
	move.w #GWVA_ERROR_WAPP_RSC_LOAD_FAILED,d7
	rts
	
.rsc_in_memory:
	ifd MDL_RELOCATE_RSC

	move.l a1,a0		; a1.l : pointeur sur le ressource  reloger
	bsr GWVA_RSC_RELOCATE_RSC

	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne.s .error_rsc_relocate

	else

	bra.s .incoherence_include	; incohrence : avec a, on vite la catastrophe plus loin

	endc	; ifd MDL_RELOCATE_RSC

.pas_de_ressource:
.rsc_loaded_ok:
	moveq #GWVA_PRGRET_CONSUMED,d6
	moveq #GWVA_NO_ERROR_GENERIC,d7
	rts

	ifnd MDL_RELOCATE_RSC
.incoherence_include:
	moveq #GWVA_PRGRET_CONSUMED,d6
	move.w #GWVA_ERROR_WAPP_RSC_LOAD_BAD_INCLUDE,d7
	rts

	else

.error_rsc_relocate:
	moveq #GWVA_PRGRET_CONSUMED,d6	; + erreur spcifique du relocate
	rts
	endc	; ifnd MDL_RELOCATE_RSC

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WAPP_UNLOAD_RSC
; Asm label   : GWVA_WAPP_PRG_UNLOAD_RSC
; Description : Mthode dchargeant le ressource
;
; in  : a0.l = pointeur sur l'objet app
; out : d7.w = GWVA_NO_ERROR_GENERIC
;
; 17/01/98 : Cration
;------------------------------------------------------------------------------
GWVA_WAPP_PRG_UNLOAD_RSC:

	tst.l global+_AESrscfile	; (?)
	ble.s .no_rsc_loaded

	bftst GWVA_WAPP_OBJ_PROPERTIES(a0){GWVA_WAPP_OLBIT_RSC_IN_MEM:1}
	bne.s .rsc_in_mem_to_free
	rsrc_free
	bra.s .rsc_load_free
.rsc_in_mem_to_free:
	ifd MDL_RELOCATE_RSC
	tst.l GWVA_ROOT_ADD_MALLOC_RSC_ICN
	beq.s .pas_buffer_icones_couleurs
	MFREE GWVA_ROOT_ADD_MALLOC_RSC_ICN
	clr.l GWVA_ROOT_ADD_MALLOC_RSC_ICN
.pas_buffer_icones_couleurs:
	endc
.rsc_load_free:

.no_rsc_loaded:
	moveq #GWVA_PRGRET_CONSUMED,d6
	moveq #GWVA_NO_ERROR_GENERIC,d7
	rts

;------------------------------------------------------------------------------

	DATA

GWVA_WAPP_ALERT_AP_INIT_FAILED:	dc.b '[3][ Appl_init failed | Cannot run ][ Strange ]',0
GWVA_WAPP_ALERT_NO_RSC:		dc.b '[3][ Ressource File | not found ][ Suspend ]',0
GWVA_WAPP_ALERT_V_OPEN_FAILED:	dc.b '[3][ Could no open | virtual Workstation ][ Cancel ]',0
 even
	BSS

GWVA_WAPP_REDRAW_BOX:		ds.w 4	; intersec. bureau avec zone message
GWVA_WAPP_REDRAW_MSG_BUF:	ds.b L_BMSG
	TEXT

;------------------------------------------------------------------------------

	endc	; ifd MDL_GEM
