
	ifd MDL_FORM_EDITABLE_TEXT

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_WFORM_HIDE_CURSOR
; Description : efface le curseur texte de la fentre
;
; in  : a0.l = pointeur sur l'objet fentre FORM
; out : -
;
; 23/08/98 : Cration
;------------------------------------------------------------------------------
GWVA_WFORM_HIDE_CURSOR:

	cmp.w #GWVA_WFORM_CTE_FOCUSED_IDX_UNDEF,GWVA_WFORM_OBJ_FOCUSED_IDX(a0)
	beq.s .pas_objet_focus

	save.l a0

	ifnd PATCH_GWVA_WFORM_CUSTOM_EDITABLE_TEXT
	objc_edit GWVA_WRSC_OBJ_TREE_PTR(a0),GWVA_WFORM_OBJ_FOCUSED_IDX(a0),#0,GWVA_WFORM_OBJ_FOCUSED_IDX_CURSOR_POS(a0),#3
	else
	move.w GWVA_WFORM_OBJ_FOCUSED_IDX(a0),d0
	move.w #0,d1
	move.w GWVA_WFORM_OBJ_FOCUSED_IDX_CURSOR_POS(a0),d2
	move.w #3,d3
	move.l GWVA_WRSC_OBJ_TREE_PTR(a0),a0
	bsr GWVA_WFORM_PRG_OBJC_EDIT
	endc

	load.l a0
.pas_objet_focus:
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_WFORM_REDRAW_ED_TXT_CURSOR
; Description : Affiche le curseur texte de la fentre
;
; in  : a0.l = pointeur sur l'objet fentre FORM
; out : -
;
; 22/08/98 : Cration
;------------------------------------------------------------------------------
GWVA_WFORM_REDRAW_CURSOR:

	cmp.w #GWVA_WFORM_CTE_FOCUSED_IDX_UNDEF,GWVA_WFORM_OBJ_FOCUSED_IDX(a0)
	beq .no_editable_text

	move.w GWVA_WRSC_OBJ_TREE(a0),d0
	move.w GWVA_WFORM_OBJ_FOCUSED_IDX(a0),d1

	save.l a0
	bsr GWVA_RSC_RETURN_PTR_ON_TEXT	; a1.l = adresse du texte ditable
	movem.l (sp),a0

	add.w GWVA_WFORM_OBJ_FOCUSED_IDX_CURSOR_POS(a0),a1
	; a1 pointe sur la position du curseur dans le champs texte
	move.b (a1),d0
	clr.b (a1)		; pour forcer le GEM  mettre le curseur autre part qu'en fin de chaine

	save.l d0/a1

	ifnd PATCH_GWVA_WFORM_CUSTOM_EDITABLE_TEXT
	objc_edit GWVA_WRSC_OBJ_TREE_PTR(a0),GWVA_WFORM_OBJ_FOCUSED_IDX(a0),#0,GWVA_WFORM_OBJ_FOCUSED_IDX_CURSOR_POS(a0),#1
	else
	move.w GWVA_WFORM_OBJ_FOCUSED_IDX(a0),d0
	move.w #0,d1
	move.w GWVA_WFORM_OBJ_FOCUSED_IDX_CURSOR_POS(a0),d2
	move.w #1,d3
	move.l GWVA_WRSC_OBJ_TREE_PTR(a0),a0
	bsr GWVA_WFORM_PRG_OBJC_EDIT
	endc

	load.l d0/a1

	move.b d0,(a1)	; on restaure le caractre
	movem.l (sp),a0
*	move.w int_out+2,GWVA_WIND_OBJ_FOCUSED_OBJ_CURSOR_POS(a0)	; nouvelle position du curseur

	load.l a0

.no_editable_text:

	rts

	endc	; ifd MDL_FORM_EDITABLE_TEXT

		*--------------------------*

	ifd MDL_WIND_ICONIFICATION

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_WIND_TEST_IF_WIND_ICONIFIED
; Description : Test si une fentre n'est iconifie
;
; in  : a0.l = pointeur sur l'objet fentre
; out : d7.w = GWVA_ERROR_GENERIC si la fentre n'est pas ouverte ou pas cre
;	   GWVA_WIND_CTE_ICONIFIED_NO  : elle est non iconifie
;	   GWVA_WIND_CTE_ICONIFIED_YES : elle est iconifie
;
; 01/05/98 : Cration
;------------------------------------------------------------------------------
GWVA_WIND_TEST_IF_WIND_ICONIFIED:

	bsr GWVA_WIND_TEST_IF_WIND_OPENED
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	beq.s .opened_ok

	rts
.opened_ok:

	bftst GWVA_WIND_OBJ_STATUS(a0){GWVA_WIND_OLBIT_ICON:1}	; iconifie ?
	beq.s .pas_iconifiee

	moveq #GWVA_WIND_CTE_ICONIFIED_YES,d7
	rts

.pas_iconifiee:
	moveq #GWVA_WIND_CTE_ICONIFIED_NO,d7
	rts

	endc	; ifd MDL_WIND_ICONIFICATION

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_WIND_RETURN_TOP_WINDOW
; Description : retourne la fentre TOP si elle est Visual
;
; Rq  : Appel de la fonction GEM wind_create
;
; in  : a0.l = pointeur sur l'objet fentre top si d7=NO_ERROR
; out : d0.w = handle de la fentre top si d7=NO_ERROR
; out : d7.w = GWVA_NO_ERROR_GENERIC ou GWVA_ERROR_GENERIC
;
; 03/03/98 : Cration
;------------------------------------------------------------------------------
GWVA_WIND_RETURN_TOP_WINDOW:
	; renvoie a0.l = ptr fenetre, d0.w = handle gem, d7.w = erreur

	wind_get #0,#WF_TOP		; donne la window top
	move.w int_out+1*2,d0
	bra GWVA_WIND_RETURN_PTR_FROM_HANDLE
*	rts			; ruse : pas de bsr

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_WIND_CREATE_ONE_GEM_WIND
; Description : Cration d'une fentre GEM
;
; Rq  : Appel de la fonction GEM wind_create
;
; in  : a0.l = pointeur sur l'objet fentre
; out : d7.w = GWVA_NO_ERROR_GENERIC ou erreur
;	   GWVA_ERROR_WIND_GEM_CREATE
; 	   GWVA_ERROR_WIND_USER_CANCEL_CREATE (non implment)
;
; 01/02/98 : Cration
;------------------------------------------------------------------------------
GWVA_WIND_CREATE_ONE_GEM_WIND:

	bsr GWVA_WIND_RETURN_EXT_ABS_POS_SIZE	; d0-d3 = position, taille externe
	; s'il faut donner au gem une taille qu'il ne faudrait par la suite
	; ne jamais dpasser, alors comme on ne peut jamais savoir ...
	; il vaudrait peut-etre mieux appeler la routine suivante :
	;bsr GWVA_WIND_OBJ_PRG_RETURN_MAX_EXT_ABS_POS_SIZE

	ifd MDL_CHILDREN_WINDOWS

	cmp.w #GWVA_WIND_CLASS_APPLICATION,(GWVA_WIND_OBJ_CLASS,[GWVA_OBJ_FATHER_PTR,a0])
	bne.s .creation_fenetre_fille

	endc	; ifd MDL_CHILDREN_WINDOWS

	save.l a0
	wind_create GWVA_WIND_OBJ_FLAGS(a0),d0,d1,d2,d3
	load.l a0

	tst d0
	bmi.s .erreur_wind_create
	move d0,GWVA_WIND_OBJ_GEM_HANDLE(a0)

	ifd MDL_CHILDREN_WINDOWS

	bra.s .creation_fenetre_mere_ok

.creation_fenetre_fille:
	; une fentre fille prend le handle de sa fentre mre
; Il faudrait demander le handle  la fentre mre !!!!!
	move.w ([a0,GWVA_OBJ_FATHER_PTR],GWVA_WIND_OBJ_GEM_HANDLE),GWVA_WIND_OBJ_GEM_HANDLE(a0)
	bmi .erreur_wind_create

.creation_fenetre_mere_ok:

	endc	; ifd MDL_CHILDREN_WINDOWS

	bsr GWVA_WIND_UPDATE_WIND_TITLE
	bsr GWVA_WIND_UPDATE_WIND_INFO

*	; Pour avoir la bonne taille ds le dpart -> le faire plutot  l'open
*	GWVA_CALL_METHOD	#GWVA_METHOD_WIND_CALC_SLIDERS,#GWVA_MODE_SEARCH_EXEC_UNIQUE

	moveq #GWVA_NO_ERROR_GENERIC,d7
.common_error:
	rts

.erreur_wind_create:
	move #GWVA_ERROR_WIND_GEM_CREATE,d7
	bra.s .common_error

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_WIND_CREATE_OPEN_ONE_WIND
; Description : Fonction pour enchainer la cration et l'ouverture d'une fentre.
;
; in  : a0   = pointeur sur l'objet fentre
; out : d7.w = GWVA_NO_ERROR_GENERIC ou erreur de la fonction GWVA_WIND_OPEN_ONE_WIND
; 
; 31/01/98 : Cration
;------------------------------------------------------------------------------
GWVA_WIND_CREATE_OPEN_ONE_WIND:

	bsr.s GWVA_WIND_CREATE_ONE_WIND
	cmp.w #GWVA_ERROR_ROOT_HANDLE_ALREADY_ALLOCATED,d7
	beq.s .open_window
	cmp.w #GWVA_ERROR_WIND_ALREADY_CREATED,d7
	beq.s .open_window
*	cmp.w #GWVA_ERROR_ROOT_HANDLE_ALREADY_ALLOCATED,d7
*	beq.s .open_window

	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne.s .no_open

.open_window:
	bsr.s GWVA_WIND_OPEN_ONE_WIND
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	beq.s .open_was_successfull

	save.w d7
	GWVA_CALL_METHOD_OTHER_OBJ #GWVA_METHOD_DELETE
	load.w d7
.open_was_successfull:

.no_open:	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_WIND_OPEN_ONE_WIND
; Description : Fonction pour l'ouverture d'une fentre
;
; in  : a0   = pointeur sur l'objet fentre
; out : d7.w = retour de la mthode OPEN de la fentre
; 
; 07/03/98 : Cration
;------------------------------------------------------------------------------
GWVA_WIND_OPEN_ONE_WIND:
	move.w GWVA_WIND_OBJ_GEM_HANDLE(a0),d0	; les mthodes wind prennent d0 en entre
	GWVA_CALL_METHOD_OTHER_OBJ	#GWVA_METHOD_OPEN
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_WIND_CREATE_ONE_WIND
; Description : Fonction pour la cration d'une fentre
;
; in  : a0   = pointeur sur l'objet fentre
; out : d7.w =
; 
; 31/01/98 : Cration
;------------------------------------------------------------------------------
GWVA_WIND_CREATE_ONE_WIND:
	bra GWVA_ROOT_CREATE_OBJECT

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_WIND_DELETE_ONE_WIND
; Description : Fonction pour la suppression d'une fentre
;
; in  : a0   = pointeur sur l'objet fentre
; out : d7.w = erreur de la mthode DELETE
; 
; 31/01/98 : Cration
;------------------------------------------------------------------------------
GWVA_WIND_DELETE_ONE_WIND:
*	bra GWVA_ROOT_DELETE_OBJECT

	; a0 = sender
	; d0-d2/a1-a2 : rien
	move.w GWVA_OBJ_HANDLE(a0),d3		; handle dest
	move.l #GWVA_METHOD_DELETE,d4		; mthode

	move.w #%0000000000000000,d5		; pas de paramtre

	bsr GWVA_ROOT_ACTIVATE_METHODE_VIA_MESSAGE

	moveq #GWVA_NO_ERROR_GENERIC,d7
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_WIND_DELETE_ALL_WIND
; Description : Fonction pour la suppression de toutes les fentres sauf WAPP
;
; Rq  : sauvegarde a0
;
; 31/01/98 : Cration
;------------------------------------------------------------------------------
GWVA_WIND_DELETE_ALL_WIND:

	save.l a0

	move.l GWVA_ROOT_PTR_WAPP,a0
	bsr GWVA_ROOT_DELETE_ALL_FIRST_SONS

	load.l a0
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_WIND_CLOSE_ALL_WIND
; Description : Fonction pour la fermeture de toutes les fentres
;
; Rq  : sauvegarde a0
;
; 08/02/98 : Cration
;------------------------------------------------------------------------------
GWVA_WIND_CLOSE_ALL_WIND:
	save.l a0
	move.l GWVA_ROOT_PTR_WAPP,a0
	GWVA_CALL_METHOD4	#GWVA_MODE_CLASS_METHOD_SEARCH_AFS_WITH_HANDLE,#GWVA_METHOD_CLOSE
	load.l a0
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_WIND_RETURN_EXT_ABS_POS_SIZE
; Description : Retourne la position et la taille externe absolue d'une fentre
;
; in  : a0.l    = pointeur sur l'objet fentre
; out : d0-d3.w = position/taille externe de la fentre
; 
; 01/02/98 : Cration
;------------------------------------------------------------------------------
GWVA_WIND_RETURN_EXT_ABS_POS_SIZE:
	bsr.s GWVA_WIND_RETURN_INT_ABS_POS_SIZE
	bsr.s GWVA_WIND_CONVERT_INT_EXT_POS_SIZE
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_WIND_RETURN_INT_ABS_POS_SIZE
; Description : Retourne la position et la taille interne absolue d'une fentre
;
; Rq  : Uniquement d0-d3 sont modifis
;
; in  : a0.l    = pointeur sur l'objet fentre
; out : d0-d3.w = position/taille interne de la fentre
; 
; 01/02/98 : Cration
;------------------------------------------------------------------------------
GWVA_WIND_RETURN_INT_ABS_POS_SIZE:

	clr.w d0
	clr.w d1
	save.l a0

.fenetre_mere_existe:
	movem.w GWVA_WIND_OBJ_INT_DX(a0),d2-d3	; position relative  la mre
	add.w d2,d0
	add.w d3,d1

	move.l GWVA_OBJ_FATHER_PTR(a0),a0
	cmp.l #0,a0
	bne.s .fenetre_mere_existe		; on remonte jusqu' la fentre application

	load.l a0
	movem.w GWVA_WIND_OBJ_INT_VISIBLE_W(a0),d2-d3	; taille

	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_WIND_CONVERT_EXT_INT_POS_SIZE
; Description : Convertion d'une position/taille externe en une position/taille interne
;
; Rq : Prend en compte le menu
;
; in  : a0.l    = pointeur sur l'objet fentre
; in  : d0-d3.w = position/taille externe
; out : d0-d3.w = position/taille interne
; out : d0-d1.w = position relative  la mre
; 
; 01/02/98 : Cration
;------------------------------------------------------------------------------
GWVA_WIND_CONVERT_EXT_INT_POS_SIZE:	; a0 = ptr fentre V.A., d0-d3.w position/taille externe
	move GWVA_WIND_OBJ_FLAGS(a0),d4
	bsr.s GWVA_WIND_WINDCALC_EXT_INT	; d0-d3 : x,y,w,h interne relatif
	; si menu
	add GWVA_WIND_OBJ_MENU_HEIGHT(a0),d1	; position y interne du contenu
	sub GWVA_WIND_OBJ_MENU_HEIGHT(a0),d3	; taille h interne du contenu (visible)
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_WIND_CONVERT_INT_EXT_POS_SIZE
; Description : Convertie une position/taille interne en externe
;
; in  : a0.l    = pointeur sur l'objet fentre
; in  : d0-d3.w = position/taille interne de la fentre
; out : d0-d3.w = position/taille externe de la fentre
; 
; 01/02/98 : Cration
;------------------------------------------------------------------------------
GWVA_WIND_CONVERT_INT_EXT_POS_SIZE:
	move.w GWVA_WIND_OBJ_FLAGS(a0),d4
	bsr.s GWVA_WIND_WINDCALC_INT_EXT		; int -> externe relatif
	; si menu
	sub GWVA_WIND_OBJ_MENU_HEIGHT(a0),d1
	add GWVA_WIND_OBJ_MENU_HEIGHT(a0),d3	; position/taille interne reelle de la fentre
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_WIND_WINDCALC_INT_EXT
; Description : Convertie une position/taille interne en externe (sans le menu)
;
; in  : a0.l    = pointeur sur l'objet fentre
; in  : d0-d3.w = position/taille interne de la fentre
; in  : d4.w    = gadgets de la fentre
; out : d0-d3.w = position/taille externe de la fentre
; 
; 01/02/98 : Cration
;------------------------------------------------------------------------------
GWVA_WIND_WINDCALC_INT_EXT:	; Interne -> Externe

	cmp.w #GWVA_CLASS_WIND.APP,(GWVA_OBJ_CLASS,[GWVA_OBJ_FATHER_PTR,a0])
	beq.s .je_suis_une_fenetre_GEM
*	tst d4
*	bne.s .gadgets_non_nuls
	rts			; d0-d3 => inchangs

.gadgets_non_nuls:
.je_suis_une_fenetre_GEM:
	save.l a0
	wind_calc #0,d4,d0,d1,d2,d3	; int -> ext
	load.l a0
	movem.w int_out+1*2,d0-d3	; x,y,w,h
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_WIND_WINDCALC_EXT_INT
; Description : Convertie une position/taille externe en interne (sans le menu)
;
; in  : a0.l    = pointeur sur l'objet fentre
; in  : d0-d3.w = position/taille externe de la fentre
; in  : d4.w    = gadgets de la fentre
; out : d0-d3.w = position/taille interne de la fentre
; 
; 01/02/98 : Cration
;------------------------------------------------------------------------------
GWVA_WIND_WINDCALC_EXT_INT:

	cmp.w #GWVA_CLASS_WIND.APP,(GWVA_OBJ_CLASS,[GWVA_OBJ_FATHER_PTR,a0])
	beq.s .je_suis_une_fenetre_GEM
*	tst d4
*	bne.s .gadgets_non_nuls
	rts			; d0-d3 => inchangs

.gadgets_non_nuls:
.je_suis_une_fenetre_GEM:
	save.l a0
	wind_calc #1,d4,d0,d1,d2,d3	; ext -> int
	load.l a0
	movem.w int_out+1*2,d0-d3	; x,y,w,h
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_WIND_CONVERT_RELATIVE_ABSOLUTE_POS
; Description : Convertie une position relative en une position absolue
;
; in  : a0.l    = pointeur sur l'objet fentre
; in  : d0-d1.w = position relative de la fentre / sa mre
; out : d0-d1.w = position absolue de la fentre dans l'cran
; 
; 01/02/98 : Cration
;------------------------------------------------------------------------------
GWVA_WIND_CONVERT_RELATIVE_ABSOLUTE_POS:	; NE TOUCHE QUE D0  D1

	save.l a0

.teste_mere_suivante:
	move.l GWVA_OBJ_FATHER_PTR(a0),a0
	cmp.l #0,a0
	beq.s .fenetre_mere_existe_pas

	add.w GWVA_WIND_OBJ_INT_DX(a0),d0	; position relative  la mre
	add.w GWVA_WIND_OBJ_INT_DY(a0),d1

	bra.s .teste_mere_suivante

.fenetre_mere_existe_pas:

	load.l a0

	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_WIND_VERIFY_CENTER_AND_POS
; Description : Vrifie le centrage + taille / mre et la positionne dans partie visible
;
; in  : a0.l    = pointeur sur l'objet fentre
; in  : d0-d3.w = position/taille relative  la mre
; out : d0-d3.w = position/taille corriges pour apparaitre dans la mre + eventuellement centrs
; 
; 01/02/98 : Cration
;------------------------------------------------------------------------------
GWVA_WIND_VERIFY_CENTER_AND_POS:

	move.l GWVA_OBJ_FATHER_PTR(a0),a1

	movem.w GWVA_WIND_OBJ_CONTENTS_W(a1),d4-d5
	add.w GWVA_WIND_OBJ_INT_BORDERS_W(a1),d4
	add.w GWVA_WIND_OBJ_INT_BORDERS_H(a1),d5

	cmp.w d4,d2			; plus large que sa mere ?
	ble.s .pas_plus_large_que_sa_mere
	move d4,d2
.pas_plus_large_que_sa_mere:

	cmp.w d5,d3			; plus haut que sa mere ?
	ble.s .pas_plus_haut_que_sa_mere
	move d5,d3
.pas_plus_haut_que_sa_mere:

	cmp.w #GWVA_WIND_CTE_H_CENTER,d0	; centrage horizontal ?
	bne.s .pas_centrage_x

	sub.w d2,d4
	bge.s .inf_larg_ecran
	clr.w d0
	bra.s .centrage_x_impossible
.inf_larg_ecran:
	lsr.w #1,d4
	move.w d4,d0
.centrage_x_impossible:
	bra.s .test_position_verticale
.pas_centrage_x:

	tst.w d0			; sortie  gauche ?
	bpl.s .in_left
	clr.w d0
.in_left:	cmp.w d4,d0			; sortie  droite ?
	blt.s .in_right
	clr.w d0
.in_right:

.test_position_verticale:
	cmp.w #GWVA_WIND_CTE_V_CENTER,d1	; centrage vertical ?
	bne.s .pas_centrage_y

	sub.w d3,d5
	bge.s .inf_haut_ecran
	clr.w d1
	bra.s .centrage_y_impossible
.inf_haut_ecran:
	lsr #1,d5
	move d5,d1
.centrage_y_impossible:
	bra.s .fin_test_positions
.pas_centrage_y:

	tst.w d1			; sortie en haut ?
	bge.s .in_top
	clr.w d1
.in_top:	cmp.w d5,d1			; sortie en bas ?
	blt.s .in_bottom
	clr.w d1
.in_bottom:

.fin_test_positions:
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_WIND_CALC_AND_SET_SIZE_WIND
; Description : met  jour internal_dx/dy, visible_w/h + menu + form_pos
;
; Rq  : ATTENTION : pas de vrification
; Rq  :  partir d'un X,Y,W,H externe absolu en pixels dsir remet toutes les infos de la fentre  jour
; Rq  : i.e : internal_dx/dy, visible_w/h + menu + form_pos
; Rq  : ATTENTION A LA CREATION DES FENETRES : ELLES DOIVENT AVOIR UNE TAILLE
; Rq  : MINIMALE A L'OUVERTURE ; SINON LE GEM LES RESIZE AU PREMIER 'MOVE'
;
; in  : a0.l    = pointeur sur l'objet fentre
; in  : d0-d1.w = position externe absolue dsire
; in  : d2-d3.w = taille externe dsire
; 
; 01/02/98 : Cration
;------------------------------------------------------------------------------
GWVA_WIND_CALC_AND_SET_SIZE_WIND:

	bsr GWVA_WIND_CONVERT_ABSOLUTE_RELATIVE_POS
	; tout ce que l'on va stocker par la suite sera du relatif / mre

	bsr GWVA_WIND_CONVERT_EXT_INT_POS_SIZE	; -> d0-d3.w : position/taille interne
	movem.w d0-d1,GWVA_WIND_OBJ_INT_DX(a0)	; x,y relatif
	movem.w d2-d3,GWVA_WIND_OBJ_INT_VISIBLE_W(a0)	; taille interne

*; Correction pour les fentres textes entre autres
*
*	move.w d2,d0
*	move.w d3,d1
*	lea GWVA_WIND_OBJ_INT_VISIBLE_W(a0),a2
*	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS	#GWVA_METHOD_WIND_CORRECT_VISIBLE_SIZES

	cmp.w #GWVA_WIND_CTE_HANDLE_UNDEF,GWVA_WIND_OBJ_GEM_HANDLE(a0)
	beq.s .not_yet_created

	movem.w GWVA_WIND_OBJ_INT_DX(a0),d0-d1	; x,y relatif
	movem.w GWVA_WIND_OBJ_INT_VISIBLE_W(a0),d2-d3	; taille interne
	bsr GWVA_WIND_CONVERT_INT_EXT_POS_SIZE	; int -> d0-d3.w = externe relatif

; Recopie la taille et la position externe absolue pour le wind_set

	bsr GWVA_WIND_CONVERT_RELATIVE_ABSOLUTE_POS	; -> d0-d3.w

	bftst GWVA_WIND_OBJ_STATUS(a0){GWVA_WIND_OLBIT_NAMIFIED:1}	; namified ?
	beq.s .pas_namifiee

	move.w GWVA_WIND_OBJ_INT_VISIBLE_H(a0),d4
	add GWVA_WIND_OBJ_MENU_HEIGHT(a0),d4
	sub.w d4,d3
.pas_namifiee:

	cmp.w #GWVA_CLASS_WIND.APP,(GWVA_OBJ_CLASS,[GWVA_OBJ_FATHER_PTR,a0])
	bne.s .pas_wind_set_pour_fenetre_fille

	bftst GWVA_WIND_OBJ_STATUS(a0){GWVA_WIND_OLBIT_OPEN:1}	; open ?
	beq.s .fenetre_non_ouverte_pas_wind_set

	save.l a0
	movem.w d0-d3,int_in+2*2
	wind_set GWVA_WIND_OBJ_GEM_HANDLE(a0),#WF_CURRXYWH
	load.l a0

.fenetre_non_ouverte_pas_wind_set:
.pas_wind_set_pour_fenetre_fille:
.not_yet_created:

; Il faudrait faire appel au mthode : UPDATE_MENU et UPDATE_CONTENTS

	bsr.s GWVA_WIND_UPDATE_ONE_FAMILY_MEMBER_MENU_AND_FORM

	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_WIND_CONVERT_ABSOLUTE_RELATIVE_POS
; Description : Convertion d'une position absolue en position relative  sa mre
;
; Rq  : Une position absolue est relative pour la fentre application
;
; in  : a0.l    = pointeur sur l'objet fentre
; in  : d0-d1.w = position absolue
; out : d0-d1.w = position relative  la mre
; 
; 01/02/98 : Cration
;------------------------------------------------------------------------------
GWVA_WIND_CONVERT_ABSOLUTE_RELATIVE_POS:	; NE TOUCHE QUE D0  D1

	save.l a0

.teste_mere_suivante:
	move.l GWVA_OBJ_FATHER_PTR(a0),a0
	cmp.l #0,a0
	beq.s .fenetre_mere_existe_pas

	sub.w GWVA_WIND_OBJ_INT_DX(a0),d0	; position relative  la mre
	sub.w GWVA_WIND_OBJ_INT_DY(a0),d1	; position relative  la mre

	bra.s .teste_mere_suivante
.fenetre_mere_existe_pas:

	load.l a0

	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_WIND_UPDATE_ONE_FAMILY_MEMBER_MENU_AND_FORM
; Description : Met  jour la position du menu et du formulaire
;
; Rq  : A couper en deux et  appeler en mthode 
;
; in  : a0.l = pointeur sur l'objet fentre
; 
; 01/02/98 : Cration
;------------------------------------------------------------------------------
GWVA_WIND_UPDATE_ONE_FAMILY_MEMBER_MENU_AND_FORM:

	bftst GWVA_WIND_OBJ_PROPERTIES(a0){GWVA_WIND_OLBIT_AMENU:1}
	beq.s .no_menu

	tst.l GWVA_WIND_OBJ_MENU_SPEC_PTR(a0)
	bne.s .ptr_menu_non_nul
	GWVA_PROGRAMMER_ERROR	GWVA_ASCII_ERROR_MENU_PTR_NULL
.ptr_menu_non_nul:

	save.l a0
	move.l a0,a1
	move.l GWVA_WIND_OBJ_MENU_SPEC_PTR(a0),a0
	GWVA_CALL_METHOD_OTHER_OBJ	#GWVA_METHOD_MENU_UPDATE
	load.l a0
.no_menu:

	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_WIND_TEST_IF_WIND_CREATED
; Description : Test si une fentre est cre
;
; in  : a0.l = pointeur sur l'objet fentre
; out : d7.w = GWVA_NO_ERROR_GENERIC si la fentre existe,
;	   GWVA_ERROR_GENERIC sinon.
;
; 01/02/98 : Cration
;------------------------------------------------------------------------------
GWVA_WIND_TEST_IF_WIND_CREATED:
	bsr GWVA_ROOT_TEST_IF_OBJECT_CREATED
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne.s .no_exist
	cmp.w #GWVA_WIND_CTE_HANDLE_UNDEF,GWVA_WIND_OBJ_GEM_HANDLE(a0)
	beq.s .no_exist
	moveq #GWVA_NO_ERROR_GENERIC,d7
	rts
.no_exist:	moveq #GWVA_ERROR_GENERIC,d7
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_WIND_TEST_IF_WIND_OPENED
; Description : Test si une fentre est ouverte
;
; in  : a0.l = pointeur sur l'objet fentre
; out : d7.w = GWVA_NO_ERROR_GENERIC si la fentre existe et est ouverte,
;	   GWVA_ERROR_GENERIC sinon.
;
; 27/02/98 : Cration
;------------------------------------------------------------------------------
GWVA_WIND_TEST_IF_WIND_OPENED:

	bsr.s GWVA_WIND_TEST_IF_WIND_CREATED
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne.s .no_exists

	bftst GWVA_WIND_OBJ_STATUS(a0){GWVA_WIND_OLBIT_OPEN:1}	; la fentre est ferme
	beq.s .fermee

	moveq #GWVA_NO_ERROR_GENERIC,d7
	rts
.fermee:	moveq #GWVA_ERROR_GENERIC,d7
.no_exists:
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_WIND_UPDATE_WIND_TITLE
; Description : Met  jour le titre de la fentre
;
; in  : a0.l = pointeur sur l'objet fentre
; 
; 01/02/98 : Cration
;------------------------------------------------------------------------------
GWVA_WIND_UPDATE_WIND_TITLE:
	bsr.s GWVA_WIND_TEST_IF_WIND_CREATED
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne.s .not_created

	btst #NAME,GWVA_WIND_OBJ_FLAGS+1(a0)	; titre/move ?
	beq.s .pas_de_titre
	move.l GWVA_WIND_OBJ_NAME_PTR(a0),d0
	beq.s .pas_de_titre
	move.l d0,int_in+4
	save.l a0
	wind_set GWVA_WIND_OBJ_GEM_HANDLE(a0),#WF_NAME
	load.l a0
.pas_de_titre:
.not_created:
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_WIND_UPDATE_WIND_INFO
; Description : Met  jour l'info de la fentre
;
; in  : a0.l = pointeur sur l'objet fentre
; 
; 01/02/98 : Cration
;------------------------------------------------------------------------------
GWVA_WIND_UPDATE_WIND_INFO:
	bsr.s GWVA_WIND_TEST_IF_WIND_CREATED
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne.s .not_created

	btst #INFO,GWVA_WIND_OBJ_FLAGS+1(a0)	; ligne info ?
	beq.s .pas_d_info
	move.l GWVA_WIND_OBJ_INFO_PTR(a0),d0
	beq.s .pas_d_info
	move.l d0,int_in+4
	save.l a0
	wind_set GWVA_WIND_OBJ_GEM_HANDLE(a0),#WF_INFO
	load.l a0
.pas_d_info:
.not_created:
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_WIND_RETURN_MAX_EXT_ABS_POS_SIZE
; Description : Retourne la taille externe maximum possible de cette fentre
;
; in  : a0.l = pointeur sur l'objet fentre
; out : d0-d3.w = x,y,w,h max ext
; 
; 10/02/98 : Cration
;------------------------------------------------------------------------------

GWVA_WIND_RETURN_MAX_EXT_ABS_POS_SIZE:

	save.l a0

	move.l GWVA_OBJ_FATHER_PTR(a0),a0	; on prend la mre
	cmp.l #0,a0
	bne.s .fenetre_mere_existe
	illegal	; normalement, on doit renvoyer la taille de l'cran ...
.fenetre_mere_existe:

	movem.w GWVA_WIND_OBJ_INT_DX(a0),d0-d1
	movem.w GWVA_WIND_OBJ_CONTENTS_W(a0),d2-d3
	add.w GWVA_WIND_OBJ_INT_BORDERS_W(a0),d2
	add.w GWVA_WIND_OBJ_INT_BORDERS_H(a0),d3

	bsr GWVA_WIND_CONVERT_RELATIVE_ABSOLUTE_POS
	load.l a0

	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_WIND_REDUCE_EXT_WH_TO_CONTENTS
; Description : Rduit une taille externe donne en tenant compte du max w,h
;
; Rq  : d0/d1 modifis
;
; in  : a0.l = pointeur sur l'objet fentre
; out : d2-d3.w = w,h ext corrig si besoin
; 
; 10/02/98 : Cration
;------------------------------------------------------------------------------

GWVA_WIND_REDUCE_EXT_WH_TO_CONTENTS:

	bsr GWVA_WIND_CONVERT_EXT_INT_POS_SIZE

	movem.w GWVA_WIND_OBJ_CONTENTS_W(a0),d4-d5
	add.w GWVA_WIND_OBJ_INT_BORDERS_W(a0),d4
	add.w GWVA_WIND_OBJ_INT_BORDERS_H(a0),d5

	cmp.w d4,d2
	ble.s .pas_trop_large
	move.w d4,d2
.pas_trop_large:
	cmp.w d5,d3
	ble.s .pas_trop_haut
	move.w d5,d3
.pas_trop_haut:

	bsr GWVA_WIND_CONVERT_INT_EXT_POS_SIZE

	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_WIND_INTERSEC_REC
; Description : Vrifie s'il y a intersection de deux zones
;
; Rq  : d0/d1 modifis
;
; in  : a3.l = pointeur sur l'objet fentre
; in  : d0-d3.w = x,y,w,h de la zone 1
; in  : d4-d7.w = x,y,w,h de la zone 2
; out : d0-d3.w = x,y,w,h de la zone intersection si GWVA_NO_ERROR_GENERIC
; out : d7.w = GWVA_NO_ERROR_GENERIC s'il y a intersection,
;	   GWVA_ERROR_GENERIC sinon.
; 
; 12/02/98 : Cration
;------------------------------------------------------------------------------

GWVA_WIND_INTERSEC_REC:
*	movem.w (a2),d4-d7
	add.w d0,d2		; x1
	add.w d1,d3		; y1
	add.w d4,d6		; x2
	add.w d5,d7		; y2

; pas de sub.w #1... car on repasse en fin de fonction en w,h

	cmp.w d7,d3
	ble.s .min1
	move.w d7,d3
.min1:	cmp.w d6,d2
	ble.s .min2
	move.w d6,d2
.min2:
	cmp.w d5,d1
	bge.s .max1
	move.w d5,d1
.max1:	cmp.w d4,d0
	bge.s .max2
	move.w d4,d0
.max2:
	sub.w d1,d3
	sub.w d0,d2

	moveq #GWVA_ERROR_GENERIC,d7

	tst d3
	ble.s .pb
	tst d2
	ble.s .pb
	moveq #GWVA_NO_ERROR_GENERIC,d7
.pb:	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_WIND_RETURN_VISIBLE_CONTENTS_ABS_POS_SIZE
; Description : retourne la position/taille abosule du contenu visible
;
; Rq  : Uniquement d0-d3 sont modifis
;
; in  : a0.l = pointeur sur l'objet fentre
; out : d0-d1.w = position absolue du contenu visible de la fentre
; out : d2-d3.w = taille visible contenu(peut tre <=0)
; 
; 12/02/98 : Cration
;------------------------------------------------------------------------------

GWVA_WIND_RETURN_VISIBLE_CONTENTS_ABS_POS_SIZE:

	bsr GWVA_WIND_RETURN_INT_ABS_POS_SIZE
	add.w GWVA_WIND_OBJ_CONTENTS_DX(a0),d0
	add.w GWVA_WIND_OBJ_CONTENTS_DY(a0),d1
	sub.w GWVA_WIND_OBJ_INT_BORDERS_W(a0),d2
	sub.w GWVA_WIND_OBJ_INT_BORDERS_H(a0),d3
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_WIND_UPDATE_MENU_AND_FORM
; Description : positionne le menu et le form en multi-form
;
; Rq  : Routine utile en multiform ou multi-menu
;
; in  : a0.l = pointeur sur la fentre
;
; 12/02/98 : Cration
;------------------------------------------------------------------------------

GWVA_WIND_UPDATE_MENU_AND_FORM:	; a0=ptr fenetre

	ifd MDL_CHILDREN_WINDOWS

	save.l a0
	clr.w -(sp) 			; niveau relatif
.update_all_child_windows:
	bsr GWVA_WIND_OBJ_PRG_UPDATE_ONE_FAMILY_MEMBER_MENU_AND_FORM	; a0=ptr fenetre

	load.w d0
	bsr GWVA_WIND_OBJ_PRG_RETURN_NEXT_FAMILY_MEMBER
	tst d0
	ble.s .retour_a_la_fenetre_mere_son_frere_ou_au_dessus
	save.w d0
	bra.s .update_all_child_windows

.retour_a_la_fenetre_mere_son_frere_ou_au_dessus:
	load.l a0
	clr.w d7
	rts

	endc	; ifd MDL_CHILDREN_WINDOWS

	*-------------------------------*

	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_WIND_RETURN_PTR_FROM_HANDLE
; Description : retourne  partir d'un handle un pointeur sur une fentre
;
; Rq  : aucun registre n'est modifi
;
; in  : d0.w = handle GEM de la fenetre dont on veut le pointeur
; out : a0.l = pointeur sur la fentre
; out : d7.w = GWVA_NO_ERROR_GENERIC s'il y a une fentre rpondant au critre,
;	   GWVA_ERROR_GENERIC sinon.
;
; 14/02/98 : Cration
;------------------------------------------------------------------------------
GWVA_WIND_RETURN_PTR_FROM_HANDLE:

	tst d0
	bmi.s .bad_handle

	move.l GWVA_ROOT_PTR_WAPP,a0
	move.l GWVA_OBJ_FIRST_SON_PTR(a0),a0
	cmp.l #0,a0
	beq.s .pas_de_fenetre

.cherche_handle:
	cmp.w GWVA_WIND_OBJ_GEM_HANDLE(a0),d0
	beq.s .found
	move.l GWVA_OBJ_NEXT_BROTHER_PTR(a0),a0
	cmp.l #0,a0
	bne.s .cherche_handle

.pas_de_fenetre:
.bad_handle:moveq #GWVA_ERROR_GENERIC,d7
	rts

.found:	moveq #GWVA_NO_ERROR_GENERIC,d7
	rts
