	DATA

GWVA_WRSC_DEFAULT_METHODLIST:
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_CREATE,GWVA_WRSC_PRG_CREATE
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_DELETE,GWVA_WRSC_PRG_DELETE
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WM_REDRAW,GWVA_WRSC_PRG_WM_REDRAW
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WM_FULL,GWVA_WRSC_PRG_FULL
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WRSC_REDRAW_PART_CONTENTS,GWVA_WRSC_PRG_REDRAW_PART_CONTENTS
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WRSC_UPDATE,GWVA_WRSC_PRG_UPDATE
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WIND_CLICK,GWVA_WRSC_PRG_CLICK
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_WRSC_IDX_UNDER_XY,GWVA_WRSC_PRG_OBJECT_UNDER_XY
	GWVA_OBJ_STRUCT_METHOD_END_LIST

	TEXT

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WRSC_IDX_UNDER_XY
; Asm label   : GWVA_WRSC_PRG_OBJECT_UNDER_XY
; Description : Renvoi l'index de l'objet RSC  la position x,y, ainsi que le pre
;
; Rq  : -
;
; in  : a0.l = pointeur sur l'objet fentre RSC
; in  : a1.l = pointeur sur la zone  remplir avec l'index de l'objet et celui du pre (0 si pas de pre)
; in  : d0.w = X.w
; in  : d1.w = Y.w
; out : d6.w = GWVA_PRGRET_CONSUMED
; out : d7.w = GWVA_NO_ERROR_GENERIC ou 
;	   GWVA_WRSC_CTE_NO_RSC_OBJECT
;
; 10/08/98 : Cration
;------------------------------------------------------------------------------
GWVA_WRSC_PRG_OBJECT_UNDER_XY:

	save.l a0-a1/d0-d1
	objc_find GWVA_WRSC_OBJ_TREE_PTR(a0),GWVA_WRSC_OBJ_IDX(a0),GWVA_WRSC_OBJ_DEPTH(a0),d0,d1
	move d0,d2			; objet trouv
	load.l a0-a1/d0-d1

	tst d2
	bmi .pas_d_objet_gem_rsc

	save.l d0-d2/a0-a1
	move.l GWVA_WRSC_OBJ_TREE_PTR(a0),a0	; a0.l tree
	move d2,d0				; d0.w num obj
	bsr GWVA_RSC_FIND_FATHER_OBJECT
	move d0,d3			; pre
	load.l d0-d2/a0-a1
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	beq.s .pas_erreur
	clr d3			; c'est qu'on tait obj 0 : pas de pre
.pas_erreur:

	move.w d2,(a1)+
	move.w d3,(a1)+
	move.w #GWVA_NO_ERROR_GENERIC,d7
	move.w #GWVA_PRGRET_CONSUMED,d6
	rts
.pas_d_objet_gem_rsc:
	move.w #GWVA_WRSC_CTE_NO_RSC_OBJECT,d7
	move.w #GWVA_PRGRET_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WIND_CLICK
; Asm label   : GWVA_WRSC_PRG_CLICK
; Description : Gestion du clic dans une fentre ressource
;
; Rq  : -
;
; in  : a0.l = pointeur sur l'objet fentre
; in  : d0.l = [ X.w | handle fentre gem.w ]
; in  : d1.l = [ mouse button.w | Y.w ]
; in  : d2.l = [ Key state.w | mouse count.w ]
; out : d6.w = GWVA_PRGRET_CONSUMED si le click est pour la fentre
;	   ou GWVA_PRGRET_NOT_CONSUMED sinon
; out : d7.w = GWVA_WIND_CTE_CLICK_IS_CONSUMED : le clic a t consomm par la fentre
;	   GWVA_WRSC_CTE_CLICK_IS_CONSUMED : clic dans un objet GEM RSC
; 	   GWVA_WRSC_CTE_CLICK_IS_NOT_CONSUMED : clic pas dans un objet GEM RSC
;
; 14/01/98 : Cration
; 26/03/98 : Changement de l'infertace pour le form_clic
; 30/07/98 : Surcharge de la mthode click de la classe WIND
;------------------------------------------------------------------------------
GWVA_WRSC_PRG_CLICK:

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_WIND_CLICK
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq .pas_wrsc_click_car_on_wrsc_click_consome

	;-----------------------------------;

	; appeler la mthode de la fentre WIND
	GWVA_CALL_METHOD_INHERITED

	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	bne .methode_non_consommee_par_pere

	cmp.w #GWVA_WIND_CTE_CLICK_IS_NOT_CONSUMED,d7
	bne .click_consommee_par_pere

	;--------------------

; Mise  jour du ressource

	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS	#GWVA_METHOD_WRSC_UPDATE

	;--------------------

	save.l d0
	lea GWVA_WRSC_TMP_BUFFER,a1
	swap d0
	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS	#GWVA_METHOD_WRSC_IDX_UNDER_XY
	load.l d0

	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	beq.s .object_under_xy
	cmp.w #GWVA_WRSC_CTE_NO_RSC_OBJECT,d7
	beq.s .pas_d_objet_gem_rsc
	illegal
.object_under_xy:

	;-----------------------------------;

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_WIND_CLICKED

	move.w #GWVA_WRSC_CTE_CLICK_IS_CONSUMED,d7
.pas_wrsc_click_car_on_wrsc_click_consome:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts
.pas_d_objet_gem_rsc:
	move.w #GWVA_WRSC_CTE_CLICK_IS_NOT_CONSUMED,d7
.click_consommee_par_pere:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts
.methode_non_consommee_par_pere:
	moveq #GWVA_PRGRET_NOT_CONSUMED,d6
	rts
 
;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WM_FULL
; Asm label   : GWVA_WRSC_PRG_FULL
; Description : demande de Full d'une fentre : namification d'une fentre RSC
;
; Rq  : Surcharge de la mthode FULL de la classe WIND
;
; in  : a0.l = pointeur sur la fentre
; in  : a1.l = pointeur sur le buffer message reu du GEM
; in  : a2.l = pointeur sur le buffer GEM tendu s'il y en avait un prsent ou 0.l sinon
; in  : d0.w = handle de la fentre  fuller
; out : d6.w = GWVA_PRGRET_CONSUMED
;
; 14/06/98 : Cration
;------------------------------------------------------------------------------
GWVA_WRSC_PRG_FULL:

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_WM_FULL
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq .pas_full_car_on_full_consome

	;-----------------------------------;

	cmp.w GWVA_WIND_OBJ_GEM_HANDLE(a0),d0	; handle de la fentre concerne
	bne .je_ne_suis_pas_concerne_par_ce_msg

	save.l d0/a0-a2

	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS	#GWVA_METHOD_WIND_NAMIFY_UNAMIFY

	;-----------------------------------;

	load.l d0/a0-a2

	; envoyer la mthode GWVA_METHOD_FULLED

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_WM_FULLED

.pas_full_car_on_full_consome:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.je_ne_suis_pas_concerne_par_ce_msg:
	moveq #GWVA_PRGRET_NOT_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WRSC_REDRAW_PART_CONTENTS
; Asm label   : GWVA_WRSC_PRG_REDRAW_PART_CONTENTS
; Description : Mthode de redessin d'une partie d'un ressource
;
; Rq  : La demande de dessin se fera via le pipe GEM
; Rq  : C'est un message spcial tendu qui sera envoy : GWVA_MSG_REDRAW_PART
;
; in  : a0.l = pointeur sur l'objet fentre ressource
; in  : a1.l = pointeur sur un buffer liste de objet/profondeur
;	   termine par GWVA_WRSC_CTE_REDRAW_PART_END_LIST
;	   aucune limite sur la taille du buffer point par a1:
;	   on morcellera si ncssaire
; out : d6.w = GWVA_PRGRET_CONSUMED
;
; 21/06/98 : Cration
;------------------------------------------------------------------------------
GWVA_WRSC_PRG_REDRAW_PART_CONTENTS:

	bsr GWVA_WIND_RETURN_INT_ABS_POS_SIZE

	lea GWVA_ROOT_TMP_MSG_OUT_BUF,a2
	move.w GWVA_WIND_OBJ_GEM_HANDLE(a0),bmsg_handle(a2)
	movem.w d0-d3,bmsg_xywh(a2)

	move.w #GWVA_MSG_WRSC_REDRAW_PART,bmsg_msgid(a2)

.suite_cut_input:
	lea GWVA_ROOT_TMP_MSG_OUT_EXT_BUF,a2
	moveq #2,d0			; compteur taille

.copie_dans_out_buf:
	cmp.w #256-(2*2),d0		; le dernier .w est dj compt
	bgt.s .cut_input
	move.w (a1)+,(a2)+
	cmp.w #GWVA_WRSC_CTE_REDRAW_PART_END_LIST,-2(a2)
	beq.s .fin_liste_entree
	move.w (a1)+,(a2)+
	add.w #2*2,d0
	bra.s .copie_dans_out_buf

.cut_input:
	; on a dj recopi la fin de liste dans la foule
	moveq #GWVA_MODE_SEND_GEM_MESSAGE_TO_MYSELF,d1
	save.l a1
	lea GWVA_ROOT_TMP_MSG_OUT_BUF,a0
	add #16,d0			; de base
	bsr GWVA_ROOT_SEND_GEM_MESSAGE
	load.l a1
	bra.s .suite_cut_input

.fin_liste_entree:
	; on a dj recopi la fin de liste dans la foule
	moveq #GWVA_MODE_SEND_GEM_MESSAGE_TO_MYSELF,d1
	lea GWVA_ROOT_TMP_MSG_OUT_BUF,a0
	add #16,d0			; de base
	bsr GWVA_ROOT_SEND_GEM_MESSAGE

	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WM_REDRAW
; Asm label   : GWVA_WRSC_PRG_WM_REDRAW
; Description : Mthode de redessin d'une partie d'une fenetre ressource
;
; in  : a0.l = pointeur sur la fentre ressource
; in  : a1.l = pointeur sur le buffer message reu du GEM
; in  : a2.l = pointeur sur le buffer GEM tendu s'il y en avait un prsent ou 0.l sinon
; in  : d0.w = handle de la fentre
; out : d6.w = GWVA_PRGRET_CONSUMED si le message est pour cette fentre
;	   GWVA_PRGRET_NOT_CONSUMED sinon
; out : d7.w = GWVA_WIND_CTE_REDRAW_IS_POSSIBLE
; 	   GWVA_WIND_CTE_REDRAW_IS_NOT_POSSIBLE
;
; 13/06/98 : Cration
; 20/07/98 : Surcharge de la mthode REDRAW de la classe WIND
; 30/07/98 : Prise en compte de l'hritage
;------------------------------------------------------------------------------
GWVA_WRSC_PRG_WM_REDRAW:

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_WM_REDRAW
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq .pas_redraw_car_on_redraw_consome

	;-----------------------------------;

	; !! attention  a1 et a2 tout du long !!!

	; appeler la mthode de la fentre WIND
	GWVA_CALL_METHOD_INHERITED

	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	bne .methode_non_consommee_par_pere

	cmp.w #GWVA_WIND_CTE_REDRAW_IS_POSSIBLE,d7
	bne .methode_consomme_mais_pas_traitement_par_pere

	;-----------------------------------;

; On remet le ressource  sa place dans la fentre

	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS	#GWVA_METHOD_WRSC_UPDATE

	;----------------

	save.w d0

	save.l a0-a2

	bsr GWVA_ROOT_HIDE_MOUSE

	movem.l (sp),a0-a2

	cmp.l #0,a2
	bne.s .redraw_not_all_object

	movem.w bmsg_xywh(a1),d0-d3
	move.w GWVA_WRSC_OBJ_IDX(a0),d4
	move.w GWVA_WRSC_OBJ_DEPTH(a0),d5
	bsr .do_one_basic_redraw_of_a_object
	bra .fin_redraw_formulaire

.redraw_not_all_object:
.boucle_parse_all_objects:
	cmp.w #GWVA_WRSC_CTE_REDRAW_PART_END_LIST,(a2)
	beq .fin_boucle_redraw_multi_objets
	movem.w bmsg_xywh(a1),d0-d3
	movem.w (a2),d4/d5
	save.l a0-a2
	bsr .do_one_basic_redraw_of_a_object
	load.l a0-a2
	lea 2*2(a2),a2
	bra.s .boucle_parse_all_objects

	;-------------------

.do_one_basic_redraw_of_a_object:
	; d0-d3 = x,y,w,h  de la zone  redessiner
	; d4/d5 = objet  redessiner / profondeur de redessin

	save.w d4-d5
	save.l d0-d3/a0

	move.l GWVA_WRSC_OBJ_TREE_PTR(a0),a0
	move d4,d0
	bsr GWVA_RSC_RETURN_OBJ_POS_SIZE	; d0=index/a0=ptr sur l'arbre
	move.w d0,d4
	move.w d1,d5
	move.w d2,d6
	move.w d3,d7

	load.l d0-d3/a0

	bsr GWVA_WIND_INTERSEC_REC	; intersection entre d0-d3 et d4-d7
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne .pas_intersection_objet_rectangle_reduit

	movem.w (sp),d4-d5

	save.l a0
	objc_draw GWVA_WRSC_OBJ_TREE_PTR(a0),d4,d5,d0,d1,d2,d3
	load.l a0

.pas_intersection_objet_rectangle_reduit:

	load.w d4-d5
	rts

	;-----------

.fin_boucle_redraw_multi_objets:
.fin_redraw_formulaire:

	bsr GWVA_ROOT_SHOW_MOUSE
	load.l a0-a2
	load.w d0

	;-----------------------------------;
	; envoyer la mthode GWVA_METHOD_WM_REDRAWN

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_WM_REDRAWN

	moveq #GWVA_WIND_CTE_REDRAW_IS_POSSIBLE,d7
.methode_consomme_mais_pas_traitement_par_pere:
.pas_redraw_car_on_redraw_consome:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts
.methode_non_consommee_par_pere:
	moveq #GWVA_PRGRET_NOT_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_DELETE
; Asm label   : GWVA_WRSC_PRG_DELETE
; Description : Mthode de destruction du contenu d'une fentre ressource
;
; in  : a0.l = pointeur sur la fentre
; out : d6.w = GWVA_PRGRET_CONSUMED
;
; 13/06/98 : Cration
;------------------------------------------------------------------------------
GWVA_WRSC_PRG_DELETE:

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_DELETE
; Si on revient de cette mthode, il faut tout de mme continuer (cas exceptionel)

	;-----------------------------------;

	ifd MDL_WIND_RSC_CLONING
	
	tst.w GWVA_WRSC_OBJ_IS_CLONE_RSC(a0)
	beq.s .pas_de_clonage

	bftst GWVA_WRSC_OBJ_PROPERTIES(a0){GWVA_WRSC_OLBIT_FREECLONE:1}
	beq.s .pas_de_libration_automatique
	move.l GWVA_WRSC_OBJ_CLONE_SAVED_RSC_PTR(a0),d0
	beq.s .pas_de_sauvegarde
	save.l a0
	MFREE d0
	load.l a0
	clr.l GWVA_WRSC_OBJ_CLONE_SAVED_RSC_PTR(a0)
.pas_de_sauvegarde:
.pas_de_libration_automatique:
.pas_de_clonage:

	endc	; ifd MDL_WIND_RSC_CLONING

	;-------------

	; appeler la mthode de la fentre WIND
	GWVA_CALL_METHOD_INHERITED

	;-------------

	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_CREATE
; Asm label   : GWVA_WRSC_PRG_CREATE
; Description : Mthode de cration du contenu d'une fentre ressource
;
; Rq  : Renseigne les champs GWVA_WIND_OBJ_CONTENTS_W/H
;
; in  : a0.l = pointeur sur la fentre
; out : d6.w = GWVA_PRGRET_CONSUMED
; out : d7.w = GWVA_NO_ERROR_GENERIC ou
;	   GWVA_ERROR_MALLOC si on n'a pas pu dupliquer le clone du ressource
;	   ou erreurs de la classe WIND
;
; 01/06/98 : Cration
; 01/09/98 : Clonage du ressource
;------------------------------------------------------------------------------
GWVA_WRSC_PRG_CREATE:
	GWVA_CHECK_OBJ_HANDLE

	;-----------------------------------;

	save.l a0
	move.w GWVA_WRSC_OBJ_TREE(a0),d0
	lea GWVA_WRSC_OBJ_TREE_PTR(a0),a0
	bsr GWVA_RSC_RETURN_PTR_ON_TREE	; on initialise le pointeur du formulaire
	load.l a0

	;------------

	ifd MDL_WIND_RSC_CLONING
	
; On doit cloner le ressource si ncessaire
	tst.w GWVA_WRSC_OBJ_IS_CLONE_RSC(a0)
	beq.s .pas_de_clonage

	tst.l GWVA_WRSC_OBJ_CLONE_SAVED_RSC_PTR(a0)
	bne.s .sauvegarde_deja_presente

	save.l a0
	move.l GWVA_WRSC_OBJ_CLONE_SAVED_RSC_PTR(a0),a0
	lea 0.w,a1
	bsr GWVA_RSC_COPY_SAVED_TREE
	move.l a0,a1
	load.l a0
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne .erreur_creation_clone
	move.l a1,GWVA_WRSC_OBJ_CLONE_SAVED_RSC_PTR(a0)

.sauvegarde_deja_presente:
.pas_de_clonage:

	endc	; ifd MDL_WIND_RSC_CLONING

	*---- Traitement de la toolbar ----*

	ifd MDL_WIND_TOOLBAR

	bftst GWVA_WIND_OBJ_PROPERTIES(a0){GWVA_WIND_OLBIT_TOOLBAR:1}
	beq.s .pas_toolbar

; on prend la largeur du bureau car c'est la seule chose fixe que l'on
; connaisse  coup sur ! Prendre "ma mre de la mre" ne fonctionne pas !
	move.l GWVA_ROOT_PTR_WAPP,a1

	move.l GWVA_WRSC_OBJ_TREE_PTR(a0),a2	; je pointe directement l'objet #0
; Prendre IDX au lieu du root

	movem.w GWVA_WIND_OBJ_CONTENTS_W(a1),d0-d1
	add.w GWVA_WIND_OBJ_INT_BORDERS_W(a1),d0
	add.w GWVA_WIND_OBJ_INT_BORDERS_H(a1),d1

	move.l GWVA_WIND_OBJ_PROPERTIES(a0),d4
	and.l #GWVA_WIND_MASK_TOOLBAR_POS,d4

	cmp.l #GWVA_WIND_MASK_TOOLBAR_TOP,d4
	bne.s .pas_toolbar_top
	move.w d0,ob_width(a2)	; on force la taille de l'objet #0  la taille max interne de la mre
.pas_toolbar_top:
	cmp.l #GWVA_WIND_MASK_TOOLBAR_BOTTOM,d4
	bne.s .pas_toolbar_bottom
	move.w d0,ob_width(a2)	; on force la taille de l'objet #0  la taille max interne de la mre
.pas_toolbar_bottom:
	cmp.l #GWVA_WIND_MASK_TOOLBAR_RIGHT,d4
	bne.s .pas_toolbar_right
	move.w d1,ob_height(a2)	; on force la taille de l'objet #0  la taille max interne de la mre
.pas_toolbar_right:
	cmp.l #GWVA_WIND_MASK_TOOLBAR_LEFT,d4
	bne.s .pas_toolbar_left
	move.w d1,ob_height(a2)	; on force la taille de l'objet #0  la taille max interne de la mre
.pas_toolbar_left:

.pas_toolbar:
	endc	; ifd MDL_WIND_TOOLBAR

; On calcule la taille de l'objet #0 du formulaire : a nous donne 
; la taille de la fentre

	save.l a0
	move.w GWVA_WRSC_OBJ_IDX(a0),d0
	move.l GWVA_WRSC_OBJ_TREE_PTR(a0),a0
	bsr GWVA_RSC_RETURN_OBJ_POS_SIZE
	move.l a0,a2
	load.l a0
	movem.w d2-d3,GWVA_WIND_OBJ_CONTENTS_W(a0)

	;-------------

	; appeler la mthode de la fentre WIND
	GWVA_CALL_METHOD_INHERITED
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne.s .pas_creation

	;-------------

	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS	#GWVA_METHOD_WRSC_UPDATE

	;-----------------------------------;

	; envoyer la mthode GWVA_METHOD_CREATED

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_CREATED

	moveq #GWVA_NO_ERROR_GENERIC,d7
.pas_creation:
.erreur_creation_clone:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_WRSC_UPDATE
; Asm label   : GWVA_WRSC_PRG_UPDATE
; Description : Met  jour la position du ressource, et son contenu dans le cas
;	    d'un multi-formulaire
;
; Rq  : 
;
; in  : a0.l = pointeur objet
; out : d6.w = GWVA_PRGRET_CONSUMED
;
; 30/07/98 : Cration
;------------------------------------------------------------------------------
GWVA_WRSC_PRG_UPDATE:
	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_WRSC_UPDATE
	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	beq .pas_wrsc_update_car_on_wrsc_update

	;-----------------------------------;

	ifd MDL_WIND_RSC_CLONING

	bsr GWVA_WRSC_UPDATE_MULTI_RSC

	endc	; ifd MDL_WIND_RSC_CLONING

	save.l a0
	objc_offset GWVA_WRSC_OBJ_TREE_PTR(a0),#0	; -> position du root
	movem.w int_out+1*2,d2-d3	; x,y du root du tree
	load.l a0
	save.l d2-d3/a0
	objc_offset GWVA_WRSC_OBJ_TREE_PTR(a0),GWVA_WRSC_OBJ_IDX(a0)	; -> position de l'objet de la fentre
	movem.w int_out+1*2,d0-d1	; x,y de l'objet voulue
	load.l d2-d3/a0
	sub.w d0,d2			; dcalage du root/objet de la fentre
	sub.w d1,d3

	save.w d2-d3
	bsr GWVA_WIND_RETURN_INT_ABS_POS_SIZE	; -> d0/d1 position absolue de la fentre
	load.w d2-d3
	add.w d2,d0
	add.w d3,d1

	move.l GWVA_WRSC_OBJ_TREE_PTR(a0),a2
	movem.w d0-d1,ob_x(a2)			; positionne l'objet voulu dans dans le contents de la fentre

	save.l a0/a2
	move.w GWVA_WRSC_OBJ_IDX(a0),d0
	move.l GWVA_WRSC_OBJ_TREE_PTR(a0),a0
	bsr GWVA_RSC_RETURN_OBJ_POS_SIZE
	load.l a0/a2

	save.l d0-d1/a0/a2
	objc_offset a2,GWVA_WRSC_OBJ_IDX(a0)	; -> position de l'objet de la fentre
	movem.w int_out+1*2,d2-d3
	load.l d0-d1/a0/a2

	sub.w d0,d2
	sub.w d1,d3
	add.w d2,ob_x(a2)
	add.w d3,ob_y(a2)		; on dcale l'objet root de la taille des scultures haute et gauche

	movem.w GWVA_WIND_OBJ_CONTENTS_DX(a0),d0-d1
	add.w d0,ob_x(a2)
	add.w d1,ob_y(a2)

	;-----------------------------------;

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_WRSC_UPDATED

.pas_wrsc_update_car_on_wrsc_update:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts


	ifd MDL_WIND_RSC_CLONING

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_WRSC_UPDATE_MULTI_RSC
; Description : Met  jour le contenu du ressource
;
; Rq  : -
;
; in  : a0.l = pointeur objet
;
; 01/09/98 : Cration
;------------------------------------------------------------------------------
GWVA_WRSC_UPDATE_MULTI_RSC:

	tst.w GWVA_WRSC_OBJ_IS_CLONE_RSC(a0)
	beq.s .not_a_clone

	move.l ([GWVA_WRSC_OBJ_CLONE_MAIN_PTR,a0]),a1	; a1.l=pointeur sur la fentre RSC qui a le contenu du RSC pour lui
	cmp.l #0,a1
	beq.s .pas_de_precedent_pas_de_sauvegarde

	cmp.l a1,a0
	beq.s .c_est_moi_pas_de_restauration_sauvegarde

; On doit sauver le contenu du ressource du prcdent

	save.l a0-a1
	move.w GWVA_WRSC_OBJ_TREE(a1),d0
	move.w GWVA_WRSC_OBJ_IS_CLONE_RSC(a1),d1
	move.l GWVA_WRSC_OBJ_CLONE_SAVED_RSC_PTR(a1),a0
	bsr GWVA_RSC_SAVE_TREE
	load.l a0-a1

.pas_de_precedent_pas_de_sauvegarde:

; On restaure la restaure le formulaire pour la fentre

	save.l a0
	move.w GWVA_WRSC_OBJ_IS_CLONE_RSC(a0),d0
	move.l GWVA_WRSC_OBJ_CLONE_SAVED_RSC_PTR(a0),a0
	bsr GWVA_RSC_RESTORE_TREE
	load.l a0

	move.l a0,([GWVA_WRSC_OBJ_CLONE_MAIN_PTR,a0])

.c_est_moi_pas_de_restauration_sauvegarde:
.not_a_clone:
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_WRSC_CREATE_TREE_CLONE
; Description : Cree un clone du ressource de la fentre
;
; Rq  : Cette fonction ne doit tre utilise que pour la premire cration du clone
; Rq  : du ressource, avant toute cration d'une fentre clone.
;
; in  : a0.l = pointeur objet
;
; 03/09/98 : Cration
;------------------------------------------------------------------------------
GWVA_WRSC_CREATE_TREE_CLONE:
	save.l a0
	move.l a0,a1
	lea 0.w,a0
	move GWVA_WRSC_OBJ_TREE(a1),d0
	move GWVA_WRSC_OBJ_IS_CLONE_RSC(a1),d1
	save.l a1
	bsr GWVA_RSC_SAVE_TREE
	load.l a1
	tst d7
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne.s .erreur
	move.l a0,GWVA_WRSC_OBJ_CLONE_SAVED_RSC_PTR(a1)
	clr.l ([GWVA_WRSC_OBJ_CLONE_MAIN_PTR,a1])
.erreur:
	load.l a0
	rts

	endc	; ifd MDL_WIND_RSC_CLONING

;------------------------------------------------------------------------------

 BSS

GWVA_WRSC_TMP_BUFFER:		ds.w 2

 TEXT
