	DATA

GWVA_WRSCPOPUP_DEFAULT_METHODLIST:
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_CREATE,GWVA_WRSCPOPUP_PRG_CREATE
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_DELETE,GWVA_WRSCPOPUP_PRG_DELETE
*	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_OPEN,GWVA_WRSCPOPUP_PRG_OPEN
*	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_CLOSE,GWVA_WRSCPOPUP_PRG_CLOSE

	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_CLICK,GWVA_WRSCPOPUP_PRG_CLICK
	GWVA_OBJ_STRUCT_METHOD	GWVA_METHOD_MOUSE_ZONE,GWVA_WRSCPOPUP_PRG_MOUSE_ZONE

	GWVA_OBJ_STRUCT_METHOD_END_LIST

	TEXT

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_MOUSE_ZONE
; Asm label   : GWVA_WRSCPOPUP_PRG_MOUSE_ZONE
; Description : Gestion de l'entre dans la fentre popup
;
; Rq  : Pas de ON_ ni de ED
;
; in  : a0.l = pointeur sur la fentre popup
; in  : d0.w = x souris
; in  : d1.w = y souris
; in  : d2.l = [ Key state.w | mouse button.w ]
; out : d6.w = GWVA_PRGRET_CONSUMED
;
; 15/08/98 : Cration
;------------------------------------------------------------------------------
GWVA_WRSCPOPUP_PRG_MOUSE_ZONE:
; pas de before
	;-----------------------------------;

	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS #GWVA_METHOD_WRSC_UPDATE

	;-------------------

	save.l d0-d1/a0
	objc_find GWVA_WRSC_OBJ_TREE_PTR(a0),GWVA_WRSC_OBJ_IDX(a0),GWVA_WRSC_OBJ_DEPTH(a0),d0,d1	; dans la dropdown ?
	move.w d0,d2
	load.l d0-d1/a0

	tst.w d2
	bmi.s .pas_dans_dropdown

	move.w d2,d0

	cmp.w GWVA_WRSCPOPUP_OBJ_CURRENT_ITEM_IDX(a0),d0	; BUG des objets outlined
	beq .on_ne_change_pas_de_sous_item			; est-t-on toujours dans le meme subitem ?

	save.w d0
	bsr GWVA_WRSCPOPUP_UNSELECT_ITEM
	load.w d0

	save.w d0
	bsr GWVA_WRSCPOPUP_SELECT_ITEM
	load.w d0

; on doit dfinir une zone autour de l'item
.on_ne_change_pas_de_sous_item:

	save.l a0
	move.l GWVA_WRSC_OBJ_TREE_PTR(a0),a0
	bsr GWVA_RSC_RETURN_OBJ_POS_SIZE
	load.l a0

	lea GWVA_ROOT_TMP_MOUSE_ZONE_XYWH,a1
	movem.w d0-d3,(a1)
	move.w #MO_LEAVE,d1
	move.l #GWVA_METHOD_MOUSE_ZONE,d0
	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS #GWVA_METHOD_REGISTER_MOUSE_ZONE

	bra.s .fin_mouse_zone
	
	;----------------

.pas_dans_dropdown

	bsr GWVA_WRSCPOPUP_UNSELECT_ITEM

.pas_item_selectionne:

; On doit redfinir une mouse zone autour de la fentre

	bsr GWVA_WIND_RETURN_EXT_ABS_POS_SIZE

	lea GWVA_ROOT_TMP_MOUSE_ZONE_XYWH,a1
	movem.w d0-d3,(a1)
	move.w #MO_ENTER,d1
	move.l #GWVA_METHOD_MOUSE_ZONE,d0
	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS #GWVA_METHOD_REGISTER_MOUSE_ZONE

.fin_mouse_zone:

	;-----------------------------------;
; pas d'after

	move.w #GWVA_PRGRET_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_CLICK
; Asm label   : GWVA_WRSCPOPUP_PRG_CLICK
; Description : Gestion du click souris
;
; Rq  : Pas de ON_ ni de ED
;
; in  : a0.l = pointeur sur la fentre popup
; in  : d0.w = [ X.w ]
; in  : d1.l = [ mouse button.w | Y.w ]
; in  : d2.l = [ Key state.w | mouse count.w ]
; out : d6.w = GWVA_PRGRET_CONSUMED
;
; 14/08/98 : Cration
;------------------------------------------------------------------------------
GWVA_WRSCPOPUP_PRG_CLICK:
; pas de before
	;-----------------------------------;

	move.w GWVA_WRSCPOPUP_OBJ_CURRENT_ITEM_IDX(a0),d0
	bmi.s .pas_item_selectionne

	move.w d0,GWVA_WRSCPOPUP_OBJ_SELECTED_ITEM_IDX(a0)

	move.l GWVA_WRSCPOPUP_OBJ_SELECTED_METHOD(a0),d3
	move.l GWVA_WRSCPOPUP_OBJ_ATTACHED_OBJECT(a0),a1

	save.l a1/d0/d3
	bsr GWVA_WIND_DELETE_ONE_WIND
	load.l a1/d0/d3

; d0.w : index de l'objet slectionn

	move.l a1,a0
	GWVA_CALL_METHOD_OTHER_OBJ	d3

	bra.s .fin_click_popup

.pas_item_selectionne:
	bsr GWVA_WIND_DELETE_ONE_WIND

	;-----------------
.fin_click_popup:

	;-----------------------------------;
; pas d'after

	move.w #GWVA_PRGRET_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_DELETE
; Asm label   : GWVA_WRSCPOPUP_PRG_DELETE
; Description : Mthode de destruction d'une fentre popup
;
; in  : a0.l = pointeur sur la fentre
; out : d6.w = GWVA_PRGRET_CONSUMED
;
; 16/08/98 : Cration
;------------------------------------------------------------------------------
GWVA_WRSCPOPUP_PRG_DELETE:

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_DELETE
; Si on revient de cette mthode, il faut tout de mme continuer (cas exceptionel)

	;-----------------------------------;

	bsr GWVA_WRSCPOPUP_UNSELECT_ITEM

	;-------------

	; appeler la mthode de la fentre RSC
	GWVA_CALL_METHOD_INHERITED

	;-----------------------------------;

	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_CREATE
; Asm label   : GWVA_WRSCPOPUP_PRG_CREATE
; Description : Mthode de cration d'une fentre popup avec un ressource comme contenu
;
; Rq  : -
;
; in  : a0.l = pointeur objet
; out : d6.w = GWVA_PRGRET_CONSUMED
; out : d7.w = GWVA_NO_ERROR_GENERIC ou
;	   GWVA_ERROR_WRSCPOPUP_UNABLE_REGISTER_CLICK
; 14/08/98 : Cration
;------------------------------------------------------------------------------
GWVA_WRSCPOPUP_PRG_CREATE:

	; appeler la mthode de la fentre RSC
	GWVA_CALL_METHOD_INHERITED
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne .erreur_creation

	;-----------------------------------;

; Cration d'une classe WIND.RSC.POPUP

	move.l #GWVA_METHOD_CLICK,d0
	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS #GWVA_METHOD_REGISTER_BUTTON
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne.s .erreur_pas_souris

; Il faut mettre le delete automatique

	bfset GWVA_WIND_OBJ_PROPERTIES(a0){GWVA_WIND_OLBIT_AUTODEL:1}

	;----------------------

	bsr GWVA_WIND_RETURN_EXT_ABS_POS_SIZE

	lea GWVA_ROOT_TMP_MOUSE_ZONE_XYWH,a1
	movem.w d0-d3,(a1)
	move.w #MO_ENTER,d1
	move.l #GWVA_METHOD_MOUSE_ZONE,d0
	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS #GWVA_METHOD_REGISTER_MOUSE_ZONE

	move.w #-1,GWVA_WRSCPOPUP_OBJ_SELECTED_ITEM_IDX(a0)
	move.w #-1,GWVA_WRSCPOPUP_OBJ_CURRENT_ITEM_IDX(a0)

	;-----------------------------------;

	; envoyer la mthode GWVA_METHOD_CREATED

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_CREATED

	moveq #GWVA_NO_ERROR_GENERIC,d7
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.erreur_pas_souris:
	move.w #GWVA_ERROR_WRSCPOPUP_UNABLE_REGISTER_CLICK,d7
.erreur_creation:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : 
; Asm label   : GWVA_WRSCPOPUP_SELECT_ITEM
; Description : 
;
; Rq  : 
;
; in  : a0.l = pointeur fentre popup
; in  : d0.w = index de l'item slectionn
;
; 18/04/98 : Cration
;------------------------------------------------------------------------------
GWVA_WRSCPOPUP_SELECT_ITEM:

	move.l GWVA_WRSC_OBJ_TREE_PTR(a0),a2
	move.w d0,d1
	mulu #L_OBJECT,d1

	move.w ob_state(a2,d1.l),d2
	btst #DISABLED,d2
	bne.s .sous_item_disable

	move.w d0,GWVA_WRSCPOPUP_OBJ_CURRENT_ITEM_IDX(a0)
	bset #SELECTED,d2
	move.w d2,ob_state(a2,d1.l)

; Pas possible de passer par la mthode de redraw part, car un objet string n'a pas de fond.
; Par consquent le redraw de fait mal : il faut utiliser l'objc_change -> nouveau type de mthode ?

	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS #GWVA_METHOD_WIND_REDRAW_ALL_CONTENTS

.sous_item_disable:

	rts

;------------------------------------------------------------------------------
; Method name : 
; Asm label   : GWVA_WRSCPOPUP_UNSELECT_ITEM
; Description : 
;
; Rq  : 
;
; in  : a0.l = pointeur fentre popup
;
; 15/08/98 : Cration
;------------------------------------------------------------------------------
GWVA_WRSCPOPUP_UNSELECT_ITEM:

	move.w GWVA_WRSCPOPUP_OBJ_CURRENT_ITEM_IDX(a0),d0
	bmi.s .pas_de_subitem_selectionne

	move.l GWVA_WRSC_OBJ_TREE_PTR(a0),a2
	move.w d0,d1
	mulu #L_OBJECT,d1
	move.w ob_state(a2,d1.l),d2
	bclr #SELECTED,d2
	move.w d2,ob_state(a2,d1.l)

; Pas possible de passer par la mthode de redraw part, car un objet string n'a pas de fond.
; Par consquent le redraw de fait mal : il faut utiliser l'objc_change -> nouveau type de mthode ?

	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS #GWVA_METHOD_WIND_REDRAW_ALL_CONTENTS

	move.w #-1,GWVA_WRSCPOPUP_OBJ_CURRENT_ITEM_IDX(a0)
.pas_de_subitem_selectionne:
	rts
