;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_DELETE
; Asm label   : GWVA_WIND_PRG_DELETE
; Description : Mthode de destruction d'une fentre
;
; Rq  : Ne dcroche pas la fentre de l'arbre
; Rq  : Pour une fentre iconifie, elle est closed et handle=DEAD
; Rq  : mais on fait tout le reste (libre contents + USER_PTR ...)
;
; in  : a0.l = pointeur sur l'objet fentre
; out : d6.w = GWVA_PRGRET_CONSUMED
;
; 08/02/98 : Cration
; 24/02/98 : Ajoutt le clr.l focused(father) + appel unregister all timer methods
; 28/03/98 : retir appel unregister all timer methods et mis dans le delete_object
; 26/07/98 : Modification pour l'hritage
;------------------------------------------------------------------------------
GWVA_WIND_PRG_DELETE:

	ifd MDL_CHILDREN_WINDOWS

	save.l a0

	clr.w -(sp) 			; niveau relatif
.delete_all_child_windows:
	bsr GWVA_WIND_PRG_DELETE_ONE_FAMILY_MEMBER

	; on ne teste pas l'erreur : tant pis, car il faut quand mme deleter les autres

	load.w d0
	bsr GWVA_WIND_OBJ_PRG_RETURN_NEXT_FAMILY_MEMBER
	tst d0
	ble.s .retour_a_la_fenetre_mere_son_frere_ou_au_dessus
	save.w d0
	bra.s .delete_all_child_windows

.retour_a_la_fenetre_mere_son_frere_ou_au_dessus:
	load.l a0
	moveq #GWVA_PRGRET_CONSUMED,d6

	rts

GWVA_WIND_PRG_DELETE_ONE_FAMILY_MEMBER:	; a0=ptr sur structure

	endc	; ifd MDL_CHILDREN_WINDOWS

	ifd OPT_GWVA_DEBUG_ERROR
	cmp.w #GWVA_CLASS_WIND.APP,GWVA_OBJ_CLASS(a0)
	bne.s .pas_fenetre_application
	GWVA_PROGRAMMER_ERROR	GWVA_ASCII_ERROR_BAD_OBJECT_METHOD
.pas_fenetre_application:
	endc	; OPT_GWVA_DEBUG_ERROR

	;-----------------------------------;

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_ON_DELETE
; Si on revient de cette mthode, il faut tout de mme continuer (cas exceptionel)

	;-----------------------------------;

	ifd MDL_CHILDREN_WINDOWS

	bsr GWVA_WIND_OBJ_PRG_CLOSE_ONE_FAMILY_MEMBER

	else	; ifd MDL_CHILDREN_WINDOWS

	move.w GWVA_WIND_OBJ_GEM_HANDLE(a0),d0	; les mthodes wind prennent d0 en entre
	bsr GWVA_WIND_TEST_IF_WIND_OPENED		; sinon on entre dans une spirale close->delete->close...  cause du bit AUTODEL
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne.s .deja_fermee
	lea 0.w,a2			; ?_ERROR_? : a1 ?

; ?_ERROR_? : On fait cette appel pour que le close se fasse de la classe la plus haute.
; Autrement on n'executerait que la mthode close de la classe WIND

	GWVA_CALL_METHOD_OTHER_OBJ	#GWVA_METHOD_CLOSE

.deja_fermee:

	endc	; ifd MDL_CHILDREN_WINDOWS

	; tient compte des bits spciaux pour librer le contenu gnrique wind

	ifd MDL_WIND_MENU

	tst.l GWVA_WIND_OBJ_MENU_SPEC_PTR(a0)
	beq.s .pas_de_menu

	save.l a0
	move.l GWVA_WIND_OBJ_MENU_SPEC_PTR(a0),a0
	GWVA_CALL_METHOD_OTHER_OBJ	#GWVA_METHOD_DELETE
	load.l a0
.pas_de_menu:

	endc	; ifd MDL_WIND_MENU

	; efface le handle

	move.w GWVA_WIND_OBJ_GEM_HANDLE(a0),d0	; d0=sauve le handle

	; Dans le cas d'un 2me delete ou d'un delete fenetre iconifie
	cmp.w #GWVA_WIND_CTE_HANDLE_UNDEF,d0
	beq .deja_efface

	move.w #GWVA_WIND_CTE_HANDLE_UNDEF,GWVA_WIND_OBJ_GEM_HANDLE(a0)

	move.w #GWVA_WIND_CTE_FIELD_UNDEF,GWVA_WIND_OBJ_INT_VISIBLE_W(a0)
	move.w #GWVA_WIND_CTE_FIELD_UNDEF,GWVA_WIND_OBJ_INT_VISIBLE_H(a0)
	move.w #GWVA_WIND_CTE_FIELD_UNDEF,GWVA_WIND_OBJ_CONTENTS_DX(a0)
	move.w #GWVA_WIND_CTE_FIELD_UNDEF,GWVA_WIND_OBJ_CONTENTS_DY(a0)
	move.w #GWVA_WIND_CTE_FIELD_UNDEF,GWVA_WIND_OBJ_CONTENTS_W(a0)
	move.w #GWVA_WIND_CTE_FIELD_UNDEF,GWVA_WIND_OBJ_CONTENTS_H(a0)
	move.w #GWVA_WIND_CTE_FIELD_UNDEF,GWVA_WIND_OBJ_INT_BORDERS_W(a0)
	move.w #GWVA_WIND_CTE_FIELD_UNDEF,GWVA_WIND_OBJ_INT_BORDERS_H(a0)

	ifd MDL_CHILDREN_WINDOWS

	cmp.w #GWVA_WIND_TYPE_APPLICATION,(GWVA_WIND_OBJ_TYPE,[GWVA_WIND_OBJ_FATHER_PTR,a0])
	bne.s .delete_fenetre_fille

	endc	; ifd MDL_CHILDREN_WINDOWS

	bftst GWVA_WIND_OBJ_STATUS(a0){GWVA_WIND_OLBIT_ICON:1}	; iconifie ?
	bne.s .window_inconified

	save.l a0
	wind_delete d0
	load.l a0

.window_inconified:
.delete_fenetre_fille:

	cmp.w #GWVA_CLASS_WIND.APP,([GWVA_OBJ_FATHER_PTR,a0],GWVA_OBJ_CLASS)
	bne.s .fenetre_fille_pas_enlevee_arbre

	bsr GWVA_ROOT_REMOVE_OBJECT_FROM_TREE

.fenetre_fille_pas_enlevee_arbre:

	; mettre la libration des user ptr1&2 aprs la lib des autres
	; au cas o la structure de fentre serait justement ce Malloc

	clr.l d0
	bftst GWVA_WIND_OBJ_PROPERTIES(a0){GWVA_WIND_OLBIT_FREEPTR1:1}
	beq.s .no_free_ptr1
	move.l GWVA_WIND_OBJ_USER_PTR1(a0),d0
	clr.l GWVA_WIND_OBJ_USER_PTR1(a0)
.no_free_ptr1:
	clr.l d1
	bftst GWVA_WIND_OBJ_PROPERTIES(a0){GWVA_WIND_OLBIT_FREEPTR2:1}
	beq.s .no_free_ptr2
	move.l GWVA_WIND_OBJ_USER_PTR2(a0),d1
	clr.l GWVA_WIND_OBJ_USER_PTR2(a0)
.no_free_ptr2:
	tst.l d0
	beq.s .pas_lib_ptr1
	save.l a0/d1
	MFREE d0
	load.l a0/d1
.pas_lib_ptr1:
	tst.l d1
	beq.s .pas_lib_ptr2
	save.l a0
	MFREE d1
	load.l a0
.pas_lib_ptr2:

	; fin traitement bits spciaux 

.deja_efface:

	;-----------------------------------;

	GWVA_CALL_METHOD_INHERITED

	;-----------------------------------;

	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

;------------------------------------------------------------------------------
; Method name : GWVA_METHOD_CREATE
; Asm label   : GWVA_WIND_PRG_CREATE
; Description : Mthode de cration d'une fentre
;
; Rq  : Accroche la fentre  l'arbre si ce n'est pas dj fait
;
; in  : a0.l = pointeur sur l'objet fentre
; out : d6.w = GWVA_PRGRET_NOT_CONSUMED ou GWVA_PRGRET_CONSUMED
; out : d7.w = GWVA_NO_ERROR_GENERIC ou erreur
;	   GWVA_ERROR_WIND_ALREADY_CREATED
;	   GWVA_ERROR_BAD_CLASS
;	   GWVA_ERROR_WIND_BAD_INC_DEF
;	   GWVA_ERROR_WIND_BORDERS_TOO_SMALL
;	   GWVA_ERROR_WIND_MOTHER_DOESNT_EXIST
;	   GWVA_ERROR_WIND_CONTENTS_VERIFY_ERR
;
; 31/01/98 : Cration
; 26/02/98 : Passage du calcul des sliders du create  l'open
; 25/07/98 : Modification pour l'hritage
;------------------------------------------------------------------------------
GWVA_WIND_PRG_CREATE:

	GWVA_CALL_METHOD_INHERITED

	;-----------------------------------;

; on s'accroche au WAPP si ce n'est pas dj fait

	move.l GWVA_OBJ_FATHER_PTR(a0),a1
	cmp.l #0,a1
	bne.s .fenetre_mere_existe

	move.l GWVA_ROOT_PTR_WAPP,a1
	move.l a1,GWVA_OBJ_FATHER_PTR(a0)

	lea GWVA_OBJ_FIRST_SON_PTR(a1),a2
.trouver_derniere_soeur:
	tst.l (a2)
	beq.s .je_suis_la_premiere_fille

	lea (GWVA_OBJ_NEXT_BROTHER_PTR,[a2]),a2
	bra.s .trouver_derniere_soeur
.je_suis_la_premiere_fille:
	move.l a0,(a2)
.fenetre_mere_existe:

	;-----------------------------------;

; Quelques tests avant la cration

	cmp.w #GWVA_WIND_CTE_HANDLE_UNDEF,GWVA_WIND_OBJ_GEM_HANDLE(a0)
	bne.s .erreur_window_already_created

	ifd MDL_CHILDREN_WINDOWS
	cmp.w #GWVA_WIND_CTE_HANDLE_UNDEF,GWVA_WIND_OBJ_GEM_HANDLE(a1)
	beq .erreur_pas_de_mere_pas_de_fille
	endc

	movem.w GWVA_WIND_OBJ_FIRST_CONTENTS_DX(a0),d0-d1
	cmp.w GWVA_WIND_OBJ_FIRST_INT_BORDERS_W(a0),d0
	bgt.s .erreur_border_w_pas_assez_grand
	cmp.w GWVA_WIND_OBJ_FIRST_INT_BORDERS_H(a0),d1
	bgt.s .erreur_border_h_pas_assez_grand

	bra.s .fin_verification

.erreur_border_w_pas_assez_grand:
.erreur_border_h_pas_assez_grand:
	move #GWVA_ERROR_WIND_BORDERS_TOO_SMALL,d7	; borders w/h doit etre >= contents_dx/dy
	bra .common_error
	ifd MDL_CHILDREN_WINDOWS
.erreur_pas_de_mere_pas_de_fille:
	moveq #GWVA_ERROR_WIND_MOTHER_DOESNT_EXIST,d7	; la mre n'existe pas
	bra .common_error
	endc	; ifd MDL_CHILDREN_WINDOWS
.erreur_window_already_created:
	move #GWVA_ERROR_WIND_ALREADY_CREATED,d7	; handle<>-1 ou existe dj
	bra .common_error

.fin_verification:

*-----------------------------------------------------------------------------*

	; Ne pas effacer le bit GWVA_WIND_OLBIT_ICON (pour iconification)

	bfclr GWVA_WIND_OBJ_STATUS(a0){0:GWVA_WIND_OLBIT_ICON}
	bfclr GWVA_WIND_OBJ_STATUS(a0){GWVA_WIND_OLBIT_ICON+1:7-GWVA_WIND_OLBIT_ICON}

	; Si window iconified : Le handle est  -1 et ICON =1
	; handle =-1 : plus bas : calc_size_wind : pas d'update graphique
	; ICON=1 : plus bas : pas de cration de handle GEM

	* -------- Init. des champs aux valeurs d'initialisation ------ *

; A NE FAIRE QUE SI UNDEF : PENSER A LES REMETTRE UNDEF LORS DU DELETE !!!!

	; pas de GWVA_WIND_OBJ_FIRST_EXT_DX -> GWVA_WIND_OBJ_INT_DX

	cmp.w #GWVA_WIND_CTE_FIELD_UNDEF,GWVA_WIND_OBJ_INT_VISIBLE_W(a0)
	bne.s .int_visible_w_pas_undef
	move.w GWVA_WIND_OBJ_FIRST_INT_VISIBLE_W(a0),GWVA_WIND_OBJ_INT_VISIBLE_W(a0)
.int_visible_w_pas_undef:
	cmp.w #GWVA_WIND_CTE_FIELD_UNDEF,GWVA_WIND_OBJ_INT_VISIBLE_H(a0)
	bne.s .int_visible_h_pas_undef
	move.w GWVA_WIND_OBJ_FIRST_INT_VISIBLE_H(a0),GWVA_WIND_OBJ_INT_VISIBLE_H(a0)
.int_visible_h_pas_undef:
	cmp.w #GWVA_WIND_CTE_FIELD_UNDEF,GWVA_WIND_OBJ_CONTENTS_DX(a0)
	bne.s .contents_dx_pas_undef
	move.w GWVA_WIND_OBJ_FIRST_CONTENTS_DX(a0),GWVA_WIND_OBJ_CONTENTS_DX(a0)
.contents_dx_pas_undef:
	cmp.w #GWVA_WIND_CTE_FIELD_UNDEF,GWVA_WIND_OBJ_CONTENTS_DY(a0)
	bne.s .contents_dy_pas_undef
	move.w GWVA_WIND_OBJ_FIRST_CONTENTS_DY(a0),GWVA_WIND_OBJ_CONTENTS_DY(a0)
.contents_dy_pas_undef:
	cmp.w #GWVA_WIND_CTE_FIELD_UNDEF,GWVA_WIND_OBJ_CONTENTS_W(a0)
	bne.s .contents_w_pas_undef
	move.w GWVA_WIND_OBJ_FIRST_CONTENTS_W(a0),GWVA_WIND_OBJ_CONTENTS_W(a0)
.contents_w_pas_undef:
	cmp.w #GWVA_WIND_CTE_FIELD_UNDEF,GWVA_WIND_OBJ_CONTENTS_H(a0)
	bne.s .contents_h_pas_undef
	move.w GWVA_WIND_OBJ_FIRST_CONTENTS_H(a0),GWVA_WIND_OBJ_CONTENTS_H(a0)
.contents_h_pas_undef:
	cmp.w #GWVA_WIND_CTE_FIELD_UNDEF,GWVA_WIND_OBJ_INT_BORDERS_W(a0)
	bne.s .int_borders_w_pas_undef
	move.w GWVA_WIND_OBJ_FIRST_INT_BORDERS_W(a0),GWVA_WIND_OBJ_INT_BORDERS_W(a0)
.int_borders_w_pas_undef:
	cmp.w #GWVA_WIND_CTE_FIELD_UNDEF,GWVA_WIND_OBJ_INT_BORDERS_H(a0)
	bne.s .int_borders_h_pas_undef
	move.w GWVA_WIND_OBJ_FIRST_INT_BORDERS_H(a0),GWVA_WIND_OBJ_INT_BORDERS_H(a0)
.int_borders_h_pas_undef:

	* - On vrifie qu'on aurait pas plant dans l'init du contenu - *

	cmp.w #GWVA_WIND_CTE_SIZE_UNDEF,GWVA_WIND_OBJ_CONTENTS_W(a0)
	beq.s .faute_sur_init_du_contenu
	cmp.w #GWVA_WIND_CTE_SIZE_UNDEF,GWVA_WIND_OBJ_CONTENTS_H(a0)
	bne.s .pas_faute_sur_init_du_contenu

.faute_sur_init_du_contenu:
	move #GWVA_ERROR_WIND_CONTENTS_VERIFY_ERR,d7	; erreur d'init V.A ou utilisateur si custom
	bra .erreur_creation
.pas_faute_sur_init_du_contenu:

	* -------------- Cration du menu de la fentre --------------- *

	clr.w GWVA_WIND_OBJ_MENU_HEIGHT(a0)

	ifd MDL_WIND_MENU

	tst.l GWVA_WIND_OBJ_MENU_SPEC_PTR(a0)
	beq.s .pas_de_menu

	save.l a0
	move.l a0,a1
	move.l GWVA_WIND_OBJ_MENU_SPEC_PTR(a0),a0

	bsr GWVA_ROOT_CREATE_OBJECT
	load.l a0
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne .error_create_menu
.pas_de_menu:

	endc	; ifd MDL_WIND_MENU


	* - Init du visible w/h  priori  contents+borders+contents_dx - *

	move.w GWVA_WIND_OBJ_INT_VISIBLE_W(a0),d2
	cmp.w #GWVA_WIND_CTE_SIZE_UNDEF,d2
	bne.s .no_width_init_asked_by_user
	move.w GWVA_WIND_OBJ_CONTENTS_W(a0),d2
	add.w GWVA_WIND_OBJ_INT_BORDERS_W(a0),d2
.no_width_init_asked_by_user:
	add.w GWVA_WIND_OBJ_CONTENTS_DX(a0),d2
	move.w d2,GWVA_WIND_OBJ_INT_VISIBLE_W(a0)

	move.w GWVA_WIND_OBJ_INT_VISIBLE_H(a0),d3
	cmp.w #GWVA_WIND_CTE_SIZE_UNDEF,d3
	bne.s .no_height_init_asked_by_user
	move.w GWVA_WIND_OBJ_CONTENTS_H(a0),d3
	add.w GWVA_WIND_OBJ_INT_BORDERS_H(a0),d3
.no_height_init_asked_by_user:
	add.w GWVA_WIND_OBJ_CONTENTS_DY(a0),d3
	move.w d3,GWVA_WIND_OBJ_INT_VISIBLE_H(a0)

	*---- traitement spcifique pour la toolbar ----*

; A FAIRE A FAIRE A FAIRE A FAIRE A FAIRE A FAIRE A FAIRE A FAIRE 
; A FAIRE A FAIRE A FAIRE A FAIRE A FAIRE A FAIRE A FAIRE A FAIRE 

	ifd MDL_WIND_TOOLBAR

	bftst GWVA_WIND_OBJ_PROPERTIES(a0){GWVA_WIND_OLBIT_TOOLBAR:1}
	beq .pas_toolbar

	bftst GWVA_WIND_OBJ_PROPERTIES(a0){GWVA_WIND_OLBIT_HIDETREE:1}
	bne .toolbar_not_drawn

	move.l GWVA_OBJ_FATHER_PTR(a0),a1

; anciene position contents de la mre devient nouvelle position externe de la toolbar
; left et top
	movem.w GWVA_WIND_OBJ_CONTENTS_DX(a1),d0-d1
	save.l a1
	bsr GWVA_WIND_OBJ_PRG_CONVERT_EXT_INT_POS_SIZE
	load.l a1
	movem.w d0-d1,GWVA_WIND_OBJ_INT_DX(a0)

	movem.w GWVA_WIND_OBJ_INT_VISIBLE_W(a0),d2-d3	; taille de la toolbar visible

	move.l GWVA_WIND_OBJ_PROPERTIES(a0),d4
	and.l #GWVA_WIND_MASK_TOOLBAR_POS,d4

	cmp.l #GWVA_WIND_MASK_TOOLBAR_TOP,d4
	bne.s .pas_toolbar_top
	add.w d3,GWVA_WIND_OBJ_CONTENTS_DY(a1)	; on descend le contenu de la taille de la toolbar
	add.w d3,GWVA_WIND_OBJ_INT_BORDERS_H(a1)	; on augmente la taille des bords
	bra.s .init_visible_top_bottom
.pas_toolbar_top:
	cmp.l #GWVA_WIND_MASK_TOOLBAR_LEFT,d4
	bne.s .pas_toolbar_left
	add.w d2,GWVA_WIND_OBJ_CONTENTS_DX(a1)	; on pousse le contenu de la taille de la toolbar 
	add.w d2,GWVA_WIND_OBJ_INT_BORDERS_W(a1)	; on augmente la taille des bords
	bra.s .init_visible_left_right
.pas_toolbar_left:

	movem.w GWVA_WIND_OBJ_INT_BORDERS_W(a1),d0-d1
	add.w GWVA_WIND_OBJ_CONTENTS_W(a1),d0
	add.w GWVA_WIND_OBJ_CONTENTS_H(a1),d1
	save.l d4/a1
	bsr GWVA_WIND_OBJ_PRG_CONVERT_EXT_INT_POS_SIZE
	load.l d4/a1

	cmp.l #GWVA_WIND_MASK_TOOLBAR_BOTTOM,d4
	bne.s .pas_toolbar_bottom
	move.w d1,GWVA_WIND_OBJ_INT_DY(a0)
	add.w d3,GWVA_WIND_OBJ_INT_BORDERS_H(a1)	; on augmente la taille des bords
	bra.s .init_visible_top_bottom
.pas_toolbar_bottom:
*	cmp.l #GWVA_WIND_MASK_TOOLBAR_RIGHT,d4
*	bne.s .pas_toolbar_right
	move.w d0,GWVA_WIND_OBJ_INT_DX(a0)
	add.w d2,GWVA_WIND_OBJ_INT_BORDERS_W(a1)	; on augmente la taille des bords
*	bra.s .init_visible_left_right
*.pas_toolbar_right:

.init_visible_left_right:
	move.w GWVA_WIND_OBJ_FIRST_INT_VISIBLE_W(a1),d3
	cmp.w #GWVA_WIND_CTE_SIZE_UNDEF,d3
	bne.s .width_init_asked_by_user_for_mother
	add.w d2,GWVA_WIND_OBJ_INT_VISIBLE_W(a1)	; on augmente la taille de la zone visble de la mre
.width_init_asked_by_user_for_mother:
	bra.s .correct_pos_size_mother

.init_visible_top_bottom:
	move.w GWVA_WIND_OBJ_FIRST_INT_VISIBLE_H(a1),d2
	cmp.w #GWVA_WIND_CTE_SIZE_UNDEF,d2
	bne.s .height_init_asked_by_user_for_mother
	add.w d3,GWVA_WIND_OBJ_INT_VISIBLE_H(a1)	; on augmente la taille de la zone visble de la mre
.height_init_asked_by_user_for_mother:

.correct_pos_size_mother:

	save.l a0
	move.l a1,a0
	bsr GWVA_WIND_OBJ_PRG_RETURN_EXT_ABS_POS_SIZE	; position, taille externe
	movem.w GWVA_WIND_OBJ_FIRST_EXT_DX(a0),d0-d1	; 
	bsr GWVA_WIND_OBJ_PRG_VERIFY_CENTER_AND_POS
	bsr GWVA_WIND_OBJ_PRG_CONVERT_RELATIVE_ABSOLUTE_POS ; => sortie d0-d1=position absolue
	bsr GWVA_WIND_OBJ_PRG_CALC_AND_SET_SIZE_WIND	; en entre : externe absolue
	load.l a0

.toolbar_not_drawn:
.pas_toolbar:
	endc	; ifd MDL_WIND_TOOLBAR

	*---- on positionne dans la fentre mre et on centre ventuellement ---*
	*---- on ne dpasse pas la fentre mre ? ------*

	bsr GWVA_WIND_RETURN_EXT_ABS_POS_SIZE	; position, taille externe

; Il ne faut pas rduire la taille de la fentre toolbar  la taille max de la mre

	bftst GWVA_WIND_OBJ_PROPERTIES(a0){GWVA_WIND_OLBIT_TOOLBAR:1}
	bne.s .pas_test_taille_pour_toolbar

	movem.w GWVA_WIND_OBJ_FIRST_EXT_DX(a0),d0-d1	; relatif / mre
	bsr GWVA_WIND_VERIFY_CENTER_AND_POS
	bsr GWVA_WIND_CONVERT_RELATIVE_ABSOLUTE_POS ; => sortie d0-d1=position absolue

.pas_test_taille_pour_toolbar:

	*---- on initialise tout le reste ----*

	bsr GWVA_WIND_CALC_AND_SET_SIZE_WIND	; en entre : externe absolu
	; met  jour internal_dx/dy, visible_w/h + menu + form_pos

	*--------- Cration GEM ---------*

; Maintenant que la taille/position de la fentre est dtermine, on peut la crer

	bftst GWVA_WIND_OBJ_STATUS(a0){GWVA_WIND_OLBIT_ICON:1}
	bne.s .creating_iconified_window

	bsr GWVA_WIND_CREATE_ONE_GEM_WIND
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne.s .erreur_creation

.creating_iconified_window:

; La fentre cre est la fentre recevant le focus

	move.l a0,(GWVA_WIND_OBJ_FOCUSED_CHILD_PTR,[a0,GWVA_OBJ_FATHER_PTR])

	;-----------------------------------;

	; envoyer la mthode GWVA_METHOD_CREATED

	GWVA_EXEC_VISUAL_EVENT	#GWVA_METHOD_CREATED

	moveq #GWVA_PRGRET_CONSUMED,d6
	moveq #GWVA_NO_ERROR_GENERIC,d7
	rts

.error_create_menu:
.erreur_creation:
.common_error:	; retour avec code d7 = erreur
	ifd OPT_GWVA_DEBUG_ERROR
	lea GWVA_ASCII_ERROR_RETURN_D7,a6
	illegal
	endc	; ifd OPT_GWVA_DEBUG_ERROR
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts
