;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_CALL_FSEL_CP_BSS_UPDATE_FORM
; Description : appelle un slecteur de fichier et update un buffer
;	    + option : copie le rsultat vers un objet texte dans formulaire
;
; in  : a0.l = pointeur sur le texte d'invitation (termin par un 0.b) : 35 chars max.
; in  : a1.l = masque pour les types fichiers  afficher : 18 caractres max
; in  : a2.l = pointeur sur un ventuel ancien pathname : "A:\TEMP\" ou sinon #0.l
; in  : a3.l = pointeur sur le BSS  remplir avec le retour du fsel (ou 0.l si pas)
; in  : a4.l = pointeur sur la structure de la fentre o est l'objet  redessiner
; in  : d0.w = numro du formulaire o se trouve le texte  remplir pour update
;	   graphique ou -1.w si pas d'update (d1+d2 inutiliss dans ce cas)
; in  : d1.w = numro de l'objet de famille text  remplir avec le contenu en
;	   faisant attention de ne pas dpasser.
; in  : d2.w = si long nouveau nom > longueur prvue dans le form :
;	   GWVA_CFCBUF_ALIGN_LEFT    = alignement  gauche (PATH.......)
;	   GWVA_CFCBUF_ALIGN_RIGHT   = alignement  droite (.......PATH)
;	   GWVA_CFCBUF_ALIGN_CENTER  = cent               (PATH...NAME)
; in  : d3.w = quoi recopier ? en retour du file_selector
;	   GWVA_CFCBUF_COPY_NAME     = recopier le nom (8+3) uniquement
;	   GWVA_CFCBUF_COPY_PATH     = recopier le path uniquement
;	   GWVA_CFCBUF_COPY_PATHNAME = recopie tout le pathname
; out : d7.w = code retour du fsel (0 si annule, <0 pour erreur, >0 pour OK)
;
; 23/05/98 : Cration
;------------------------------------------------------------------------------
GWVA_CALL_FSEL_CP_BSS_UPDATE_FORM:

	save.l d0-d3/a3/a4
	bsr GWVA_FILE_SELECTOR
	move d0,d7
	load.l d0-d3/a3/a4

	tst d7
	ble .annule_ou_erreur

	cmp.w #GWVA_CFCBUF_COPY_NAME,d3
	bne.s .pas83
	move.l a0,a2		; nom en 8+3
	bra.s .do_copy
.pas83:	cmp #GWVA_CFCBUF_COPY_PATH,d3
	bne.s .do_copy
	move.l a1,a2		; pathname
.do_copy:	save.l a2
	cmp.l #0,a3			; pas de copie vers un BSS
	beq.s .no_copy
.copy0:	move.b (a2)+,(a3)+
	bne.s .copy0
.no_copy:	load.l a1			; a1 => info copie va resservir

	cmp.w #-1,d0
	beq.s .no_graphic_update

	move.l a4,a0
	move #GWVA_CFCBUF_REDRAW_YES,d3
	bsr GWVA_NO_FSEL_CP_BSS_UPDATE_FORM

.no_graphic_update:
	clr d7

.annule_ou_erreur:
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_NO_FSEL_CP_BSS_UPDATE_FORM
; Description : copie un path(name) dans un formulaire avec alignement
;	    + redraw ventuel
;
; in  : a0.l = pointeur sur la structure de la fentre o est l'objet  redessiner (ne sert pas si pas de redraw)
; in  : a1.l = pointeur sur le buffer source pour la recopie dans le formulaire
; in  : d0.w = numro du formulaire o se trouve le texte  remplir pour update
;	   graphique ou -1.w si pas d'update (d1+d2 inutiliss dans ce cas)
; in  : d1.w = numro de l'objet de famille text  remplir avec le contenu en
;	   faisant attention de ne pas dpasser.
; in  : d2.w = si long nouveau nom > longueur prvue dans le form :
;	   GWVA_CFCBUF_ALIGN_LEFT    = alignement  gauche (PATH.......)
;	   GWVA_CFCBUF_ALIGN_RIGHT   = alignement  droite (.......PATH)
;	   GWVA_CFCBUF_ALIGN_CENTER  = cent               (PATH...NAME)
; in  : d3.w = doit on faire un redraw ?
;	   GWVA_CFCBUF_REDRAW_YES = oui
;	   GWVA_CFCBUF_REDRAW_NO  = non
; out : d7.w = code retour du fsel (0 si annule, <0 pour erreur, >0 pour OK)
;
; 23/05/98 : Cration
;------------------------------------------------------------------------------
GWVA_NO_FSEL_CP_BSS_UPDATE_FORM:

	save.l d1/d2/d3/a0/a1			; d0=pre d1=fils
	bsr GWVA_RSC_RETURN_PTR_ON_TEXT
	move.w ([a0,ob_spec],te_txtlen),d4		; longueur du texte
	subq #1,d4				; moins le 0
	load.l d0/d2/d3/a0/a2

	move.l a2,a3
	move #-1,d1
.compte:	add #1,d1
	tst.b (a3)+
	bne.s .compte

	cmp d4,d1
	ble.s .inf_taille_max

	cmp #GWVA_CFCBUF_ALIGN_LEFT,d2
	beq.s .alignement_gauche

	cmp #GWVA_CFCBUF_ALIGN_RIGHT,d2
	beq.s .alignement_droite

.centre:	move d4,d2
	lsr.w #1,d2
	move d2,d5
	subq #1,d5
	move.l a2,a3
.cp_gauche:	move.b (a3)+,(a1)+
	dbf d5,.cp_gauche
	move.b #'~',(a1)+

	add.w d1,a2

	move d4,d1			; copie max
	sub d2,d1			; moins deja copi
	sub #1,d1			; moins "~"

	sub.w d1,a2

	bra.s .do_the_copy

.alignement_gauche:
	move d4,d1			; copie max
	sub #1,d1			; moins "~"

	move.b #'~',0(a1,d1.w)
	bra.s .do_the_copy

.alignement_droite:
	move.b #'~',(a1)+

	add.w d1,a2

	move d4,d1			; copie max
	sub #1,d1			; moins "~"

	sub.w d1,a2
	bra.s .do_the_copy

.inf_taille_max:
	clr.b 0(a1,d1.w)

.do_the_copy:
	subq #1,d1
	bmi.s .nothing2copy

.cp:	move.b (a2)+,(a1)+
	dbf d1,.cp

.nothing2copy:
	cmp.w #GWVA_CFCBUF_REDRAW_NO,d3
	beq.s .no_wind_redraw

	lea GWVA_FSEL_UPD_TMP_OBJ_LIST,a1
	move.w d0,(a1)
	move.w #1,2(a1)
	move.w #GWVA_WRSC_CTE_REDRAW_PART_END_LIST,4(a1)
	GWVA_CALL_METHOD_OTHER_OBJ	#GWVA_METHOD_WRSC_REDRAW_PART_CONTENTS

.no_wind_redraw:
	rts

 BSS
GWVA_FSEL_UPD_TMP_OBJ_LIST:	ds.w 2+1
 TEXT
