;------------------------------------------------------------------------------
; Method name : -
; Asm label   : STIK_PRG_SEARCH_COOKIE
; Description : Initialisation de la librairie STIK/STING
;
; Rq  : Recherche le cookie STiK
;
; in  : -
; out : d7.w = GWVA_NO_ERROR_GENERIC ou GWVA_ERROR_GENERIC si Stik/Sting non trouv
; out : STIK_TPL_POINTER <>0 si Stik est l i.e TSR+ACC
;
; 16/11/98 : Cration
;------------------------------------------------------------------------------
STIK_PRG_SEARCH_COOKIE:

	move.l #'STiK',GWVA_ROOT_SEARCH_IN_OUT
	SUPEXEC GWVA_COOKIE_SEARCH_ONE_COOKIE
	move.l GWVA_ROOT_SEARCH_IN_OUT,a0

	clr.l STIK_TPL_POINTER

	cmp.l #0,a0
	beq.s .no_stik

	move.l (a0),a1

	cmp.l #"STiK",(a1)
	bne.s .no_magic
	cmp.l #"magi",4(a1)
	bne.s .no_magic
	cmp.w #"c"*256,8(a1)
	bne.s .no_magic

	tst.l STIK_DRV_LIST_get_dftab(a1)
	beq.s .no_dftab_routine

	save.l a1
	pea STIK_TRANSPORT_DRIVER
	jsr ([STIK_DRV_LIST_get_dftab,a1])
	lea 4(sp),sp
	load.l a1

	tst.l d0
	beq.s .no_transport

	move.l d0,STIK_TPL_POINTER	; transport structure

	move.l STIK_DRV_LIST_get_dftab(a1),STIK_GET_DFTAB
	move.l STIK_DRV_LIST_ETM_exec(a1),STIK_ETM_EXEC
	move.l STIK_DRV_LIST_cfg(a1),STIK_STIK_CONFIG	; stik config struct

	moveq #GWVA_NO_ERROR_GENERIC,d7
	rts

.no_transport:
.no_dftab_routine:
.no_magic:
.no_stik:
	moveq #GWVA_ERROR_GENERIC,d7
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : STIK_PRG_KRmalloc
;
; in  : d0.l = taille
; out : d0.l = pointeur
;
; 16/11/98 : Cration
;------------------------------------------------------------------------------
STIK_PRG_KRmalloc:

	move.l d0,-(sp)
	move.l STIK_TPL_POINTER,a0
	jsr ([STIK_TPL_KRmalloc,a0])
	lea 4(sp),sp
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : STIK_PRG_KRfree
;
; in  : a0.l = pointeur
; out : d0.w = code erreur ?
;
; 16/11/98 : Cration
;------------------------------------------------------------------------------
STIK_PRG_KRfree:

	pea (a0)
	move.l STIK_TPL_POINTER,a0
	jsr ([STIK_TPL_KRfree,a0])
	lea 4(sp),sp
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : STIK_PRG_KRgetfree
;
; in  : d0.w = flag
; out : d0.l = taille
;
; 16/11/98 : Cration
;------------------------------------------------------------------------------
STIK_PRG_KRgetfree:

	move.w d0,-(sp)
	move.l STIK_TPL_POINTER,a0
	jsr ([STIK_TPL_KRgetfree,a0])
	lea 2(sp),sp
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : STIK_PRG_KRrealloc
;
; in  : a0.l = pointeur bloc mmoire
; in  : d0.l = nouvelle taille
; out : d0.l = pointeur
;
; 16/11/98 : Cration
;------------------------------------------------------------------------------
STIK_PRG_KRrealloc:

	move.l d0,-(sp)
	pea (a0)
	move.l STIK_TPL_POINTER,a0
	jsr ([STIK_TPL_KRrealloc,a0])
	lea 4+4(sp),sp
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : STIK_PRG_get_err_text
;
; in  : 
; out : 
;
; 16/11/98 : Cration
;------------------------------------------------------------------------------
STIK_PRG_get_err_text:
	; Entre :	d0.w : code d'erreur
	; Sortie :	d0.l : pointeur

	move.w d0,-(sp)
	move.l STIK_TPL_POINTER,a0
	jsr ([STIK_TPL_get_err_text,a0])
	lea 2(sp),sp
	rts
;------------------------------------------------------------------------------
; Method name : -
; Asm label   : STIK_PRG_get_vstr
;
; in  : a0.l = pointeur sur le nom d'une variable stik
; out : d0.l = pointeur
;
; 16/11/98 : Cration
;------------------------------------------------------------------------------
STIK_PRG_get_vstr:

	pea (a0)
	move.l STIK_TPL_POINTER,a0
	jsr ([STIK_TPL_getvstr,a0])
	lea 4(sp),sp
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : STIK_PRG_carrier_detect
;
; in  : -
; out : d0.w = state
;
; 16/11/98 : Cration
;------------------------------------------------------------------------------
STIK_PRG_carrier_detect:

	move.l STIK_TPL_POINTER,a0
	jmp ([STIK_TPL_carrier_detect,a0])

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : STIK_PRG_TCP_open
;
; in  : d0.l = remote host address
; in  : d1.w = remote port
; in  : d2.w = type of service (cf. TCP/IP Illustrated Volume 1 p.35)
; in  : d3.w = size of output buff
; out : d0.w = handle or error code
;
; 16/11/98 : Cration
;------------------------------------------------------------------------------
STIK_PRG_TCP_open:

	move.w d3,-(sp)
	move.w d2,-(sp)
	move.w d1,-(sp)
	move.l d0,-(sp)
	move.l STIK_TPL_POINTER,a0
	jsr ([STIK_TPL_TCP_open,a0])
	lea 2+2+2+4(sp),sp
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : STIK_PRG_TCP_close
;
; in  : d0.w = handle
; in  : d1.w = timeout
; out : d0.w = error code
;
; 16/11/98 : Cration
;------------------------------------------------------------------------------
STIK_PRG_TCP_close:

	move.w d1,-(sp)
	move.w d0,-(sp)
	move.l STIK_TPL_POINTER,a0
	jsr ([STIK_TPL_TCP_close,a0])
	lea 2+2(sp),sp
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : STIK_PRG_TCP_send
;
; in  : d0.w = handle
; in  : a0.l = pointeur buffer
; in  : d1.w = taille (<taille bufer reserv au dbut en output)
; out : d0.w = error code
;
; 16/11/98 : Cration
;------------------------------------------------------------------------------
STIK_PRG_TCP_send:

	move.w d1,-(sp)
	pea (a0)
	move.w d0,-(sp)
	move.l STIK_TPL_POINTER,a0
	jsr ([STIK_TPL_TCP_send,a0])
	lea 2+4+2(sp),sp
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : STIK_PRG_TCP_wait_state
;
; in  : d0.w = handle
; in  : d1.w = state
; in  : d2.w = timeout
; out : d0.w = error code
;
; 16/11/98 : Cration
;------------------------------------------------------------------------------
STIK_PRG_TCP_wait_state:

	move.w d2,-(sp)
	move.w d1,-(sp)
	move.w d0,-(sp)
	move.l STIK_TPL_POINTER,a0
	jsr ([STIK_TPL_TCP_wait_state,a0])
	lea 2+2+2(sp),sp
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : STIK_PRG_TCP_ack_wait
;
; in  : d0.w = handle
; in  : d1.w = timeout
; out : d0.w = error code
;
; 16/11/98 : Cration
;------------------------------------------------------------------------------
STIK_PRG_TCP_ack_wait:

	move.w d1,-(sp)
	move.w d0,-(sp)
	move.l STIK_TPL_POINTER,a0
	jsr ([STIK_TPL_TCP_ack_wait,a0])
	lea 2+2(sp),sp
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : STIK_PRG_UDP_open
;
; in  : d0.l = remote host address
; in  : d1.w = remote port
; out : d0.w = handle or error code
;
; 16/11/98 : Cration
;------------------------------------------------------------------------------
STIK_PRG_UDP_open:

	move.w d1,-(sp)
	move.l d0,-(sp)
	move.l STIK_TPL_POINTER,a0
	jsr ([STIK_TPL_UDP_open,a0])
	lea 2+4(sp),sp
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : STIK_PRG_UDP_close
;
; in  : d0.w = handle
; out : d0.w = error code
;
; 16/11/98 : Cration
;------------------------------------------------------------------------------
STIK_PRG_UDP_close:

	move.w d0,-(sp)
	move.l STIK_TPL_POINTER,a0
	jsr ([STIK_TPL_UDP_close,a0])
	lea 2(sp),sp
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : STIK_PRG_UDP_send
;
; in  : d0.w = handle
; in  : a0.l = pointeur buffer
; in  : d1.w = taille (<taille bufer reserv au dbut en output)
; out : d0.w = error code
;
; 16/11/98 : Cration
;------------------------------------------------------------------------------
STIK_PRG_UDP_send:

	move.w d1,-(sp)
	pea (a0)
	move.w d0,-(sp)
	move.l STIK_TPL_POINTER,a0
	jsr ([STIK_TPL_UDP_send,a0])
	lea 2+4+2(sp),sp
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : STIK_PRG_CNkick
;
; in  : d0.w = handle
; out : d0.w = error code
;
; 16/11/98 : Cration
;------------------------------------------------------------------------------
STIK_PRG_CNkick:

	move.w d0,-(sp)
	move.l STIK_TPL_POINTER,a0
	jsr ([STIK_TPL_CNkick,a0])
	lea 2(sp),sp
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : STIK_PRG_CNbyte_count
;
; in  : d0.w = handle
; out : d0.w = nombre octets en attente
;
; 16/11/98 : Cration
;------------------------------------------------------------------------------
STIK_PRG_CNbyte_count:

	move.w d0,-(sp)
	move.l STIK_TPL_POINTER,a0
	jsr ([STIK_TPL_CNbyte_count,a0])
	lea 2(sp),sp
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : STIK_PRG_CNget_char
;
; in  : d0.w = handle
; out : d0.w = caractre suivant
;
; 16/11/98 : Cration
;------------------------------------------------------------------------------
STIK_PRG_CNget_char:

	move.w d0,-(sp)
	move.l STIK_TPL_POINTER,a0
	jsr ([STIK_TPL_CNget_char,a0])
	lea 2(sp),sp
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : STIK_PRG_CNget_NDB
;
; in  : d0.w = handle
; out : d0.l = pointeur NDB
;
; 16/11/98 : Cration
;------------------------------------------------------------------------------
STIK_PRG_CNget_NDB:

	move.w d0,-(sp)
	move.l STIK_TPL_POINTER,a0
	jsr ([STIK_TPL_CNget_NDB,a0])
	lea 2(sp),sp
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : STIK_PRG_CNget_block
;
; in  : d0.w = handle
; in  : a0.l = pointeur buffer
; in  : d1.w = nombre d'octets  recevoir
; out : d0.w = code d'erreur
;
; 16/11/98 : Cration
;------------------------------------------------------------------------------
STIK_PRG_CNget_block:

	move.w d1,-(sp)
	pea (a0)
	move.w d0,-(sp)
	move.l STIK_TPL_POINTER,a0
	jsr ([STIK_TPL_CNget_block,a0])
	lea 2+4+2(sp),sp
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : STIK_PRG_TCP_housekeep
;
; in  : -
; out : -
;
; 16/11/98 : Cration
;------------------------------------------------------------------------------
STIK_PRG_TCP_housekeep:

	move.l STIK_TPL_POINTER,a0
	jsr ([STIK_TPL_housekeep,a0])
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : STIK_PRG_resolve
;
; in  : a0.l = pointer to domain name
; in  : a1.l = pointer for returned resolved domain name
; in  : a2.w = pointer to array of returned IP adresses (.L)
; in  : d0.w = size of array
; out : d0.w = error code
;
; 16/11/98 : Cration
;------------------------------------------------------------------------------
STIK_PRG_resolve:

	move.w d0,-(sp)
	pea (a2)
	pea (a1)
	pea (a0)
	move.l STIK_TPL_POINTER,a0
	jsr ([STIK_TPL_resolve,a0])
	lea 4+4+4+2(sp),sp
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : STIK_PRG_ser_disable
;
; in  : -
; out : -
;
; 16/11/98 : Cration
;------------------------------------------------------------------------------
STIK_PRG_ser_disable:

	move.l STIK_TPL_POINTER,a0
	jsr ([STIK_TPL_ser_disable,a0])
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : STIK_PRG_ser_enable
;
; in  : -
; out : -
;
; 16/11/98 : Cration
;------------------------------------------------------------------------------
STIK_PRG_ser_enable:

	move.l STIK_TPL_POINTER,a0
	jsr ([STIK_TPL_ser_enable,a0])
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : STIK_PRG_set_flag
;
; in  : d0.w = flag
; out : d0.w = code d'erreur
;
; 16/11/98 : Cration
;------------------------------------------------------------------------------
STIK_PRG_set_flag:

	move.w d0,-(sp)
	move.l STIK_TPL_POINTER,a0
	jsr ([STIK_TPL_set_flag,a0])
	lea 2(sp),sp
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : STIK_PRG_clear_flag
;
; in  : d0.w = flag
; out : d0.w = code d'erreur
;
; 16/11/98 : Cration
;------------------------------------------------------------------------------
STIK_PRG_clear_flag:

	move.w d0,-(sp)
	move.l STIK_TPL_POINTER,a0
	jsr ([STIK_TPL_clear_flag,a0])
	lea 2(sp),sp
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : STIK_PRG_CNgetinfo
;
; in  : d0.w = handle
; out : d0.l = pointeur CIB
;
; 16/11/98 : Cration
;------------------------------------------------------------------------------
STIK_PRG_CNgetinfo:

	move.w d0,-(sp)
	move.l STIK_TPL_POINTER,a0
	jsr ([STIK_TPL_CNgetinfo,a0])
	lea 2(sp),sp
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : STIK_PRG_on_port
;
; in  : a0.l = pointeur sur un nom de port dans DEV_LIST
; out : d0.w = code d'erreur
;
; 16/11/98 : Cration
;------------------------------------------------------------------------------
STIK_PRG_on_port:

	pea (a0)
	move.l STIK_TPL_POINTER,a0
	jsr ([STIK_TPL_on_port,a0])
	lea 4(sp),sp
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : STIK_PRG_off_port
;
; in  : a0.l = pointeur sur un nom de port dans DEV_LIST
; out : d0.w = code d'erreur
;
; 16/11/98 : Cration
;------------------------------------------------------------------------------
STIK_PRG_off_port:

	pea (a0)
	move.l STIK_TPL_POINTER,a0
	jsr ([STIK_TPL_off_port,a0])
	lea 4(sp),sp
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : STIK_PRG_setvstr
;
; in  : a0.l = config variable name
; in  : a1.l = value
; out : d0.w = code d'erreur
;
; 16/11/98 : Cration
;------------------------------------------------------------------------------
STIK_PRG_setvstr:

	pea (a1)
	pea (a0)
	move.l STIK_TPL_POINTER,a0
	jsr ([STIK_TPL_setvstr,a0])
	lea 4+4(sp),sp
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : STIK_PRG_query_port
;
; in  : a0.l = pointeur sur un nom de port dans DEV_LIST
; out : d0.w = code d'erreur
;
; 16/11/98 : Cration
;------------------------------------------------------------------------------
STIK_PRG_query_port:

	pea (a0)
	move.l STIK_TPL_POINTER,a0
	jsr ([STIK_TPL_query_port,a0])
	lea 4(sp),sp
	rts

;------------------------------------------------------------------------------

	ifnd LIB_STING

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : STIK_PRG_g_resolve
;
; in  : a0.l = pointer to domain name
; in  : a1.l = pointer for returned resolved domain name
; in  : a2.w = pointer to array of returned IP adresses (.L)
; in  : d0.w = size of array
; out : d0.w = error code
;
; 16/11/98 : Cration
;------------------------------------------------------------------------------
STIK_PRG_g_resolve:

	move.w d0,-(sp)
	pea (a2)
	pea (a1)
	pea (a0)
	move.l STIK_TPL_POINTER,a0
	jsr ([STIK_TPL_g_resolve,a0])
	lea 4+4+4+2(sp),sp
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : STIK_PRG_g_TCP_wait_state
;
; in  : d0.w = handle
; in  : d1.w = state
; in  : d2.w = timeout
; out : d0.w = error code
;
; 16/11/98 : Cration
;------------------------------------------------------------------------------
STIK_PRG_g_TCP_wait_state:

	move.w d2,-(sp)
	move.w d1,-(sp)
	move.w d0,-(sp)
	move.l STIK_TPL_POINTER,a0
	jsr ([STIK_TPL_g_TCP_wait_state,a0])
	lea 2+2+2(sp),sp
	rts

;------------------------------------------------------------------------------

	else

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : STING_PRG_CNgets
;
; in  : a0.l = pointer to buffer
; in  : d0.w = cn
; in  : d1.w = length
; in  : d2.w = delimiter
; out : d0.w = error code
;
; 16/11/98 : Cration
;------------------------------------------------------------------------------
STING_PRG_CNgets:

	move.w d2,-(sp)
	move.w d1,-(sp)
	pea (a0)
	move.w d0,-(sp)
	move.l STIK_TPL_POINTER,a0
	jsr ([STING_TPL_CNgets,a0])
	lea 2+4+2+2(sp),sp
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : STING_PRG_ICMP_send
;
; in  : a0.l = pointer to data
; in  : d0.l = destination host
; in  : d1.b = type
; in  : d2.b = code
; in  : d3.w = length
; out : d0.w = error code
;
; 16/11/98 : Cration
;------------------------------------------------------------------------------
STING_PRG_ICMP_send:

	move.w d3,-(sp)
	pea (a0)
	move.w d2,-(sp)
	move.w d1,-(sp)
	move.l d0,-(sp)
	move.l STIK_TPL_POINTER,a0
	jsr ([STING_TPL_ICMP_send,a0])
	lea 4+2+2+4+2(sp),sp
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : STING_PRG_ICMP_handler
;
; in  : a0.l = pointer to routine
; in  : d0.w = install code
; out : d0.w = error code
;
; 16/11/98 : Cration
;------------------------------------------------------------------------------
STING_PRG_ICMP_handler:

	move.w d0,-(sp)
	pea (a0)
	move.l STIK_TPL_POINTER,a0
	jsr ([STING_TPL_ICMP_handler,a0])
	lea 4+2(sp),sp
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : STING_PRG_ICMP_discard
;
; in  : a0.l = pointer to ICPM datagram
; out : d0.w = error code
;
; 16/11/98 : Cration
;------------------------------------------------------------------------------
STING_PRG_ICMP_discard:

	pea (a0)
	move.l STIK_TPL_POINTER,a0
	jsr ([STING_TPL_ICMP_discard,a0])
	lea 4(sp),sp
	rts

;------------------------------------------------------------------------------

	endc	; ifnd LIB_STING

;------------------------------------------------------------------------------


 DATA
STIK_TRANSPORT_DRIVER:		dc.b 'TRANSPORT_TCPIP',0	
 even

 BSS
STIK_GET_DFTAB:		ds.l 1
STIK_ETM_EXEC:		ds.l 1
STIK_STIK_CONFIG:		ds.l 1	; pointeur sur une structure STIK_CONFIG
STIK_TPL_POINTER:		ds.l 1	; pointeur sur une structure STIK_TPL

 TEXT
