
;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_XBRA_SEARCH_ONE_XBRA
; Description : Fonction de recherche d'une fonction respectant la norme XBRA
;
; Rq  : Fonction  excuter en superviseur (SUPEXEC)
;
; in  : GWVA_ROOT_SEARCH_IN_OUT.l = pointeur sur le vecteur de dpart de recherche
; in  : GWVA_ROOT_SEARCH_IN_OUT.l+4 = texte XBRA  rechercher
; out : GWVA_ROOT_SEARCH_IN_OUT.l =	ptr sur le mot long aprs la chaine 
;			donne comme recherche ou 0.l si pas trouv
;
; 16/05/98 : Cration
;------------------------------------------------------------------------------
GWVA_XBRA_SEARCH_ONE_XBRA:

	move.l ([GWVA_ROOT_SEARCH_IN_OUT]),a0
	move.l GWVA_ROOT_SEARCH_IN_OUT+4,d0

	clr.l GWVA_ROOT_SEARCH_IN_OUT

.search:	cmp.l #'XBRA',xbra_magic(a0)
	bne.s .fin_liste

	cmp.l xbra_id(a0),d0
	beq.s .found

	move.l xbra_next(a0),a0
	cmp.l #0,a0
	beq.s .fin_liste
	bra.s .search

.found:	move.l a0,GWVA_ROOT_SEARCH_IN_OUT
.fin_liste:	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_XBRA_INSTALL_ONE_XBRA
; Description : Fonction pour installer une fonction  la norme XBRA
;
; Rq  : Fonction  excuter en superviseur (SUPEXEC)
; Rq  : Ne teste pas s'il existe dj,  vous de le faire en vous servant 
; Rq  : de GWVA_XBRA_SEARCH_ONE_XBRA
;
; in  : GWVA_ROOT_SEARCH_IN_OUT.l = pointeur sur le vecteur  changer
; in  : GWVA_ROOT_SEARCH_IN_OUT.l+4 = pointeur sur votre routine  la norme XBRA
;			  XBRA, "TEXT", 0.l
; out : GWVA_ROOT_SEARCH_IN_OUT.l =	GWVA_NO_ERROR_GENERIC si installe correcte
;			GWVA_ERROR_GENERIC sinon
;
; 16/05/98 : Cration
;------------------------------------------------------------------------------
GWVA_XBRA_INSTALL_ONE_XBRA:

	move.l GWVA_ROOT_SEARCH_IN_OUT,a0
	move.l GWVA_ROOT_SEARCH_IN_OUT+4,a1

	cmp.l #'XBRA',xbra_magic(a1)
	bne.s .cannot_install
	tst.l xbra_next(a1)
	bne.s .cannot_install

	move.l (a0),xbra_next(a1)
	move.l a1,(a0)

	move.l #GWVA_NO_ERROR_GENERIC,GWVA_ROOT_SEARCH_IN_OUT
	rts
.cannot_install:
	move.l #GWVA_ERROR_GENERIC,GWVA_ROOT_SEARCH_IN_OUT
	rts

;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_XBRA_REMOVE_ONE_XBRA
; Description : Fonction pour enlever une fonction respectant la norme XBRA
;
; Rq  : Fonction  excuter en superviseur (SUPEXEC)
;
; in  : GWVA_ROOT_SEARCH_IN_OUT.l = pointeur sur le vecteur pointant sur la fonction
; in  : GWVA_ROOT_SEARCH_IN_OUT.l+4 = texte de la fonction XBRA
; out : GWVA_ROOT_SEARCH_IN_OUT.l =	GWVA_NO_ERROR_GENERIC si enlvement correcte
;			GWVA_ERROR_GENERIC sinon
;
; 16/05/98 : Cration
;------------------------------------------------------------------------------
GWVA_XBRA_REMOVE_ONE_XBRA:
	move.l GWVA_ROOT_SEARCH_IN_OUT,a0
	move.l GWVA_ROOT_SEARCH_IN_OUT+4,d0

	move.l #GWVA_ERROR_GENERIC,GWVA_ROOT_SEARCH_IN_OUT

.search:	move.l (a0),a1	; a0=ptr sur struct XBRA
	cmp.l #0,a1
	beq.s .fin_liste
	cmp.l #'XBRA',xbra_magic(a1)
	bne.s .fin_liste

	cmp.l xbra_id(a1),d0
	beq.s .found

	lea xbra_next(a1),a0
	bra.s .search

.found:	move.l xbra_next(a1),(a0)
	clr.l xbra_next(a1)

	move.l #GWVA_NO_ERROR_GENERIC,GWVA_ROOT_SEARCH_IN_OUT

.fin_liste:	rts
