	output d:\assemble\visual45\src\skeleton\multidoc\bitmap\project.acx

OPT_GWVA_DEBUG_ERROR			; [option][root] generates an illegal when something goes wrong (for debugging purposes)
OPT_GWVA_DEBUG_PRINT_COMMENTS		; [option][root] print comments/warnings when assembling source

*OPT_GWVA_DEBUG_SEARCH_EXEC		; [option][root] is needed to do any log alert_box/logger
*OPT_GWVA_DEBUG_SEARCH_EXEC_IN_ALERT_BOX	; [option][root][LIB_HEXA][LIB_DECI][OPT_GWVA_DEBUG_SEARCH_EXEC] prints an alert box at each method distribution
*OPT_GWVA_DEBUG_SEARCH_EXEC_IN_LOGGER	; [option][root][LIB_HEXA][LIB_DECI][OPT_GWVA_DEBUG_SEARCH_EXEC] prints in log window each method distribution
*LIB_HEXA				; [none]
*LIB_DECI				; [none]

*GWVA_DEBUG_MSG_MAX_SIZE = 256		; [var] defines the debug message max length (generated by SEARCH_EXEC)
*GWVA_DEBUG_MAX_MSG_DEBUG_PENDING = 64	; [var] how many debug messages can be sent in a row

*PATCH_GWVA_ROOT_GEM_MESSAGE_PADDED16	; [option][MDL_GEM] aligns automatically the length of outgoing messages on multiple of 16 bytes

OPT_FULL_PATHNAMES
*OPT_DEBUG_IN_ACCESSORY_MODE
*OPT_DEBUG

	lea objet_application,a1

	include project.def
	include visual45.s
	include project.hs
	include project.obj

	comment HEAD=7
	section TEXT

;---------------------------------------------------------------------------
	; Exemple de programme Visual Assembleur 4.5
	; Proprit : marche aussi bien en accessoire qu'en programme

	; ce programme rpond aux quatre lois de l'ouverture :
	; 1) ligne de commande
	; 2) si pas de ligne de commande : slecteur de fichiers
	;    et si annule, CTRL+O -> redemande
	; 3) en accessoire : un click appelle le slecteur
	; 4) en accessoire, supporte le VA_START
;---------------------------------------------------------------------------

my_inits_created:
	tst GWVA_ROOT_IS_ACC_PRG
	beq.s .acc

	bfset GWVA_WIND_OBJ_PROPERTIES(a0){GWVA_WIND_OLBIT_AMENU:1}	; menu principal
	bfset GWVA_WAPP_OBJ_PROPERTIES(a0){GWVA_WAPP_OLBIT_BACKGROUND:1}	; fond
	bfset GWVA_WAPP_OBJ_PROPERTIES(a0){GWVA_WAPP_OLBIT_BACKGROUND_CENTER:1}	; fond centr
.acc:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

my_inits_opened:
	tst GWVA_ROOT_IS_ACC_PRG
	beq.s .acc

	tst GWVA_ROOT_CMD_LINE_SIZE
	beq.s .no_cmd_line
	move.l GWVA_ROOT_CMD_LINE_PTR,a0
	bra open_object
.no_cmd_line:
	moveq #GWVA_PRGRET_CONSUMED,d6
	bra menu_open
.acc:	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

acc_open:
menu_open:
	lea texte,a0		; 35 chars max.
	lea mask,a1			; 18 caracteres max
	lea 0,a2
	bsr GWVA_FILE_SELECTOR
	tst d0
	ble .annule

	move.l a2,a0
	bra.s open_object

.annule:	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

menu_information:
	lea objet_fenetre_info,a0
	bsr GWVA_WIND_CREATE_OPEN_ONE_WIND
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

routine_menu_quit:
app_term:
acc_close:

	bsr GWVA_ROOT_KILL_APPLICATION
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

*--------------------------------------------------------------------------*
; Sur un event_message (VA_START) on appelle la mthode si elle est prsente avec
; le buffer GEM en entre point par a1, a0 pointeur sur l'objet application, 
; le numro du message dans d0.w.
va_start_message:

	GWVA_CALL_METHOD_OTHER_OBJ	#GWVA_METHOD_OPEN

	move.l bmsg_start_free_data(a1),a0

	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	beq.s open_object

	; ne pas partir boucle infinie : et si jamais 1 vstation se libre ?

	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

*--------------------------------------------------------------------------*

open_object:		; ici : a0 pointeur sur un pathname !
	; le programme ... de traitement et cration du bitmap
	; votre image finale doit tre un malloc ainsi que sa palette
	; puis ...

	; pas de routine de fermeture de fentre ni de libration de
	; mmoire : tout est gr en interne

	move.l a0,img_filename_ptr	; sauve pour plus tard

	;  vous d'initialiser les 5 lignes qui suivent ...
	move #640,img_width
	move #480,img_height
	move GWVA_ROOT_VDI_WORKSTATION_EXTD+4*2,img_nbr_bitplane
	move.l #$400,img_pal_ptr
	move.l #$400,img_data_ptr
	; ... on va faire un dump graphique de la mmoire ... tip top

	; on fait un malloc de la taille d'une structure de fentre
	; bitmap, on reloge et on recopie tout comme il faut dedans

	lea objet_fenetre_clone,a0
	lea offsets_objet_fenetre_clone,a1
	move.l #fin_objet_fenetre_clone-objet_fenetre_clone,d0	; les 2 ont la mme taille
	move.w #GWVA_ROOT_CTE_CLONE_RELOC_ONE_OBJECT,d1
	bsr GWVA_ROOT_CLONE_OBJECT
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne .erreur_clone		; plus de mmoire

	move.l a0,GWVA_WIND_OBJ_USER_PTR1(a0)
	; sera libr automatiquement car on a mis le bit GWVA_WIND_OLBIT_FREEPTR1 des PROPERTIES

	move img_width,GWVA_WIND_OBJ_FIRST_INT_VISIBLE_W(a0)
	move img_height,GWVA_WIND_OBJ_FIRST_INT_VISIBLE_H(a0)

	move img_width,GWVA_WBITM_OBJ_IMG_WIDTH(a0)
	move img_height,GWVA_WBITM_OBJ_IMG_HEIGHT(a0)
	move.l img_data_ptr,GWVA_WBITM_OBJ_DATA_PTR(a0)
	move.l img_pal_ptr,GWVA_WBITM_OBJ_PAL_PTR(a0)
	move.w img_nbr_bitplane,GWVA_WBITM_OBJ_NB_BITPLANES(a0)

	move.l img_filename_ptr,a2	; nom du fichier en info
	move.l GWVA_WIND_OBJ_INFO_PTR(a0),a3
	COPY_STRING_0 a2,a3

	bsr GWVA_WIND_CREATE_OPEN_ONE_WIND
	; si la cration choue ... la mmoire a t libre

.erreur_clone:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

;------------------------------------------------------------------------------

	section DATA

offsets_objet_fenetre_clone:
	dc.l GWVA_WIND_OBJ_NAME_PTR
	dc.l GWVA_WIND_OBJ_INFO_PTR
	dc.l GWVA_ROOT_CTE_END_OFFSET_LIST

texte:	dc.b 'Genuwax for the best : ',0
mask:	dc.b '*.S,*.BAK',0
 even

;------------------------------------------------------------------------------

	section BSS

img_width:		ds.w 1
img_height:		ds.w 1
img_nbr_bitplane:	ds.w 1
img_pal_ptr:	ds.l 1
img_data_ptr:	ds.l 1
img_filename_ptr:	ds.l 1

 END
