	output d:\assemble\visual45\src\valogger\valogger.acx

OPT_GWVA_DEBUG_ERROR			; [option][root] generates an illegal when something goes wrong (for debugging purposes)
OPT_GWVA_DEBUG_PRINT_COMMENTS		; [option][root] print comments/warnings when assembling source

*OPT_GWVA_DEBUG_SEARCH_EXEC		; [option][root] is needed to do any log alert_box/logger
*OPT_GWVA_DEBUG_SEARCH_EXEC_IN_ALERT_BOX	; [option][root][LIB_HEXA][LIB_DECI][OPT_GWVA_DEBUG_SEARCH_EXEC] prints an alert box at each method distribution
*OPT_GWVA_DEBUG_SEARCH_EXEC_IN_LOGGER	; [option][root][LIB_HEXA][LIB_DECI][OPT_GWVA_DEBUG_SEARCH_EXEC] prints in log window each method distribution
*GWVA_DEBUG_MSG_MAX_SIZE = 256		; [var] defines the debug message max length (generated by SEARCH_EXEC)
*GWVA_DEBUG_MAX_MSG_DEBUG_PENDING = 64	; [var] how many debug messages can be sent in a row

*LIB_HEXA				; [none]
*LIB_DECI				; [none]

OPT_FULL_PATHNAMES
*OPT_DEBUG_IN_ACCESSORY_MODE
*OPT_DEBUG

	lea objet_application,a1

	include valogger.def
	include visual45.s
	include valogger.hs
	include valogger.obj

	comment HEAD=7
	section TEXT

;---------------------------------------------------------------------------
	; Le Logger Visual Assembleur 4.5
	; Programme permettant de looger les appels mthodes dans une fentre
	; 1) Compilez votre application avec l'option OPT_GWVA_DEBUG_SEARCH_EXEC_IN_LOGGER
	; 2) Lancez le logger en accessoire
	; 3) Lancez votre application : ses appels sont loggs.

;---------------------------------------------------------------------------

my_inits_created:
	ifd OPT_DEBUG_IN_ACCESSORY_MODE
	bra.s .acc
	endc	; ifd OPT_DEBUG_IN_ACCESSORY_MODE

	tst GWVA_ROOT_IS_ACC_PRG
	beq.s .acc

	bfset objet_application+GWVA_WIND_OBJ_PROPERTIES{GWVA_WIND_OLBIT_AMENU:1}	; menu
.acc:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

	;-------------------------------------------------

my_inits_opened:

	tst GWVA_ROOT_IS_ACC_PRG
	bne.s .app

	moveq #GWVA_PRGRET_CONSUMED,d6
	rts
.app:

menu_open:
acc_open:	lea objet_fenetre_main,a0
	bsr GWVA_WIND_CREATE_OPEN_ONE_WIND

	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne.s erreur_create_wind

	ifd OPT_DEBUG_IN_ACCESSORY_MODE

	lea GWVA_ROOT_TMP_MSG_OUT_BUF,a0
	move.w #GWVA_MSG_LOG,bmsg_msgid(a0)
	move.w #'11',bmsg_debug_format(a0)
	move.l #texte_de_test_affichage,bmsg_debug_string_ptr(a0)
	move.l #ad_mot_a_effacer,bmsg_debug_ack_word_ptr(a0)

	moveq #16,d0
	moveq #GWVA_MODE_SEND_GEM_MESSAGE_TO_MYSELF,d1

	bsr GWVA_ROOT_SEND_GEM_MESSAGE
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	beq.s .send_ok
	illegal
.send_ok:

*	appl_find #name_logger
*
*	lea buffer_message_gem_essai,a2
*	move.w #GWVA_MSG_LOG,bmsg_msgid(a2)
*	move.w global+_AESapid,bmsg_apid(a2)
*	move.w #((fin_buffer_message_gem_extend_essai-buffer_message_gem_extend_essai)>>4)<<4+16,bmsg_extd(a2)
*	appl_write d0,#((fin_buffer_message_gem_extend_essai-buffer_message_gem_extend_essai)>>4)<<4+16+16,a2

	endc	; ifd OPT_DEBUG_IN_ACCESSORY_MODE

	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

erreur_create_wind:
app_term:
menu_quit:
acc_close:
wmenu_quit:
	lea objet_fenetre_main,a0
	bsr GWVA_WIND_DELETE_ONE_WIND

	bsr GWVA_ROOT_KILL_APPLICATION
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

	;-------------------------------------------------

wmenu_log_window_selected:
wmenu_auto_open_selected:

	move.w #GWVA_MENU_CTE_CHANGE_CHECK,d0
	; d1.w (idx item) est donn en entre
	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS	#GWVA_METHOD_MENU_CHECK
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

wmenu_clear_log_window:
	lea objet_fenetre_main,a0
	GWVA_CALL_METHOD_OTHER_OBJ #GWVA_METHOD_WTEXT_CLEAR_BUFFER_AND_UPDATE
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts
	
event_window_main_closed:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts


write_message_in_log_window:

; Si la fentre est cre ca veut dire que la station graphique est ouverte

; Ici on a a1=ptr buff_gem et a2=ptr buff tendu

	save.l a1-a2

	lea objet_fenetre_main,a0
	bsr GWVA_ROOT_TEST_IF_OBJECT_CREATED
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	beq.s .fenetre_cree

	;  amliorer ... si possible ...

; On ouvre la station graphique

	lea objet_application,a0
	GWVA_CALL_METHOD_OTHER_OBJ	#GWVA_METHOD_OPEN
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne .station_graphique_non_ouverte

	lea objet_fenetre_main,a0
	bsr GWVA_WIND_CREATE_ONE_WIND
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne .erreur_create_wind

.fenetre_cree:

	; Ne pas l'ouvrir si elle est dj ouverte, sinon elle passe TOP

	lea objet_fenetre_main,a0
	bsr GWVA_WIND_TEST_IF_WIND_OPENED
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	beq.s .fenetre_ouverte

; L'auto open est-il autoris ?

	move.l GWVA_WIND_OBJ_MENU_SPEC_PTR(a0),a0
	move.w #GWVA_MENU_CTE_TEST_CHECK,d0
	move.w #WMNU_OPT_AUTOPEN,d1
	GWVA_CALL_METHOD_OTHER_OBJ	#GWVA_METHOD_MENU_CHECK
	; -> d7.w
	cmp.w #GWVA_MENU_CTE_UNCHECKED,d7
	beq .pas_auto_open

	lea objet_fenetre_main,a0
	bsr GWVA_WIND_OPEN_ONE_WIND
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne.s .erreur_open_wind
	; exemple : log du create mshrink non fait : create wind_log a plant
.pas_auto_open:
.fenetre_ouverte:

	load.l a1-a2

	cmp.w #'11',bmsg_debug_format(a1)
	bne.s .pas_bonne_version_de_message

; Le log dans une fentre est-il autoris ?

	save.l a0-a2
	move.l GWVA_WIND_OBJ_MENU_SPEC_PTR(a0),a0
	move.w #GWVA_MENU_CTE_TEST_CHECK,d0
	move.w #WMNU_OPT_LOGW,d1
	GWVA_CALL_METHOD_OTHER_OBJ	#GWVA_METHOD_MENU_CHECK
	; -> d7.w
	load.l a0-a2

	cmp.w #GWVA_MENU_CTE_UNCHECKED,d7
	beq .pas_log_dans_fenetre

	move.l bmsg_debug_ack_word_ptr(a1),a6

*	save.l a6

	lea objet_fenetre_main,a0
	save.l a1
*	move.l a2,a1
	move.l bmsg_debug_string_ptr(a1),a1
	GWVA_CALL_METHOD_OTHER_OBJ	#GWVA_METHOD_WTEXT_WRITE_IN_WINDOW
	load.l a1

*	load.l a6

*	clr.w (a6)

	; !! appeler la nouvelle super mthode root pour env message
*	lea buffer_message_gem,a2
*	move.w #GWVA_MSG_LOG_ACK,bmsg_msgid(a2)
*	move.w global+_AESapid,bmsg_apid(a2)
*	clr.w bmsg_extd(a2)
*
*	appl_write bmsg_apid(a1),#16,a2

.pas_log_dans_fenetre:
.pas_bonne_version_de_message:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.station_graphique_non_ouverte:
.erreur_create_wind:
.erreur_open_wind:
	load.l a1-a2
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

	;-------------------------------------------------

	section DATA

	ifd OPT_DEBUG_IN_ACCESSORY_MODE
ad_mot_a_effacer:	dc.w $1234
*name_logger:	dc.b 'VALOGGER',0

texte_de_test_affichage:	dc.b "Essai de message pour le V.A Logger",0
*buffer_message_gem_essai:	dcb.b 16,0
*buffer_message_gem_extend_essai:	dc.b "Essai de message pour le V.A Logger",0
*fin_buffer_message_gem_extend_essai:dcb.b 16,0
 even

	endc	; ifd OPT_DEBUG_IN_ACCESSORY_MODE

	section BSS
 even
buffer_message_gem_simule:		ds.b 16

 END
