;------------------------------------------------------------------------------
; Method name : -
; Asm label   : GWVA_ROOT_PRG_SEARCH_AND_EXEC_METHOD
; Description : Fonction de distribution de mthode
;
; in  : a0.l = pointeur sur l'objet
; in  : d0-d2/a0-a2 : paramtres passs en entre de la mthode trouve
; in  : d4.l = nom de la mthode
; in  : d5.w = mode d'activation
;	   GWVA_MODE_CLASS_METHOD_SEARCH_ALL_FIRST_SON : distribue  tous les fils de cet objet sans tester CONSUMED or NOT
;	   GWVA_MODE_CLASS_METHOD_SEARCH_AFS_WITH_HANDLE : distribue  tous les fils fentre de cet objet sans tester CONSUMED or NOT et positionne leur handle GEM dans d0 pour forcer la prise en compte (CLICK)
;	   GWVA_MODE_CLASS_METHOD_SEARCH_VISUAL_EVENT : distribue un vnement gnr par le VA
;	   GWVA_MODE_CLASS_METHOD_SEARCH_OTHER_OBJ : Appel de mthode d'un objet autre que l'objet courant (class MAX forcment)
;	   GWVA_MODE_CLASS_METHOD_SEARCH_DIFF_METH_SAME_CLASS : Appel d'une mthode diffrente de la mme classe (cherche  partir de i)
;	   GWVA_MODE_CLASS_METHOD_SEARCH_INHERITED : Appel de la mme mthode que courante mais classe i-1 (classe dont on hrite)
;
; out : d6.w = code de retour
;	   GWVA_SEARCH_EXEC_CONSUMED		(pas pour ALL_FIRST_SON)
;	   GWVA_SEARCH_EXEC_CONSUMED_BY_ONE_OBJECT	(pour ALL_FIRST_SON)
;	   GWVA_SEARCH_EXEC_NOT_CONSUMED
;	   GWVA_SEARCH_EXEC_NOT_FOUND
;	   GWVA_SEARCH_EXEC_NO_DEST_FOUND
;	   GWVA_SEARCH_EXEC_USER_ERROR	; erreur du programmeur
; out : d7.w = code d'erreur
;
; 19/07/98 : Cration
;------------------------------------------------------------------------------

gwva_exec_method:			; in : a4.l ptr struct methode

	moveq #GWVA_SEARCH_EXEC_NOT_FOUND,d6	; par dfaut on ne la trouve pas

	save.l d0-d2/d4-d5/a0-a2
	jsr ([GWVA_OBJ_METHODLIST_ITEM_ROUTINE,a4])	; -> d6,d7
	load.l d0-d2/d4-d5/a0-a2

	ifd OPT_GWVA_DEBUG_ERROR

	cmp.w #GWVA_PRGRET_CONSUMED,d6
	beq.s .no_error
	cmp.w #GWVA_PRGRET_NOT_CONSUMED,d6
	beq.s .no_error
	GWVA_PROGRAMMER_ERROR	GWVA_ASCII_ERROR_RETURN_D6
.no_error:
	endc	; ifd OPT_GWVA_DEBUG_ERROR
	rts

			*---------------

GWVA_ROOT_PRG_SEARCH_AND_EXEC_METHOD:
exec3:
	ifd MDL_GEM

	ifd OPT_GWVA_DEBUG_SEARCH_EXEC
	add.w #1,GWVA_DEBUG_STACK_LEVEL_COUNTER
	endc	; OPT_GWVA_DEBUG_SEARCH_EXEC

	cmp.l #GWVA_ROOT_STACK_TOP+9*4*2,sp	; 9*4 mini sinon on peut mme pas faire
	bgt.s .no_stack_overflow	; d'dition d'erreur sans craser qqchose

	save.l d0-d2/d4-d5/a0-a2
	lea GWVA_ROOT_ALERT_STACK_OVERFLOW,a0
	move #1,d0
	bsr GWVA_ROOT_PRG_ALERT_BOX
	load.l d0-d2/d4-d5/a0-a2
.no_stack_overflow:

	endc	; ifd MDL_GEM

	ifd OPT_GWVA_DEBUG_ERROR
	bsr GWVA_ROOT_TEST_IF_OBJECT_CREATED
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	beq.s .objet_cree
	GWVA_PROGRAMMER_ERROR	GWVA_ASCII_ERROR_OBJ_HANDLE
	moveq #GWVA_SEARCH_EXEC_NO_DEST_FOUND,d6	; dfense
	rts
.objet_cree:
	endc	; OPT_GWVA_DEBUG_ERROR

;---------------------------------------------------------------------------------------
	cmp.w #GWVA_MODE_CLASS_METHOD_SEARCH_VISUAL_EVENT,d5
	bne pas_distribution_evenement_visual

	;;;;;;;;; GWVA_MODE_CLASS_METHOD_SEARCH_VISUAL_EVENT

	; On ne peut le laisser car si un message envoy par une
	; autre application arrive sur l'objet WAPP = erreur
	; car distribu en mode local alors que son ID<>message_event

*	ifd OPT_GWVA_DEBUG_ERROR
*	move.l d4,d6
*	and.l #GWVA_METHOD_MASK_EVENT|GWVA_METHOD_MASK_BEFORE|GWVA_METHOD_MASK_AFTER,d6
*	bne.s .methode_est_evenementielle
*	GWVA_PROGRAMMER_ERROR	GWVA_ASCII_ERROR_VISUAL_EVENT
*	bra .pas_de_liste_methode_locale
*.methode_est_evenementielle:
*	endc	; OPT_GWVA_DEBUG_ERROR


	move.l GWVA_OBJ_METHODTLIST_PTR(a0),a4

	cmp.l #GWVA_OBJ_CTE_METHODLISTPTR_UNDEF,a4
	beq .pas_de_liste_methode_locale

.recherche_methode_class:
	bsr find_method_in_method_list	; in : a4.l=liste+d4.l=methode ; out : a4.l=ptr struct trouvee (0.l si pas trouv)
	cmp.l #0,a4
	beq .pas_trouve_methode

; La macro GWVA_EXEC_VISUAL_EVENT ne peut tre appele que d'une mthode d'un objet.
; Par consquent, les informations lies  sa classe sont stockes.

	move.l GWVA_SEARCH_EXEC_OBJECT_LEVEL_STACK_PTR,a5

	move.w GWVA_OBJ_METHODLIST_ITEM_CLASS(a4),d7	; correspond-t-elle  celle de la mthode ?
	cmp.w #GWVA_OBJ_CTE_BEFORE_AFTER_ON_OBJECT_CLASS,d7
	bne.s .methode_classe_definie

	move.w GWVA_OBJ_CLASS(a0),d7		: classe de l'objet
	cmp.w GWVA_SEARCH_EXEC_STACK_CLASS(a5),d7	: = classe courante
	beq.s .methode_classe_objet

	ifnd MDL_TOS

.recherche_1er_heritage:
	save.l d4/a4
	bsr return_class_method_list	; in : d7.w ; out : a4.l (0.l si pas trouv)
	and.l #~(GWVA_METHOD_MASK_EVENT|GWVA_METHOD_MASK_BEFORE|GWVA_METHOD_MASK_AFTER),d4	; Mthode de base sur laquelle on veut faire soit le before, soit l'after
	bsr find_method_in_method_list	; in : a4.l=liste+d4.l=methode ; out : a4.l=ptr struct trouvee (0.l si pas trouv)
	move.l a4,d6
	load.l d4/a4
	tst.l d6
	bne.s .premiere_methode_trouvee

	save.l a4
	bsr return_herited_class
	load.l a4
	cmp.w #GWVA_OBJ_CTE_CLASS_UNDEF,d7
	bne.s .recherche_1er_heritage

*	GWVA_PROGRAMMER_ERROR	GWVA_ASCII_ERROR_BEFORE_METHOD_NOT_FOUND
	illegal
	lea GWVA_OBJ_METHODLIST_STRUCT_LENGTH(a4),a4	; lment suivant de la liste
	bra.s .recherche_methode_class
.premiere_methode_trouvee:

; On a trouve le premier niveau d'apparition de la mthode

	cmp.w GWVA_SEARCH_EXEC_STACK_CLASS(a5),d7	: = classe courante
	bne.s .methode_pas_de_cette_classe

	move.w GWVA_OBJ_CLASS(a0),d7		: classe de l'objet
	bra.s .methode_classe_objet

	endc	; ifnd MDL_TOS

.methode_classe_definie:
	cmp.w GWVA_SEARCH_EXEC_STACK_CLASS(a5),d7	: = classe courante
	beq.s .methode_de_cette_classe
.methode_pas_de_cette_classe:

	lea GWVA_OBJ_METHODLIST_STRUCT_LENGTH(a4),a4	; lment suivant de la liste
	bra.s .recherche_methode_class

.methode_classe_objet:
.methode_de_cette_classe:
	moveq #1,d6			; dans la liste locale
	bsr store_search_exec_information	; in : d6+d7+a0+d4

			;---------

	ifd OPT_GWVA_DEBUG_SEARCH_EXEC_IN_ALERT_BOX
	bsr gwva_show_debug_alert_box
	endc	; OPT_GWVA_DEBUG_SEARCH_EXEC_IN_ALERT_BOX

	ifd OPT_GWVA_DEBUG_SEARCH_EXEC_IN_LOGGER
	bsr gwva_show_debug_send_logger_in
	endc	; ifd OPT_GWVA_DEBUG_SEARCH_EXEC_IN_LOGGER

			;---------

	bsr gwva_exec_method	; out -> d6.w+d7 positionns par la mthode

	add.l #GWVA_SEARCH_EXEC_STACK_STRUCT_LENGTH,GWVA_SEARCH_EXEC_OBJECT_LEVEL_STACK_PTR

	bra common_distribution_ending

.pas_trouve_methode:
.pas_de_liste_methode_locale:
	move.l #GWVA_SEARCH_EXEC_NOT_FOUND,d6	; par dfaut on ne la trouve pas

	bra common_distribution_ending

;---------------------------------------------------------------------------------------
pas_distribution_evenement_visual:

	cmp.w #GWVA_MODE_CLASS_METHOD_SEARCH_OTHER_OBJ,d5
	bne pas_distribution_sur_autre_objet

	;;;;;;;;; GWVA_MODE_CLASS_METHOD_SEARCH_OTHER_OBJ

; La mthode ne doit maintenant tre ni un BEFORE, ni un AFTER, ni un EVENT

	ifd OPT_GWVA_DEBUG_ERROR
	move.l d4,d6
	and.l #GWVA_METHOD_MASK_EVENT|GWVA_METHOD_MASK_BEFORE|GWVA_METHOD_MASK_AFTER,d6
	beq.s .methode_pas_evenementielle
	GWVA_PROGRAMMER_ERROR	GWVA_ASCII_ERROR_BEFORE_AFTER
	bra .pas_trouve_methode
.methode_pas_evenementielle:
	endc	; OPT_GWVA_DEBUG_ERROR

; D'abord on recherche dans la liste locale la mthode

	move.l GWVA_OBJ_METHODTLIST_PTR(a0),a4

	cmp.l #GWVA_OBJ_CTE_METHODLISTPTR_UNDEF,a4
	beq.s .pas_de_liste_methode_locale

	bsr find_method_in_method_list	; in : a4.l=liste+d4.l=methode ; out : a4.l=ptr struct trouvee (0.l si pas trouv)
	cmp.l #0,a4
	beq.s .pas_trouve_methode

	move.w GWVA_OBJ_CLASS(a0),d7	; classe de l'objet
	moveq #1,d6			; dans la liste locale
	bsr store_search_exec_information	; in : d6+d7+a0+d4

	save.l d4		; sauvegarde la mthode pour la comparer avec la mthode DELETE ...
	bsr gwva_exec_method	; out -> d6.w+d7 positionns par la mthode
	load.l d4

	add.l #GWVA_SEARCH_EXEC_STACK_STRUCT_LENGTH,GWVA_SEARCH_EXEC_OBJECT_LEVEL_STACK_PTR

	bra .comparaison_methode_delete

.pas_trouve_methode:
.pas_de_liste_methode_locale:

; Si la liste locale n'a pas consomm la mthode

	move.w GWVA_OBJ_CLASS(a0),d7

	save.l d4		; sauvegarde la mthode pour la comparer avec la mthode DELETE ...
	bsr partie_commune_search_method
	load.l d4

.comparaison_methode_delete:
	cmp.l #GWVA_METHOD_DELETE,d4
	bne.s .pas_traitement_speciale_delete

	move.w #GWVA_OBJ_CTE_HANDLE_UNDEF,GWVA_OBJ_HANDLE(a0)	; desallocation du handle VA

.pas_traitement_speciale_delete:

	bra common_distribution_ending

;---------------------------------------------------------------------------------------

pas_distribution_sur_autre_objet:

	ifnd MDL_TOS

	cmp.w #GWVA_MODE_CLASS_METHOD_SEARCH_DIFF_METH_SAME_CLASS,d5
	bne.s pas_distribution_different_method_same_class

	;;;;;;;;; GWVA_MODE_CLASS_METHOD_SEARCH_DIFF_METH_SAME_CLASS

	move.l GWVA_SEARCH_EXEC_OBJECT_LEVEL_STACK_PTR,a5
	move.w GWVA_SEARCH_EXEC_STACK_CLASS(a5),d7

	bsr partie_commune_search_method
	bra common_distribution_ending

	endc	; ifnd MDL_TOS

;---------------------------------------------------------------------------------------
pas_distribution_different_method_same_class:

	ifnd MDL_TOS

	cmp.w #GWVA_MODE_CLASS_METHOD_SEARCH_INHERITED,d5
	bne.s pas_distribution_mode_heritage

	;;;;;;;;; GWVA_MODE_CLASS_METHOD_SEARCH_INHERITED

	move.l GWVA_SEARCH_EXEC_OBJECT_LEVEL_STACK_PTR,a5
	move.w GWVA_SEARCH_EXEC_STACK_CLASS(a5),d7

	tst.w GWVA_SEARCH_EXEC_STACK_IS_IN_LOCAL_METHOD_LIST(a5)
	bne.s .pas_de_classe_herite_si_dans_local

	bsr return_herited_class	; in : d7.w ; out : d7.w
	cmp.w #GWVA_OBJ_CTE_CLASS_UNDEF,d7
	beq common_distribution_ending

.pas_de_classe_herite_si_dans_local:
	move.l GWVA_SEARCH_EXEC_OBJECT_LEVEL_STACK_PTR,a5
	move.l GWVA_SEARCH_EXEC_STACK_METHOD(a5),d4

	bsr partie_commune_search_method
	bra common_distribution_ending

	endc	; ifnd MDL_TOS

;---------------------------------------------------------------------------------------
pas_distribution_mode_heritage:

	ifnd MDL_TOS

	cmp.w #GWVA_MODE_CLASS_METHOD_SEARCH_ALL_FIRST_SON,d5
	beq.s .distribution_afs
	cmp.w #GWVA_MODE_CLASS_METHOD_SEARCH_AFS_WITH_HANDLE,d5
	bne pas_distribution_afs
.distribution_afs:

	;;;;;;;;; GWVA_MODE_CLASS_METHOD_SEARCH_ALL_FIRST_SON
	;;;;;;;;; GWVA_MODE_CLASS_METHOD_SEARCH_AFS_WITH_HANDLE

	save.l a0

	move.w #GWVA_SEARCH_EXEC_NO_DEST_FOUND,GWVA_SEARCH_EXEC_RETURN_CODE_D6

	move.l GWVA_OBJ_FIRST_SON_PTR(a0),a0
	cmp.l #0,a0
	beq .no_child_at_all

.parcourir_toutes:
	bsr GWVA_ROOT_TEST_IF_OBJECT_CREATED
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne.s .cet_objet_n_est_pas_cree

	cmp.w #GWVA_MODE_CLASS_METHOD_SEARCH_AFS_WITH_HANDLE,d5
	bne.s .pas_init_d0
	move.w GWVA_WIND_OBJ_GEM_HANDLE(a0),d0	; les mthodes wind prennent d0 en entre
.pas_init_d0:

	move.l GWVA_OBJ_NEXT_BROTHER_PTR(a0),-(sp)

	save.l d4/d5		; a0 est sauv
	GWVA_CALL_METHOD_OTHER_OBJ	d4
	load.l d4/d5

	cmp.w #GWVA_SEARCH_EXEC_CONSUMED_BY_ONE_OBJECT,GWVA_SEARCH_EXEC_RETURN_CODE_D6
	beq.s .one_object_has_consumed

	cmp.w #GWVA_SEARCH_EXEC_CONSUMED,d6
	bne.s .method_not_consumed

	move.w #GWVA_SEARCH_EXEC_CONSUMED_BY_ONE_OBJECT,GWVA_SEARCH_EXEC_RETURN_CODE_D6
	bra.s .one_object_has_consumed
.method_not_consumed:

	move.w d6,GWVA_SEARCH_EXEC_RETURN_CODE_D6
.one_object_has_consumed:

; On rcupre directement le frre de l'objet, au cas o il est enlev de l'arbre
	move.l (sp)+,a0
	bra.s .frere_deja_connu

.cet_objet_n_est_pas_cree:
	move.l GWVA_OBJ_NEXT_BROTHER_PTR(a0),a0
.frere_deja_connu:
	cmp.l #0,a0
	bne.s .parcourir_toutes

.no_child_at_all:
.fin_commune:
	load.l a0
	move.w GWVA_SEARCH_EXEC_RETURN_CODE_D6,d6
	bra common_distribution_ending

.methode_shortcut_consomee_arrete_tout:
	move.w #GWVA_SEARCH_EXEC_CONSUMED_BY_ONE_OBJECT,GWVA_SEARCH_EXEC_RETURN_CODE_D6
	bra.s .fin_commune

	endc	; ifnd MDL_TOS

;---------------------------------------------------------------------------------------
pas_distribution_afs:
	illegal

;---------------------------------------------------------------------------------------

common_distribution_ending:
	ifd OPT_GWVA_DEBUG_SEARCH_EXEC
	sub.w #1,GWVA_DEBUG_STACK_LEVEL_COUNTER
	endc	; OPT_GWVA_DEBUG_SEARCH_EXEC

	rts

			*---------------

	ifnd MDL_TOS

return_herited_class:	; in : d7.w ; out : d7.w (=UNDEF si pas d'heritage) ; scratch a4

	lea GWVA_ROOT_CLASS_INHERITANCE_LIST,a4

.search_my_class:
	cmp.w #GWVA_OBJ_CTE_END_INHERITANCE_LIST,GWVA_OBJ_INHERITANCELIST_ITEM_SONCLASS(a4)
	beq.s .fin_liste_heritage

	cmp.w GWVA_OBJ_INHERITANCELIST_ITEM_SONCLASS(a4),d7
	beq.s .found

	lea GWVA_OBJ_INHERITANCELIST_ITEM_STRUCT_LENGTH(a4),a4
	bra.s .search_my_class

.fin_liste_heritage:
	cmp.l #GWVA_OBJ_CTE_END_LINK_INHERITANCE_LIST,GWVA_OBJ_INHERITANCELIST_LINKLIST_PTR(a4)
	beq.s .pas_trouve_heritage
	move.l GWVA_OBJ_INHERITANCELIST_LINKLIST_PTR(a4),a4
	bra.s .search_my_class

.found:	move.w GWVA_OBJ_INHERITANCELIST_ITEM_FATHERCLASS(a4),d7
	rts

.pas_trouve_heritage:
	ifd OPT_GWVA_DEBUG_ERROR
	GWVA_PROGRAMMER_ERROR	GWVA_ASCII_ERROR_NO_INHERITANCE
.trouve_default_liste:
	endc	; OPT_GWVA_DEBUG_ERROR

	endc	; ifnd MDL_TOS

			*---------------

find_method_in_method_list:	; in : a4.l=liste+d4.l=methode ; out : a4.l=ptr struct trouvee (0.l si pas trouv)

.search_method_in_list:
	cmp.l #GWVA_OBJ_CTE_END_METHOD_LIST,GWVA_OBJ_METHODLIST_ITEM_METHOD(a4)
	beq.s .fin_liste

	bftst GWVA_OBJ_METHODLIST_ITEM_PROPERTIES(a4){GWVA_METHOD_PROPERTIES_OLBIT_COMMAND:1}
	beq.s .pas_commande

	cmp.l #GWVA_METHOD_CTE_COMMAND_GOTO,GWVA_OBJ_METHODLIST_ITEM_METHOD(a4)
	bne.s .pas_goto
	move.l GWVA_OBJ_METHODLIST_ITEM_ROUTINE(a4),a4
	bra.s .search_method_in_list
.pas_goto:
	ifd OPT_GWVA_DEBUG_ERROR
	GWVA_PROGRAMMER_ERROR	GWVA_ASCII_ERROR_METHOD_UNKNOW_COMMAND
	endc	; ifd OPT_GWVA_DEBUG_ERROR
	bra.s .fin_liste

.pas_commande:
	cmp.l GWVA_OBJ_METHODLIST_ITEM_METHOD(a4),d4
	beq.s .methode_trouvee
	lea GWVA_OBJ_METHODLIST_STRUCT_LENGTH(a4),a4
	bra.s .search_method_in_list
.methode_trouvee:
	rts
.fin_liste:	lea 0.w,a4
	rts

			*---------------

return_class_method_list:	; in : d7.w ; out : a4.l (0.l si pas trouv)
	lea GWVA_ROOT_DEFAULT_METHODLIST_LIST,a4

.find_class_def_meth_list:
	cmp.w #GWVA_OBJ_CTE_END_CLASS_LIST,GWVA_OBJ_CLASSLIST_ITEM_CLASS(a4)
	beq.s .fin_liste_pas_trouve
	cmp.w GWVA_OBJ_CLASSLIST_ITEM_CLASS(a4),d7
	beq.s .found
	lea GWVA_OBJ_CLASSLIST_ITEM_STRUCT_LENGTH(a4),a4
	bra.s .find_class_def_meth_list
.fin_liste_pas_trouve:
	move.l GWVA_OBJ_CLASSLIST_ITEM_DEFAULTMETHOD_PTR(a4),a4
	cmp.l #GWVA_OBJ_CTE_END_LINK_CLASS_LIST,a4
	beq.s .pas_continue_ailleurs
	bra.s .find_class_def_meth_list
.pas_continue_ailleurs:
	rts
.found:	move.l GWVA_OBJ_CLASSLIST_ITEM_DEFAULTMETHOD_PTR(a4),a4
	rts

			*---------------

store_search_exec_information:
	move.l GWVA_SEARCH_EXEC_OBJECT_LEVEL_STACK_PTR,a5
	sub.l #GWVA_SEARCH_EXEC_STACK_STRUCT_LENGTH,a5
	move.l a0,GWVA_SEARCH_EXEC_STACK_OBJECT(a5)
	move.l d4,GWVA_SEARCH_EXEC_STACK_METHOD(a5)
	move.w d7,GWVA_SEARCH_EXEC_STACK_CLASS(a5)
	; pour le cas d'un call inherited depuis une methode surcharge
	; en local : repartir de la classe courante dans le default
	; et non pas de la classe-1
	move.w d6,GWVA_SEARCH_EXEC_STACK_IS_IN_LOCAL_METHOD_LIST(a5)

	move.l a5,GWVA_SEARCH_EXEC_OBJECT_LEVEL_STACK_PTR
	rts

	;---------------------------------------------;

partie_commune_search_method:

; La mthode ne doit maintenant tre ni un BEFORE, ni un AFTER

	ifd OPT_GWVA_DEBUG_ERROR
	move.l d4,d6
	and.l #GWVA_METHOD_MASK_EVENT|GWVA_METHOD_MASK_BEFORE|GWVA_METHOD_MASK_AFTER,d6
	beq.s .methode_pas_evenementielle
	GWVA_PROGRAMMER_ERROR	GWVA_ASCII_ERROR_BEFORE_AFTER
	bra .pas_trouve_nulle_part
.methode_pas_evenementielle:
	endc	; OPT_GWVA_DEBUG_ERROR

.scan_in_herited_class:
	bsr return_class_method_list	; in : d7.w ; out : a4.l (0.l si pas trouv)

	ifd OPT_GWVA_DEBUG_ERROR
	cmp.l #GWVA_OBJ_CTE_END_LINK_CLASS_LIST,a4
	bne.s .trouve_default_liste
	GWVA_PROGRAMMER_ERROR	GWVA_ASCII_ERROR_NO_DEFAULT_LIST
	move.w #GWVA_SEARCH_EXEC_NOT_FOUND,d6
	bra fin_partie_commune_search_method
.trouve_default_liste:
	endc	; OPT_GWVA_DEBUG_ERROR

	bsr find_method_in_method_list	; in : a4.l=liste+d4.l=methode ; out : a4.l=ptr struct trouvee (0.l si pas trouv)

	ifnd MDL_TOS

	cmp.l #0,a4
	bne.s .trouve_methode

	bsr return_herited_class	; in : d7.w ; out : d7.w

	cmp.w #GWVA_OBJ_CTE_CLASS_UNDEF,d7
	beq.s .pas_trouve_nulle_part

	bra.s .scan_in_herited_class

.trouve_methode:

	endc	; ifnd MDL_TOS

	clr.w d6			; pas dans la liste locale
	bsr store_search_exec_information	; in : d6+d7+a0+d4

			;---------

	ifd OPT_GWVA_DEBUG_SEARCH_EXEC_IN_ALERT_BOX
	bsr gwva_show_debug_alert_box
	endc	; OPT_GWVA_DEBUG_SEARCH_EXEC_IN_ALERT_BOX

	ifd OPT_GWVA_DEBUG_SEARCH_EXEC_IN_LOGGER
	bsr gwva_show_debug_send_logger_in
	endc	; ifd OPT_GWVA_DEBUG_SEARCH_EXEC_IN_LOGGER

			;---------

	bsr gwva_exec_method	; out -> d6.w+d7 positionns par la mthode

	add.l #GWVA_SEARCH_EXEC_STACK_STRUCT_LENGTH,GWVA_SEARCH_EXEC_OBJECT_LEVEL_STACK_PTR

			;---------

*	ifd OPT_GWVA_DEBUG_SEARCH_EXEC_IN_ALERT_BOX
*	bsr gwva_show_debug_alert_box
*	endc	; OPT_GWVA_DEBUG_SEARCH_EXEC_IN_ALERT_BOX

	ifd OPT_GWVA_DEBUG_SEARCH_EXEC_IN_LOGGER
	bsr gwva_show_debug_send_logger_out
	endc	; ifd OPT_GWVA_DEBUG_SEARCH_EXEC_IN_LOGGER

			;---------

	bra.s fin_partie_commune_search_method

.pas_trouve_nulle_part:
	move.l #GWVA_SEARCH_EXEC_NOT_FOUND,d6	; par dfaut on ne la trouve pas

fin_partie_commune_search_method:
	rts

*////////////////////////////////////////////\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*

	ifd OPT_GWVA_DEBUG_SEARCH_EXEC

	ifd OPT_GWVA_DEBUG_SEARCH_EXEC_IN_ALERT_BOX

gwva_show_debug_alert_box:
	save.l d0-a6

	bsr gwva_test_debug_filter	; out=>d5 =ERROR/NO_ERROR
	cmp.w #GWVA_NO_ERROR_GENERIC,d5
	bne .pas_d_edition

	movem.l (sp),d0-a6		; pour rcuprer d5

	lea GWVA_ROOT_ALERT_METHOD_DISTRI_OBJ,a6	; Obj=1234
	move.l GWVA_OBJ_NAME(a0),(a6)
	moveq #4-1,d3
.test_4_chars:
	tst.b (a6)+
	bne.s .test_next
	move.b #'0',-1(a6)	; ne pas mettre de 0.b : coupe l'affichage
.test_next:	dbf d3,.test_4_chars

	move.l #'AFT-',GWVA_ROOT_ALERT_METHOD_DISTRI_AFTB	; AFT-
	btst #GWVA_METHOD_BIT_AFTER,d4
	bne.s .this_was_after
	move.l #'BEF-',GWVA_ROOT_ALERT_METHOD_DISTRI_AFTB
	btst #GWVA_METHOD_BIT_BEFORE,d4
	bne.s .this_was_before
	move.l #'   -',GWVA_ROOT_ALERT_METHOD_DISTRI_AFTB
.this_was_after:
.this_was_before:

	save.l d0-a6			; Meth=$12345678
	move.l d4,d0
	lea GWVA_ROOT_ALERT_METHOD_DISTRI_NR,a1
	bsr fill_8char_field_with_hexa
	load.l d0-a6

	lea GWVA_ROOT_ALERT_METHOD_DISTRI_NAME,a6	; nom mthode
	move.l #'    ',(a6)
	move.l #'    ',4(a6)
	move.l #'    ',8(a6)
	move.l #'    ',12(a6)

	moveq #16-1,d7
	bsr fill_method_name

	save.l d0-a6
	lea GWVA_ROOT_ALERT_METHOD_DISTRI_MODE,a1	; Mode
	move.l d5,d0
	and.l #$ffff,d0
	bsr GWVA_STOCK_DECI
	move.b #' ',-1(a1)
	load.l d0-a6

	save.l d0-a6
	lea GWVA_ROOT_ALERT_METHOD_DISTRI_CLASS,a1	; Class
	move.l GWVA_SEARCH_EXEC_OBJECT_LEVEL_STACK_PTR,a5
	move.w GWVA_SEARCH_EXEC_STACK_CLASS(a5),d0
	and.l #$00ff,d0			; <=99 !!
	bsr GWVA_STOCK_DECI
	move.b #' ',-1(a1)
	load.l d0-a6

	save.l d0-a6			; a0
	move.l a0,d0
	lea GWVA_ROOT_ALERT_METHOD_DISTRI_A0,a1
	bsr fill_8char_field_with_hexa
	load.l d0-a6

	save.l d0-a6			; d0
	lea GWVA_ROOT_ALERT_METHOD_DISTRI_D0,a1
	bsr fill_8char_field_with_hexa
	load.l d0-a6

	save.l d0-a6			; d1
	move.l d1,d0
	lea GWVA_ROOT_ALERT_METHOD_DISTRI_D1,a1
	bsr fill_8char_field_with_hexa
	load.l d0-a6

	save.l d0-a6			; d2
	move.l d2,d0
	lea GWVA_ROOT_ALERT_METHOD_DISTRI_D2,a1
	bsr fill_8char_field_with_hexa
	load.l d0-a6

	lea GWVA_ROOT_ALERT_METHOD_DISTRI,a0
	moveq #1,d0
	bsr GWVA_ROOT_PRG_ALERT_BOX

.pas_d_edition:
	load.l d0-a6
	rts

	endc	; ifd OPT_GWVA_DEBUG_SEARCH_EXEC_IN_ALERT_BOX

	;-----------------

	ifd OPT_GWVA_DEBUG_SEARCH_EXEC_IN_LOGGER

gwva_show_debug_send_logger_entete_commune_in_out:
	move.l GWVA_DEBUG_SEARCH_EXEC_TEXT_PTR,a6
	cmp.l #0,a6
	bne.s .pas_premiere_fois
	lea GWVA_DEBUG_SEARCH_EXEC_IN_LOGGER_TMP_MSG_BUF,a6
.pas_premiere_fois:
	lea GWVA_DEBUG_MSG_MAX_SIZE(a6),a6
	cmp.l #GWVA_DEBUG_SEARCH_EXEC_IN_LOGGER_TMP_MSG_BUF+GWVA_DEBUG_MSG_MAX_SIZE*GWVA_DEBUG_MAX_MSG_DEBUG_PENDING,a6
	blt.s .end_not_reached
	lea GWVA_DEBUG_SEARCH_EXEC_IN_LOGGER_TMP_MSG_BUF,a6
.end_not_reached:
	move.l a6,GWVA_DEBUG_SEARCH_EXEC_TEXT_PTR


	move.l GWVA_ROOT_PTR_WAPP,a5		; le nom de mon appli
	move.l ([GWVA_WAPP_OBJ_REG_NAME,a5]),(a6)+
	move.l ([GWVA_WAPP_OBJ_REG_NAME,a5],4),(a6)+
	move.b #' ',(a6)+

	move.w GWVA_DEBUG_STACK_LEVEL_COUNTER,d3
	subq #1,d3		; qd on est ici on a toujours au moins 1
	bmi.s .erreur_niveau_pile
	mulu #2,d3
	beq.s .nul
.put_spaces:move.b #' ',(a6)+
	dbf d3,.put_spaces
.nul:
.erreur_niveau_pile:
	rts

		;-----------------

gwva_show_debug_send_logger_fin_commune_in_out:
	move.b #rc,(a6)+
	move.b #lf,(a6)+
	clr.b (a6)+

	ifeq 1
	; au moins 69+62=131 de long
	lea GWVA_ROOT_TMP_MSG_OUT_BUF,a0
	move.w #GWVA_MSG_LOG,bmsg_msgid(a0)
	sub.l a0,a6
	move.l a6,d0

	lea GWVA_DEBUG_CTE_LOGGER_REGNAME,a1
	moveq #GWVA_MODE_SEND_GEM_MESSAGE_APNAME,d1

	moveq #1,d5
.retry_sending_message:
	save.l d0/d1/d5/a0/a1
	bsr GWVA_ROOT_SEND_GEM_MESSAGE
	load.l d0/d1/d5/a0/a1
	cmp.w #GWVA_ERROR_ROOT_APPL_WRITE_FAILED,d7
	bne.s .cannot_do_anything
	cmp.w #32,d5
	beq.s .too_many_retries
	addq #1,d5
	save.l d0/d1/d5/a0/a1
	evnt_timer #1
	load.l d0/d1/d5/a0/a1
	bra.s .retry_sending_message

.too_many_retries:
.cannot_do_anything:

	endc	; ifeq 1

	move.l GWVA_DEBUG_SEARCH_EXEC_TEXT_PTR,a0
	bsr GWVA_DEBUG_PRG_SEND_LOGGER_MESSAGE

	load.l d0-a6
	rts

		;-----------------

gwva_show_debug_send_logger_out:
	save.l d0-a6

	bsr gwva_test_debug_filter	; out=>d5 =ERROR/NO_ERROR
	cmp.w #GWVA_NO_ERROR_GENERIC,d5
	bne .pas_d_edition

	movem.l (sp),d0-a6		; pour rcuprer d5

	bsr gwva_show_debug_send_logger_entete_commune_in_out

	lea GWVA_ROOT_DEBUG_LOGGER_D6,a5
	bsr copy_string_0_a5_a6

	save.l d0-a6			; d6
	move.l d6,d0
	move.l a6,a1
	bsr fill_8char_field_with_hexa
	load.l d0-a6
	lea 8(a6),a6

	lea GWVA_ROOT_DEBUG_LOGGER_D7,a5
	bsr copy_string_0_a5_a6

	save.l d0-a6			; d7
	move.l d7,d0
	move.l a6,a1
	bsr fill_8char_field_with_hexa
	load.l d0-a6
	lea 8(a6),a6

	bra gwva_show_debug_send_logger_fin_commune_in_out

.pas_d_edition:
	load.l d0-a6
	rts

		;-----------------

gwva_show_debug_send_logger_in:
	save.l d0-a6

	bsr gwva_test_debug_filter	; out=>d5 =ERROR/NO_ERROR
	cmp.w #GWVA_NO_ERROR_GENERIC,d5
	bne .pas_d_edition

	movem.l (sp),d0-a6		; pour rcuprer d5

	bsr gwva_show_debug_send_logger_entete_commune_in_out

	lea GWVA_ROOT_DEBUG_LOGGER_OBJ,a5
	bsr copy_string_0_a5_a6

	move.l GWVA_OBJ_NAME(a0),(a6)		; obj sur 4 chars
	moveq #4-1,d3
.test_4_chars:
	tst.b (a6)+
	bne.s .test_next
	move.b #'0',-1(a6)	; ne pas mettre de 0.b : coupe l'affichage
.test_next:	dbf d3,.test_4_chars

	lea GWVA_ROOT_DEBUG_LOGGER_FILL1,a5
	bsr copy_string_0_a5_a6

	move.l #'AFT/',(a6)			; AFT/
	btst #GWVA_METHOD_BIT_AFTER,d4
	bne.s .this_was_after
	move.l #'BEF/',(a6)
	btst #GWVA_METHOD_BIT_BEFORE,d4
	beq.s .ni_before_ni_after
.this_was_after:
	lea 4(a6),a6
.ni_before_ni_after:

	moveq #64,d7			; method name
	bsr fill_method_name

	lea GWVA_ROOT_DEBUG_LOGGER_FILL2,a5
	bsr copy_string_0_a5_a6

	save.l d0-a6			; Meth=$12345678
	move.l d4,d0
	move.l a6,a1
	bsr fill_8char_field_with_hexa
	load.l d0-a6
	lea 8(a6),a6

	lea GWVA_ROOT_DEBUG_LOGGER_CLASS,a5
	bsr copy_string_0_a5_a6

	save.l d0-a5
	move.l a6,a1			; Class
	move.l GWVA_SEARCH_EXEC_OBJECT_LEVEL_STACK_PTR,a5
	move.w GWVA_SEARCH_EXEC_STACK_CLASS(a5),d0
	and.l #$00ff,d0
	bsr GWVA_STOCK_DECI
	lea -1(a1),a6
	load.l d0-a5

	lea GWVA_ROOT_DEBUG_LOGGER_MODE,a5
	bsr copy_string_0_a5_a6

	save.l d0-a5
	move.l a6,a1			; Mode
	move.l d5,d0
	and.l #$ffff,d0
	bsr GWVA_STOCK_DECI
	lea -1(a1),a6
	load.l d0-a5

	lea GWVA_ROOT_DEBUG_LOGGER_REGS_DUMPA0,a5
	bsr copy_string_0_a5_a6

	save.l d0-a6			; a0
	move.l a0,d0
	move.l a6,a1
	bsr fill_8char_field_with_hexa
	load.l d0-a6
	lea 8(a6),a6

	lea GWVA_ROOT_DEBUG_LOGGER_D0,a5
	bsr copy_string_0_a5_a6

	save.l d0-a6			; d0
	move.l a6,a1
	bsr fill_8char_field_with_hexa
	load.l d0-a6
	lea 8(a6),a6

	lea GWVA_ROOT_DEBUG_LOGGER_D1,a5
	bsr copy_string_0_a5_a6

	save.l d0-a6			; d1
	move.l d1,d0
	move.l a6,a1
	bsr fill_8char_field_with_hexa
	load.l d0-a6
	lea 8(a6),a6

	lea GWVA_ROOT_DEBUG_LOGGER_D2,a5
	bsr copy_string_0_a5_a6

	save.l d0-a6			; d2
	move.l d2,d0
	move.l a6,a1
	bsr fill_8char_field_with_hexa
	load.l d0-a6
	lea 8(a6),a6

	bra gwva_show_debug_send_logger_fin_commune_in_out

.pas_d_edition:
	load.l d0-a6
	rts

	;-----------------

GWVA_DEBUG_PRG_SEND_LOGGER_MESSAGE:		; in : a0=ptr on string to log. Rq: scratches registers
				; out : nothing
	move.l a0,a1

*	move.w #$1234,GWVA_DEBUG_SEARCH_EXEC_IN_LOGGER_LOG_ACK

	lea GWVA_ROOT_TMP_MSG_OUT_BUF,a0
	move.w #GWVA_MSG_LOG,bmsg_msgid(a0)
	move.l a1,bmsg_debug_string_ptr(a0)	; ptr sur le texte
*	move.l #GWVA_DEBUG_SEARCH_EXEC_IN_LOGGER_TMP_MSG_BUF,bmsg_debug_string_ptr(a0)
	move.w #'11',bmsg_debug_format(a0)
*	move.l #GWVA_DEBUG_SEARCH_EXEC_IN_LOGGER_LOG_ACK,bmsg_debug_ack_word_ptr(a0)

	moveq #16,d0
	lea GWVA_DEBUG_CTE_LOGGER_REGNAME,a1
	moveq #GWVA_MODE_SEND_GEM_MESSAGE_APNAME,d1

	bsr GWVA_ROOT_SEND_GEM_MESSAGE
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne.s .do_not_wait_for_ack

*	; Remarque: on peut attendre  l'infini si le logger ne rpond pas !
*.wait_loop:	tst GWVA_DEBUG_SEARCH_EXEC_IN_LOGGER_LOG_ACK
*	beq.s .ack_received

	evnt_timer #1
	evnt_timer #1
*	bra.s .wait_loop
*.ack_received:

.do_not_wait_for_ack:
	rts

	;-----------------

copy_string_0_a5_a6:
	COPY_STRING_0 a5,a6
	lea -1(a6),a6
	rts

	endc	; ifd OPT_GWVA_DEBUG_SEARCH_EXEC_IN_LOGGER

	;-----------------

fill_8char_field_with_hexa:
	move.w 7(a1),-(sp)
	moveq #32,d1
	save.l a1
	bsr GWVA_STOCK_HEXA
	load.l a1
	load.w d0
	move.b d0,8(a1)
	rts

	;-----------------

fill_method_name:		; entre : a6=dest+d7=longeur maxi  copier
	save.l d4
	bclr #GWVA_METHOD_BIT_AFTER,d4		; on perd d4
	bclr #GWVA_METHOD_BIT_BEFORE,d4
	lea GWVA_DEBUG_EVNT_TABLE,a5
.search_method:
	cmp.l #-1,(a5)
	beq.s .fin_pas_trouve
	cmp.l (a5),d4
	beq.s .trouve
	lea 4+4(a5),a5
	bra.s .search_method
.trouve:	move.l 4(a5),a5

.seulement_16:
	move.b (a5)+,d3
	beq.s .fin_recopie
	move.b d3,(a6)+
	dbf d7,.seulement_16
.fin_recopie:
.fin_pas_trouve:
	load.l d4
	rts

	;-----------------

gwva_test_debug_filter:		; out=>d5 =ERROR/NO_ERROR

	save.l d0-d4/d6-a6
	move.w  #-1,-(sp)	; Shift_Droit:1, SG:2 CTRL:4 ALT:8
	appel bios,kbshift,4	; tat des touches spciales
	and.w #%1010,d0
	move d0,d5
	load.l d0-d4/d6-a6
	cmp.w #%1010,d5
	bne.s .pas_annule_shift_shift

	moveq #GWVA_ERROR_GENERIC,d5
	rts

.pas_annule_shift_shift:

		;-----------

	ifd OPT_GWVA_DEBUG_FILTER_0NAMES

	tst.l GWVA_OBJ_NAME(a0)
	bne.s .pas_filtre_objet_nom0

	moveq #GWVA_ERROR_GENERIC,d5
	rts
.pas_filtre_objet_nom0:

	endc	; ifd OPT_GWVA_DEBUG_FILTER_0NAMES

		;-----------

	ifnd OPT_GWVA_DEBUG_FILTER

	moveq #GWVA_NO_ERROR_GENERIC,d5
	rts

	else

		;-----------

	moveq #GWVA_ERROR_GENERIC,d5
	lea OPT_GWVA_DEBUG_FILTER_PTR,a5

.cherche:	tst.l (a5)
	beq.s .fin_pas_trouve
	cmp.l (a0)+,(a5)+
	beq.s .on_veut_debugger_celui_la
	lea -4(a0),a0	; ah les modes d'adressage de 68030 sont limits alors on ruse
	bra.s .cherche
.on_veut_debugger_celui_la:
	lea -4(a0),a0	; ah les modes d'adressage de 68030 sont limits alors on ruse
	moveq #GWVA_NO_ERROR_GENERIC,d5
.fin_pas_trouve:
	rts

	endc	; ifnd OPT_GWVA_DEBUG_FILTER

	;-----------------

	ifd OPT_GWVA_DEBUG_SEARCH_EXEC_IN_ALERT_BOX

 DATA
			; 'V.A. Kernel Method distribution'
			; 'Obj="1234",AFT-1234567890123456'
			; 'Meth=$12345678 Mode=12 Class=12'
			; 'Regs: a0=$12345678 d0=$12345678'
			; 'Dump: d1=$12345678 d2=$12345678'

	dc.b 0	; pour vider l'odd add sur un move.l sur ad impaire
GWVA_ROOT_ALERT_METHOD_DISTRI:	dc.b '[3]'
			dc.b '[V.A. Kernel Method distribution'
			dc.b '|Obj="'
GWVA_ROOT_ALERT_METHOD_DISTRI_OBJ:	dc.b '1234'
			dc.b '",'
GWVA_ROOT_ALERT_METHOD_DISTRI_AFTB:	dc.b 'AFT-'
GWVA_ROOT_ALERT_METHOD_DISTRI_NAME:	dc.b '1234567890123456'
			dc.b '|Meth=$'
GWVA_ROOT_ALERT_METHOD_DISTRI_NR:	dc.b '12345678'
			dc.b ' Mode='
GWVA_ROOT_ALERT_METHOD_DISTRI_MODE:	dc.b '12'
			dc.b ' Class='
GWVA_ROOT_ALERT_METHOD_DISTRI_CLASS:dc.b '12'
			dc.b '|Regs: a0=$'
GWVA_ROOT_ALERT_METHOD_DISTRI_A0:	dc.b '12345678'
			dc.b ' d0=$'
GWVA_ROOT_ALERT_METHOD_DISTRI_D0:	dc.b '12345678'
			dc.b '|Dump: d1=$'
GWVA_ROOT_ALERT_METHOD_DISTRI_D1:	dc.b '12345678'
			dc.b ' d2=$'
GWVA_ROOT_ALERT_METHOD_DISTRI_D2:	dc.b '12345678'
			dc.b '][Thanx]'
			dc.b 0
 even
 TEXT
	endc	; ifd OPT_GWVA_DEBUG_SEARCH_EXEC_IN_ALERT_BOX

	;-----------------

	ifd OPT_GWVA_DEBUG_SEARCH_EXEC_IN_LOGGER

 DATA
; 69 'APP_NAME [tabs]Obj="1234" AFT/the method name(<=21)/$12345678 Mode=12'
; 62 'Regs Dump: a0=$12345678 d0=$12345678 d1=$12345678 d2=$12345678'
GWVA_ROOT_DEBUG_LOGGER_OBJ:	dc.b 'Obj="',0
GWVA_ROOT_DEBUG_LOGGER_FILL1:	dc.b '" ',0
GWVA_ROOT_DEBUG_LOGGER_FILL2:	dc.b '/$',0
GWVA_ROOT_DEBUG_LOGGER_CLASS:	dc.b ' Class=',0
GWVA_ROOT_DEBUG_LOGGER_MODE:	dc.b ' Mode=',0
GWVA_ROOT_DEBUG_LOGGER_REGS_DUMPA0:	dc.b ' Regs Dump: a0=$',0
GWVA_ROOT_DEBUG_LOGGER_D0:	dc.b ' d0=$',0
GWVA_ROOT_DEBUG_LOGGER_D1:	dc.b ' d1=$',0
GWVA_ROOT_DEBUG_LOGGER_D2:	dc.b ' d2=$',0

GWVA_ROOT_DEBUG_LOGGER_D6:	dc.b '-> d6=$',0
GWVA_ROOT_DEBUG_LOGGER_D7:	dc.b ' d7=$',0

GWVA_DEBUG_CTE_LOGGER_REGNAME:	dc.b 'VALOGGER',0
 even

	endc	; ifd OPT_GWVA_DEBUG_SEARCH_EXEC_IN_LOGGER

	;-----------------

 DATA

GWVA_DEBUG_EVNT_TABLE:
	dc.l GWVA_METHOD_CREATE
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_CREATE
	dc.l GWVA_METHOD_DELETE
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_DELETE
	dc.l GWVA_METHOD_OPEN
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_OPEN
	dc.l GWVA_METHOD_CLOSE
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_CLOSE

	dc.l GWVA_METHOD_MOUSE_ZONE
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_MOUSE_ZONE
	dc.l GWVA_METHOD_TIMER
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_TIMER
	dc.l GWVA_METHOD_CLICK
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_CLICK
	dc.l GWVA_METHOD_MESSAGE
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_MESSAGE
	dc.l GWVA_METHOD_KEYPRESS
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_KEYPRESS

	dc.l GWVA_METHOD_REGISTER_TIMER
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_REGISTER_TIMER
	dc.l GWVA_METHOD_UNREGISTER_TIMER
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_UNREGISTER_TIMER
	dc.l GWVA_METHOD_REGISTER_MOUSE_ZONE
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_REGISTER_MOUSE_ZONE
	dc.l GWVA_METHOD_UNREGISTER_MOUSE_ZONE
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_UNREGISTER_MOUSE_ZONE
	dc.l GWVA_METHOD_REGISTER_BUTTON
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_REGISTER_BUTTON
	dc.l GWVA_METHOD_UNREGISTER_BUTTON
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_UNREGISTER_BUTTON

	dc.l GWVA_METHOD_WIND_CLICK
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_WIND_CLICK
	dc.l GWVA_METHOD_WIND_CREATE_CONTENTS
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_WIND_CREATE_CONTENTS
	dc.l GWVA_METHOD_WIND_DELETE_CONTENTS
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_WIND_DELETE_CONTENTS
	dc.l GWVA_METHOD_WIND_REDRAW_CONTENTS_BOX
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_WIND_REDRAW_CONTENTS_BOX
	dc.l GWVA_METHOD_WIND_SET_VSLIDER
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_WIND_SET_VSLIDER
	dc.l GWVA_METHOD_WIND_SET_HSLIDER
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_WIND_SET_HSLIDER
	dc.l GWVA_METHOD_WIND_CALC_SLIDERS
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_WIND_CALC_SLIDERS
	dc.l GWVA_METHOD_WIND_NAMIFY_UNAMIFY
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_WIND_NAMIFY_UNAMIFY
	dc.l GWVA_METHOD_WIND_REDRAW_ALL_CONTENTS
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_WIND_REDRAW_ALL_CONTENTS
	dc.l GWVA_METHOD_WIND_REDRAW_PART_CONTENTS
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_WIND_REDRAW_PART_CONTENTS
	dc.l GWVA_METHOD_WIND_SET_PALETTE
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_WIND_SET_PALETTE
	dc.l GWVA_METHOD_WIND_MOVE_SLIDERS_WITH_KEY
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_WIND_MOVE_SLIDERS_WITH_KEY

	dc.l GWVA_METHOD_WRSC_REDRAW_PART_CONTENTS
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_WRSC_REDRAW_PART_CONTENTS
	dc.l GWVA_METHOD_WRSC_UPDATE
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_WRSC_UPDATE
	dc.l GWVA_METHOD_WRSC_IDX_UNDER_XY
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_WRSC_IDX_UNDER_XY

	dc.l GWVA_METHOD_FORM_KEYBD
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_FORM_KEYBD
	dc.l GWVA_METHOD_WFORM_CLEAR_FOCUS
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_WFORM_CLEAR_FOCUS
	dc.l GWVA_METHOD_WFORM_SET_FOCUS
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_WFORM_SET_FOCUS
	dc.l GWVA_METHOD_WFORM_HIDE_FOCUS
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_WFORM_HIDE_FOCUS
	dc.l GWVA_METHOD_WFORM_SHOW_FOCUS
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_WFORM_SHOW_FOCUS

	dc.l GWVA_METHOD_WAPP_LOAD_RSC
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_WAPP_LOAD_RSC
	dc.l GWVA_METHOD_WAPP_UNLOAD_RSC
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_WAPP_UNLOAD_RSC
	dc.l GWVA_METHOD_WAPP_SET_RIGHT_PALETTE
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_WAPP_SET_RIGHT_PALETTE

	dc.l GWVA_METHOD_MENU_SELECT
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_MENU_SELECT
	dc.l GWVA_METHOD_MENU_CLICK
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_MENU_CLICK
	dc.l GWVA_METHOD_MENU_UPDATE
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_MENU_UPDATE
	dc.l GWVA_METHOD_MENU_MZONE_TITLE
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_MENU_MZONE_TITLE
	dc.l GWVA_METHOD_MENU_CHECK
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_MENU_CHECK
	dc.l GWVA_METHOD_MENU_REDRAW_ALL_CONTENTS
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_MENU_REDRAW_ALL_CONTENTS
	dc.l GWVA_METHOD_MENU_ITEM_SELECTED
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_MENU_ITEM_SELECTED

	dc.l GWVA_METHOD_WTEXT_WRITE_IN_BUFFER
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_WTEXT_WRITE_IN_BUFFER
	dc.l GWVA_METHOD_WTEXT_WRITE_IN_WINDOW
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_WTEXT_WRITE_IN_WINDOW
	dc.l GWVA_METHOD_WTEXT_WRITE_BUFFER
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_WTEXT_WRITE_BUFFER
	dc.l GWVA_METHOD_WTEXT_CLEAR_BUFFER
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_WTEXT_CLEAR_BUFFER
	dc.l GWVA_METHOD_WTEXT_CLEAR_BUFFER_AND_UPDATE
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_WTEXT_CLEAR_BUFFER_AND_UPDATE
	dc.l GWVA_METHOD_WTEXT_CORRECT_VISIBLE_SIZES
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_WTEXT_CORRECT_VISIBLE_SIZES

	dc.l GWVA_METHOD_FORM_KEYPRESS
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_FORM_KEYPRESS
	dc.l GWVA_METHOD_FORM_CLICK
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_FORM_CLICK
	dc.l GWVA_METHOD_FORM_BUTTON
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_FORM_BUTTON
	dc.l GWVA_METHOD_FORM_OBJC_EDIT
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_FORM_OBJC_EDIT
	dc.l GWVA_METHOD_FORM_IFACE_CLICK
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_FORM_IFACE_CLICK

	dc.l GWVA_METHOD_FORM_CLICKED
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_FORM_CLICKED
	dc.l GWVA_METHOD_FORM_DCLICKED
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_FORM_DCLICKED
	dc.l GWVA_METHOD_FORM_RCLICKED
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_FORM_RCLICKED
	dc.l GWVA_METHOD_FORM_SELECTED
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_FORM_SELECTED
	dc.l GWVA_METHOD_FORM_UNSELECTED
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_FORM_UNSELECTED
	dc.l GWVA_METHOD_FORM_CHANGED
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_FORM_CHANGED

	dc.l GWVA_METHOD_FORM_RELEASE_FOCUS
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_FORM_RELEASE_FOCUS
	dc.l GWVA_METHOD_FORM_CATCH_FOCUS
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_FORM_CATCH_FOCUS
	dc.l GWVA_METHOD_FPROGRESS_BAR_SET_PERCENT
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_FPROGRESS_BAR_SET_PERCENT
	dc.l GWVA_METHOD_FPROGRESS_BAR_UPDATE_PERCENT
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_FPROGRESS_BAR_UPDATE_PERCENT
	dc.l GWVA_METHOD_FPROGRESS_BAR_REDRAW
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_FPROGRESS_BAR_REDRAW

	dc.l GWVA_METHOD_FSLIDER_MOVE
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_FSLIDER_MOVE
	dc.l GWVA_METHOD_FSLIDER_PLUS1
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_FSLIDER_PLUS1
	dc.l GWVA_METHOD_FSLIDER_MINUS1
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_FSLIDER_MINUS1
	dc.l GWVA_METHOD_FSLIDER_PLUSPAGE
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_FSLIDER_PLUSPAGE
	dc.l GWVA_METHOD_FSLIDER_MINUSPAGE
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_FSLIDER_MINUSPAGE
	dc.l GWVA_METHOD_FSLIDER_SET_POSITION
	dc.l GWVA_DEBUG_EVNT_GWVA_METHOD_FSLIDER_SET_POSITION

	dc.l MN_SELECTED
	dc.l GWVA_DEBUG_EVNT_MN_SELECTED

	dc.l GWVA_METHOD_WM_REDRAW
	dc.l GWVA_DEBUG_EVNT_WM_REDRAW
	dc.l GWVA_METHOD_WM_TOP
	dc.l GWVA_DEBUG_EVNT_WM_TOP
	dc.l GWVA_METHOD_WM_CLOSE
	dc.l GWVA_DEBUG_EVNT_WM_CLOSE
	dc.l GWVA_METHOD_WM_FULL
	dc.l GWVA_DEBUG_EVNT_WM_FULL
	dc.l GWVA_METHOD_WM_ARROW
	dc.l GWVA_DEBUG_EVNT_WM_ARROW
	dc.l GWVA_METHOD_WM_HSLID
	dc.l GWVA_DEBUG_EVNT_WM_HSLID
	dc.l GWVA_METHOD_WM_VSLID
	dc.l GWVA_DEBUG_EVNT_WM_VSLID
	dc.l GWVA_METHOD_WM_SIZE
	dc.l GWVA_DEBUG_EVNT_WM_SIZE
	dc.l GWVA_METHOD_WM_MOVE
	dc.l GWVA_DEBUG_EVNT_WM_MOVE
	dc.l GWVA_METHOD_WM_NEWTOP
	dc.l GWVA_DEBUG_EVNT_WM_NEWTOP
	dc.l GWVA_METHOD_WM_UNTOP
	dc.l GWVA_DEBUG_EVNT_WM_UNTOP
	dc.l GWVA_METHOD_WM_ONTOP
	dc.l GWVA_DEBUG_EVNT_WM_ONTOP
	dc.l GWVA_METHOD_WM_BOTTOM
	dc.l GWVA_DEBUG_EVNT_WM_BOTTOM
	dc.l GWVA_METHOD_WM_ICONIFY
	dc.l GWVA_DEBUG_EVNT_WM_ICONIFY
	dc.l GWVA_METHOD_WM_UNICONIFY
	dc.l GWVA_DEBUG_EVNT_WM_UNICONIFY
*	dc.l GWVA_METHOD_WM_ALLICONIFY
*	dc.l GWVA_DEBUG_EVNT_WM_ALLICONIFY
*	dc.l GWVA_METHOD_WM_TOOLBAR
*	dc.l GWVA_DEBUG_EVNT_WM_TOOLBAR

	dc.l AC_OPEN
	dc.l GWVA_DEBUG_EVNT_AC_OPEN
	dc.l AC_CLOSE
	dc.l GWVA_DEBUG_EVNT_AC_CLOSE
	dc.l AP_TERM
	dc.l GWVA_DEBUG_EVNT_AP_TERM
	dc.l AP_TFAIL
	dc.l GWVA_DEBUG_EVNT_AP_TFAIL
	dc.l AP_RESCHG
	dc.l GWVA_DEBUG_EVNT_AP_RESCHG
	dc.l SHUT_COMPLETED
	dc.l GWVA_DEBUG_EVNT_SHUT_COMPLETED
	dc.l RESCH_COMPLETED
	dc.l GWVA_DEBUG_EVNT_RESCH_COMPLETED
	dc.l AP_DRAGDROP
	dc.l GWVA_DEBUG_EVNT_AP_DRAGDROP
	dc.l SH_WDRAW
	dc.l GWVA_DEBUG_EVNT_SH_WDRAW
	dc.l CH_EXIT
	dc.l GWVA_DEBUG_EVNT_CH_EXIT

	dc.l -1

GWVA_DEBUG_EVNT_GWVA_METHOD_CREATE:			dc.b "CREATE",0
GWVA_DEBUG_EVNT_GWVA_METHOD_DELETE:			dc.b "DELETE",0
GWVA_DEBUG_EVNT_GWVA_METHOD_MOUSE_ZONE:		dc.b "MOUSE_ZONE",0
GWVA_DEBUG_EVNT_GWVA_METHOD_TIMER:			dc.b "TIMER",0
GWVA_DEBUG_EVNT_GWVA_METHOD_CLICK:			dc.b "CLICK",0
GWVA_DEBUG_EVNT_GWVA_METHOD_MESSAGE:		dc.b "MESSAGE",0
GWVA_DEBUG_EVNT_GWVA_METHOD_OPEN:			dc.b "OPEN",0
GWVA_DEBUG_EVNT_GWVA_METHOD_CLOSE:			dc.b "CLOSE",0
GWVA_DEBUG_EVNT_GWVA_METHOD_KEYPRESS:		dc.b "KEYPRESS",0

GWVA_DEBUG_EVNT_GWVA_METHOD_REGISTER_TIMER:		dc.b "REGISTER_TIMER",0
GWVA_DEBUG_EVNT_GWVA_METHOD_UNREGISTER_TIMER:		dc.b "UNREGISTER_TIMER",0
GWVA_DEBUG_EVNT_GWVA_METHOD_REGISTER_MOUSE_ZONE:	dc.b "REGISTER_MOUSE_ZONE",0
GWVA_DEBUG_EVNT_GWVA_METHOD_UNREGISTER_MOUSE_ZONE:	dc.b "UNREGISTER_MOUSE_ZONE",0
GWVA_DEBUG_EVNT_GWVA_METHOD_REGISTER_BUTTON:		dc.b "REGISTER_BUTTON",0
GWVA_DEBUG_EVNT_GWVA_METHOD_UNREGISTER_BUTTON:		dc.b "UNREGISTER_BUTTON",0

GWVA_DEBUG_EVNT_GWVA_METHOD_WIND_CLICK:		dc.b "WIND_CLICK",0
GWVA_DEBUG_EVNT_GWVA_METHOD_WIND_CREATE_CONTENTS:	dc.b "WIND_CREATE_CONTENTS",0
GWVA_DEBUG_EVNT_GWVA_METHOD_WIND_DELETE_CONTENTS:	dc.b "WIND_DELETE_CONTENTS",0
GWVA_DEBUG_EVNT_GWVA_METHOD_WIND_REDRAW_CONTENTS_BOX:	dc.b "REDRAW_CONTENTS_BOX",0
GWVA_DEBUG_EVNT_GWVA_METHOD_WIND_SET_VSLIDER:		dc.b "WIND_SET_VSLIDER",0
GWVA_DEBUG_EVNT_GWVA_METHOD_WIND_SET_HSLIDER:		dc.b "WIND_SET_HSLIDER",0
GWVA_DEBUG_EVNT_GWVA_METHOD_WIND_CALC_SLIDERS:		dc.b "WIND_CALC_SLIDERS",0
GWVA_DEBUG_EVNT_GWVA_METHOD_WIND_NAMIFY_UNAMIFY:	dc.b "WIND_NAMIFY_UNAMIFY",0
GWVA_DEBUG_EVNT_GWVA_METHOD_WIND_REDRAW_ALL_CONTENTS:	dc.b "WIND_REDRAW_ALL_CONTENTS",0
GWVA_DEBUG_EVNT_GWVA_METHOD_WIND_REDRAW_PART_CONTENTS:	dc.b "WIND_REDRAW_PART_CONTENTS",0
GWVA_DEBUG_EVNT_GWVA_METHOD_WIND_SET_PALETTE:		dc.b "WIND_SET_PALETTE",0
GWVA_DEBUG_EVNT_GWVA_METHOD_WIND_MOVE_SLIDERS_WITH_KEY:	dc.b "WIND_MOVE_SLIDERS_WITH_KEY",0
GWVA_DEBUG_EVNT_GWVA_METHOD_WRSC_REDRAW_PART_CONTENTS:	dc.b "WRSC_REDRAW_PART_CONTENTS",0
GWVA_DEBUG_EVNT_GWVA_METHOD_WRSC_UPDATE		dc.b "WRSC_UPDATE",0
GWVA_DEBUG_EVNT_GWVA_METHOD_WRSC_IDX_UNDER_XY:		dc.b "WRSC_IDX_UNDER_XY",0
GWVA_DEBUG_EVNT_GWVA_METHOD_WFORM_CLEAR_FOCUS:		dc.b "WFORM_CLEAR_FOCUS",0
GWVA_DEBUG_EVNT_GWVA_METHOD_WFORM_SET_FOCUS:		dc.b "WFORM_SET_FOCUS",0
GWVA_DEBUG_EVNT_GWVA_METHOD_WFORM_HIDE_FOCUS:		dc.b "WFORM_HIDE_FOCUS",0
GWVA_DEBUG_EVNT_GWVA_METHOD_WFORM_SHOW_FOCUS:		dc.b "WFORM_SHOW_FOCUS",0
GWVA_DEBUG_EVNT_GWVA_METHOD_WAPP_LOAD_RSC:		dc.b "WAPP_LOAD_RSC",0
GWVA_DEBUG_EVNT_GWVA_METHOD_WAPP_UNLOAD_RSC:		dc.b "WAPP_UNLOAD_RSC",0
GWVA_DEBUG_EVNT_GWVA_METHOD_WAPP_SET_RIGHT_PALETTE:	dc.b "WAPP_SET_RIGHT_PALETTE",0
GWVA_DEBUG_EVNT_GWVA_METHOD_MENU_SELECT:		dc.b "MENU_SELECT",0
GWVA_DEBUG_EVNT_GWVA_METHOD_MENU_CLICK:		dc.b "MENU_CLICK",0
GWVA_DEBUG_EVNT_GWVA_METHOD_MENU_UPDATE:		dc.b "MENU_UPDATE",0
GWVA_DEBUG_EVNT_GWVA_METHOD_MENU_MZONE_TITLE:		dc.b "MENU_MZONE_TITLE",0
GWVA_DEBUG_EVNT_GWVA_METHOD_MENU_CHECK:		dc.b "MENU_CHECK",0
GWVA_DEBUG_EVNT_GWVA_METHOD_MENU_REDRAW_ALL_CONTENTS:	dc.b "MENU_REDRAW_ALL_CONTENTS",0
GWVA_DEBUG_EVNT_GWVA_METHOD_MENU_ITEM_SELECTED:		dc.b "MENU_ITEM_SELECTED",0
GWVA_DEBUG_EVNT_GWVA_METHOD_WTEXT_WRITE_IN_BUFFER:	dc.b "WTEXT_WRITE_IN_BUFFER",0
GWVA_DEBUG_EVNT_GWVA_METHOD_WTEXT_WRITE_IN_WINDOW:	dc.b "WTEXT_WRITE_IN_WINDOW",0
GWVA_DEBUG_EVNT_GWVA_METHOD_WTEXT_WRITE_BUFFER:		dc.b "WTEXT_WRITE_BUFFER",0
GWVA_DEBUG_EVNT_GWVA_METHOD_WTEXT_CLEAR_BUFFER:		dc.b "WTEXT_CLEAR_BUFFER",0
GWVA_DEBUG_EVNT_GWVA_METHOD_WTEXT_CLEAR_BUFFER_AND_UPDATE:	dc.b "WTEXT_CLEAR_BUFFER_AND_UPDATE",0
GWVA_DEBUG_EVNT_GWVA_METHOD_WTEXT_CORRECT_VISIBLE_SIZES:	dc.b "CORRECT_VISIBLE_SIZES",0

GWVA_DEBUG_EVNT_GWVA_METHOD_FORM_KEYPRESS:		dc.b "FORM_KEYPRESS",0
GWVA_DEBUG_EVNT_GWVA_METHOD_FORM_CLICK:		dc.b "FORM_CLICK",0
GWVA_DEBUG_EVNT_GWVA_METHOD_FORM_BUTTON:		dc.b "FORM_BUTTON",0
GWVA_DEBUG_EVNT_GWVA_METHOD_FORM_KEYBD:		dc.b "FORM_KEYBD",0
GWVA_DEBUG_EVNT_GWVA_METHOD_FORM_OBJC_EDIT:		dc.b "FORM_OBJC_EDIT",0
GWVA_DEBUG_EVNT_GWVA_METHOD_FORM_IFACE_CLICK:		dc.b "FORM_IFACE_CLICK",0
GWVA_DEBUG_EVNT_GWVA_METHOD_FORM_CLICKED:		dc.b "FORM_CLICKED",0
GWVA_DEBUG_EVNT_GWVA_METHOD_FORM_DCLICKED:		dc.b "FORM_DCLICKED",0
GWVA_DEBUG_EVNT_GWVA_METHOD_FORM_RCLICKED:		dc.b "FORM_RCLICKED",0
GWVA_DEBUG_EVNT_GWVA_METHOD_FORM_SELECTED:		dc.b "FORM_SELECTED",0
GWVA_DEBUG_EVNT_GWVA_METHOD_FORM_UNSELECTED:		dc.b "FORM_UNSELECTED",0
GWVA_DEBUG_EVNT_GWVA_METHOD_FORM_CHANGED:		dc.b "FORM_CHANGED",0
GWVA_DEBUG_EVNT_GWVA_METHOD_FORM_RELEASE_FOCUS:		dc.b "FORM_RELEASE_FOCUS",0
GWVA_DEBUG_EVNT_GWVA_METHOD_FORM_CATCH_FOCUS:		dc.b "FORM_CATCH_FOCUS",0
GWVA_DEBUG_EVNT_GWVA_METHOD_FPROGRESS_BAR_SET_PERCENT:	dc.b "PROGBAR_SET_PERCENT",0
GWVA_DEBUG_EVNT_GWVA_METHOD_FPROGRESS_BAR_UPDATE_PERCENT:	dc.b "PROGBAR_UPDATE_PERCENT",0
GWVA_DEBUG_EVNT_GWVA_METHOD_FPROGRESS_BAR_REDRAW:	dc.b "PROGBAR_REDRAW",0
GWVA_DEBUG_EVNT_GWVA_METHOD_FSLIDER_MOVE:		dc.b "FSLIDER_MOVE",0
GWVA_DEBUG_EVNT_GWVA_METHOD_FSLIDER_PLUS1:		dc.b "FSLIDER_PLUS1",0
GWVA_DEBUG_EVNT_GWVA_METHOD_FSLIDER_MINUS1:		dc.b "FSLIDER_MINUS1",0
GWVA_DEBUG_EVNT_GWVA_METHOD_FSLIDER_PLUSPAGE:		dc.b "FSLIDER_PLUSPAGE",0
GWVA_DEBUG_EVNT_GWVA_METHOD_FSLIDER_MINUSPAGE:		dc.b "FSLIDER_MINUSPAGE",0
GWVA_DEBUG_EVNT_GWVA_METHOD_FSLIDER_SET_POSITION:	dc.b "FSLIDER_SET_POSITION",0

GWVA_DEBUG_EVNT_MN_SELECTED:	dc.b "MN_SELECTED",0

GWVA_DEBUG_EVNT_WM_REDRAW:	dc.b "WM_REDRAW",0
GWVA_DEBUG_EVNT_WM_TOP:		dc.b "WM_TOPPED",0
GWVA_DEBUG_EVNT_WM_CLOSE:	dc.b "WM_CLOSED",0
GWVA_DEBUG_EVNT_WM_FULL:	dc.b "WM_FULLED",0
GWVA_DEBUG_EVNT_WM_ARROW:	dc.b "WM_ARROWED",0
GWVA_DEBUG_EVNT_WM_HSLID:	dc.b "WM_HSLID",0
GWVA_DEBUG_EVNT_WM_VSLID:	dc.b "WM_VSLID",0
GWVA_DEBUG_EVNT_WM_SIZE:	dc.b "WM_SIZED",0
GWVA_DEBUG_EVNT_WM_MOVE:	dc.b "WM_MOVED",0
GWVA_DEBUG_EVNT_WM_NEWTOP:	dc.b "WM_NEWTOP",0
GWVA_DEBUG_EVNT_WM_UNTOP:	dc.b "WM_UNTOPPED",0
GWVA_DEBUG_EVNT_WM_ONTOP:	dc.b "WM_ONTOP",0
GWVA_DEBUG_EVNT_WM_BOTTOM:	dc.b "WM_BOTTOM",0
GWVA_DEBUG_EVNT_WM_ICONIFY:	dc.b "WM_ICONIFY",0
GWVA_DEBUG_EVNT_WM_UNICONIFY:	dc.b "WM_UNICONIFY",0
GWVA_DEBUG_EVNT_WM_ALLICONIFY:	dc.b "WM_ALLICONIFY",0
GWVA_DEBUG_EVNT_WM_TOOLBAR:	dc.b "WM_TOOLBAR",0
GWVA_DEBUG_EVNT_AC_OPEN:	dc.b "AC_OPEN",0
GWVA_DEBUG_EVNT_AC_CLOSE:	dc.b "AC_CLOSE",0
GWVA_DEBUG_EVNT_AP_TERM:	dc.b "AP_TERM",0
GWVA_DEBUG_EVNT_AP_TFAIL:	dc.b "AP_TFAIL",0
GWVA_DEBUG_EVNT_AP_RESCHG:	dc.b "AP_RESCHG",0
GWVA_DEBUG_EVNT_SHUT_COMPLETED:	dc.b "SHUT_COMPLETED",0
GWVA_DEBUG_EVNT_RESCH_COMPLETED:	dc.b "RESCH_COMPLETED",0
GWVA_DEBUG_EVNT_AP_DRAGDROP:	dc.b "AP_DRAGDROP",0
GWVA_DEBUG_EVNT_SH_WDRAW:	dc.b "SH_WDRAW",0
GWVA_DEBUG_EVNT_CH_EXIT:	dc.b "CH_EXIT",0
 even

 BSS
GWVA_DEBUG_STACK_LEVEL_COUNTER:	ds.w 1

	ifd OPT_GWVA_DEBUG_SEARCH_EXEC_IN_LOGGER

*GWVA_DEBUG_SEARCH_EXEC_IN_LOGGER_LOG_ACK:	ds.w 1
GWVA_DEBUG_SEARCH_EXEC_IN_LOGGER_TMP_MSG_BUF:	ds.b GWVA_DEBUG_MSG_MAX_SIZE*GWVA_DEBUG_MAX_MSG_DEBUG_PENDING
GWVA_DEBUG_SEARCH_EXEC_TEXT_PTR:	ds.l 1

	endc	 ; ifd OPT_GWVA_DEBUG_SEARCH_EXEC_IN_LOGGER

 TEXT
	endc	; OPT_GWVA_DEBUG_SEARCH_EXEC

;------------------------------------------------------------------------------

	rsreset
GWVA_SEARCH_EXEC_STACK_METHOD:		rs.l 1
GWVA_SEARCH_EXEC_STACK_OBJECT:		rs.l 1
GWVA_SEARCH_EXEC_STACK_CLASS:		rs.w 1
GWVA_SEARCH_EXEC_STACK_IS_IN_LOCAL_METHOD_LIST:	rs.w 1
GWVA_SEARCH_EXEC_STACK_STRUCT_LENGTH:	rs.w 0

 DATA
GWVA_SEARCH_EXEC_OBJECT_LEVEL_STACK_PTR:	dc.l GWVA_SEARCH_EXEC_OBJECT_LEVEL_STACK

			****************
 BSS
				ds.b GWVA_SEARCH_EXEC_STACK_STRUCT_LENGTH*64
GWVA_SEARCH_EXEC_OBJECT_LEVEL_STACK:	ds.b GWVA_SEARCH_EXEC_STACK_STRUCT_LENGTH	; celle par dfaut=0
GWVA_SEARCH_EXEC_RETURN_CODE_D6:		ds.w 1
 TEXT
