*--------------------------------------------------------------------------*

	opt o+,ow-

	include verify.s

	include bios.i
	include xbios.i
	include gemdos.i

	ifd MDL_GEM
	include gemmacro.i
	endc

	include inc\system.cte
	include inc\gwva.cte
	include inc\methods.cte
	include inc\lib.cte
	include inc\system.rs
	include inc\gwva.rs
	include inc\class.rs
	include inc\lib.rs
	include gwva_sys.mac
	include objstruc.mac
	include objextd.mac

*--------------------------------------------------------------------------*
*--------------------------------------------------------------------------*
*--------------------------------------------------------------------------*
*---------------------       DEBUT CODE VISUAL        ---------------------*
*--------------------------------------------------------------------------*
*--------------------------------------------------------------------------*
*--------------------------------------------------------------------------*

	TEXT

VISUAL_START:
	move.l a1,GWVA_ROOT_PTR_WAPP

	ifd MDL_GEM
	moveq #0,d1
	move.l a0,d0
	bne.s .acc
	moveq #1,d1
	endc	; ifd MDL_GEM
	move.l 4(sp),a5
	move.l a5,GWVA_ROOT_BASE_PAGE
.acc:
	ifd MDL_GEM
	move.w d1,GWVA_ROOT_IS_ACC_PRG
	endc	; ifd MDL_GEM

	lea GWVA_ROOT_STACK,sp
	move.l sp,GWVA_ROOT_STACK_SAVE_CMP_PTR

	clr.w GWVA_ROOT_CMD_LINE_SIZE	; 0 si acc

	ifd MDL_GEM
	tst GWVA_ROOT_IS_ACC_PRG
	beq .acc_pas_de_cmd_line
	endc	; ifd MDL_GEM

	clr.w d0
	add.b p_cmdlin(a5),d0
	move.w d0,GWVA_ROOT_CMD_LINE_SIZE
	lea p_cmdlin+1(a5),a0
	move.l a0,GWVA_ROOT_CMD_LINE_PTR
	clr.b (a0,d0.w)	; patch pour Magic qui met CR  la fin de la cmd line

	ifd OPT_GWVA_ROOT_ARGV

	cmp.w #127,d0
	bne.s .pas_de_argv_necessaire

	move.l p_env(a5),a0
.pas_fin_environement1:
	tst.b (a0)
	beq.s .fin_chaine_environement
.pas_fin_environement2:
	cmp.l #'ARGV',(a0)
	bne.s .recherche_ARGV
	cmp.b #'=',4(a0)
	bne.s .recherche_ARGV

	lea 5(a0),a0
	STOP_ON_0 a0
	lea 1(a0),a0	; argv[0] : nom du process
	STOP_ON_0 a0
	lea 1(a0),a0
	move.l a0,GWVA_ROOT_CMD_LINE_PTR
	moveq #-1,d0
.recherche_fin_argument:
	addq.w #1,d0
	tst.b (a0)+
	bne.s .recherche_fin_argument
	tst.b (a0)+
	beq.s .fin_recherche_arguments
	move.b #' ',-2(a0)
	addq.w #1,d0
	bra.s .recherche_fin_argument
.fin_recherche_arguments:
	move.w d0,GWVA_ROOT_CMD_LINE_SIZE
	bra.s .fin_recherche_ARGV
.recherche_ARGV:
	STOP_ON_0 a0
.fin_chaine_environement:
	lea 1(a0),a0
	tst.b (a0)
	bne.s .pas_fin_environement2

	move.w #125,GWVA_ROOT_CMD_LINE_SIZE	; taille maxi de la chaine
.fin_recherche_ARGV:
.pas_de_argv_necessaire:

	endc	;	ifd OPT_GWVA_ROOT_ARGV

.acc_pas_de_cmd_line:

	;-----------------------------------;

	; tos+lecteur+selectrix+copro+Mint+Magic+Geneva
	SUPEXEC GWVA_ROOT_PRG_SEARCH_SYSTEM_VARIABLES_AND_COOKIES

; Le DTA est dans la page de base pour les programmes, mais on le redfinit
; par suret (VFAT)
	FSETDTA GWVA_ROOT_DTA

	lea GWVA_ROOT_STARTED_PATH,a0
	bsr GWVA_ROOT_PRG_STORE_CURRENT_PATH

	;-----------------------------------;

	move.l GWVA_ROOT_PTR_WAPP,a0

	cmp.w #GWVA_CLASS_WIND.APP,GWVA_OBJ_CLASS(a0)
	bne GWVA_NOT_WAPP

	bsr GWVA_ROOT_CREATE_OBJECT
	cmp.w #GWVA_ERROR_ROOT_INIT_METHOD_LIST,d7
	beq GWVA_ERROR_BEFORE_CREATE_WAPP
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne GWVA_ERROR_CREATE

	ifd MDL_WIND_MENU
	save.l a0
	bsr GWVA_ROOT_PRG_MENU_FIX_OBJECT_ARROW	;  besoin des informations de la station physique
	load.l a0
	endc

	clr.w GWVA_ROOT_RETURN_CODE

	ifd MDL_GEM

	tst GWVA_ROOT_IS_ACC_PRG
	beq.s .acc_pas_ouverture

	GWVA_CALL_METHOD_OTHER_OBJ	#GWVA_METHOD_OPEN
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne GWVA_BRANCH_IF_OPEN_WORKSTATION_FAILED
.acc_pas_ouverture:

	endc	; ifd MDL_GEM

*--------------------------------------------------------------------------*
*--------------------------------------------------------------------------*
*--------------------------------------------------------------------------*
*------------------    CODE SPECIFIQUE AUX EVENEMENTS   -------------------*
*--------------------------------------------------------------------------*
*--------------------------------------------------------------------------*
*--------------------------------------------------------------------------*

	ifd MDL_EVENTS

	clr.w GWVA_ROOT_EVENT_BITS

; Par dfaut, c'est l'objet application qui reoit les vnements clavier, click et message

	move.l GWVA_ROOT_PTR_WAPP,GWVA_ROOT_KEYPRESS_OBJ_PTR
	move.l GWVA_ROOT_PTR_WAPP,GWVA_ROOT_CLICK_OBJ_PTR
	move.l #GWVA_METHOD_CLICK,GWVA_ROOT_CLICK_METHOD
	move.l GWVA_ROOT_PTR_WAPP,GWVA_ROOT_MESSAGE_OBJ_PTR

GWVA_MAIN_EVENTS_LOOP:
	cmp.l GWVA_ROOT_STACK_SAVE_CMP_PTR,sp
	beq.s .no_stack_slide

	move.l sp,GWVA_ROOT_STACK_SAVE_CMP_PTR
	lea GWVA_ROOT_ALERT_STACK_SLIDING,a0
	move #1,d0
	bsr GWVA_ROOT_PRG_ALERT_BOX
.no_stack_slide:

	tst.w GWVA_ROOT_EVENT_BITS
	bne .old_evnt_waiting

	clr d0

	bset #EVNT_KEYBD,d0
	bset #EVNT_BUTTON,d0
	bset #EVNT_MESAG,d0

	ifge GWVA_ROOT_CTE_MAX_MOUSEZONE-1

	save.w d0
	bsr GWVA_ROOT_ELABORATE_MOUSE_ZONES	; => GWVA_ROOT_M1_ACTIVATED, GWVA_ROOT_M2_ACTIVATED
	load.w d0

	tst.w GWVA_ROOT_M1_ACTIVATED
	beq.s .pas_evnt_mouse1

	bset #EVNT_MOUSE1,d0
.pas_evnt_mouse1:

	tst.w GWVA_ROOT_M2_ACTIVATED
	beq.s .pas_evnt_mouse2

	bset #EVNT_MOUSE2,d0
.pas_evnt_mouse2:

	endc	; ifge GWVA_ROOT_CTE_MAX_MOUSEZONE-1

	ifge GWVA_ROOT_CTE_MAX_TIMER-1
	save.w d0
	bsr GWVA_ROOT_ELABORATE_TIMER_AND_EXEC_METHOD	; => GWVA_ROOT_TIMER_COUNT
	load.w d0
	tst.l GWVA_ROOT_TIMER_COUNT
	beq.s .no_timer
	bset #EVNT_TIMER,d0
.no_timer:
	endc	; ifge GWVA_ROOT_CTE_MAX_TIMER-1

	; #2,#3,#3
	evnt_multi d0,
&	#$102,#$3,#$0,
&	GWVA_ROOT_M1FLAG,GWVA_ROOT_M1X,GWVA_ROOT_M1Y,GWVA_ROOT_M1W,GWVA_ROOT_M1H,
&	GWVA_ROOT_M2FLAG,GWVA_ROOT_M2X,GWVA_ROOT_M2Y,GWVA_ROOT_M2W,GWVA_ROOT_M2H,
&	#GWVA_ROOT_MSG_BUF,
&	GWVA_ROOT_TIMER_COUNT

			******************

	move.w d0,GWVA_ROOT_EVENT_BITS

	move.l int_out+2,GWVA_ROOT_EVNT_MULTI_MX
	move.l int_out+6,GWVA_ROOT_EVNT_MULTI_MB
	move.l int_out+10,GWVA_ROOT_EVNT_MULTI_KC

.old_evnt_waiting:
	move.w GWVA_ROOT_EVENT_BITS,d0

; L'evnt_mesag doit etre trait en premier car il peut informer d'un changement systeme
; dont il faut que les routines suivantes soient averties.

			******************

	btst #EVNT_MESAG,d0
	beq .pas_evenement_message

.new_message:
	lea 0,a2			; par dfaut : pas de buffer tendu

	tst.w GWVA_ROOT_MSG_BUF+bmsg_extd	; message tendu ? (+ de 16 octets)
	beq.s .pas_lecture_buffer_message_etendu

; Il faut absolument lire le reste du message s'il est prsent ; sinon
; cela cre un faux vnement MESSAGE GEM.
	appl_read global+_AESapid,GWVA_ROOT_MSG_BUF+bmsg_extd,#GWVA_ROOT_MSG_EXT_BUF
	lea GWVA_ROOT_MSG_EXT_BUF,a2
.pas_lecture_buffer_message_etendu:

	lea GWVA_ROOT_MSG_BUF,a1
	; a2 initialis
	move.w bmsg_msgid(a1),d0	; numro du message GEM

	cmp.w #GWVA_MSG_META_MESSAGE,d0
	bne.s .pas_traitement_meta_message

	bsr .traitement_meta_message
	bra.s .test_si_nouveau_message
	
.pas_traitement_meta_message:

	move.l GWVA_ROOT_MESSAGE_OBJ_PTR,a0
	move.l GWVA_ROOT_PTR_WAPP,GWVA_ROOT_MESSAGE_OBJ_PTR

	GWVA_CALL_METHOD_OTHER_OBJ	#GWVA_METHOD_MESSAGE

.test_si_nouveau_message:

; On va tester s'il reste des messages a traiter dans la buffer.
; Pour sortir de l'evnt_multi, on utilise l'evenement timer
	evnt_multi #$10+$20,
&	#0,#0,#0,
&	#0,#0,#0,#0,#0,
&	#0,#0,#0,#0,#0,
&	#GWVA_ROOT_MSG_BUF,
&	#1

	btst #EVNT_MESAG,d0
	bne .new_message	; il y a un message en attente -> on se rappelle

	move #EVNT_MESAG,d0
	bsr GWVA_ROOT_PRG_CLEAR_EVNT_BIT

	bra GWVA_MAIN_EVENTS_LOOP

.pas_evenement_message:

			******************

	ifge GWVA_ROOT_CTE_MAX_TIMER-1

	btst #EVNT_TIMER,d0
	beq.s .pas_evenement_timer

	move #EVNT_TIMER,d0		; tout est trait avant l'evnt_multi
	bsr GWVA_ROOT_PRG_CLEAR_EVNT_BIT

	bra GWVA_MAIN_EVENTS_LOOP
.pas_evenement_timer:

	endc	; ifge GWVA_ROOT_CTE_MAX_TIMER-1

			******************

	btst #EVNT_BUTTON,d0
	beq.s .pas_evenement_bouton

	move.w GWVA_ROOT_EVNT_MULTI_MX,d0	; position souris
	move.w GWVA_ROOT_EVNT_MULTI_MB,d1	; tat des boutons souris

	ifd PATCH_GWVA_ROOT_GEM_EVNT_BTON_MB_0
	bne.s .un_bouton_clique
	move.w #%1,GWVA_ROOT_EVNT_MULTI_MB	; BUG GEM : on met le bouton gauche par dfaut
	move.w #%1,d1
.un_bouton_clique:
	endc	; PATCH_GWVA_ROOT_GEM_EVNT_BTON_MB_0

	swap d1
	move.w GWVA_ROOT_EVNT_MULTI_MY,d1	; position souris
	move.w GWVA_ROOT_EVNT_MULTI_KS,d2	; tat des touches spciales
	swap d2
	move.w GWVA_ROOT_EVNT_MULTI_MC,d2	; nbre de clik souris

	move.l GWVA_ROOT_CLICK_OBJ_PTR,a0
	move.l GWVA_ROOT_CLICK_METHOD,d3

	save.l d3
	GWVA_CALL_METHOD_OTHER_OBJ	#GWVA_METHOD_UNREGISTER_BUTTON
	load.l d3

	GWVA_CALL_METHOD_OTHER_OBJ	d3

	move #EVNT_BUTTON,d0
	bsr GWVA_ROOT_PRG_CLEAR_EVNT_BIT

	bra GWVA_MAIN_EVENTS_LOOP

.pas_evenement_bouton:

			******************

	ifge GWVA_ROOT_CTE_MAX_MOUSEZONE-1

	btst #EVNT_MOUSE1,d0
	beq.s .pas_evenement_mouse_zone1
	move.w d0,d2
	move.w GWVA_ROOT_EVNT_MULTI_MX,d0	; position souris
	move.w GWVA_ROOT_EVNT_MULTI_MY,d1	; position souris
	bsr GWVA_ROOT_EXECUTE_MOUSE_ZONES_METHODES
	move #EVNT_MOUSE1,d0
	bsr GWVA_ROOT_PRG_CLEAR_EVNT_BIT
	bra GWVA_MAIN_EVENTS_LOOP
.pas_evenement_mouse_zone1:
	btst #EVNT_MOUSE2,d0
	beq.s .pas_evenement_mouse_zone2
	move.w d0,d2
	move.w GWVA_ROOT_EVNT_MULTI_MX,d0	; position souris
	move.w GWVA_ROOT_EVNT_MULTI_MY,d1	; position souris
	bsr GWVA_ROOT_EXECUTE_MOUSE_ZONES_METHODES
	move #EVNT_MOUSE2,d0
	bsr GWVA_ROOT_PRG_CLEAR_EVNT_BIT
	bra GWVA_MAIN_EVENTS_LOOP
.pas_evenement_mouse_zone2:

	endc	; ifge GWVA_ROOT_CTE_MAX_MOUSEZONE-1

			******************

	btst #EVNT_KEYBD,d0	; doit tre aprs le button : car on transforme un evnt_keyb en evnt_but
	beq.s .pas_evenement_keyb

	move.l GWVA_ROOT_KEYPRESS_OBJ_PTR,a0
	move.l GWVA_ROOT_PTR_WAPP,GWVA_ROOT_KEYPRESS_OBJ_PTR	; on remet l'objet APP par dfaut

	move.w GWVA_ROOT_EVNT_MULTI_KC,d0	; touche
	move.w GWVA_ROOT_EVNT_MULTI_KS,d1	; tat des touches spciales

	; Pour cette mthode KEYPRESS, un check des shortcuts de l'objet a lieu
	; automatiquement dans le SEARCH_EXEC juste avant.
	GWVA_CALL_METHOD_OTHER_OBJ	#GWVA_METHOD_KEYPRESS

	move #EVNT_KEYBD,d0
	bsr GWVA_ROOT_PRG_CLEAR_EVNT_BIT

	bra GWVA_MAIN_EVENTS_LOOP

.pas_evenement_keyb:
	illegal		; du dlire : un vnement pas prvu
*	bra GWVA_MAIN_EVENTS_LOOP

			******************

.traitement_meta_message:

	move.w GWVA_ROOT_MSG_BUF+bmsg_start_free_data+2,d0	; Handle de l'objet destinataire
	bsr GWVA_ROOT_RETURN_OBJ_PTR_FROM_HANDLE

	cmp.w #GWVA_ERROR_GENERIC,d7
	bne.s .objet_destinataire_trouve

*	GWVA_PROGRAMMER_ERROR	GWVA_ASCII_ERROR_NO_DEST_FOR_PIPED_METH
	bra.s .erreur_handle

.objet_destinataire_trouve:
*	movem.l GWVA_ROOT_MSG_EXT_BUF,d0-d2/a1-a2

	lea GWVA_ROOT_MSG_EXT_BUF,a3
	move.w GWVA_ROOT_MSG_BUF+bmsg_start_free_data+8,d3
	btst #0,d3
	beq.s .pas_d0
	move.l (a3)+,d0
.pas_d0:

	GWVA_CALL_METHOD_OTHER_OBJ	GWVA_ROOT_MSG_BUF+bmsg_start_free_data+4

.erreur_handle:
	rts

	endc	; ifd MDL_EVENTS

			******************

; End of Visual Assembleur

_VISUAL_END:

	ifd MDL_GEM

	move.l GWVA_ROOT_PTR_WAPP,a0
	GWVA_CALL_METHOD_OTHER_OBJ	#GWVA_METHOD_CLOSE

	endc	; ifd MDL_GEM

	moveq #GWVA_NO_ERROR_GENERIC,d7	; pour parame entre mthode DELETE

GWVA_BRANCH_IF_OPEN_WORKSTATION_FAILED:
GWVA_BRANCH_IF_RSC_LOAD_FAILED:
GWVA_BRANCH_IF_APPL_INIT_FAILED:

	move.w d7,d0
	GWVA_CALL_METHOD_OTHER_OBJ	#GWVA_METHOD_DELETE

	GWVA_PROGRAMMER_ERROR	GWVA_ASCII_ERROR_NO_DELETED

GWVA_ERROR_CREATE:
	cmp.w #GWVA_ERROR_WAPP_INIT_FAILED,d7
	beq.s GWVA_BRANCH_IF_APPL_INIT_FAILED
	cmp.w #GWVA_ERROR_WAPP_RSC_LOAD_FAILED,d7
	bne.s gwva_no_rsc_error

	ifd MDL_EVENTS

; erreur au chargement du ressource en accessoire

	tst GWVA_ROOT_IS_ACC_PRG
	bne.s GWVA_BRANCH_IF_RSC_LOAD_FAILED
GWVA_INFINITE_LOOP:
	evnt_mesag #GWVA_ROOT_MSG_BUF
	bra.s GWVA_INFINITE_LOOP

	endc	; MDL_EVENTS
gwva_no_rsc_error:
	GWVA_PROGRAMMER_ERROR GWVA_ASCI_ERROR_CREATE_RETURN

GWVA_ERROR_BEFORE_CREATE_WAPP:
GWVA_NOT_WAPP:
	illegal		; on ne peut rien faire d'autre ... (meme pas appeler le DELETE)

*--------------------------------------------------------------------------*

	include srchexec.s
	include class\root.s
	include class\rootmeth.s
	include class\wind\wapp.s
	include library\library.s
	include library\extend\file.s
	include library\extend\string.s

	ifd MDL_GEM

	include library\rsc.s		; si MDL_TOS : pas rsc
	ifd LIB_MULTI_RSC
	include library\extend\multirsc.s
	endc	; ifd LIB_MULTI_RSC

	ifd LIB_FSEL_BSS_FORM
	include library\extend\fsel_upd.s
	endc	; ifd LIB_FSEL_BSS_FORM

	ifd LIB_FILESELECTOR
	include library\file_sel.s
	endc	; ifd LIB_FILESELECTOR

	ifd LIB_GEM_CLIPBOARD
	include library\clipbrd.s
	endc	; ifd LIB_GEM_CLIPBOARD

	ifd MDL_EVENTS
	include class\wind\w_method.s	; une seule mthode est active (KEYPRESS) si pas de MDL_WIND

	ifd MDL_MENU
	include class\menu.s
	ifd LIB_MENU
	include library\extend\menu.s
	endc	; ifd LIB_MENU
	endc	; ifd MDL_MENU
	
	ifd MDL_WIND
	include class\wind\wind_lib.s
	include class\wind\w_cr_del.s
*	include classs\wind\wsliders.s

	ifd MDL_WIND_BITMAP
	include class\wind\wbitmap.s
	endc	; ifd MDL_WIND_BITMAP

	ifd MDL_WIND_TEXT
	include class\wind\wtext.s
	endc	; ifd MDL_WIND_TEXT

	ifd MDL_WIND_RSC
	include class\wind\wrsc.s

	ifd MDL_WIND_RSC_POPUP
	include class\wind\wrscpop.s
	endc	; ifd MDL_WIND_RSCPOPUP

	ifd MDL_WIND_FORM
	include class\wind\wform.s
	include class\form\common.s

	ifd PATCH_GWVA_WFORM_CUSTOM_EDITABLE_TEXT
	include library\extend\objcedit.s
	endc

	ifd MDL_FORM_BUTTON
	include class\form\button.s	; objet cliquable de base : le bouton
	endc	; ifd MDL_FORM_BUTTON

	ifd MDL_FORM_PROGRESS
	include class\form\prog_bar.s	; objet progress bar
	endc	; ifd MDL_FORM_PROGRESS

	ifd MDL_FORM_MENU_POPUP
	include class\form\menu_pop.s	; objet menu popup
	endc	; ifd MDL_FORM_MENU_POPUP

	ifd MDL_FORM_RADIO_BUTTON
	include class\form\radio_bt.s	; objet radio bouton
	endc	; ifd MDL_FORM_RADIO_BUTTON

	ifd MDL_FORM_SLIDER
	include class\form\slider.s	; objet slider
	endc	; ifd MDL_FORM_SLIDER

	ifd MDL_FORM_CLICK_EQUIV
	include class\form\click_eq.s	; objet click equivalent
	endc	; ifd MDL_FORM_CLICK_EQUIV

	ifd MDL_FORM_TEXT
	include class\form\text.s	; objet text (pas ditable)
	endc	; ifd MDL_FORM_TEXT

	ifd MDL_FORM_EDITABLE_TEXT
	include class\form\edit_txt.s	; objet text ditable
	endc	; ifd MDL_FORM_EDITABLE_TEXT

*	ifd MDL_FORM_CHAINED_TEXT
*	include class\form\chaintxt.s	; objet textes chains
*	endc	; ifd MDL_FORM_CHAINED_TEXT

	endc	; ifd MDL_WIND_FORM
	endc	; ifd MDL_WIND_RSC
	endc	; ifd MDL_WIND
	endc	; ifd MDL_EVENTS

	include aeslib.s
 TEXT
	include vdilib.s
 TEXT
	endc	; ifd MDL_GEM

	;----------------------;

	ifd LIB_COLOR
	include library\extend\color.s
	endc	; ifd LIB_COLOR

	ifd LIB_COOKIE
	include library\cookie.s
	endc	; ifd LIB_COOKIE

	ifd LIB_XBRA
	include library\extend\xbra.s
	endc	; ifd LIB_XBRA

	ifd LIB_STIK
	include library\extend\lib_stik.s
	endc	; ifd LIB_STIK

	ifd LIB_XHDI
	include library\extend\xhdicall.s
	endc

*-------------------------------------  D  A  T  A  -------------------------------------*

	DATA

GWVA_ROOT_RETURN_CODE:		dc.w -1

GWVA_ROOT_HANDLE_COUNTER:	dc.w GWVA_OBJ_CTE_HANDLE_UNDEF+1

GWVA_ROOT_COPYRIGHT_MESSAGE:	dc.b 'Written in Visual Assembler 4.5  Gen & Wax 1996,97,98',0
GWVA_ROOT_VISUAL_VERSION:	dc.b '4501',0
GWVA_ROOT_REGISTER_STRING:	dc.b 'RN : UNREGISTERED version for FREEWARE programs',0

	; The label GWVA_APP_OBJ_REGISTER_MESSAGE must point on to a
	; string 'RN : ' followed by your full registration string
	; if you intend to earn money with your program (SHAREWARE or SOLD)

	; Le label GWVA_APP_OBJ_REGISTER_MESSAGE doit pointer sur une
	; chaine 'RN : ' suivie de votre numro d'enregistrement complet
	; si vous diffusez un produit qui doit vous rapporter de l'argent
	; (SHAREWARE ou VENDU)

	ifd OPT_GWVA_DEBUG_ERROR

*GWVA_ASCII_ERROR_HANDLE_EXISTS:	dc.b 'You are trying to allocate an handle to an object which already has one.',0
GWVA_ASCII_ERROR_RETURN_D6:	dc.b 'All your methods must return either GWVA_PRGRET_CONSUMED or GWVA_PRGRET_NOT_CONSUMED in register d6',0
GWVA_ASCII_ERROR_OBJ_HANDLE:	dc.b 'An objet must have his handle allocated before calling any of its methods (including CREATE).',0
GWVA_ASCII_ERROR_NO_DELETED:	dc.b 'The DELETE method of the APP object must do a PTERM or a PTERMRES (GEMDOS calls)',0
GWVA_ASCII_ERROR_SEARCH_EXEC:	dc.b 'You called the GWVA_ROOT_PRG_SEARCH_EXEC_METHOD function with an invalid activation mode.',0
GWVA_ASCII_ERROR_METHOD_CONSUMED:	dc.b 'This method should not return anything but GWVA_PRGRET_CONSUMED in register d6.',0
GWVA_ASCII_ERROR_DEFAULT_PTR:	dc.b 'The default method list pointer of the object must be set before calling any method.',0
GWVA_ASCII_ERROR_LOCAL_PTR:	dc.b 'The local method list pointer of the object must not be set to 0 but to GWVA_OBJ_CTE_METHODLISTPTR_UNDEF.',0
GWVA_ASCII_ERROR_SUBCLASS_CALL:	dc.b 'Only methods of an object are allowed to use activation GWVA_MODE_EXEC_METHOD_ENCAPSULATED_CLASS mode to call methods of this object.',0
GWVA_ASCII_ERROR_NO_LOWER_CLASS:	dc.b 'There is no more encapsulated class. You cannot use activation GWVA_MODE_EXEC_METHOD_ENCAPSULATED_CLASS mode.',0
GWVA_ASCII_ERROR_NO_SUBCLASS_METHOD:dc.b 'The called method does not exist in lower subclass.',0
GWVA_ASCII_ERROR_METHOD_UNKNOW_COMMAND:dc.b 'You gave an unknow command in your method list.',0
GWVA_ASCII_ERROR_MENU_SELECTED:	dc.b 'Menu selected occurs while GWVA_WIND_OLBIT_AMENU=0 or GWVA_WIND_OBJ_MENU_SPEC_PTR=0.',0
GWVA_ASCII_ERROR_MENU_PTR_NULL:	dc.b 'A keyboard event arrived on a menu with VA_WIND_OLBIT_AMENU set and GWVA_WIND_OBJ_MENU_SPEC_PTR=0.',0
GWVA_ASCII_ERROR_ICON_PTR_NULL:	dc.b 'The method ICONIFY of a window has been called with GWVA_WIND_OBJ_ICON_WIND_PTR=0',0
GWVA_ASCII_ERROR_BAD_OBJECT_METHOD:	dc.b 'This method cannot be called for the WAPP object: bad (default)method list or bsr.',0
GWVA_ASCII_ERROR_NO_DEFAULT_LIST:	dc.b 'This CLASS cannot work because it has no default Method list !',0
GWVA_ASCII_ERROR_NO_INHERITANCE:	dc.b 'This CLASS has no heritance (even NULL) defined !',0
GWVA_ASCII_ERROR_RSC_ON_ODD_ADDRESS:dc.b 'Your ressource file you want to relocate is located at an odd address : add an ''even'' instruction before your include.',0
GWVA_ASCII_ERROR_BUTTON_ALREADY_REGISTER:	dc.b 'The button is already registered.',0
GWVA_ASCII_ERROR_NO_MORE_TIMER:	dc.b 'There is not enough timer defined. Increase GWVA_ROOT_CTE_MAX_TIMER.',0
GWVA_ASCII_ERROR_NO_MORE_MZONE:	dc.b 'There is not enough mouse zone defined. Increase GWVA_ROOT_CTE_MAX_MOUSEZONE.',0
GWVA_ASCII_ERROR_RETURN_D7:	dc.b 'The d7 register gives you the returning error code.',0
GWVA_ASCII_ERROR_VISUAL_EVENT:	dc.b 'Only BEFORE and AFTER event methods can be called by the GWVA_EXEC_VISUAL_EVENT macro.',0
GWVA_ASCII_ERROR_BEFORE_AFTER:	dc.b 'BEFORE and AFTER event methods can only be called by the GWVA_EXEC_VISUAL_EVENT macro.',0
GWVA_ASCII_ERROR_NO_EVENT_PIPED:	dc.b 'EVENT / BEFORE and AFTER event methods can not be piped using GWVA_ROOT_ACTIVATE_METHODE_VIA_MESSAGE',0
GWVA_ASCII_ERROR_NO_DEST_FOR_PIPED_METH:	dc.b 'A GEM-piped Method did not find his destination object (bad handle ?)',0
GWVA_ASCII_ERROR_ICONIFY_IMPOSSIBLE:	dc.b 'You cannot Iconify a Window which is already iconified !',0
GWVA_ASCII_ERROR_UNICONIFY_IMPOSSIBLE:	dc.b 'You cannot Uniconify a Window which is not iconified !',0

GWVA_ASCI_ERROR_CREATE_RETURN:	dc.b 'V.A. INTERNAL ERROR : The CREATE method of the APP objet return an invalid error code.',0

	endc	; ifd OPT_GWVA_DEBUG_ERROR

	ifd MDL_GEM
			; 31 charactres maximum sur 5 lignes
			;     [1234567890123456789012345678901]
GWVA_ROOT_ALERT_STACK_OVERFLOW:	dc.b '[3]'
			dc.b '[ * Visual-Asm kernel Warning * '
			dc.b '|         - - - - - - -         '
			dc.b '| A stack OVERFLOW occured, this'
			dc.b '| may cause an error. Conctact  '
			dc.b '| the programmer for resizing it]'
			dc.b '[Continue]'
			dc.b 0

	ifd MDL_EVENTS

GWVA_ROOT_ALERT_STACK_SLIDING:	dc.b '[3]'
			dc.b '[ * Visual-Asm kernel Warning * '
			dc.b '|         - - - - - - -         '
			dc.b '| A stack SLIDING occured, this '
			dc.b '| may cause errors if it happens'
			dc.b '| several times. This is a bug !]'
			dc.b '[Continue|Contact|Author]'
			dc.b 0

 even

	ifd MDL_WIND

GWVA_WIND_GENERIC_METHOD_SHORTCUTLIST:	; METHOD,SHORTCUT
	GWVA_NEXT_SHORTCUT_CONTROL 'u'
	GWVA_OBJ_STRUCT_SHORTCUT GWVA_METHOD_DELETE
	GWVA_OBJ_STRUCT_SHORTCUT_END_LIST

	ifd MDL_WIND_MENU

GWVA_ROOT_MENU_TREE_ARROWS:	; objet pour les fleches dans les menu des fenetres
	dc.w -1,1,2,G_BOX
	dc.w 0,$0000
	dc.l $00FF1100
	dc.w 0,0,4,$0201
	
	dc.w 2,-1,-1,G_BOXCHAR
	dc.w 0,0
	dc.l (4<<24)|$00001100
	dc.w 0,0,2,$0201

	dc.w 0,-1,-1,G_BOXCHAR
	dc.w $0020,0
	dc.l (3<<24)|$00FF1100
	dc.w 2,0,2,$0201

	endc	; ifd MDL_WIND_MENU

	endc	; ifd MDL_WIND

	endc	; ifd MDL_EVENTS

	endc	; ifd MDL_GEM

*-----------------------------------------------------------------------------*

GWVA_ROOT_CLASS_INHERITANCE_LIST:
	GWVA_OBJ_STRUCT_INHERITANCE GWVA_CLASS_ROOT			; 1
	GWVA_OBJ_STRUCT_INHERITANCE GWVA_CLASS_WIND,GWVA_CLASS_ROOT		; 2
	GWVA_OBJ_STRUCT_INHERITANCE GWVA_CLASS_WIND.APP,GWVA_CLASS_WIND	; 3
	GWVA_OBJ_STRUCT_INHERITANCE GWVA_CLASS_WIND.RSC,GWVA_CLASS_WIND	; 4
	GWVA_OBJ_STRUCT_INHERITANCE GWVA_CLASS_WIND.RSC.FORM,GWVA_CLASS_WIND.RSC ; 5
	GWVA_OBJ_STRUCT_INHERITANCE GWVA_CLASS_WIND.RSC.POPUP,GWVA_CLASS_WIND.RSC ; 6
	GWVA_OBJ_STRUCT_INHERITANCE GWVA_CLASS_WIND.BITMAP,GWVA_CLASS_WIND	; 7
	GWVA_OBJ_STRUCT_INHERITANCE GWVA_CLASS_WIND.TEXT,GWVA_CLASS_WIND	; 8
	GWVA_OBJ_STRUCT_INHERITANCE GWVA_CLASS_MENU,GWVA_CLASS_ROOT		; 9
	ifd MDL_WIND_FORM
	 GWVA_OBJ_STRUCT_INHERITANCE GWVA_CLASS_FORM,GWVA_CLASS_ROOT	; 10
	 GWVA_OBJ_STRUCT_INHERITANCE GWVA_CLASS_FORM.BUTTON,GWVA_CLASS_FORM	; 11
	 GWVA_OBJ_STRUCT_INHERITANCE GWVA_CLASS_FORM.MENU_POPUP,GWVA_CLASS_FORM	; 12
	 GWVA_OBJ_STRUCT_INHERITANCE GWVA_CLASS_FORM.RADIO_BUTTON,GWVA_CLASS_FORM ; 13
	 GWVA_OBJ_STRUCT_INHERITANCE GWVA_CLASS_FORM.SLIDER,GWVA_CLASS_FORM	; 14
	 GWVA_OBJ_STRUCT_INHERITANCE GWVA_CLASS_FORM.CLICK_EQUIV,GWVA_CLASS_FORM ; 15
	 GWVA_OBJ_STRUCT_INHERITANCE GWVA_CLASS_FORM.PROGRESS_BAR,GWVA_CLASS_FORM ; 16
	 GWVA_OBJ_STRUCT_INHERITANCE GWVA_CLASS_FORM.TEXT,GWVA_CLASS_FORM	; 17
	 GWVA_OBJ_STRUCT_INHERITANCE GWVA_CLASS_FORM.TEXT.EDITABLE,GWVA_CLASS_FORM.TEXT	; 18
*	 GWVA_OBJ_STRUCT_INHERITANCE GWVA_CLASS_FORM.TEXT.CHAINED,GWVA_CLASS_FORM.TEXT	; 19
*	 GWVA_OBJ_STRUCT_INHERITANCE GWVA_CLASS_FORM.TEXT.EDITABLE.CHAINED,GWVA_CLASS_FORM.TEXT.EDITABLE	; 20
	endc	; ifd MDL_WIND_FORM
GWVA_ROOT_CLASS_INHERITANCELIST_LINK:
	GWVA_OBJ_STRUCT_INHERITANCE_END_LIST

GWVA_ROOT_DEFAULT_METHODLIST_LIST:
	GWVA_OBJ_STRUCT_CLASSMETHOD GWVA_CLASS_ROOT,GWVA_ROOT_DEFAULT_METHODLIST
	GWVA_OBJ_STRUCT_CLASSMETHOD GWVA_CLASS_WIND.APP,GWVA_WAPP_DEFAULT_METHODLIST

	ifd MDL_EVENTS
	 GWVA_OBJ_STRUCT_CLASSMETHOD GWVA_CLASS_WIND,GWVA_WIND_DEFAULT_METHODLIST
	ifd MDL_WIND_RSC
	 GWVA_OBJ_STRUCT_CLASSMETHOD GWVA_CLASS_WIND.RSC,GWVA_WRSC_DEFAULT_METHODLIST
	 ifd MDL_WIND_FORM
	  GWVA_OBJ_STRUCT_CLASSMETHOD GWVA_CLASS_WIND.RSC.FORM,GWVA_WFORM_DEFAULT_METHODLIST
	 endc	; ifd MDL_WIND_FORM
	 ifd MDL_WIND_RSC_POPUP
	  GWVA_OBJ_STRUCT_CLASSMETHOD GWVA_CLASS_WIND.RSC.POPUP,GWVA_WRSCPOPUP_DEFAULT_METHODLIST
	 endc	; ifd MDL_WIND_RSC_POPUP
	endc	; ifd MDL_WIND_RSC
	ifd MDL_WIND_BITMAP
	 GWVA_OBJ_STRUCT_CLASSMETHOD GWVA_CLASS_WIND.BITMAP,GWVA_WBITM_DEFAULT_METHODLIST
	endc	; ifd MDL_WIND_BITMAP
	ifd MDL_WIND_TEXT
	 GWVA_OBJ_STRUCT_CLASSMETHOD GWVA_CLASS_WIND.TEXT,GWVA_WTEXT_DEFAULT_METHODLIST
	endc	; ifd MDL_WIND_TEXT
	ifd MDL_MENU
	 GWVA_OBJ_STRUCT_CLASSMETHOD GWVA_CLASS_MENU,GWVA_MENU_DEFAULT_METHODLIST
	endc	; ifd MDL_MENU
	ifd MDL_WIND_FORM
	 GWVA_OBJ_STRUCT_CLASSMETHOD GWVA_CLASS_FORM,GWVA_FORM_DEFAULT_METHODLIST
	 ifd MDL_FORM_BUTTON
	  GWVA_OBJ_STRUCT_CLASSMETHOD GWVA_CLASS_FORM.BUTTON,GWVA_FBUTTON_DEFAULT_METHODLIST
	 endc	; ifd MDL_FORM_BUTTON
	 ifd MDL_FORM_PROGRESS
	  GWVA_OBJ_STRUCT_CLASSMETHOD GWVA_CLASS_FORM.PROGRESS_BAR,GWVA_FPROGRESS_BAR_DEFAULT_METHODLIST
	 endc	; ifd MDL_FORM_PROGRESS
	 ifd MDL_FORM_MENU_POPUP
	  GWVA_OBJ_STRUCT_CLASSMETHOD GWVA_CLASS_FORM.MENU_POPUP,GWVA_FMENU_POPUP_DEFAULT_METHODLIST
	 endc	; ifd MDL_FORM_MENU_POPUP
	 ifd MDL_FORM_RADIO_BUTTON
	  GWVA_OBJ_STRUCT_CLASSMETHOD GWVA_CLASS_FORM.RADIO_BUTTON,GWVA_FRADIO_BUTTON_DEFAULT_METHODLIST
	 endc	; ifd MDL_FORM_RADIO_BUTTON
	 ifd MDL_FORM_SLIDER
	  GWVA_OBJ_STRUCT_CLASSMETHOD GWVA_CLASS_FORM.SLIDER,GWVA_FSLIDER_DEFAULT_METHODLIST
	 endc	; ifd MDL_FORM_SLIDER
	 ifd MDL_FORM_CLICK_EQUIV
	  GWVA_OBJ_STRUCT_CLASSMETHOD GWVA_CLASS_FORM.CLICK_EQUIV,GWVA_FCLICK_EQUIV_DEFAULT_METHODLIST
	 endc	; ifd MDL_FORM_CLICK_EQUIV
	 ifd MDL_FORM_TEXT
	  GWVA_OBJ_STRUCT_CLASSMETHOD GWVA_CLASS_FORM.TEXT,GWVA_FTEXT_DEFAULT_METHODLIST
	 endc	; ifd MDL_FORM_TEXT
	 ifd MDL_FORM_EDITABLE_TEXT
	  GWVA_OBJ_STRUCT_CLASSMETHOD GWVA_CLASS_FORM.TEXT.EDITABLE,GWVA_EDITABLE_TEXT_DEFAULT_METHODLIST
	 endc	; ifd MDL_FORM_EDITABLE_TEXT
	endc	; ifd MDL_WIND_FORM
	endc	; ifd MDL_EVENTS
GWVA_ROOT_DEFAULT_METHODLIST_LINK:
	GWVA_OBJ_STRUCT_CLASSMETHOD_END_LIST

GWVA_ROOT_CLASS_INHERITANCE_NEXT_LINK:	dc.l GWVA_ROOT_CLASS_INHERITANCELIST_LINK
GWVA_ROOT_DEFAULT_METHODLIST_NEXT_LINK:	dc.l GWVA_ROOT_DEFAULT_METHODLIST_LINK

*---------------------------------------- B  S  S  ---------------------------------------*

	BSS

GWVA_ROOT_STACK_TOP:		ds.b GWVA_ROOT_CTE_STACK_SIZE
GWVA_ROOT_STACK:		ds.l 1
GWVA_ROOT_STACK_SAVE_CMP_PTR:	ds.l 1	; pointeur sur le sommet de la pile  chaque event_multi (warning)

GWVA_ROOT_PTR_WAPP:		ds.l 1	; pointeur sur l'objet application principale
GWVA_ROOT_BASE_PAGE:		ds.l 1
GWVA_ROOT_CMD_LINE_PTR:		ds.l 1
GWVA_ROOT_CMD_LINE_SIZE:	ds.w 1

GWVA_ROOT_OLD_SUPERVISOR_STACK:	ds.l 1	; pour macro SUPER

	ifd MDL_GEM
GWVA_ROOT_IS_ACC_PRG:		ds.w 1	; 0 : acc, 1 : app
	endc	; ifd MDL_GEM

GWVA_ROOT_DTA:		ds.b L_DTA
GWVA_ROOT_STARTED_PATH:		ds.b GWVA_ROOT_MAX_PATH_LENGTH

GWVA_ROOT_SEARCH_IN_OUT:	ds.l 2	; le paramtre pour la recherche COOKIE,XBRA

GWVA_ROOT_SYSVAR_BOOT_DEVICE:	ds.w 1	; lecteur de boot : 0=A, 1=B, 2=C ...
GWVA_ROOT_SYSVAR_TOS_VERSION:	ds.w 1	: ex. : $0404

	ifd LIB_SEARCH_SYSTEM_COOKIES
GWVA_ROOT_COOKIE_COPRO:		ds.w 1	; 0=aucun 1=68881 2=68882
GWVA_ROOT_COOKIE_MINT:		ds.w 1	; 0 ou la version
GWVA_ROOT_COOKIE_MAGIC:		ds.l 1	; 0 ou un pointeur sur la structure de MagiC
GWVA_ROOT_COOKIE_GENEVA:	ds.l 1	; 0 ou un pointeur sur la structure de Geneva

GWVA_ROOT_COOKIE_SELECTRIX_PTR:	ds.l 1	; Selctrix base adress (0 si pas slectrix)
GWVA_ROOT_COOKIE_SELECTRIX_COMM_WORD:ds.l 1	; ad. du word communication
GWVA_ROOT_COOKIE_SELECTRIX_OUT_COUNT:ds.l 1	; ad. du compteur sortie
GWVA_ROOT_COOKIE_SELECTRIX_OUT_PTR:	ds.l 1	; ad. du pointeur sortie
	endc	; ifd LIB_SEARCH_SYSTEM_COOKIES

	ifd MDL_GEM

GWVA_ROOT_MOUSE_STATE:		ds.w 1

GWVA_ROOT_TEXT_WIDTH:		ds.w 1
GWVA_ROOT_TEXT_HEIGHT:		ds.w 1
GWVA_ROOT_CELL_WIDTH:		ds.w 1
GWVA_ROOT_CELL_HEIGHT:		ds.w 1

GWVA_ROOT_SYSTEM_LARGEFONT_HEIGHT:	ds.w 1
GWVA_ROOT_SYSTEM_SMALLFONT_HEIGHT:	ds.w 1
GWVA_ROOT_SYSTEM_LARGEFONT_CELL_WIDTH:	ds.w 1
GWVA_ROOT_SYSTEM_LARGEFONT_CELL_HEIGHT:	ds.w 1
GWVA_ROOT_SYSTEM_SMALLFONT_CELL_WIDTH:	ds.w 1
GWVA_ROOT_SYSTEM_SMALLFONT_CELL_HEIGHT:	ds.w 1

GWVA_ROOT_SYSTEM_AES_3D_HBORDER:	ds.w 1
GWVA_ROOT_SYSTEM_AES_3D_VBORDER:	ds.w 1

GWVA_ROOT_VDI_WORKSTATION:	ds.w 57
GWVA_ROOT_VDI_WORKSTATION_EXTD:	ds.w 57

	ifd MDL_RELOCATE_RSC
GWVA_ROOT_ADD_MALLOC_RSC_ICN:	ds.l 2
	endc

; Utilis par RELOCATE
GWVA_ROOT_MFDB_SRC:		ds.l 1	; buffers pour vro_cpyfrm & vrt_ & vr_trnfm
			ds.w 8
GWVA_ROOT_MFDB_DEST:		ds.l 1
			ds.w 8

	ifd MDL_EVENTS
GWVA_ROOT_ACC_NUMBER:		ds.w 1	; pas d'acc sans events

GWVA_ROOT_EVENT_BITS:		ds.w 1

GWVA_ROOT_KEYPRESS_OBJ_PTR:	ds.l 1	; pointeur sur l'objet qui demande  recevoir les touches
GWVA_ROOT_CLICK_OBJ_PTR:	ds.l 1	; pointeur sur l'objet qui demande  recevoir les clicks souris
GWVA_ROOT_CLICK_METHOD:		ds.l 1	; mthode devant tre appel lors de la rception d'un click souris
GWVA_ROOT_CLICK_LOCK:		ds.w 1	; 0 unlock, 1 lock (wind_update #BEG_MCTRL)
GWVA_ROOT_MESSAGE_OBJ_PTR:	ds.l 1	; pointeur sur l'objet qui demande  recevoir le messages GEM

GWVA_ROOT_TIMER_COUNT:		ds.l 1	; valeur du timer GEM en mili-secondes(<> 0 pour tre actif)
	ifge GWVA_ROOT_CTE_MAX_TIMER-1
GWVA_ROOT_TIMER_LIST:		ds.b GWVA_ROOT_OBJ_TIMER_STRUCT_LENGTH*GWVA_ROOT_CTE_MAX_TIMER	; Liste des objets voulant accder au Timer
	endc	; ifge GWVA_ROOT_CTE_MAX_TIMER-1

GWVA_ROOT_M1_ACTIVATED:		ds.w 1	; 1 : Zone valide
GWVA_ROOT_M1FLAG:		ds.w 1	; entre de zone (0) sortie (1)
GWVA_ROOT_M1X:		ds.w 1	; position et taille de la zone (<> 0 pour tre actif)
GWVA_ROOT_M1Y:		ds.w 1
GWVA_ROOT_M1W:		ds.w 1
GWVA_ROOT_M1H:		ds.w 1
GWVA_ROOT_M2_ACTIVATED:		ds.w 1	; 1 : Zone valide
GWVA_ROOT_M2FLAG:		ds.w 1	; entre de zone (0) sortie (1)
GWVA_ROOT_M2X:		ds.w 1	; position et taille de la zone (<> 0 pour tre actif)
GWVA_ROOT_M2Y:		ds.w 1
GWVA_ROOT_M2W:		ds.w 1
GWVA_ROOT_M2H:		ds.w 1
	ifge GWVA_ROOT_CTE_MAX_MOUSEZONE-1
GWVA_ROOT_MOUSEZONE_LIST:	ds.b GWVA_ROOT_OBJ_MOUSEZONE_STRUCT_LENGTH*GWVA_ROOT_CTE_MAX_MOUSEZONE	; Liste des objets voulant accder  une MOUSE_ZONE
	endc	; ifge GWVA_ROOT_CTE_MAX_MOUSEZONE-1

GWVA_ROOT_EVNT_MULTI_MX:	ds.w 1	; position souris
GWVA_ROOT_EVNT_MULTI_MY:	ds.w 1
GWVA_ROOT_EVNT_MULTI_MB:	ds.w 1	; tat des boutons souris
GWVA_ROOT_EVNT_MULTI_KS:	ds.w 1	; tat des touches spciales
GWVA_ROOT_EVNT_MULTI_KC:	ds.w 1	; touche
GWVA_ROOT_EVNT_MULTI_MC:	ds.w 1	; nbre de clik souris
GWVA_ROOT_MSG_BUF:		ds.b L_BMSG	; pour event-multi
GWVA_ROOT_MSG_EXT_BUF:		ds.b 256	; pour appl_read - appl_write

	endc	; ifd MDL_EVENTS

	ifd MDL_COLORS
GWVA_ROOT_DESK_PALETTE:		ds.w 256*3	; palette RGB VDI (vq_color)
GWVA_ROOT_TMP_PALETTE:		ds.w 256*3	; palette RGB VDI (vq_color)
	endc	; ifd MDL_COLORS

	endc	; ifd MDL_GEM

	TEXT

*----------------------------------------------------------------------------*
