	output d:\assemble\visual45\src\h2hs\h2hs.prg

OPT_GWVA_DEBUG_ERROR			; [option][root] generates an illegal when something goes wrong (for debugging purposes)
OPT_GWVA_DEBUG_PRINT_COMMENTS		; [option][root] print comments/warnings when assembling source

*OPT_GWVA_DEBUG_SEARCH_EXEC		; [option][root] is needed to do any log alert_box/logger
*OPT_GWVA_DEBUG_SEARCH_EXEC_IN_ALERT_BOX	; [option][root][LIB_HEXA][LIB_DECI][OPT_GWVA_DEBUG_SEARCH_EXEC] prints an alert box at each method distribution
*OPT_GWVA_DEBUG_SEARCH_EXEC_IN_LOGGER	; [option][root][LIB_HEXA][LIB_DECI][OPT_GWVA_DEBUG_SEARCH_EXEC] prints in log window each method distribution
*GWVA_DEBUG_MSG_MAX_SIZE = 256		; [var] defines the debug message max length (generated by SEARCH_EXEC)
*GWVA_DEBUG_MAX_MSG_DEBUG_PENDING = 64	; [var] how many debug messages can be sent in a row
*LIB_HEXA				; [none]
*LIB_DECI				; [none]

	lea objet_application,a1

	include h2hs.def
	include visual45.s
	include h2hs.obj

	comment HEAD=7
	section TEXT

;---------------------------------------------------------------------------
	; Transformation d'un fichier .H gnr par un constructeur de ressource
	; en fichier .HS exploitable par le V.A.

	; Proprit : ne marche qu'en programme (.PRG .APP .GTP)
;---------------------------------------------------------------------------

h2hs_program_opened:
	tst GWVA_ROOT_IS_ACC_PRG
	beq no_acc_run

	tst.b d0
	bne.s .ligne_de_commande

.pas_de_fichier_h_en_memoire:
	lea texte_loadh,a0		; 35 chars max.
	lea texte_mask,a1
	lea 0.w,a2
	bsr GWVA_FILE_SELECTOR
	tst d0
	beq fini
	bmi fini

	move.l a2,a1

.ligne_de_commande:
	move.l a1,a0
	move.w #MX_PREFTTRAM,d0
	bsr GWVA_FILE_LOAD_IN_MEM

	cmp.l #GWVA_ERROR_MALLOC,d0
	beq pas_de_memoire1
	tst d0
	ble.s .pas_de_fichier_h_en_memoire

	move.l d0,length_file1

	save.l a0
	MXALLOC #MX_PREFTTRAM,d0
	load.l a0
	tst.l d0
	ble pas_de_memoire2

	move.l d0,a1
	move.l d0,a2

	move.l length_file1,d0
	clr.l length_file2

.transforme_file_h_hs:
	sub.l #1,d0
	bmi fin_trans_file

	move.b (a0)+,d1

	cmp.b #'/',d1
	bne.s .pas_debut_commentaire

	move.b (a0),d2
	cmp.b #'*',d2
	bne.s .pas_debut_commentaire

	move.b #9,(a1)+	; tab
	move.b #";",(a1)+
	addq.l #2,length_file2

	lea 1(a0),a0
	subq.l #1,d0

.pas_fin_commentaire:
	subq.l #1,d0
	bmi fin_trans_file

	move.b (a0)+,d1
	move.b d1,(a1)+
	addq.l #1,length_file2

	cmp.b #'*',d1
	bne.s .pas_fin_commentaire

	move.b (a0),d1
	cmp.b #'/',d1
	bne.s .pas_fin_commentaire

	lea 1(a0),a0
	subq.l #1,d0

	bra.s .decompte_fichier

.pas_debut_commentaire:
	cmp.b #'#',d1
	bne.s .pas_opcode_DEFINE

	addq.l #7,a0	; +define[ ]
	subq.l #7,d0

.cherche_espace:
	move.b (a0)+,d1
	subq.l #1,d0
	move.b d1,(a1)+
	addq.l #1,length_file2
	cmp.b #' ',d1
	bne.s .cherche_espace

	move.b #'=',(a1)+
	move.b #' ',(a1)+
	addq.l #2,length_file2

.cherche_espace2:
	move.b (a0)+,d1
	subq.l #1,d0
	move.b d1,(a1)+
	addq.l #1,length_file2
	cmp.b #' ',d1
	bne.s .cherche_espace2

	lea -1(a1),a1
	subq.l #1,length_file2

.cherche_texte:
	move.b (a0)+,d1
	subq.l #1,d0
	cmp.b #' ',d1
	beq.s .cherche_texte

	subq.l #1,a0
	addq.l #1,d0
	bra.s .decompte_fichier

.pas_opcode_DEFINE:
	move.b d1,(a1)+
	addq.l #1,length_file2

.decompte_fichier:
	bne .transforme_file_h_hs
fin_trans_file:

	tst.w GWVA_ROOT_CMD_LINE_SIZE
	bne.s chargement_parametre

	save.l a2
	lea texte_savehs,a0		; 35 chars max.
	lea texte_maskhs,a1
	lea 0.w,a2
	bsr GWVA_FILE_SELECTOR
	load.l a3
	tst d0
	beq.s fini
	bmi.s fini

	move.l a2,a0
	move.l a3,a2

er:	save.l a2
	FILE_OPEN write,(a0),d7
	load.l a2
	tst d7
	bmi.s fini
	FWRITE a2,length_file2,d7
	FCLOSE d7

fini:
no_acc_run:
	bsr GWVA_ROOT_KILL_APPLICATION

	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

chargement_parametre:
	move.l GWVA_ROOT_CMD_LINE_PTR,a0
	lea (a0),a1

.p0:	tst.b (a1)+
	bne.s .p0
	move.b #'S',-1(a1)
	clr.b (a1)
	bra.s er

pas_de_memoire2:
	MFREE a0
pas_de_memoire1:
	lea alert_memoire,a0
	move.w #1,d0
	bsr GWVA_RSC_ALERT_BOX
	bra.s fini
	
	DATA
texte_loadh:	dc.b 'Choose a .H to transform to .HS :',0
texte_mask:		dc.b '*.H',0
texte_maskhs:	dc.b '*.HS',0
texte_savehs:	dc.b 'Choose the .HS save filename :',0
alert_memoire:	dc.b "[3][ Pas assez de memoire | pour mener  bien l'opration ][ Quitter ]",0

	even
	BSS
length_file1:ds.l 1
length_file2:ds.l 1

 END
